// DbgLoggerCltMgr.cpp: implementation of the CDbgLoggerCltMgr class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"


#include "../CLMService/LogDef.h"
#include "ShmMgrClient.h"
#include "ShmLoggerClient.h"
#include "DbgLoggerCltMgr.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CDbgLoggerCltMgr& CDbgLoggerCltMgr::Instance()
{
	static CDbgLoggerCltMgr obj;
	return obj;
}


CDbgLoggerCltMgr::CDbgLoggerCltMgr()
{
	SHMBLOCK block=CShmMgrClient::ClientInstance().GetDebugLogBlock();
	m_pShmLogClient=NULL;
	m_bValid=false;

	if (block.m_address&&block.m_size)
	{
		std::string MagicString=MAGIC_STRING_DEBUG;
		m_pShmLogClient=CShmLogClient::CreateClient(block.m_address,
												block.m_size,
												MagicString);
		if (m_pShmLogClient && (*m_pShmLogClient))
		{
			m_bValid=true;
		}
	}
}

CDbgLoggerCltMgr::~CDbgLoggerCltMgr()
{
	delete m_pShmLogClient;
	CShmMgrClient::CleanupClientInstance();
}

bool CDbgLoggerCltMgr::LogDbgString( const char* msg)
{
	if (*this)
	{
		 return m_pShmLogClient->WriteString(msg);
	}
	return false;
}