// DllApi.cpp: implementation of the DllApi class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <atlBase.h>
#include "DllApi.h"

#include "ShmMgrClient.h"
#include "ShmLoggerClient.h"
#include "DbgLoggerCltMgr.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

 BOOL LoginDebugLogger(ULONG Handle)
 {
	 BOOL bRet=FALSE;
	 HRESULT hr=CoInitialize(NULL);
	 if (SUCCEEDED(hr))
	 {
		 USES_CONVERSION;
		 CComPtr<IGeneralApi> pGeneralApi;
		 hr=pGeneralApi.CoCreateInstance(__uuidof(GeneralApi));
		 if (SUCCEEDED(hr))
		 {
			 ULONG retCode;
			 pGeneralApi->LoginDebugLogger(Handle,&retCode);
             if(retCode==CLM_ERROR_SUCCESS)
			 {
				 bRet=(bool)CDbgLoggerCltMgr::Instance();
			 }
		 }
	 }
	 CoUninitialize();
	 return bRet;
 
 }

 void LogoutDebugLogger(ULONG Handle)
 {
 	 HRESULT hr=CoInitialize(NULL);
	 if (SUCCEEDED(hr))
	 {
		 USES_CONVERSION;
		 CComPtr<IGeneralApi> pGeneralApi;
		 hr=pGeneralApi.CoCreateInstance(__uuidof(GeneralApi));
		 if (SUCCEEDED(hr))
		 {
			 ULONG retCode;
			 pGeneralApi->LogoutDebugLogger(Handle,&retCode);
             if(retCode==CLM_ERROR_SUCCESS)
			 {
			 }
		 }
	 }
	 CoUninitialize();
 }

 BOOL CLMAPI LogDebugString (const char* msg)
 {
 	 return CDbgLoggerCltMgr::Instance().LogDbgString(msg);
 }
