// DebugLoggerAppender.cpp: implementation of the CDebugLoggerAppender class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DebugLoggerAppender.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDebugLoggerAppender::CDebugLoggerAppender()
{
	m_bValid=false;
	m_bEnableDbgView=false;
	m_fp=NULL;
	m_bEnableFile=false;
	Init();
}

CDebugLoggerAppender::~CDebugLoggerAppender()
{
	if(m_fp)
	{
	   fclose(m_fp);
	}
}

void CDebugLoggerAppender::Init ()
{

	HKEY	h_key=NULL;
	char    LogPath[MAX_PATH+1];
	DWORD   dwSize=sizeof(LogPath);

	do 
	{
		if (ERROR_SUCCESS != RegOpenKeyEx(HKEY_LOCAL_MACHINE, 
										(LPCTSTR)DEBUG_LOG_KEY,
										0, 
										KEY_READ, 
										&h_key))
		{
			break;
		}
 
		if (ERROR_SUCCESS != RegQueryValueEx(h_key, 
											DEBUG_LOG_FILE_NAME,
											0,
											NULL, 
											(LPBYTE)&LogPath, 
											&dwSize))
		{
			break;
		}
  
		DWORD   mask=0;
 		dwSize=sizeof(mask);
 
		if (ERROR_SUCCESS != RegQueryValueEx(h_key, 
											DEBUG_LOG_MASK,
											0,
											NULL, 
											(LPBYTE)&mask, 
											&dwSize))
		{
			break;
		}
		m_nMask=mask;

		if (DEBUG_LOG_FILE&m_nMask)
		{
	 		m_fp=fopen(LogPath,"a");
			if(m_fp==NULL)
			{
				break;
			}
			m_bEnableFile=true;
		}

		if (DEBUG_LOG_DBGVIEW&m_nMask)
		{
			m_bEnableDbgView=true;		
		}

		m_bValid=true;

	}while(0);

	if (h_key)
	{
		RegCloseKey(h_key);
	}
}


void CDebugLoggerAppender::AppendLogInfo (const char* str)
{
	if (*this)
	{
		if (m_bEnableDbgView)
		{
			int size=strlen(str);
			fwrite(str,1,size,m_fp);
			fflush(m_fp);
		}
		if (m_bEnableDbgView)
		{
			OutputDebugStringA(str);
		}
	}
}