// ShmMgr.h: interface for the CShmLogMgr class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SHMMGR_LOGGER_H__D6FD0559_46F1_4D99_8996_9538EF2A0EFA__INCLUDED_)
#define AFX_SHMMGR_LOGGER_H__D6FD0559_46F1_4D99_8996_9538EF2A0EFA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Appender.h"


class CShmLogMgr  
{
public:
	void ProcessLogs();
	virtual ~CShmLogMgr();

	void SetLogAppender(CAppender* p); 
 
	static CShmLogMgr* CreateServer(PVOID addr, ULONG size, std::string& strPrefix,CAppender* pLogAppender);
	static CShmLogMgr* CreateClient(PVOID addr, ULONG size, std::string& strPrefix);

	virtual void Delete()	{delete this;	}
	inline operator bool () const {return m_bIsValid;}

	//
	// OPERATIONS
	//
	
	bool WriteString (std::vector<char>& data);
	void StopLogger();


private:

//
// Server side constructor
//
	CShmLogMgr(bool bIsServer, 
			PVOID MemoryAddress, 
			ULONG MemorySize,
			std::string& KeyPrefix,
			CAppender*pAppender);

//
// Client side constructor
//
	CShmLogMgr(PVOID MemoryAddress, 
			ULONG MemorySize,
			std::string& KeyPrefix);

	CShmLogMgr()
	{
		//
		// We should not use the defulat constructor
		//
		  throw std::exception("CShmLogMgr default constructor is not allowed");
	}

  	bool WriteToBuffer(std::vector<char>& data, 
						bool bFragmented=false, 
						bool endFragment=true);
	
	bool ReadOneEntry(std::vector<char>& entry);
	void ProcessEntry(PLOG_ENTRY);


	LOGBUFFER*		m_ShmBuffer;
	ULONG			m_MaxSize;
	bool			m_bIsValid;
	bool			m_bIsServer;
	volatile bool            m_bStop;



	CMclSemaphoreAutoPtr	m_LogEntrySemPtr;
	CMclSemaphoreAutoPtr	m_LogSpaceSemPtr;
	CMclEvent				m_StopNotify;
	CMclEvent				m_StopAck;
	std::string				m_strKeyPrefix;


	CAppender				*m_pLogAppender;
 
};

#endif // !defined(AFX_SHMMGR_LOGGER_H__D6FD0559_46F1_4D99_8996_9538EF2A0EFA__INCLUDED_)
