// ShmMgr.cpp: implementation of the CShmMgr class.
//
//////////////////////////////////////////////////////////////////////
//
// PROJECT INCLUDE
//
#include <windows.h>
#include "LogDef.h"
#include "ShmMgr.h"
#include <sstream>
#include "ServerSecurityAttribute.h"
using namespace std;
 
 
 
//////////////////////////////////////////////////////////////////////////////
//
//	SHM Manager code
//
//

CShmMgr * CShmMgr::m_ServerInstance=NULL;
CShmMgr * CShmMgr::m_ClientInstance=NULL;


CShmMgr& CShmMgr::ServerInstance()
{
	if(!m_ServerInstance) 
	{
		m_ServerInstance=new CShmMgr(true);
	}
	return *m_ServerInstance;
}

CShmMgr& CShmMgr::ClientInstance()
{
	if(!m_ClientInstance) 
	{
		m_ClientInstance=new CShmMgr(false);
	}
	return *m_ClientInstance;
}

void CShmMgr::CleanupServerInstance()
{
	delete m_ServerInstance;

}
void CShmMgr::CleanupClientInstance()
{
	delete m_ClientInstance;
}



CShmMgr::CShmMgr(bool bIsServe):m_hFileMap(NULL),m_pView(NULL)
{
	m_bIsValid=false;
	m_size=LOGBUFFER_SIZE;
	
	if (bIsServe)
	{
		m_hFileMap=CreateFileMapping(INVALID_HANDLE_VALUE,
			CServerSecurityAttribute::NotQuitNullOne().GetNewsSecurityAttribute(),
										PAGE_READWRITE,
										0,
										m_size,
										TEXT(MAGIC_STRING));

		if (m_hFileMap!=NULL)
		{
			if (GetLastError()==ERROR_ALREADY_EXISTS)
			{
				//
				// Mapping is already there
				//
				CloseHandle(m_hFileMap);
				return;
			}

			m_pView= MapViewOfFile(m_hFileMap,
										FILE_MAP_READ|FILE_MAP_WRITE,
										0,
										0,
										0);
 
			m_bIsValid=m_pView!=NULL;
		}
		else
		{
			OutputDebugStringA("Unable to create the memory map");
		}
	}
	else
	{
		m_hFileMap=OpenFileMapping(FILE_MAP_READ|FILE_MAP_WRITE,
										FALSE,
										TEXT(MAGIC_STRING));

		if (m_hFileMap!=NULL)
		{
			m_pView= MapViewOfFile(m_hFileMap,
										FILE_MAP_READ|FILE_MAP_WRITE,
										0,
										0,
										0);

			m_bIsValid=m_pView!=NULL;
		}
		else
		{
			ostringstream os;
			os<<"Fail to open the shared memory:"<<GetLastError()<<endl;
			OutputDebugStringA(os.str().c_str());
		}
	}

}

CShmMgr::~CShmMgr()
{
	if (m_pView)
	{
		UnmapViewOfFile(m_pView);
	}

	if (m_hFileMap)
	{
		CloseHandle(m_hFileMap);
	}
}


