// TeeferTalk.cpp: implementation of the CTeeferTalk class.
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "tfman.h"
#include "TeeferTalk.h"


#include <string>
using namespace std;


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTeeferTalk::CTeeferTalk()
{
	m_hTeeferHandle=NULL;
}

CTeeferTalk::~CTeeferTalk()
{
	if (m_hTeeferHandle)
	{
		TeeferClose(m_hTeeferHandle);
	}

}

CTeeferTalk& CTeeferTalk::Instance()
{
	static CTeeferTalk obj;
	return obj;
}

bool CTeeferTalk::IsTeeFerInstalled()
{
	return TeeferIsInstall()==TRUE;
}

bool CTeeferTalk::OpenDriver()
{
	if (!TeeferIsInstall())
		return false;
	
 	char DummyName[250];
	strcpy(DummyName,"0");

	FUNC_TEEFER_PacketCallback pCallback = CTeeferTalk::TeererCallBack;

	m_hTeeferHandle=TeeferOpen(FALSE, 
						DummyName, 
						0x100000, 
						0x100000, 
						pCallback, 
						(void*)01234);

	if (m_hTeeferHandle==NULL)
	{
		return false;
	}

	//
	// Allow both input and output
	//
    if (TeeferSetMode(m_hTeeferHandle, TRUE, TRUE)==TEEFER_ERR)
    {
		OutputDebugStringA("Unable to set the driver mode");
		return false;
	}

	TeeferApplyRuleTable(m_hTeeferHandle, TRUE);


	//
	// Set the rules to upload all the packets
	//

	TEEFER_RULE rule[2];
	rule[0].Action = TEEFER_RULE_ACTION_EXAMINE;
    rule[0].ProtocolDriverType = TEEFER_RULE_PROTOCOLTYPE_ANY;
    rule[0].ProtocolDriverPath[0] = 0;
    rule[0].ProtocolDriverId = TEEFER_RULE_PROTOCOLID_ANY;
    rule[0].InterfaceDriverId = TEEFER_RULE_INTERFACEID_ANY;
    rule[0].PacketType = TEEFER_RULE_PACKETTYPE_ANY;
    rule[0].TrafficDirection = TEEFER_RULE_DIRECTION_ANY ;
    int ret=TeeferSetRuleTable( m_hTeeferHandle,rule,1);

	return true;

 
}

int __cdecl CTeeferTalk::TeererCallBack(unsigned nProtocolid, 
										unsigned nInterfaceid, 
										void*p, 
										unsigned len, 
										unsigned dwProcessId, 
										BOOL bIsSending, 
										BOOL bDonotBlock, 
										void*pControl, 
										unsigned pControlLen, 
										void *pContext)
{


	return TRUE;
}

