// file DBGIOS.H

/*++
*************************************************************************
+-----------------------------------------------------------------------+
|  Copyright (C) SYBERGEN, INC. 2004                                    |
|      All Rights Reserved.                                             |
| Reproduction, adaptation, or translation without prior written        |
| permission is prohibited, except as allowed under Copyright laws.     |
|                                                                       |
| N O T I C E                                                           |
|                                                                       |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC.                     |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED.                             |
+-----------------------------------------------------------------------+
*************************************************************************
--*/



#ifndef DBGIOS_H
#define DBGIOS_H

#define MAX_DIOS_HEADERSIZE	 512 // BYTES
#define MAX_DIOS_DATASIZE	 (1<<18) // 256KB

#define DIOS_HEADERSIZE		 0
#define DIOS_VERSION		 1
#define DIOS_DEBUGLEVEL		 2
#define DIOS_RESERVED		 3
#define DIOS_TXCOUNT		 4
#define DIOS_TXDROP			 5
#define DIOS_TXPASS			 6
#define DIOS_TXLATENCYMIN	 7
#define DIOS_TXLATENCYMAX	 8
#define DIOS_TXLATENCYAVG	 9
#define DIOS_RXCOUNT		10
#define DIOS_RXDROP			11
#define DIOS_RXPASS			12
#define DIOS_RXLATENCYMIN	13
#define DIOS_RXLATENCYMAX	14
#define DIOS_RXLATENCYAVG	15

typedef struct _DEVICE_DBGIOS {
    unsigned int       header[MAX_DIOS_HEADERSIZE>>2];
	unsigned long	   flags;
	unsigned long	   head;
	unsigned long	   tail;
    unsigned long      data_len;
    unsigned char      data[MAX_DIOS_DATASIZE];
}   DEVICE_DBGIOS, *PDEVICE_DBGIOS;

int DbgiosInit(PDEVICE_DBGIOS pd);

int DbgiosSetInfo(int field, int value);
int DbgiosGetInfo(char *info, int *len);

int sysprint(char *format, ...);

#endif

// end of DBGIOS.H
