// file ShareDef.H

/*++
*************************************************************************
+-----------------------------------------------------------------------+
|  Copyright (C) SYBERGEN, INC. 1998                                    |
|      All Rights Reserved.                                             |
| Reproduction, adaptation, or translation without prior written        |
| permission is prohibited, except as allowed under Copyright laws.     |
|                                                                       |
| N O T I C E                                                           |
|                                                                       |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC.                     |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED.                             |
+-----------------------------------------------------------------------+
*************************************************************************
--*/

#ifndef TEEFERSHAREDEF_H
#define TEEFERSHAREDEF_H

/*
#define PI_PROTOCOL_NAME_MAX_LENGTH           64
#define PI_PROTOCOL_DESCRIPTION_MAX_LENGTH    128

#define AI_ADAPTER_NAME_MAX_LENGTH            132
#define AI_MAC_NAME_MAX_LENGTH                32
#define AI_ADAPTER_DESCRIPTION_MAX_LENGTH     132
#define MAX_PROTOCOL_INFO                     64
#define MAX_PROTOCOL_PATH                     260

#define NAI_ADAPTER_NAME_MAX_LENGTH           64
#define NAI_MAC_NAME_MAX_LENGTH               32
#define NAI_ADAPTER_DESCRIPTION_MAX_LENGTH    132
#define PROTOCOL_MAX_ADAPTER                  16
*/

#include "packon1.h"

typedef LARGE_INTEGER    STAT_TYPE;
typedef struct _NDIS_PACKET_STAT {
    STAT_TYPE                       SendExamineBytesCount;
    STAT_TYPE                       SendExaminePacketCount;
    STAT_TYPE                       ReceiveExamineBytesCount;
    STAT_TYPE                       ReceiveExaminePacketCount;
    STAT_TYPE                       SendExamineDispatchedBytesCount;
    STAT_TYPE                       SendExamineDispatchedPacketCount;
    STAT_TYPE                       ReceiveExamineDispatchedBytesCount;
    STAT_TYPE                       ReceiveExamineDispatchedPacketCount;
    STAT_TYPE                       SendBlockBytesCount;
    STAT_TYPE                       SendBlockPacketCount;
    STAT_TYPE                       ReceiveBlockBytesCount;
    STAT_TYPE                       ReceiveBlockPacketCount;
    STAT_TYPE                       SendPassBytesCount;
    STAT_TYPE                       SendPassPacketCount;
    STAT_TYPE                       ReceivePassBytesCount;
    STAT_TYPE                       ReceivePassPacketCount;
}   NDIS_PACKET_STAT, *PNDIS_PACKET_STAT;


typedef enum {
    TEEFER_RULE_ACTION_BLOCK = 0,
    TEEFER_RULE_ACTION_EXAMINE,
    TEEFER_RULE_ACTION_PASS
} RULE_ACTION, *PRULE_ACTION;


#define  TEEFER_RULE_MAX_COUNT                      300
#define  TEEFER_RULE_BYTE_ANY                       255

#define  TEEFER_RULE_PACKETTYPE_ANY                 255
#define  TEEFER_RULE_PACKETTYPE_EXAMINE_CONTENT     0

#define  TEEFER_RULE_ETHTYPE_ANY                    255


#define  TEEFER_RULE_IPTYPE_ANY                     255
#define  TEEFER_RULE_IPTYPE_TCP                     IPPROTO_TCP
#define  TEEFER_RULE_IPTYPE_UDP                     IPPROTO_UDP
#define  TEEFER_RULE_IPTYPE_ICMP                    IPPROTO_ICMP   

#define  TEEFER_RULE_DIRECTION_ANY                  255
#define  TEEFER_RULE_DIRECTION_INCOMING             0
#define  TEEFER_RULE_DIRECTION_OUTGOING             1

#define  TEEFER_RULE_PROTOCOLID_ANY                 255
#define  TEEFER_RULE_PROTOCOLID_UNDEFINED           254

#define  TEEFER_RULE_INTERFACEID_ANY                255

#define  TEEFER_RULE_PROTOCOLTYPE_ANY               255
#define  TEEFER_RULE_PROTOCOLTYPE_TCPIP_STACK       0     // stardard tcpip and rasarp(NT only)
#define  TEEFER_RULE_PROTOCOLTYPE_NONTCPIP_STACK    1     // all additional and 3rd party protocols
#define  TEEFER_RULE_PROTOCOLTYPE_WAN               0x80  // protocol WAN type

#define  TEEFER_RULE_ETHTYPE_IP               0x08  // protocol IP type
#define  TEEFER_RULE_ETHTYPE_ARP              0x0608  // protocol IP type


typedef struct
{
    // Condition for packet content
    UCHAR      SrcMac[6];          // "00-00-00-00-00-00" means any
    UCHAR      DstMac[6];          // "00-00-00-00-00-00" means any
    UINT       SrcSubnetAddr;      // define the source ip subnet,
                                   // 0.0.0.0 means any srcip
    UINT       SrcSubnetMask;
    UINT       DstSubnetAddr;      // define the destionation ip subnet,
                                   // 0.0.0.0 means any dstip
    UINT       DstSubnetMask;
    USHORT     SrcPortLow;         // "TCP/UDP source port" or icmp_type range
                                   // - low, for IpType == TCP/UDP/ICMP only
    USHORT     SrcPortHigh;        // "TCP/UDP source port" or icmp_type range
                                   // - high, for IpType == TCP/UDP/ICMP only
    USHORT     DstPortLow;         // "TCP/UDP destination port" or icmp_code
                                   // range - low, IpType == TCP/UDP/ICMP only
    USHORT     DstPortHigh;        // "TCP/UDP destination port" or icmp_code
                                   // range - high, IpType == TCP/UDP/ICMP only
    USHORT     EthType;            // TEEFER_ETHTYPE_ANY means any
    UCHAR      TrafficDirection;   // TEEFER_DIRECTION_ANY means any

    // Condition for non packet content (interface or protocol driver level)
    UCHAR      PacketType;         // TEEFER_PACKETTYPE_ANY match all packets
    UCHAR      InterfaceDriverId;  // TEEFER_INTERFACEID_ANY means any
    UCHAR      ProtocolDriverId;   // Reserved for ring0 level(DO NOT use in ring3)
    UCHAR      ProtocolDriverType; // TEEFER_PROTOCOLTYPE_ANY means any
    UCHAR      IpType;             // TEEFER_IPTYPE_ANY means any
    CHAR       ProtocolDriverPath[260*2];  // full path to protocol driver
    
    // ------- Action while packet matches the condition ----------
    UINT       Action;			// see TEEFER_RULE_ACTION_XXXXX 
    UINT       uiReserved[4];
} TEEFER_RULE, *PTEEFER_RULE;


#include "packoff1.h"

#endif

// end of SHAREDEF.H
