// file tcpip.h

/*++
*************************************************************************
+-----------------------------------------------------------------------+
|  Copyright (C) SYBERGEN, INC. 1998                                    |
|      All Rights Reserved.                                             |
| Reproduction, adaptation, or translation without prior written        |
| permission is prohibited, except as allowed under Copyright laws.     |
|                                                                       |
| N O T I C E                                                           |
|                                                                       |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC.                     |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED.                             |
+-----------------------------------------------------------------------+
*************************************************************************
--*/



#ifndef TCPIP_H
#define TCPIP_H

// set the struct alignment=1
#ifdef _MSC_VER
#pragma pack(push,1)
#endif

typedef unsigned short            NWORD;    // Network Word
typedef UINT                      NDWORD;   // Network DWord

typedef struct
{
	UCHAR	DestAddr[6];
	UCHAR	SourAddr[6];
	NWORD	Type;
} SEtherII_FrameHead;
#ifdef _MSC_VER
#pragma pack(pop)
#endif

// set the struct alignment=1
#ifdef _MSC_VER
#pragma pack(push,1)
#endif

#define	IEEE8023LEN	0x05EE

typedef struct
{
	UCHAR	DSAP;
	UCHAR	SSAP;
	UCHAR	CONTROL;
	UCHAR	OUI[3];
	NWORD	Type;
} S8022SNAP_FrameHead;
#ifdef _MSC_VER
#pragma pack(pop)
#endif

// set the struct alignment=1
#ifdef _MSC_VER
#pragma pack(push,1)
#endif
typedef struct
{
	UCHAR		Vers_Hlen;
	UCHAR		ServiceType;
	NWORD		TotalLength;
	NWORD		Identification;
	USHORT      Flags_FragmentOffset;
	UCHAR		TimeToLive;
	UCHAR		Protocol;
	NWORD		HeadChecksum;
	UINT		SourAddr;
	UINT		DestAddr;
	UCHAR		Options;
	UCHAR		OptionsLength;
} SIp4_FrameHead;
#ifdef _MSC_VER
#pragma pack(pop)
#endif
// restore struct alignment before

// set the struct alignment=1
#ifdef _MSC_VER
#pragma pack(push,1)
#endif
typedef struct
{
	NWORD		SourPort;
	NWORD		DestPort;
	NWORD		Length;
	NWORD		Checksum;
} SUdp_FrameHead;
#ifdef _MSC_VER
#pragma pack(pop)
#endif
// restore struct alignment before

// set the struct alignment=1
#ifdef _MSC_VER
#pragma pack(push,1)
#endif
typedef struct
{
	NWORD		SourPort;
	NWORD		DestPort;
	NDWORD		SeqNumber;		// Sequence Number
	NDWORD		AckNumber;		// Acknowledgment Number
	USHORT		Offset_Flags;	// Offset is number of TCP head 32bit
	NWORD		Window;
	NWORD		Checksum;
	NWORD		UrgentPointer;
} STcpSegment_FrameHead;
#ifdef _MSC_VER
#pragma pack(pop)
#endif
// restore struct alignment before

#define TCP_FLAGS_URG	0x2000
#define TCP_FLAGS_ACK	0x1000
#define TCP_FLAGS_PSH   0x800
#define TCP_FLAGS_RST	0x400
#define TCP_FLAGS_SYN	0x200
#define TCP_FLAGS_FIN	0x100

#define ETHENRET_PROTOCOL_IP_TYPE		0x800
#define IP_PROTOCOL_TCP_TYPE			0x6
#define IP_PROTOCOL_UDP_TYPE			0x11
#define IP_PROTOCOL_ICMP_TYPE			0x1
#define IP_PROTOCOL_GRE_TYPE			0x2f

_inline UINT TODWORD(NDWORD a)
{
    return ( ((a>>24)&0x000000FFL) + ((a>>8)&0x0000FF00L) + ((a<<8)&0x00FF0000L) 
        + ((a<<24)&0xFF000000L) );
}

_inline unsigned short TOWORD(NWORD a)
{
    return (unsigned short)( ((a>>8)&0x00FFL) + ((a<<8)&0xFF00L) );
}

_inline NDWORD TONDWORD(UINT a)
{
    return ( ((a>>24)&0x000000FFL) + ((a>>8)&0x0000FF00L) + ((a<<8)&0x00FF0000L) 
        + ((a<<24)&0xFF000000L) );
}

_inline NWORD TONWORD(unsigned short a)
{
    return (unsigned short)( ((a>>8)&0x00FFL) + ((a<<8)&0xFF00L) );
}

#endif

// restore struct alignment before
