/*++
*************************************************************************
+-----------------------------------------------------------------------+
|  Copyright 1998-2001 by Sygate Technologies, Inc.                     |
|      All Rights Reserved.                                             |
| Reproduction, adaptation, or translation without prior written        |
| permission is prohibited, except as allowed under Copyright laws.     |
|                                                                       |
| N O T I C E                                                           |
|                                                                       |
| THIS MATERIAL IS A TRADE SECRET OF SYGATE Techlogies, INC.            |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED.                             |
+-----------------------------------------------------------------------+
*************************************************************************
--*/

/*++
 *
 * $Author: yyeap $
 * $Date: 2003/01/17 22:37:40 $
 * $Revision: 1.22 $
 * $Workfile: Teefer.c $
 * $Log: Tffun.c,v $
 * Revision 1.22  2003/01/17 22:37:40  yyeap
 * no message
 *
 * Revision 1.21  2003/01/16 00:10:33  yyeap
 * Check in new teefer loader class
 *
 * Revision 1.20  2003/01/15 23:16:09  yyeap
 * Check in new teefer loader class
 *
 * Revision 1.19  2003/01/03 01:15:44  yyeap
 * Check in IP Spoofing in driver
 *
 * Revision 1.18  2002/12/03 23:29:42  yyeap
 * Check in allow initial traffic feature
 *
 * Revision 1.17  2002/10/03 02:13:53  yyeap
 * Limit the restore open handle code to after receiving
 * NDIS_STATUS_MEDIA_CONNECT only.
 *
 * Revision 1.16  2002/10/01 22:55:02  yyeap
 * no message
 *
 * Revision 1.15  2002/10/01 21:18:34  yyeap
 * Fix a win2k ndissend not work on a dlink card bug.  This card will get a
 * NdisMFakeSend during boot and later switch to the real NdisMSend
 * after receiving a NDIS_STATUS_LINE_UP.
 *
 * Revision 1.14  2002/10/01 21:08:23  yyeap
 * Fix a win2k ndissend not work on a dlink card bug.  This card will get a
 * NdisMFakeSend during boot and later switch to the real NdisMSend
 * after receiving a NDIS_STATUS_LINE_UP.
 *
 * Revision 1.13  2002/08/15 22:28:43  yyeap
 * Merge bug fixes from 3.0 branch
 *
 * Revision 1.11.4.4  2002/08/12 18:02:01  yyeap
 * Fix a block all traffic code conflict with watchdog function
 *
 * Revision 1.12.2.1  2002/08/12 17:58:33  yyeap
 * Merged driver Watchdog code from 3.0 branch
 *
 * Revision 1.11.4.3  2002/08/10 23:21:28  yyeap
 * Added WatchDog function in Win9x Driver
 *
 * Revision 1.11.4.2  2002/08/10 17:02:39  yyeap
 * no message
 *
 * Revision 1.11.4.1  2002/04/23 23:09:25  yyeap
 * Check in infrared fix
 *
 * Revision 1.12  2002/04/10 23:57:21  yyeap
 * Fix Infrared driver not working under WinNt platform bug
 *
 * Revision 1.11  2002/03/01 01:33:49  yyeap
 * Check in AllowInitTraffic modification and fixed lots of bugs in the
 * rule engine
 *
 * Revision 1.10  2002/01/07 21:04:45  yyeap
 * Close the back door for ARP
 *
 * Revision 1.9  2002/01/02 23:43:36  yyeap
 * Check in PPTP BSOD fix
 *
 * Revision 1.8  2001/12/11 01:06:56  yyeap
 * Fix teefer corrupt NetXray packets bug
 *
 * Revision 1.7  2001/12/07 00:43:17  yyeap
 * Hook TransferData to provide data to Receive function when MacContext
 * is expired.
 *
 * Revision 1.6  2001/11/29 21:35:51  yyeap
 * Fix bug in Transferdata before service start.
 *
 * Revision 1.5  2001/11/29 00:59:02  yyeap
 * Check in support to read default rules from registry
 *
 * Revision 1.4  2001/11/20 21:45:13  yyeap
 * Remove int 3
 *
 * Revision 1.3  2001/11/20 03:11:59  yyeap
 * Check in misc bug fixes
 *
 * Revision 1.1  2001/11/02 22:27:12  yyeap
 * no message
 *
 * 
 * $NoKeywords: $
 *
--*/

#ifdef WINNT

    #include "stdarg.h"
    #include "ntddk.h"
    #include "ntiologc.h"
    #include "ndis.h"
    #include "packet.H"
    #include "debug.H"
    #include "..\common\sharedef.h"
    #include "..\common\protocol.h"
	#include "process.H"

#else // WINNT

    #define  USE_NDIS
    #include <vtoolsc.h>
    #include <ndis.h>
    #define  DEVICE_MAIN 
    #include "..\common\pktfifo.h"
    #include "TEEFER.H"
    #include "..\common\sharedef.h"
    #include "..\common\protocol.h"

#endif // NOT WINNT

#undef   DEVICE_MAIN
#include "..\common\tcpip.h"
#include "..\common\tffun.h"
#include "..\common\checksum.h"

#define DISPATCH_TO_WAN_OR_ETHER_HANDLER(PPROTINFO, WAN_HANDLE, ETHER_HANDLE) \
{                                                                             \
    _asm   mov   eax, PPROTINFO                                               \
    _asm   test  dword ptr [eax].nProtocolType, TEEFER_RULE_PROTOCOLTYPE_WAN  \
    _asm   jnz   WAN_HANDLE                                                   \
    _asm   jmp   ETHER_HANDLE                                                 \
}


extern PLOWER_CONTEXT      g_MyOpen;

static NDIS_PROTOCOL_INFO         g_sProtInfo0;
static NDIS_PROTOCOL_INFO         g_sProtInfo1;
static NDIS_PROTOCOL_INFO         g_sProtInfo2;
static NDIS_PROTOCOL_INFO         g_sProtInfo3;
static NDIS_PROTOCOL_INFO         g_sProtInfo4;
static NDIS_PROTOCOL_INFO         g_sProtInfo5;
static NDIS_PROTOCOL_INFO         g_sProtInfo6;
static NDIS_PROTOCOL_INFO         g_sProtInfo7;
static NDIS_PROTOCOL_INFO         g_sProtInfo8;
static NDIS_PROTOCOL_INFO         g_sProtInfo9;
static NDIS_PROTOCOL_INFO         g_sProtInfo10;
static NDIS_PROTOCOL_INFO         g_sProtInfo11;
static NDIS_PROTOCOL_INFO         g_sProtInfo12;
static NDIS_PROTOCOL_INFO         g_sProtInfo13;
static NDIS_PROTOCOL_INFO         g_sProtInfo14;
static NDIS_PROTOCOL_INFO         g_sProtInfo15;
static NDIS_PROTOCOL_INFO         g_sProtInfo16;
static NDIS_PROTOCOL_INFO         g_sProtInfo17;
static NDIS_PROTOCOL_INFO         g_sProtInfo18;
static NDIS_PROTOCOL_INFO         g_sProtInfo19;
static NDIS_PROTOCOL_INFO         g_sProtInfo20;
static NDIS_PROTOCOL_INFO         g_sProtInfo21;
static NDIS_PROTOCOL_INFO         g_sProtInfo22;
static NDIS_PROTOCOL_INFO         g_sProtInfo23;
static NDIS_PROTOCOL_INFO         g_sProtInfo24;
static NDIS_PROTOCOL_INFO         g_sProtInfo25;
static NDIS_PROTOCOL_INFO         g_sProtInfo26;
static NDIS_PROTOCOL_INFO         g_sProtInfo27;
static NDIS_PROTOCOL_INFO         g_sProtInfo28;
static NDIS_PROTOCOL_INFO         g_sProtInfo29;
static NDIS_PROTOCOL_INFO         g_sProtInfo30;
static NDIS_PROTOCOL_INFO         g_sProtInfo31;
static NDIS_PROTOCOL_INFO         g_sProtInfo32;
static NDIS_PROTOCOL_INFO         g_sProtInfo33;
static NDIS_PROTOCOL_INFO         g_sProtInfo34;
static NDIS_PROTOCOL_INFO         g_sProtInfo35;
static NDIS_PROTOCOL_INFO         g_sProtInfo36;
static NDIS_PROTOCOL_INFO         g_sProtInfo37;
static NDIS_PROTOCOL_INFO         g_sProtInfo38;
static NDIS_PROTOCOL_INFO         g_sProtInfo39;
static NDIS_PROTOCOL_INFO         g_sProtInfo40;
static NDIS_PROTOCOL_INFO         g_sProtInfo41;
static NDIS_PROTOCOL_INFO         g_sProtInfo42;
static NDIS_PROTOCOL_INFO         g_sProtInfo43;
static NDIS_PROTOCOL_INFO         g_sProtInfo44;
static NDIS_PROTOCOL_INFO         g_sProtInfo45;
static NDIS_PROTOCOL_INFO         g_sProtInfo46;
static NDIS_PROTOCOL_INFO         g_sProtInfo47;
static NDIS_PROTOCOL_INFO         g_sProtInfo48;
static NDIS_PROTOCOL_INFO         g_sProtInfo49;
static NDIS_PROTOCOL_INFO         g_sProtInfo50;
static NDIS_PROTOCOL_INFO         g_sProtInfo51;
static NDIS_PROTOCOL_INFO         g_sProtInfo52;
static NDIS_PROTOCOL_INFO         g_sProtInfo53;
static NDIS_PROTOCOL_INFO         g_sProtInfo54;
static NDIS_PROTOCOL_INFO         g_sProtInfo55;
static NDIS_PROTOCOL_INFO         g_sProtInfo56;
static NDIS_PROTOCOL_INFO         g_sProtInfo57;
static NDIS_PROTOCOL_INFO         g_sProtInfo58;
static NDIS_PROTOCOL_INFO         g_sProtInfo59;
static NDIS_PROTOCOL_INFO         g_sProtInfo60;
static NDIS_PROTOCOL_INFO         g_sProtInfo61;
static NDIS_PROTOCOL_INFO         g_sProtInfo62;
static NDIS_PROTOCOL_INFO         g_sProtInfo63;

UINT                       g_TeeferInitRuleCount = 0;
UINT                       g_TeeferInitRuleTableSize = 0;
PTEEFER_RULE               g_TeeferInitRuleTable = NULL;
UINT                       g_TeeferRuleCount = 0;
UINT                       g_TeeferRuleTableSize = 0;
PTEEFER_RULE               g_TeeferRuleTable = NULL;
PNDIS_PROTOCOL_INFO        g_pTcpIpProtocolInfo = NULL;
PNDIS_PROTOCOL_INFO        g_pRasArpProtocolInfo = NULL;
UINT                       g_nNumberProtocol = 0;
UINT                       g_bInterfaceListHasChanged = FALSE;
UINT                       g_dwMySeed = 0;


PNDIS_PROTOCOL_INFO        g_pProtocolInfo[] = 
    {
        &g_sProtInfo0,
        &g_sProtInfo1,
        &g_sProtInfo2,
        &g_sProtInfo3,
        &g_sProtInfo4,
        &g_sProtInfo5,
        &g_sProtInfo6,
        &g_sProtInfo7,
        &g_sProtInfo8,
        &g_sProtInfo10,
        &g_sProtInfo11,
        &g_sProtInfo12,
        &g_sProtInfo13,
        &g_sProtInfo14,
        &g_sProtInfo15,
        &g_sProtInfo16,
        &g_sProtInfo17,
        &g_sProtInfo18,
        &g_sProtInfo19,
        &g_sProtInfo19,
        &g_sProtInfo20,
        &g_sProtInfo21,
        &g_sProtInfo22,
        &g_sProtInfo23,
        &g_sProtInfo24,
        &g_sProtInfo25,
        &g_sProtInfo26,
        &g_sProtInfo27,
        &g_sProtInfo28,
        &g_sProtInfo29,
        &g_sProtInfo30,
        &g_sProtInfo31,
        &g_sProtInfo32,
        &g_sProtInfo33,
        &g_sProtInfo34,
        &g_sProtInfo35,
        &g_sProtInfo36,
        &g_sProtInfo37,
        &g_sProtInfo38,
        &g_sProtInfo39,
        &g_sProtInfo40,
        &g_sProtInfo41,
        &g_sProtInfo42,
        &g_sProtInfo43,
        &g_sProtInfo44,
        &g_sProtInfo45,
        &g_sProtInfo46,
        &g_sProtInfo47,
        &g_sProtInfo48,
        &g_sProtInfo49,
        &g_sProtInfo50,
        &g_sProtInfo51,
        &g_sProtInfo52,
        &g_sProtInfo53,
        &g_sProtInfo54,
        &g_sProtInfo55,
        &g_sProtInfo56,
        &g_sProtInfo57,
        &g_sProtInfo58,
        &g_sProtInfo59,
        &g_sProtInfo60,
        &g_sProtInfo61,
        &g_sProtInfo62,
        &g_sProtInfo63,
        NULL
    };

// for bAllowProtocolTraffic 
CHAR g_pStringPool[MAX_NUMOFSTRINGPOOL][128] = {0};

// for teefer  802.1x special rule
TEEFER_RULE gTeefer8021xRule = {0};

//     Utils
LIST_ENTRY g_MediaType = { &g_MediaType, &g_MediaType };

void MediumAdd(PVOID arg, NDIS_MEDIUM NdisMedium)
{
    NDIS_PHYSICAL_ADDRESS highestAddress = {-1};
    struct LIST_MEDIUM *p;

    if (NdisAllocateMemory(&p, sizeof(struct LIST_MEDIUM), 0, highestAddress) == NDIS_STATUS_SUCCESS)
	{
		p->arg = arg;
		p->NdisMedium = NdisMedium;
		InsertHeadList(&g_MediaType, &p->Next);
	}
}

struct LIST_MEDIUM *MediumFind(PVOID arg)
{
	PLIST_ENTRY p;
	for (p = g_MediaType.Flink; p != &g_MediaType; p = p->Flink)
	{
		struct LIST_MEDIUM *m = CONTAINING_RECORD(p, struct LIST_MEDIUM, Next);
		if (m->arg == arg)
			return m;
	}
	return NULL;
}

void MediumDelete(struct LIST_MEDIUM *p)
{
	RemoveEntryList(&p->Next);
	NdisFreeMemory(p, sizeof(struct LIST_MEDIUM), 0);
}

BOOLEAN
IsTcpIpProtocolInfo(
    IN PNDIS_PROTOCOL_INFO pProtocolInfo
    )
{
    return pProtocolInfo==g_pTcpIpProtocolInfo;
}


BOOLEAN
IsRasArpProtocolInfo(
    IN PNDIS_PROTOCOL_INFO pProtocolInfo
    )
{
    return pProtocolInfo==g_pRasArpProtocolInfo;
}


UINT
GetProtocolIdFromProtocolPathName(
    IN PCHAR szPath
    )
{
#ifdef WINNT
    ANSI_STRING asSrc;
    ANSI_STRING asDst;
    INT i = 0;
    char szTmpFullPath[260];

    if (szPath==NULL || *szPath==0)
        return TEEFER_RULE_PROTOCOLID_ANY;

    NdisInitAnsiString(&asSrc, szPath);
    for (i=0; i<MAX_PROTOCOL_INFO; i++)
    {
        if (g_pProtocolInfo[i]==NULL)
            break;
	if (DriverGetFullPathName(g_pProtocolInfo[i]->szProtocolPath,
	    szTmpFullPath))
            NdisInitAnsiString(&asDst, szTmpFullPath);
        else
            NdisInitAnsiString(&asDst, g_pProtocolInfo[i]->szProtocolPath);
        if (RtlEqualString(&asDst, &asSrc, TRUE))
            return i;
    }
    return TEEFER_RULE_PROTOCOLID_UNDEFINED;
#else
    INT i = 0;
    if (szPath==NULL || *szPath==0)
        return TEEFER_RULE_PROTOCOLID_ANY;

    for (i=0; i<MAX_PROTOCOL_INFO; i++)
    {
        if (g_pProtocolInfo[i]==NULL)
            break;
        if (!stricmp(g_pProtocolInfo[i]->szProtocolPath, szPath))
            return i;
    }
    return TEEFER_RULE_PROTOCOLID_UNDEFINED;
#endif
}


BOOLEAN
MapAllProtocolNamesInRuleTableToIds(
    VOID
    )
{
    UINT i;
    if (g_TeeferRuleTable==NULL && g_TeeferInitRuleTable==NULL)
        return FALSE;
    if (g_TeeferRuleCount==0 && g_TeeferInitRuleCount==0)
        return TRUE;

    if (g_TeeferRuleTable)
    {
        for (i=0; i<g_TeeferRuleCount; i++)
        {
            g_TeeferRuleTable[i].ProtocolDriverId =
                GetProtocolIdFromProtocolPathName(
                    g_TeeferRuleTable[i].ProtocolDriverPath
                    );
            IF_VERY_LOUD(DbgPrint("TEEFER: Mapping protocol[%d] %s to %d\n",
                i,
                g_TeeferRuleTable[i].ProtocolDriverPath,
                g_TeeferRuleTable[i].ProtocolDriverId
                );)
        }
    }

    if (g_TeeferInitRuleTable)
    {
        for (i=0; i<g_TeeferInitRuleCount; i++)
        {
            g_TeeferInitRuleTable[i].ProtocolDriverId =
                GetProtocolIdFromProtocolPathName(
                    g_TeeferInitRuleTable[i].ProtocolDriverPath
                    );
            IF_VERY_LOUD(DbgPrint("TEEFER: Mapping init protocol[%d] %s to %d\n",
                i,
                g_TeeferInitRuleTable[i].ProtocolDriverPath,
                g_TeeferInitRuleTable[i].ProtocolDriverId
                );)
        }
    }

    return TRUE;
}


BOOLEAN
TeeferGetRuleTable(
    PTEEFER_RULE pRuleTable,
    UINT uRuleTableSize,
    PUINT puOutRuleCount,
    PUINT puTotalRuleCount
    )
{
    UINT n;
    // calcucate how many rules
    if (g_TeeferRuleTable==NULL)
    {
        return FALSE;
    }
    MapAllProtocolNamesInRuleTableToIds();
    n = uRuleTableSize / sizeof(TEEFER_RULE);
    if ( n > g_TeeferRuleCount )
        n = g_TeeferRuleCount;
    
    NdisMoveMemory(pRuleTable, g_TeeferRuleTable, n*sizeof(TEEFER_RULE));
    *puOutRuleCount = n;
    *puTotalRuleCount = g_TeeferRuleCount;
    
    return TRUE;
}


/*
BOOLEAN
TeeferSetRuleAt(
    PTEEFER_RULE pRule,
    UINT uRuleSize,
    UINT uRuleAt
    )
{
    if (g_TeeferRuleCount < uRuleAt)
        return FALSE;

    NdisMoveMemory(
        g_TeeferRuleTable,
        pRule,
        sizeof(TEEFER_RULE)
        );

    if (g_TeeferRuleCount == uRuleAt)
        g_TeeferRuleCount++;

    return TRUE;
}
*/

BOOLEAN
TeeferSetInitRuleTable(
    PTEEFER_RULE pSrcRuleTable,
    UINT uSrcRuleTableSize,
    UINT uSrcRuleCount
    )
{
    return TeeferSetRuleTableEx(
               pSrcRuleTable,
               uSrcRuleTableSize,
               uSrcRuleCount,
               &g_TeeferInitRuleTable,
               &g_TeeferInitRuleTableSize,
               &g_TeeferInitRuleCount
               );
}


BOOLEAN
TeeferSetRuleTable(
    PTEEFER_RULE pSrcRuleTable,
    UINT uSrcRuleTableSize,
    UINT uSrcRuleCount
    )
{
    return TeeferSetRuleTableEx(
               pSrcRuleTable,
               uSrcRuleTableSize,
               uSrcRuleCount,
               &g_TeeferRuleTable,
               &g_TeeferRuleTableSize,
               &g_TeeferRuleCount
               );
}

BOOLEAN
TeeferSetRuleTableEx(
    PTEEFER_RULE pSrcRuleTable,
    UINT uSrcRuleTableSize,
    UINT uSrcRuleCount,
    PTEEFER_RULE *ppDstRuleTable,
    PUINT puDstRuleTableSize,
    PUINT puDstRuleCount
    )
{
    UINT n;
    UINT i = 0;
    TEEFER_RULE* rule = NULL;
    NDIS_PHYSICAL_ADDRESS highestAddress = {-1};
    
    n = uSrcRuleTableSize/sizeof(TEEFER_RULE);
    if ( n > TEEFER_RULE_MAX_COUNT)
        return FALSE;

#if 0
    // dump teefer set rule table 
    for (i = 0; i < uSrcRuleCount; i++)
    {
	    rule = &pSrcRuleTable[i];
		IF_LOUD(DbgPrint("TEEFER: SetRule[%d] = {PDrvType=%d, PDrvId=%d, IDrvId=%d, TrafficDir=%d, Act=%d}\n",
			i, rule->ProtocolDriverType, rule->ProtocolDriverId, 
			rule->InterfaceDriverId, rule->TrafficDirection, rule->Action);)
	}
#endif

    if (n*sizeof(TEEFER_RULE) > *puDstRuleTableSize)
    {
        if (*ppDstRuleTable!=NULL)
        {
            NdisFreeMemory(*ppDstRuleTable, *puDstRuleTableSize, 0);
            *ppDstRuleTable = NULL;
            *puDstRuleTableSize = 0;
            *puDstRuleCount = 0;
        }
    }

    if (*ppDstRuleTable==NULL)
    {
        if (NdisAllocateMemory(
            ppDstRuleTable,
            n*sizeof(TEEFER_RULE),
            0,
            highestAddress
            )!=NDIS_STATUS_SUCCESS)
        {
            *ppDstRuleTable = NULL;
            *puDstRuleTableSize = 0;
            *puDstRuleCount = 0;

            return FALSE;
        }
        *puDstRuleTableSize = n*sizeof(TEEFER_RULE);
        *puDstRuleCount = 0;
        NdisZeroMemory(*ppDstRuleTable, *puDstRuleTableSize);
    }

	if (uSrcRuleCount)
    {
        NdisMoveMemory(
            *ppDstRuleTable,
            pSrcRuleTable,
            uSrcRuleCount*sizeof(TEEFER_RULE)
            );
        //*puDstRuleCount = uSrcRuleCount;
        MapAllProtocolNamesInRuleTableToIds();
    }
    else
    {
        if (*ppDstRuleTable!=NULL && *puDstRuleTableSize)
        {
            NdisZeroMemory(
                *ppDstRuleTable,
	        *puDstRuleTableSize);
        }
    }
    *puDstRuleCount = uSrcRuleCount;
    
    return TRUE;
}

#ifdef WINNT
NTSYSAPI
UINT
NTAPI
swprintf(
    OUT LPWSTR,
    IN LPCWSTR,
    ...
    );
#endif


#ifdef WINNT
BOOLEAN
TeeferReadRulesFromRegistry(
    IN PCHAR RegistryPath,
    PTEEFER_RULE pRuleBuffer,
    UINT dwRulesBufferInByte,
    PUINT pdwTotalRulesReturnedInBytes
    )
{
    PCHAR pTmpRuleBuffer;
    UNICODE_STRING nsString;
    UNICODE_STRING nsValue;
    HANDLE hKey;
    OBJECT_ATTRIBUTES ObjectAttributes;
    NDIS_PHYSICAL_ADDRESS highestAddress = {-1};
    UINT dwBufferSize = dwRulesBufferInByte+sizeof(PKEY_VALUE_PARTIAL_INFORMATION);
    UINT dwResultLen;
    NTSTATUS Status;
    PKEY_VALUE_PARTIAL_INFORMATION pvalue;
    WCHAR wcTmp[256];
        
    if (NdisAllocateMemory(
        &pTmpRuleBuffer,
        dwBufferSize,
        0,
        highestAddress
        )!=NDIS_STATUS_SUCCESS)
    {
        return FALSE;
    }
    
    swprintf(wcTmp, L"%S", (LPWSTR)RegistryPath);
    IF_LOUD(DbgPrint("\n\nTEEFER: REadReg=%s\n",RegistryPath);)

    RtlInitUnicodeString(&nsString, wcTmp);
    InitializeObjectAttributes(
        &ObjectAttributes,
        &nsString,
        OBJ_CASE_INSENSITIVE,
        NULL,
        NULL
        );
    Status = ZwOpenKey(&hKey, KEY_READ, &ObjectAttributes);
    if (Status!=STATUS_SUCCESS)
    {
        NdisFreeMemory(
            pTmpRuleBuffer,
            dwBufferSize,
            0
            );
        return FALSE;
    }
    
    pvalue = (PKEY_VALUE_PARTIAL_INFORMATION) pTmpRuleBuffer;

    RtlInitUnicodeString(&nsValue, L"Data");
    Status = ZwQueryValueKey(hKey, &nsValue, KeyValuePartialInformation,
        pvalue, dwBufferSize, &dwResultLen);
    if (Status==STATUS_SUCCESS)
    {
        *pdwTotalRulesReturnedInBytes = pvalue->DataLength;
        NdisMoveMemory(pRuleBuffer, pvalue->Data , pvalue->DataLength);
    }
    
    ZwClose(hKey);
    
    NdisFreeMemory(
        pTmpRuleBuffer,
        dwBufferSize,
        0
        );
    return Status==STATUS_SUCCESS;
}


#else  //  WIN9x

BOOLEAN
TeeferReadRulesFromRegistry(
    IN PCHAR RegistryPath,
    PTEEFER_RULE pRuleBuffer,
    UINT dwRulesBufferInByte,
    PUINT pdwTotalRulesReturnedInBytes
    )
{
    HKEY hKey;
    UINT dwResultLen;
    NTSTATUS Status;
    UINT dwRuleCount;
    UINT dwRegType;

    Status = RegOpenKey(HKEY_LOCAL_MACHINE, RegistryPath, &hKey);
    if (Status!=STATUS_SUCCESS)
    {
        return FALSE;
    }

    dwResultLen = dwRulesBufferInByte;
    dwRegType = REG_BINARY;
    Status = RegQueryValueEx(hKey, "Data", NULL, &dwRegType, (BYTE*)pRuleBuffer,
        &dwResultLen);

    RegCloseKey(hKey);

    if (Status==STATUS_SUCCESS)
    {
        *pdwTotalRulesReturnedInBytes = dwResultLen;
    }
    
    return Status==STATUS_SUCCESS;
}
	
#endif


BOOLEAN
TeeferSetDefaultRuleTable(
    IN PCHAR szRegistryPath
    )
{
    PCHAR p;
    PTEEFER_RULE pRuleBuffer = NULL;
    NDIS_PHYSICAL_ADDRESS highestAddress = {-1};
    UINT dwBufferSize = sizeof(TEEFER_RULE)*100;
    UINT dwResultLen;
    UINT dwRuleCount;
    BOOLEAN bRet = FALSE;

    if (NdisAllocateMemory(
        &pRuleBuffer,
        dwBufferSize,
        0,
        highestAddress
        )!=NDIS_STATUS_SUCCESS)
    {
        return FALSE;
    }

    p = (PCHAR)pRuleBuffer;

    //  Read init rules (before user login)
    strcpy (p, szRegistryPath);
    strcat (p, "\\InitParameters");

    if (!TeeferReadRulesFromRegistry(p, (TEEFER_RULE*)pRuleBuffer,
        dwBufferSize, &dwResultLen))
    {
        dwResultLen = 0;
    }

    dwRuleCount = dwResultLen / sizeof(TEEFER_RULE);    
    IF_LOUD(DbgPrint("TEEFER: InitRule# = %d Data=%d tr=%d\n", dwRuleCount, dwResultLen,
        sizeof(TEEFER_RULE));)

    if (dwRuleCount*sizeof(TEEFER_RULE) != dwResultLen)
    {
        IF_LOUD(DbgPrint("TEEFER: Incompatible data in initsetttings!\n");)
        goto cleanup_exit;
    }

	if (0)
	{
		unsigned int i;
		for (i=0; i<dwRuleCount; i++)
		{
			IF_LOUD(DbgPrint("TEEFER: EthType[%d]=%d\n", i, ((TEEFER_RULE*)pRuleBuffer)[i].EthType);)
		}
	}
	
    // If dwRuleCount==0 then TeeferSetInitRuleTable will empty the internal init rules
    bRet = TeeferSetInitRuleTable((PTEEFER_RULE)pRuleBuffer,
         dwBufferSize, dwRuleCount);

    //  Read default rules (after user login)
    strcpy (p, szRegistryPath);
    strcat (p, "\\Parameters");

    if (!TeeferReadRulesFromRegistry(p, (TEEFER_RULE*)pRuleBuffer,
        dwBufferSize, &dwResultLen))
    {
        dwResultLen = 0;
    }

    dwRuleCount = dwResultLen / sizeof(TEEFER_RULE);    
    IF_LOUD(DbgPrint("TEEFER: Rule# = %d Data=%d tr=%d\n", dwRuleCount, dwResultLen,
        sizeof(TEEFER_RULE));)

    if (dwRuleCount*sizeof(TEEFER_RULE) != dwResultLen)
    {
        IF_LOUD(DbgPrint("TEEFER: Incompatible data in setttings!\n");)
        goto cleanup_exit;
    }

    if (dwRuleCount)
    {
        bRet |= TeeferSetRuleTable((PTEEFER_RULE)pRuleBuffer,
            dwBufferSize, dwRuleCount);
    }
    else
    {
        NdisZeroMemory(pRuleBuffer, dwBufferSize);
        TeeferSetInitRuleTable(pRuleBuffer, dwBufferSize, 0);

        pRuleBuffer[0].Action = TEEFER_RULE_ACTION_EXAMINE;
        pRuleBuffer[0].ProtocolDriverType
            = TEEFER_RULE_PROTOCOLTYPE_TCPIP_STACK;
        pRuleBuffer[0].ProtocolDriverId = TEEFER_RULE_PROTOCOLID_ANY;
        pRuleBuffer[0].InterfaceDriverId = TEEFER_RULE_INTERFACEID_ANY;
        pRuleBuffer[0].PacketType = TEEFER_RULE_PACKETTYPE_ANY;
        pRuleBuffer[0].TrafficDirection = TEEFER_RULE_DIRECTION_ANY;
        
        pRuleBuffer[1].Action = TEEFER_RULE_ACTION_PASS;
        pRuleBuffer[1].ProtocolDriverType
            = TEEFER_RULE_PROTOCOLTYPE_NONTCPIP_STACK;
        pRuleBuffer[1].ProtocolDriverId = TEEFER_RULE_PROTOCOLID_ANY;
        pRuleBuffer[1].InterfaceDriverId = TEEFER_RULE_INTERFACEID_ANY;
        pRuleBuffer[1].PacketType = TEEFER_RULE_PACKETTYPE_ANY;
        pRuleBuffer[1].TrafficDirection = TEEFER_RULE_DIRECTION_ANY;
        bRet = TeeferSetRuleTable(pRuleBuffer, dwBufferSize, 2);
    }


cleanup_exit:
    if (pRuleBuffer!=NULL)
    {
        NdisFreeMemory(
            pRuleBuffer,
            dwBufferSize,
            0
            );
    }
    return bRet;
}
                   

PTEEFER_RULE
TeeferMatchRuleByPacket(
    IN PNDIS_PROTOCOL_INFO pProtocolInfo,
    IN UINT nInterfaceId,
    IN PVOID HeaderBuffer,
    IN UINT HeaderBufferSize,
    IN PVOID LookaheadBuffer,
    IN UINT LookaheadBufferSize,
    IN UINT bIsIncoming
    )
{
    S8022SNAP_FrameHead *pethSNAP = 0;
    SEtherII_FrameHead *peth = 0;
    SIp4_FrameHead* pip = 0;
    STcpSegment_FrameHead* ptcp = 0;
    SUdp_FrameHead* pudp = 0;
    UINT i;
    USHORT dstport = 0;
    USHORT srcport = 0;
	NWORD pethType;
    UINT ipheadlen;
	UCHAR *pData = NULL;
    TEEFER_RULE* rule;
    BOOLEAN is_ippkt = FALSE;
    BOOLEAN is_tcppkt = FALSE;
    BOOLEAN is_udppkt = FALSE;
    BOOLEAN is_icmppkt = FALSE;
    UINT bLogin = FALSE;
    UINT bIgnorePacketContent = FALSE;
    UINT dwRuleCount;
    PTEEFER_RULE EffectiveRuleTable;
    
    if (HeaderBufferSize < 14)
        bIgnorePacketContent = TRUE;
    if (LookaheadBufferSize < 16)
        bIgnorePacketContent = TRUE;
    
    if (!bIgnorePacketContent)
    {
        peth = (SEtherII_FrameHead *)HeaderBuffer;
        pip = (SIp4_FrameHead*)( LookaheadBuffer );

		/* twyin122203: support EthernetII and IEEE802.3SNAP formats */
		if (TOWORD(peth->Type) < IEEE8023LEN)
		{
			// IEEE802.3 format
			pethType = peth->Type;
			if (LookaheadBufferSize >= 8) {
				pethSNAP = (S8022SNAP_FrameHead *)LookaheadBuffer;
				//DbgPrint("TEEFER: 802.2SNAP *** DSAP=%x SSAP=%x CTRL=%x Type=%x\n",
				//	pethSNAP->DSAP, pethSNAP->SSAP, pethSNAP->CONTROL, pethSNAP->Type);
				if ((pethSNAP->DSAP == 0xAA) && (pethSNAP->SSAP == 0xAA) &&
					(pethSNAP->CONTROL == 3)) {
					// 802.2SNAP detected
					pethType = pethSNAP->Type;
					pip = (SIp4_FrameHead*)( ((UCHAR *)LookaheadBuffer) + 8 );
				}
			}
			//DbgPrint("TEEFER: 802.3SNAP packet type=0x%x ip-protocol=0x%x\n", 
			//	TOWORD(pethType), pip->Protocol);
		}
		else
		{
			// EthernetII format
			pethType = peth->Type;
			//DbgPrint("TEEFER: Ethernet2 packet type=0x%x ip-protocol=0x%x\n", 
			//	TOWORD(pethType), pip->Protocol);
		}

        /* it is IP packet? */
        if ( pethType == TOWORD( ETHENRET_PROTOCOL_IP_TYPE ) ) 
        {
            is_ippkt = TRUE;
            ipheadlen =  (pip->Vers_Hlen & 0xf) * 4;
        
            /* TCP map */
            if (pip->Protocol == IP_PROTOCOL_TCP_TYPE)
            {
                ptcp = (STcpSegment_FrameHead* ) ( ((char*)pip) + ipheadlen );
                srcport = TOWORD(ptcp->SourPort);
                dstport = TOWORD(ptcp->DestPort);
                is_tcppkt = TRUE;
            }
            else if (pip->Protocol == IP_PROTOCOL_UDP_TYPE)
            {
                pudp = (SUdp_FrameHead* ) ( ((char*)pip) + ipheadlen );
                srcport = TOWORD(pudp->SourPort);
                dstport = TOWORD(pudp->DestPort);
                is_udppkt = TRUE;
            }
            else if (pip->Protocol == IP_PROTOCOL_ICMP_TYPE)
            {
                srcport = (USHORT)*(UCHAR*)( ((UCHAR*)pip) + ipheadlen );
                dstport = (USHORT)*(UCHAR*)( ((UCHAR*)pip) + ipheadlen + 1 );
                is_icmppkt = TRUE;
            }
        }
    }

    if (IsLogonShellRunning() || g_TeeferInitRuleCount==0)
    {
		bLogin = TRUE;
        dwRuleCount = g_TeeferRuleCount;
        EffectiveRuleTable = g_TeeferRuleTable;
    }
    else
    {
		bLogin = FALSE;
        dwRuleCount = g_TeeferInitRuleCount;
        EffectiveRuleTable = g_TeeferInitRuleTable;
    }
  
    /* teefer special 802.1x rule */
	if ((bLogin == TRUE) && (pethType == TOWORD(0x888E)))
	{
		rule = &gTeefer8021xRule;
		if (rule->Action != TEEFER_RULE_ACTION_EXAMINE) {
			rule->Action = TEEFER_RULE_ACTION_EXAMINE;
			rule->ProtocolDriverType = TEEFER_RULE_PROTOCOLTYPE_NONTCPIP_STACK;
			rule->ProtocolDriverPath[0] = 0;
			rule->ProtocolDriverId = TEEFER_RULE_PROTOCOLID_ANY;
			rule->InterfaceDriverId = TEEFER_RULE_INTERFACEID_ANY;
			rule->PacketType = TEEFER_RULE_PACKETTYPE_EXAMINE_CONTENT;
			rule->TrafficDirection = TEEFER_RULE_DIRECTION_ANY;
			rule->EthType = TOWORD(0x888E);
		}

#if 0
		// dump 802.1x packet debugging info
        if (pethType == TOWORD(0x888E))
        {
	        pData = (UCHAR *)(LookaheadBuffer);
			IF_LOUD(DbgPrint(
				"TEEFER: ruleX %s %s %s %s eth=%x %02x-%02x-%02x-%02x...\n",
				(bLogin?"LOGON ":"LOGOFF"), 
				(rule->Action?(rule->Action==2?"PASS":"EXAM"):"DROP"), 
				pProtocolInfo->szProtocolName,
				(bIsIncoming?"IN ":"OUT"), TOWORD(pethType), 
				pData[0], pData[1], pData[2], pData[3]);)
			IF_LOUD(DbgPrint(
				"TEEFER: 802.1x body=[%02x-%02x-%02x-%02x-%02x-%02x-%02x-%02x-%02x-%02x-%02x-%02x-%02x-%02x-%02x-%02x-...]\n",
				pData[4], pData[5], pData[6], pData[7],
				pData[8], pData[9], pData[10], pData[11],
				pData[12], pData[13], pData[14], pData[15],
				pData[16], pData[17], pData[18], pData[19]);)
		}
#endif

		return rule;
	}

    /* scan rule table */
    for (i = 0; i < dwRuleCount; i++)
    {
        rule = &EffectiveRuleTable[i];
        
//		DbgPrint("RULE %d> rule->ProtocolDriverType=%d, pProtocolInfo->nProtocolType=%d\n",
//			i, rule->ProtocolDriverType, pProtocolInfo->nProtocolType);

        if (rule->ProtocolDriverType!=TEEFER_RULE_PROTOCOLTYPE_ANY)
        {
            if (rule->ProtocolDriverType!=pProtocolInfo->nProtocolType)
                continue;
        }

//		DbgPrint("RULE %d> rule->ProtocolDriverId=%d, pProtocolInfo->nIndex=%d\n",
//			i, rule->ProtocolDriverId, pProtocolInfo->nIndex);

        if (rule->ProtocolDriverId!=TEEFER_RULE_PROTOCOLID_ANY)
        {
            if (rule->ProtocolDriverId!=pProtocolInfo->nIndex)
                continue;
        }

//		DbgPrint("RULE %d> rule->InterfaceDriverId=%d, nInterfaceId=%d\n",
//			i, rule->InterfaceDriverId, nInterfaceId);

        if (rule->InterfaceDriverId!=TEEFER_RULE_INTERFACEID_ANY)
        {
            if (rule->InterfaceDriverId!=nInterfaceId)
                continue;
        }

//		DbgPrint("RULE %d> rule->TrafficDirection=%d, bIsIncoming=%d\n",
//			i, rule->TrafficDirection, bIsIncoming);

        if (rule->TrafficDirection!=TEEFER_RULE_DIRECTION_ANY)
        {
            if (rule->TrafficDirection==TEEFER_RULE_DIRECTION_INCOMING
                && !bIsIncoming)
                continue;
            if (rule->TrafficDirection==TEEFER_RULE_DIRECTION_OUTGOING
                && bIsIncoming)
                continue;
        }
        if (!bIgnorePacketContent
           && rule->PacketType!=TEEFER_RULE_PACKETTYPE_ANY)
        {

//			DbgPrint("RULE %d> rule->SrcMac=%d, peth->SourAddr=%d\n",
//				i, rule->SrcMac[5], peth->SourAddr[5]);

            // check mac address
            if ( ! IS_MAC_ANY(rule->SrcMac) )
            {
                if ( ! IS_EQUAL_MAC(rule->SrcMac, peth->SourAddr) )
                    continue;
            }
			
//			DbgPrint("RULE %d> rule->DstMac=%d, peth->DestAddr=%d\n",
//				i, rule->DstMac[5], peth->DestAddr[5]);

            if ( ! IS_MAC_ANY(rule->DstMac) )
            {
                if ( ! IS_EQUAL_MAC(rule->DstMac, peth->DestAddr) )
                    continue;
            }
            
//			DbgPrint("RULE %d> rule->EthType=%x(%x), pethType=%x\n",
//				i, rule->EthType, &rule->EthType, pethType);

            if ( rule->EthType != TEEFER_RULE_ETHTYPE_ANY )
            {
                if ( rule->EthType != pethType )
                    continue;
            }
            
            if (is_ippkt)
            {
//			DbgPrint("RULE %d> rule->SrcSubnetAddr=%x, pip->SourAddr=%x\n",
//				i, rule->SrcSubnetAddr, pip->SourAddr);

                if ( rule->SrcSubnetAddr )	// it is not ANY
                {
                    // match the ip; it is outside of the subnet?
                    if ( (pip->SourAddr & rule->SrcSubnetMask)
                        != (rule->SrcSubnetAddr & rule->SrcSubnetMask) )
                        continue;
                }
                
//			DbgPrint("RULE %d> rule->DstSubnetAddr=%x, pip->DestAddr=%x\n",
//				i, rule->DstSubnetAddr, pip->DestAddr);

                if ( rule->DstSubnetAddr )	// it is not ANY
                {
                    if ( (pip->DestAddr & rule->DstSubnetMask)
                        != (rule->DstSubnetAddr & rule->DstSubnetMask) )
                        continue;
                }
                
//			DbgPrint("RULE %d> rule->IpType=%x, pip->Protocol=%x\n",
//				i, rule->IpType, pip->Protocol);

                if ( rule->IpType != TEEFER_RULE_IPTYPE_ANY )
                {
                    if ( rule->IpType != pip->Protocol )
                        continue;
                }
                
                if ( is_tcppkt || is_udppkt || is_icmppkt )
                {
                    // check the port/icmp
//			DbgPrint("RULE %d> srcport=%d, rule->SrcPortLow=%d rule->SrcPortHigh=%d\n",
//				i, srcport, rule->SrcPortLow, rule->SrcPortHigh);

                    if ( srcport<rule->SrcPortLow
                       || srcport>rule->SrcPortHigh )
                        continue;
// 			DbgPrint("RULE %d> dstport=%d, rule->DstPortLow=%d rule->DstPortHigh=%d\n",
//				i, dstport, rule->DstPortLow, rule->DstPortHigh);

                    if ( dstport<rule->DstPortLow
                       || dstport>rule->DstPortHigh )
                        continue;
                }
            }
        }
        
	/*
	if (pethType!=0x6f88 && 
                g_TeeferRuleTable[i].Action!=TEEFER_RULE_ACTION_PASS)
        {
            if (is_ippkt)
	    {
	    if (srcport!=39999 && dstport!=39213)
            IF_LOUD(DbgPrint("eth=%x iptyp=%x src=%d dst=%d act=%d\n",
                pethType, pip->Protocol, srcport, dstport,
                g_TeeferRuleTable[i].Action);)
	    }
	    else
	    {
            IF_LOUD(DbgPrint("eth=%x  act=%d\n",
                pethType, g_TeeferRuleTable[i].Action);)
	    }
	}
	*/

	    if (is_ippkt)
            if (pip->Protocol == IP_PROTOCOL_ICMP_TYPE)
			{
				/*
				IF_LOUD(DbgPrint(
			   " icmp=%d %s ignore=%d eth=%x iptyp=%x src=%d dst=%d act=%d srcip=%x dstip=%x\n",
					i, bIsIncoming?"in ":"out", bIgnorePacketContent, pethType, pip->Protocol, srcport, dstport,
					rule->Action, pip->SourAddr, pip->DestAddr);)
				*/
			}

#if 1
        // matched
        if (rule->Action == TEEFER_RULE_ACTION_BLOCK)
        {
			if (LookaheadBuffer != NULL && 
				LookaheadBufferSize > 4) 
			{
				pData = (UCHAR *)(LookaheadBuffer);
				sysprint("TEEFER: rule%d %s %s %s %s eth=%x %02x-%02x-%02x-%02x...\n",
					i, (bLogin?"LOGON ":"LOGOFF"), 
					(rule->Action?(rule->Action==2?"PASS":"EXAM"):"DROP"), 
					pProtocolInfo->szProtocolName,
					(bIsIncoming?"IN ":"OUT"), TOWORD(pethType), 
					pData[0], pData[1], pData[2], pData[3]);
			}


			if (pip!=NULL)
			{
				IF_LOUD(DbgPrint(
					"TEEFER: rule%d %s %s %s eth=%x iptype=%x src_port=%d dst_port=%d src_ip=%x dst_ip=%x\n",
					i, (bLogin?"LOGON ":"LOGOFF"), 
					(rule->Action?(rule->Action==2?"PASS":"EXAM"):"DROP"), 
					(bIsIncoming?"IN ":"OUT"), 
					TOWORD(pethType), pip->Protocol, srcport, dstport,
					pip->SourAddr, pip->DestAddr);)
				
				/*
				// dump rule table
			    if (0) {
					DbgPrint("rule[%2d]:srcmac=%02x-%02x-%02x-%02x-%02x-%02x dstmac=%02x-%02x-%02x-%02x-%02x-%02x\n", i,
						rule->SrcMac[0], rule->SrcMac[1], rule->SrcMac[2], rule->SrcMac[3], rule->SrcMac[4], rule->SrcMac[5], 
						rule->DstMac[0], rule->DstMac[1], rule->DstMac[2], rule->DstMac[3], rule->DstMac[4], rule->DstMac[5]);
					DbgPrint("        :srcsubnet=%x, srcsubnetmask=%x dstsubnet=%x dstsubnetmask=%x\n",
						rule->SrcSubnetAddr, rule->SrcSubnetMask, rule->DstSubnetAddr, rule->DstSubnetMask);
					DbgPrint("        :srcportlo=%x, srcporthi=%x dstportlo=%x dstporthi=%x\n",
						rule->SrcPortLow, rule->SrcPortHigh, rule->DstPortLow, rule->DstPortHigh);
					DbgPrint("        :EthType=%x, TrafficDir=%x PktType=%x AdapterId=%x\n",
						rule->EthType, rule->TrafficDirection, rule->PacketType, rule->InterfaceDriverId);
					DbgPrint("        :ProtDrvID=%x, ProtDrvType=%x IP_Type=%x Action=%x\n",
						rule->ProtocolDriverId, rule->ProtocolDriverType, rule->IpType, rule->Action);
				}
				*/
			}
			/*
			else
			{
				if (peth!=NULL)
				{
					IF_LOUD(DbgPrint(
						" i=%d ignore=%d eth=%x src=%d dst=%d act=%d \n",
						i, bIgnorePacketContent, pethType, srcport, dstport, rule->Action);)
				}
				else
				{
					IF_LOUD(DbgPrint(
						" i=%d ignore=%d src=%d dst=%d act=%d \n",
						i, bIgnorePacketContent, srcport, dstport, rule->Action);)
				}
				
				
			}*/
		}
#endif

#if 0
		// dump 802.1x packet debugging info
        if (pethType == TOWORD(0x888E))
        {
	        pData = (UCHAR *)(LookaheadBuffer);
			IF_LOUD(DbgPrint(
				"TEEFER: rule%d %s %s %s %s eth=%x %02x-%02x-%02x-%02x...\n",
				i, (bLogin?"LOGON ":"LOGOFF"), 
				(rule->Action?(rule->Action==2?"PASS":"EXAM"):"DROP"), 
				pProtocolInfo->szProtocolName,
				(bIsIncoming?"IN ":"OUT"), TOWORD(pethType), 
				pData[0], pData[1], pData[2], pData[3]);)
			IF_LOUD(DbgPrint(
				"TEEFER: 802.1x body=[%02x-%02x-%02x-%02x-%02x-%02x-%02x-%02x-%02x-%02x-%02x-%02x-%02x-%02x-%02x-%02x-...]\n",
				pData[4], pData[5], pData[6], pData[7],
				pData[8], pData[9], pData[10], pData[11],
				pData[12], pData[13], pData[14], pData[15],
				pData[16], pData[17], pData[18], pData[19]);)
		}
#endif
		return rule;
    }
    
#if 0
	    if (pip!=NULL)
	    {
            IF_LOUD(DbgPrint(
	       " no match ignore=%d eth=%x iptyp=%x src=%d dst=%d srcip=%x dstip=%x\n",
                bIgnorePacketContent, pethType, pip->Protocol, srcport, dstport,
                pip->SourAddr, pip->DestAddr);)
	    }
            else
	    {
	    if (peth!=NULL)
	    {
            IF_LOUD(DbgPrint(
	       " no match ignore=%d eth=%x src=%d dst=%d \n",
                bIgnorePacketContent, pethType, srcport, dstport);)
	    }
	    else
	    {
            IF_LOUD(DbgPrint(
	       " no match ignore=%d src=%d dst=%d \n",
                bIgnorePacketContent, srcport, dstport);)
	    }

	    }
#endif
	    
        IF_LOUD(DbgPrint(
			"TEEFER: rule count=%d\n", dwRuleCount);)

        if (is_ippkt)
	    {
            IF_LOUD(DbgPrint(
	       "  no rule eth=%x iptyp=%x src=%d dst=%d srcip=%x dstip=%x\n",
                pethType, pip->Protocol, srcport, dstport,
                pip->SourAddr, pip->DestAddr);)
	    }

#if 0
		// dump 802.1x packet debugging info
        if (pethType == TOWORD(0x888E))
        {
	        pData = (UCHAR *)(LookaheadBuffer);
			IF_LOUD(DbgPrint(
				"TEEFER: rule%d %s %s %s %s eth=%x %02x-%02x-%02x-%02x\n",
				i, (bLogin?"LOGON ":"LOGOFF"), 
				"NO_RULE", 
				pProtocolInfo->szProtocolName,
				(bIsIncoming?"IN ":"OUT"), TOWORD(pethType), 
				pData[0], pData[1], pData[2], pData[3]);)
			IF_LOUD(DbgPrint(
				"TEEFER: 802.1x body=[%02x-%02x-%02x-%02x-%02x-%02x-%02x-%02x-%02x-%02x-%02x-%02x-%02x-%02x-%02x-%02x-...]\n",
				pData[4], pData[5], pData[6], pData[7],
				pData[8], pData[9], pData[10], pData[11],
				pData[12], pData[13], pData[14], pData[15],
				pData[16], pData[17], pData[18], pData[19]);)
		}
#endif
        return NULL;
}


INT
ConvertPacketToBuffer(
    IN PCHAR pTmp,
    IN PUINT pOutTotalLen,
    IN PNDIS_PACKET pPacket
    )
{
    PNDIS_BUFFER pBuffer;
    PNDIS_BUFFER pBufferNext;
    PVOID pBufferVA;
    UINT nLen;
    UINT nTotalLenTmp;
    UINT nTotalLen;

    if (pPacket==NULL)
        return NDIS_STATUS_FAILURE;

    NdisQueryPacket(pPacket, NULL, NULL, &pBuffer, &nTotalLen);
    if (pBuffer==NULL)
        return NDIS_STATUS_FAILURE;

#ifdef WINNT
    NdisQueryBufferSafe(pBuffer, &pBufferVA, &nLen, NormalPagePriority);
#else
    NdisQueryBuffer(pBuffer, &pBufferVA, &nLen);
#endif

    if (pBufferVA==NULL || !nLen || nLen>nTotalLen)
        return NDIS_STATUS_FAILURE;

    if (nTotalLen> *pOutTotalLen)
        nTotalLen = *pOutTotalLen;

    nTotalLenTmp = nTotalLen;

    while (pBufferVA!=NULL && nLen>0)
    {
        if (nLen>nTotalLenTmp)
            nLen = nTotalLenTmp;
        NdisMoveMemory(pTmp, pBufferVA, nLen);
        nTotalLenTmp -= nLen;

        if (!nTotalLenTmp)
            break;
        pTmp += nLen;
        NdisGetNextBuffer(pBuffer, &pBufferNext);
        if (pBufferNext==NULL)
            break;
        pBuffer = pBufferNext;
#ifdef WINNT
        NdisQueryBufferSafe(pBuffer, &pBufferVA, &nLen, NormalPagePriority);
#else
        NdisQueryBuffer(pBuffer, &pBufferVA, &nLen);
#endif
    }
		*pOutTotalLen = nTotalLen;
    return NDIS_STATUS_SUCCESS;
}


BOOLEAN
GetInterfaceIdFromMacBinding(
    NDIS_HANDLE MacBindingContext,
    PNDIS_PROTOCOL_INFO pProtocolInfo,
    PUINT puiInterfaceId,
    PUINT puiProtocolId,
	PNDIS_ADAPTER_INFO *ppAdapterInfo
    )
{
    PNDIS_ADAPTER_INFO pAdapterInfo;
    unsigned j;
    
    if (MacBindingContext==NULL)
        return FALSE;
    
    if (IsListEmpty(&pProtocolInfo->pAdapterInfoList))
    {
        if (!RebuildAdapterList(pProtocolInfo))
            return FALSE;
    }
    j=1;
    do
    {
        if (IsListEmpty(&pProtocolInfo->pAdapterInfoList))
        {
            return FALSE;
        }
        pAdapterInfo = (PNDIS_ADAPTER_INFO)pProtocolInfo->pAdapterInfoList.Flink;
        while ((PNDIS_ADAPTER_INFO)&pProtocolInfo->pAdapterInfoList!=pAdapterInfo)
        {
            if (pAdapterInfo->pOpen!=NULL
                && (pAdapterInfo->pOpen==MacBindingContext
                || pAdapterInfo->pMacBindingContext==MacBindingContext))
            {
                *puiInterfaceId = pAdapterInfo->nIndex;
                *puiProtocolId = pProtocolInfo->nIndex;
				*ppAdapterInfo = pAdapterInfo;
				return TRUE;
            }
            pAdapterInfo = (PNDIS_ADAPTER_INFO)pAdapterInfo->ListEntry.Flink;
        }
        //IF_LOUD(DbgPrint("MacRebuilding adapter list\n");)
        if (pProtocolInfo->bHookOn)
        {
            if (!RebuildAdapterList(pProtocolInfo))
                return FALSE;
        }
    } while (j--);
    return FALSE;
    
}

PNDIS_ADAPTER_INFO
GetAdapterInfoFromProtocolBinding(
    NDIS_HANDLE ProtocolBindingContext,
    PNDIS_PROTOCOL_INFO pProtocolInfo
	)
{
    PNDIS_ADAPTER_INFO pAdapterInfo;
    unsigned j = 0;

    if (ProtocolBindingContext==NULL)
        return NULL;

    if (IsListEmpty(&pProtocolInfo->pAdapterInfoList))
    {
        return NULL;
    }

	pAdapterInfo = (PNDIS_ADAPTER_INFO)pProtocolInfo->pAdapterInfoList.Flink;
	while ((PNDIS_ADAPTER_INFO)&pProtocolInfo->pAdapterInfoList!=pAdapterInfo)
	{
		if (pAdapterInfo->pOpen!=NULL
			&& (pAdapterInfo->pOpen==ProtocolBindingContext
			|| pAdapterInfo->pProtocolBindingContext == ProtocolBindingContext))
			return pAdapterInfo;

		pAdapterInfo = (PNDIS_ADAPTER_INFO)pAdapterInfo->ListEntry.Flink;
	}

    return NULL;
}

BOOLEAN
GetInterfaceIdFromProtocolBinding(
    NDIS_HANDLE ProtocolBindingContext,
    PNDIS_PROTOCOL_INFO pProtocolInfo,
    PUINT puiInterfaceId,
    PUINT puiProtocolId
    )
{
    PNDIS_ADAPTER_INFO pAdapterInfo;
    unsigned j;

    if (ProtocolBindingContext==NULL)
        return FALSE;

    if (IsListEmpty(&pProtocolInfo->pAdapterInfoList))
    {
        if (!RebuildAdapterList(pProtocolInfo))
            return FALSE;
    }
    j=1;
    do
    {
        if (IsListEmpty(&pProtocolInfo->pAdapterInfoList))
        {
            return FALSE;
        }
        pAdapterInfo = (PNDIS_ADAPTER_INFO)pProtocolInfo->pAdapterInfoList.Flink;
        while ((PNDIS_ADAPTER_INFO)&pProtocolInfo->pAdapterInfoList!=pAdapterInfo)
        {
            if (pAdapterInfo->pOpen!=NULL
                && (pAdapterInfo->pOpen==ProtocolBindingContext
                || pAdapterInfo->pProtocolBindingContext
                ==ProtocolBindingContext))
            {
                *puiInterfaceId = pAdapterInfo->nIndex;
                *puiProtocolId = pProtocolInfo->nIndex;
                return TRUE;
            }
            pAdapterInfo = (PNDIS_ADAPTER_INFO)pAdapterInfo->ListEntry.Flink;
        }
        //IF_LOUD(DbgPrint("Proc Rebuilding adapter list\n");)
        if (pProtocolInfo->bHookOn)
        {
            if (!RebuildAdapterList(pProtocolInfo))
                return FALSE;
        }
    } while (j--);
    return FALSE;
}


PNDIS_PROTOCOL_INFO
GetProtocolInfoFromTeeferFlags(
    unsigned  flags
    )
{
    UINT uiId = (flags>>24) & 0x7f;
    if (uiId>=MAX_PROTOCOL_INFO||!g_pProtocolInfo[uiId]->bHookOn)
        return NULL;
    return g_pProtocolInfo[uiId];
}


PNDIS_PROTOCOL_INFO
GetProtocolInfoFromProtocolHandle(
    NDIS_HANDLE  ProtocolHandle
    )
{
    INT i;
    for (i=0; i<MAX_PROTOCOL_INFO; i++)
    {
        if (g_pProtocolInfo[i]->bHookOn
            && g_pProtocolInfo[i]->pProtocol==ProtocolHandle)
            return g_pProtocolInfo[i];
    }
    return NULL;
}


PNDIS_ADAPTER_INFO
GetAdapterInfoFromMacBinding(
    NDIS_HANDLE MacBindingContext,
    PNDIS_PROTOCOL_INFO pProtocolInfo
    )
{
    PNDIS_ADAPTER_INFO pAdapterInfo;
    unsigned j;

    if (MacBindingContext==NULL)
        return NULL;

    if (IsListEmpty(&pProtocolInfo->pAdapterInfoList))
    {
        if (!RebuildAdapterList(pProtocolInfo))
            return NULL;
    }
    j=1;
    do
    {
        if (IsListEmpty(&pProtocolInfo->pAdapterInfoList))
        {
            return NULL;
        }
        pAdapterInfo = (PNDIS_ADAPTER_INFO)pProtocolInfo->pAdapterInfoList.Flink;
        while ((PNDIS_ADAPTER_INFO)&pProtocolInfo->pAdapterInfoList!=pAdapterInfo)
        {
            if (pAdapterInfo->pOpen!=NULL
                && (pAdapterInfo->pOpen==MacBindingContext
                || pAdapterInfo->pMacBindingContext ==MacBindingContext))
                return pAdapterInfo;
            pAdapterInfo = (PNDIS_ADAPTER_INFO)pAdapterInfo->ListEntry.Flink;
        }
        //IF_LOUD(DbgPrint("Proc Rebuilding adapter list\n");)
        if (pProtocolInfo->bHookOn)
        {
            if (!RebuildAdapterList(pProtocolInfo))
                return NULL;
        }
    } while (j--);
    return NULL;
}



BOOLEAN
AllocTeeferProtocolInfo(
    PNDIS_PROTOCOL_INFO *pProtocolInfo
    )
{
    INT i = 0;
    for (i=0; i<MAX_PROTOCOL_INFO; i++)
    {
        if (g_pProtocolInfo[i]==NULL)
            break;
        if (!g_pProtocolInfo[i]->bHookOn)
        {
            NdisZeroMemory(&(g_pProtocolInfo[i]->Stat),
                sizeof(NDIS_PACKET_STAT));
            g_pProtocolInfo[i]->nIndex = i;
            g_pProtocolInfo[i]->bHookOn = TRUE;
            g_pProtocolInfo[i]->nProtocolType = 0;
			g_pProtocolInfo[i]->bAllowProtocolTraffic = 0;

#ifdef WINNT
            g_pProtocolInfo[i]->nsProtocolName.Buffer
                = (PWSTR)g_pProtocolInfo[i]->szProtocolName;
#else
            g_pProtocolInfo[i]->nsProtocolName.Buffer
                = g_pProtocolInfo[i]->szProtocolName;
#endif
            g_pProtocolInfo[i]->nNumberAdapter = 0;
            *pProtocolInfo = g_pProtocolInfo[i];
            InitializeListHead(&(g_pProtocolInfo[i]->pAdapterInfoList));
            //MapAllProtocolNamesInRuleTableToIds();
            return TRUE;
        }
    }
    return FALSE;
}


BOOLEAN
FreeTeeferProtocolInfo(
    PNDIS_PROTOCOL_INFO pProtocolInfo
    )
{
    PNDIS_ADAPTER_INFO pAdapterInfoNext;
    PNDIS_ADAPTER_INFO pAdapterInfo;

	NdisZeroMemory(&(pProtocolInfo->Stat),
        sizeof(NDIS_PACKET_STAT));
    pProtocolInfo->bHookOn = FALSE;
    pAdapterInfo = (PNDIS_ADAPTER_INFO)pProtocolInfo->pAdapterInfoList.Flink;
    while ((PNDIS_ADAPTER_INFO)&pProtocolInfo->pAdapterInfoList!=pAdapterInfo)
    {
        pAdapterInfoNext = (PNDIS_ADAPTER_INFO)pAdapterInfo->ListEntry.Flink;
        RemoveEntryList(&pAdapterInfo->ListEntry);
        NdisFreeMemory(
            (PVOID)pAdapterInfo,
            sizeof(NDIS_ADAPTER_INFO),
            0
            );
        pProtocolInfo->nNumberAdapter--;
        if (pProtocolInfo->nNumberAdapter==0)
            break;
        pAdapterInfo = pAdapterInfoNext;
    }
    //MapAllProtocolNamesInRuleTableToIds();
    return TRUE;
}


#ifdef WINNT
#define   AddLargeStatistic(x, y)   ExInterlockedAddLargeStatistic(&(x), y)
#else
#define   AddLargeStatistic(x, y)   {                                     \
    PVOID p=&x;                                                           \
    _asm    mov     edx, p                                                \
    _asm    mov     eax, y                                                \
    _asm    add     [edx], eax                                            \
    _asm    adc     [edx+4], 0                                            \
}
#endif


BOOLEAN
UpdateReceiveStatBlock(
    PNDIS_PROTOCOL_INFO pProtocolInfo,
    ULONG ulLen
    )
{
    AddLargeStatistic (
        pProtocolInfo->Stat.ReceiveBlockBytesCount,
        ulLen
        );
    AddLargeStatistic (
        pProtocolInfo->Stat.ReceiveBlockPacketCount,
        1
        );
    return TRUE;
}


BOOLEAN
UpdateReceiveStatPass(
    PNDIS_PROTOCOL_INFO pProtocolInfo,
    UINT ulLen
    )
{
    AddLargeStatistic (
        pProtocolInfo->Stat.ReceivePassBytesCount,
        ulLen
        );
    AddLargeStatistic (
        pProtocolInfo->Stat.ReceivePassPacketCount,
        1
        );
    return TRUE;
}


BOOLEAN
UpdateReceiveStatExamine(
    PNDIS_PROTOCOL_INFO pProtocolInfo,
    UINT ulLen
    )
{
    AddLargeStatistic (
        pProtocolInfo->Stat.ReceiveExamineBytesCount,
        ulLen
        );
    AddLargeStatistic (
        pProtocolInfo->Stat.ReceiveExaminePacketCount,
        1
        );
    return TRUE;
}


BOOLEAN
UpdateReceiveStatExamineDispatched(
    PNDIS_PROTOCOL_INFO pProtocolInfo,
    UINT ulLen
    )
{
    AddLargeStatistic (
        pProtocolInfo->Stat.ReceiveExamineDispatchedBytesCount,
        ulLen
        );
    AddLargeStatistic (
        pProtocolInfo->Stat.ReceiveExamineDispatchedPacketCount,
        1
        );
    return TRUE;
}


BOOLEAN
UpdateSendStatBlock(
    PNDIS_PROTOCOL_INFO pProtocolInfo,
    PNDIS_PACKET Packet,
    UINT ulTotalLen
    )
{
    UINT ulLen;

    if (pProtocolInfo==NULL || (Packet==NULL && ulTotalLen==0))
        return FALSE;
    
    if (ulTotalLen)
        ulLen = ulTotalLen;
    else
        NdisQueryPacket(Packet, NULL, NULL, NULL, &ulLen);
    
    AddLargeStatistic (
        pProtocolInfo->Stat.SendBlockBytesCount,
        ulLen
        );
    AddLargeStatistic (
        pProtocolInfo->Stat.SendBlockPacketCount,
        1
        );
    return TRUE;
}


BOOLEAN
UpdateSendStatPass(
    PNDIS_PROTOCOL_INFO pProtocolInfo,
    PNDIS_PACKET Packet,
    UINT ulTotalLen
    )
{
    UINT ulLen;
    
    if (pProtocolInfo==NULL || (Packet==NULL && ulTotalLen==0))
        return FALSE;

    if (ulTotalLen)
        ulLen = ulTotalLen;
    else
        NdisQueryPacket(Packet, NULL, NULL, NULL, &ulLen);
    
    AddLargeStatistic (
        pProtocolInfo->Stat.SendPassBytesCount,
        ulLen
        );
    AddLargeStatistic (
        pProtocolInfo->Stat.SendPassPacketCount,
        1
        );
    return TRUE;
}


BOOLEAN
UpdateSendStatExamine(
    PNDIS_PROTOCOL_INFO pProtocolInfo,
    PNDIS_PACKET Packet,
    UINT ulTotalLen
    )
{
    UINT ulLen;
    
    if (pProtocolInfo==NULL || (Packet==NULL && ulTotalLen==0))
        return FALSE;
    
    if (ulTotalLen)
        ulLen = ulTotalLen;
    else
        NdisQueryPacket(Packet, NULL, NULL, NULL, &ulLen);
    
    AddLargeStatistic (
        pProtocolInfo->Stat.SendExamineBytesCount,
        ulLen
        );
    AddLargeStatistic (
        pProtocolInfo->Stat.SendExaminePacketCount,
        1
        );
    return TRUE;
}


BOOLEAN
UpdateSendStatExamineDispatched(
    PNDIS_PROTOCOL_INFO pProtocolInfo,
    PNDIS_PACKET Packet,
    UINT ulTotalLen
    )
{
    UINT ulLen;
    
    if (pProtocolInfo==NULL || (Packet==NULL && ulTotalLen==0))
        return FALSE;
    
    if (ulTotalLen)
        ulLen = ulTotalLen;
    else
        NdisQueryPacket(Packet, NULL, NULL, NULL, &ulLen);
    
    AddLargeStatistic (
        pProtocolInfo->Stat.SendExamineDispatchedBytesCount,
        ulLen
        );
    AddLargeStatistic (
        pProtocolInfo->Stat.SendExamineDispatchedPacketCount,
        1
        );
    return TRUE;
}


#define MACRONdisTransferData(Status,                                   \
    NdisBindingHandle,                                                  \
    MacReceiveContext,                                                  \
    ByteOffset,                                                         \
    BytesToTransfer,                                                    \
    Packet,                                                             \
    BytesTransferred)                                                   \
{                                                                       \
    *(Status) =                                                         \
    (((PNDIS_OPEN_BLOCK)(NdisBindingHandle))->TransferDataHandler)(     \
    ((PNDIS_OPEN_BLOCK)(NdisBindingHandle))->MacBindingHandle,          \
    (MacReceiveContext),                                                \
    (ByteOffset),                                                       \
    (BytesToTransfer),                                                  \
    (Packet),                                                           \
    (BytesTransferred));                                                \
}


NDIS_STATUS NDIS_API
TeeferTransferDataEntry(
    IN PNDIS_PROTOCOL_INFO pProtocolInfo,
    IN NDIS_HANDLE NdisBindingHandle,
    IN NDIS_HANDLE MacReceiveContext,
    IN UINT ByteOffset,
    IN UINT BytesToTransfer,
    IN OUT PNDIS_PACKET pPacket,
    OUT PUINT BytesTransferred
    )
{
    PNDIS_ADAPTER_INFO pAdapterInfo;
    PTEEFER_TRANSFER_CONTEXT pContext;

    if (MacReceiveContext!=NULL)
    {
        pContext = MacReceiveContext;
        if (pContext->Signature==TEEFER_RECEIVE_CONTEXT_SIGNATURE)
        {
	    /*
            IF_LOUD(DbgPrint("pac=%x off=%d btotlen=%d src=%x srclen=%d\n",
                pPacket, ByteOffset, BytesToTransfer,
                pContext->SrcBuf, pContext->uiSrcBufLen
                );)
	    */
            *BytesTransferred = ReplacePacket(pPacket, ByteOffset,
                BytesToTransfer, pContext->SrcBuf, pContext->uiSrcBufLen);
            return NDIS_STATUS_SUCCESS;
        }
    }
    pAdapterInfo = GetAdapterInfoFromMacBinding(NdisBindingHandle,
                       pProtocolInfo);
    if (pAdapterInfo==NULL)
    {
        return NDIS_STATUS_NOT_RECOGNIZED;
    }
    /*
    IF_LOUD(DbgPrint("TDProt=%s AdapterInfo%d=%x n=%s\nTDOTD=%x\n",
        pProtocolInfo->szProtocolName,
        pAdapterInfo,
        pAdapterInfo->nIndex,
        pAdapterInfo->szAdapterName,
        pAdapterInfo->pFuncOriginalTransferDataHandler
        );)
    */
    return pAdapterInfo->pFuncOriginalTransferDataHandler(
        NdisBindingHandle,
        MacReceiveContext,
        ByteOffset,
        BytesToTransfer,
        pPacket,
        BytesTransferred
        );
}

#ifdef WINNT

VOID NDIS_API
TeeferStatusEntry(
    IN PNDIS_PROTOCOL_INFO pProtocolInfo,
    IN NDIS_HANDLE  MiniportAdapterHandle,
    IN NDIS_STATUS  GeneralStatus,
    IN PVOID  StatusBuffer,
    IN UINT  StatusBufferSize
    )
{
    PNDIS_ADAPTER_INFO       pAdapterInfo;

    pProtocolInfo->ProtocolCharacteristics.StatusHandler(
        MiniportAdapterHandle,
        GeneralStatus,
        StatusBuffer,
        StatusBufferSize
        );

    /*
    IF_LOUD(DbgPrint(">>%s GetStatus %x\n",
        pProtocolInfo->nsProtocolName.Buffer,
        GeneralStatus);)
    */
    if (GeneralStatus==NDIS_STATUS_MEDIA_CONNECT)
    {
	    IF_LOUD(DbgPrint("TEEFER: ProtoID=%d(%s) NDIS_STATUS_MEDIA_CONNECT\n",
			pProtocolInfo->nIndex, pProtocolInfo->szProtocolName);)

        pAdapterInfo=(PNDIS_ADAPTER_INFO)pProtocolInfo->pAdapterInfoList.Flink;
        while ((PNDIS_ADAPTER_INFO)&pProtocolInfo->pAdapterInfoList
            !=pAdapterInfo)
        {
            if (pAdapterInfo->pProtocolBindingContext==MiniportAdapterHandle)
            {
                pAdapterInfo->bNeedToRestoreOpenHandle = TRUE;
                pProtocolInfo->bNeedToRestoreOpenHandles = TRUE;
            }
			IF_LOUD(DbgPrint("TEEFER: ProtoID=%d NeedToRestoreOpenHandles=%d\n",
				pProtocolInfo->nIndex, pProtocolInfo->bNeedToRestoreOpenHandles);)
            pAdapterInfo = (PNDIS_ADAPTER_INFO)pAdapterInfo->ListEntry.Flink;
        }
    }
}


#endif

//     Receive

VOID NDIS_API
TeeferTDCompleteEntry(
    IN PNDIS_PROTOCOL_INFO pProtocolInfo,
    IN NDIS_HANDLE         ProtocolBindingContext,
    IN PNDIS_PACKET        pPacket,
    IN NDIS_STATUS         Status,
    IN UINT                BytesTransfered
    )
{
    PCHAR pTmp;
    PCHAR HeaderBuffer;
    PCHAR LookAheadBuffer;
    PACKET_CONTROL *pControl;

    if (pProtocolInfo==NULL)
        return;

    if (ProtocolBindingContext==g_MyOpen)
    {
        if (pPacket!=NULL)
        {
#ifdef WINNT
            PMDL             pMdl;

            //NdisAcquireSpinLock(&g_MyOpen->NdisSpinLockPacket);
            pMdl=RESERVED(pPacket)->pMdl;
            if (pMdl!=NULL)
            {
                pTmp = MmGetSystemAddressForMdl(pMdl);
                if (Status==NDIS_STATUS_SUCCESS
                    && BytesTransfered<=1514 && pTmp!=NULL)
                {
                    pTmp -= (sizeof(PACKET_CONTROL)+ETHERNET_HEADER_LENGTH);
                    pControl = (PACKET_CONTROL*)pTmp;
                    HeaderBuffer = pTmp+sizeof(PACKET_CONTROL);
                    LookAheadBuffer = HeaderBuffer+ETHERNET_HEADER_LENGTH;
    	            TeeferReceiveIndicate(
                        pProtocolInfo,
                        pControl->ProtocolHandle,
                        (NDIS_HANDLE)(pControl->MacReceiveContext==NULL)?
                             LookAheadBuffer:pControl->MacReceiveContext,
                        HeaderBuffer,
                        ETHERNET_HEADER_LENGTH,
                        LookAheadBuffer,
                        BytesTransfered,
                        BytesTransfered
                        );
                }
            }
            //NdisReleaseSpinLock(&g_MyOpen->NdisSpinLockPacket);
            ExInterlockedInsertTailList(
                &g_MyOpen->RcvList,
                &RESERVED(pPacket)->ListElement,
                &g_MyOpen->RcvQSpinLock);
#else
            pTmp = ((PRAW_PACKET)pPacket)->Reserved.pBufferAddress;
            if (Status==NDIS_STATUS_SUCCESS
                && BytesTransfered<=1514 && pTmp!=NULL)
            {
                pTmp -= (sizeof(PACKET_CONTROL)+ETHERNET_HEADER_LENGTH);
                pControl = (PACKET_CONTROL*)pTmp;
                HeaderBuffer = pTmp+sizeof(PACKET_CONTROL);
                LookAheadBuffer = HeaderBuffer+ETHERNET_HEADER_LENGTH;
    	        TeeferReceiveIndicate(
                    pProtocolInfo,
                    pControl->ProtocolHandle,
                    (NDIS_HANDLE)(pControl->MacReceiveContext==NULL)?
                         LookAheadBuffer:pControl->MacReceiveContext,
                    HeaderBuffer,
                    ETHERNET_HEADER_LENGTH,
                    LookAheadBuffer,
                    BytesTransfered,
                    BytesTransfered
                    );
            }
            InsertTailList(
                &g_MyOpen->RcvList,
                &((PRAW_PACKET)pPacket)->Reserved.ListElement
                );
#endif
        }
    }
    else
    {
        pProtocolInfo->ProtocolCharacteristics.TransferDataCompleteHandler(
            ProtocolBindingContext,
            pPacket,
            Status,
            BytesTransfered
            );
    }
}


__declspec(naked)
NDIS_STATUS
TeeferReceiveIndicateEntry(
    IN PNDIS_PROTOCOL_INFO  pProtocolInfo,
    IN NDIS_HANDLE  ProtocolBindingContext,
    IN NDIS_HANDLE  MacReceiveContext,
    IN PVOID  HeaderBuffer,
    IN UINT HeaderBufferSize,
    IN PVOID LookAheadBuffer,
    IN UINT LookaheadBufferSize,
    IN UINT PacketSize
    )
{
    DISPATCH_TO_WAN_OR_ETHER_HANDLER(
        [esp+4],
        TeeferWanReceiveIndicate,
        TeeferReceiveIndicate
        );
}



NDIS_STATUS NDIS_API
TeeferReceiveIndicate(
    IN PNDIS_PROTOCOL_INFO pProtocolInfo,
    IN NDIS_HANDLE ProtocolBindingContext,
    IN NDIS_HANDLE MacReceiveContext,
    IN PVOID HeaderBuffer,
    IN UINT HeaderBufferSize,
    IN PVOID LookAheadBuffer,
    IN UINT LookaheadBufferSize,
    IN UINT PacketSize
    )
{
    PTEEFER_RULE pRule;
    UINT dwInterfaceId;
    UINT dwProtocolId;
    NDIS_STATUS Status;
    NDIS_HANDLE NdisOpenHandle;
    PACKET_CONTROL PacketControl;
    PLIST_ENTRY PacketListEntry;
    PCHAR pTmp;
    UINT BytesTransfered;
    UINT uiRet;

#ifdef WINNT
    PPACKET_RESERVED Reserved;
    PNDIS_PACKET pPacket;
#else
    PRAW_PACKET pPacket;
#endif
    
	if (pProtocolInfo->bNeedToRestoreOpenHandles)
	{
		pProtocolInfo->bNeedToRestoreOpenHandles = FALSE;
		RestoreOpenHandles (pProtocolInfo);
		IF_LOUD(DbgPrint("TEEFER: ProtoID=%d NeedToRestoreOpenHandles=%d\n",
			pProtocolInfo->nIndex, pProtocolInfo->bNeedToRestoreOpenHandles);)
	}

	if (AllowTokenRingTraffic && pProtocolInfo)
    {
		PNDIS_ADAPTER_INFO pAdapterInfo = GetAdapterInfoFromProtocolBinding(ProtocolBindingContext, pProtocolInfo);
		if (pAdapterInfo &&	pAdapterInfo->NdisMedium == NdisMedium802_5)
		{
#ifdef DEBUG_802_5
			DbgPrint("TEEFER: NdisMedium802_5 receive\n");
#endif

			UpdateReceiveStatPass(pProtocolInfo, PacketSize+HeaderBufferSize);
			return pProtocolInfo->ProtocolCharacteristics.ReceiveHandler(
				ProtocolBindingContext,
				MacReceiveContext,
				HeaderBuffer,
				HeaderBufferSize,
				LookAheadBuffer,
				LookaheadBufferSize,
				PacketSize
				);
		}
	}

    if (pProtocolInfo==NULL || PacketSize>=1600)
	{
		IF_LOUD(DbgPrint("TEEFER:L%d *** Drop Packet ***\n", __LINE__);)
        UpdateReceiveStatBlock(pProtocolInfo, PacketSize+HeaderBufferSize);
        return NDIS_STATUS_SUCCESS;
    }

    if (g_MyOpen==NULL || !g_MyOpen->bEnableReceive
        || pProtocolInfo->bIsTrustedProtocolDriver
		|| pProtocolInfo->bAllowProtocolTraffic)
		{
			UpdateReceiveStatPass(pProtocolInfo, PacketSize+HeaderBufferSize);
			return pProtocolInfo->ProtocolCharacteristics.ReceiveHandler(
				ProtocolBindingContext,
				MacReceiveContext,
				HeaderBuffer,
				HeaderBufferSize,
				LookAheadBuffer,
				LookaheadBufferSize,
				PacketSize
				);
		}

    if (!GetInterfaceIdFromProtocolBinding(
        ProtocolBindingContext,
        pProtocolInfo,
        &dwInterfaceId,
        &dwProtocolId
        ))
    {
        IF_LOUD(DbgPrint("TEEFER: Cannot find interface for Protocol %x\n",
            pProtocolInfo->nIndex);)
        UpdateReceiveStatBlock(pProtocolInfo, PacketSize+HeaderBufferSize);
        return NDIS_STATUS_SUCCESS;
    }
    
    if (LookaheadBufferSize<PacketSize)
    {
        PNDIS_ADAPTER_INFO pAdapterInfo;

        NdisOpenHandle = NULL;
        pAdapterInfo = (PNDIS_ADAPTER_INFO)pProtocolInfo->pAdapterInfoList.Flink;
        while ((PNDIS_ADAPTER_INFO)&pProtocolInfo->pAdapterInfoList!=pAdapterInfo)
        {
            if (pAdapterInfo->nIndex==dwInterfaceId)
            {
                NdisOpenHandle = pAdapterInfo->pOpen;
                break;
            }
            pAdapterInfo = (PNDIS_ADAPTER_INFO)pAdapterInfo->ListEntry.Flink;
        }
        if (NdisOpenHandle==NULL)
        {
            IF_LOUD(DbgPrint("TEEFER: Cannot find AdapterHandle\n");)
            UpdateReceiveStatBlock(pProtocolInfo, PacketSize+HeaderBufferSize);
            return NDIS_STATUS_SUCCESS;
        }
        
	/*
        IF_LOUD(DbgPrint("RI: Receive Need %d got %d head=%d\n", PacketSize,
            LookaheadBufferSize, HeaderBufferSize);)
        */
#ifdef WINNT
        PacketListEntry=ExInterlockedRemoveHeadList(
            &g_MyOpen->RcvList,
            &g_MyOpen->RcvQSpinLock
            );
        if (PacketListEntry == NULL)
        {
            IF_LOUD(DbgPrint("TEEFER: RI Out of buffer\n");)
            UpdateReceiveStatBlock(pProtocolInfo, PacketSize+HeaderBufferSize);
            return NDIS_STATUS_FAILURE;
        }
        Reserved=CONTAINING_RECORD(PacketListEntry,PACKET_RESERVED,ListElement);
        pPacket=CONTAINING_RECORD(Reserved,NDIS_PACKET,ProtocolReserved);
        pTmp = MmGetSystemAddressForMdl(RESERVED(pPacket)->pMdl);
#else  // WINNT
        PacketListEntry=RemoveHeadList(
            &g_MyOpen->RcvList,
            );
        if (PacketListEntry == NULL)
        {
            IF_LOUD(DbgPrint("TEEFER: RI Out of buffer\n");)
            UpdateReceiveStatBlock(pProtocolInfo, PacketSize+HeaderBufferSize);
            return NDIS_STATUS_FAILURE;
        }
        pPacket=CONTAINING_RECORD(PacketListEntry,RAW_PACKET,Reserved.ListElement);
        pTmp = pPacket->Reserved.pBufferAddress;
#endif // WINNT
        
        if (pTmp==NULL)
        {
            IF_LOUD(DbgPrint("TEEFER: RI Out of buffer\n");)
            NdisFreePacket((PNDIS_PACKET)pPacket);
            UpdateReceiveStatBlock(pProtocolInfo, PacketSize+HeaderBufferSize);
            return NDIS_STATUS_FAILURE;
        }
        pTmp -= (sizeof(PacketControl)+ETHERNET_HEADER_LENGTH);
        
        ((PACKET_CONTROL*)pTmp)->NdisDispatchFunctionIndex = 0;
        ((PACKET_CONTROL*)pTmp)->ProtocolHandle = ProtocolBindingContext;
        ((PACKET_CONTROL*)pTmp)->MacReceiveContext =
            (MacReceiveContext!=LookAheadBuffer)?MacReceiveContext:NULL;
        //IF_LOUD(DbgPrint("TEEFER: ReceiveIndicate with TD from %d\n", dwInterfaceId);)
        ((PACKET_CONTROL*)pTmp)->TeeferFlags = PACKET_CONTROL_FROM_RECEIVE
            |(dwInterfaceId<<16) | (dwProtocolId<<24);
        if (g_bInterfaceListHasChanged)
            ((PACKET_CONTROL*)pTmp)->TeeferFlags |= 0x80000000;
        ((PACKET_CONTROL*)pTmp)->pPacketControlList = NULL;
        ((PACKET_CONTROL*)pTmp)->dwProcessId = 0;
        
        NdisMoveMappedMemory(pTmp+sizeof(PacketControl), HeaderBuffer, HeaderBufferSize);
        
        MACRONdisTransferData(
            &Status,
            NdisOpenHandle,
            MacReceiveContext,
            0,
            PacketSize,   //   -LookaheadBufferSize,
            (PNDIS_PACKET)pPacket,
            &BytesTransfered);
        
	/*
        IF_LOUD(DbgPrint("TEEFER: TDreturn=%x Look=%d PSize=%d Got=%d\n",
        Status, LookaheadBufferSize, PacketSize, BytesTransfered);)
	*/
        
        if (Status==NDIS_STATUS_PENDING)
            return NDIS_STATUS_SUCCESS;
        
        TeeferTDCompleteEntry(
            pProtocolInfo,
            g_MyOpen,
            (PNDIS_PACKET)pPacket,
            Status,
            BytesTransfered
            );
        return Status;
    }

    if (IsBlackHole(pProtocolInfo, HeaderBuffer, HeaderBufferSize, LookAheadBuffer,
        LookaheadBufferSize, TRUE))
    {
        UpdateReceiveStatPass(pProtocolInfo, PacketSize+HeaderBufferSize);
        return pProtocolInfo->ProtocolCharacteristics.ReceiveHandler(
            ProtocolBindingContext,
            MacReceiveContext,
            HeaderBuffer,
            HeaderBufferSize,
            LookAheadBuffer,
            LookaheadBufferSize,
            PacketSize
            );
    }

    pRule = TeeferMatchRuleByPacket(
                pProtocolInfo,
                dwInterfaceId,
                HeaderBuffer,
                HeaderBufferSize,
                LookAheadBuffer,
                LookaheadBufferSize,
                TRUE
                );
    if (pRule!=NULL)
    {
        if (pRule->Action==TEEFER_RULE_ACTION_EXAMINE
	    && g_MyOpen->ppfIn!=NULL && !g_MyOpen->bIsClosing)
        {
            if (!PktFifoIsNotExpiring(g_MyOpen->ppfIn))
            {
                PacketControl.NdisDispatchFunctionIndex = 0;  // From ReceiveIndicate
                PacketControl.ProtocolHandle = ProtocolBindingContext;
                PacketControl.MacReceiveContext =
                    (MacReceiveContext!=LookAheadBuffer)?MacReceiveContext:NULL;
                //IF_LOUD(DbgPrint("TEEFER: Receive Indicate from %d\n",
                //dwInterfaceId);)
                PacketControl.TeeferFlags = PACKET_CONTROL_FROM_RECEIVE 
                    | (dwInterfaceId<<16)|(dwProtocolId<<24);
                if (g_bInterfaceListHasChanged)
                    PacketControl.TeeferFlags |= 0x80000000;
                PacketControl.pPacketControlList = NULL;
                PacketControl.dwProcessId = 0;
            
    #ifdef WINNT
	        NdisAcquireSpinLock(&g_MyOpen->NdisSpinLockPacket);
                uiRet = PktFifoPut3 (g_MyOpen->ppfIn, &PacketControl,
                    HeaderBuffer, HeaderBufferSize, LookAheadBuffer,
                    LookaheadBufferSize);
	        NdisReleaseSpinLock(&g_MyOpen->NdisSpinLockPacket);
    #else
                uiRet = PktFifoPut3 (g_MyOpen->ppfIn, &PacketControl,
                    HeaderBuffer, HeaderBufferSize, LookAheadBuffer,
                    LookaheadBufferSize);
    #endif
                if (uiRet==0)
                {
                    UpdateReceiveStatExamine(pProtocolInfo, PacketSize+HeaderBufferSize);
                    //IF_LOUD(DbgPrint("TEEFER: ReceiveInFifo %d\n",
                    //    HeaderBufferSize+LookaheadBufferSize);)
                    PktFifoSetEventIfNotBusy(g_MyOpen->ppfIn,
                        g_MyOpen->PacketInIsPending);
                    //g_TeeferStatus.dwReceiveIndicateCount++;
                }
                return NDIS_STATUS_SUCCESS;
            }
        }   
        else if (pRule->Action==TEEFER_RULE_ACTION_BLOCK)
        {
            IF_LOUD(DbgPrint("TEEFER:L%d *** Drop Packet ***\n", __LINE__);)
			UpdateReceiveStatBlock(pProtocolInfo, PacketSize+HeaderBufferSize);
            return NDIS_STATUS_SUCCESS;
        }
    }

    UpdateReceiveStatPass(pProtocolInfo, PacketSize+HeaderBufferSize);
    return pProtocolInfo->ProtocolCharacteristics.ReceiveHandler(
        ProtocolBindingContext,
        MacReceiveContext,
        HeaderBuffer,
        HeaderBufferSize,
        LookAheadBuffer,
        LookaheadBufferSize,
        PacketSize
        );
}



NDIS_STATUS NDIS_API
TeeferWanReceiveIndicate(
    IN PNDIS_PROTOCOL_INFO pProtocolInfo,
    IN NDIS_HANDLE NdisLinkContext,
    IN PUCHAR PacketBuffer,
    IN UINT PacketSize
    )
{
    UpdateReceiveStatPass(pProtocolInfo, PacketSize);
    return (*(WAN_RECEIVE_HANDLER)pProtocolInfo->ProtocolCharacteristics.ReceiveHandler)(
        NdisLinkContext,
        PacketBuffer,
        PacketSize
        );
}



INT NDIS_API
TeeferReceivePacketEntry(
    IN PNDIS_PROTOCOL_INFO pProtocolInfo,
    IN NDIS_HANDLE ProtocolBindingContext,
    IN PNDIS_PACKET pPacket
    )
{
    CHAR szTmp[1600];
    UINT nTotalLen = sizeof(szTmp);
    UINT nLen = 0;
    UINT dwInterfaceId;
    UINT dwProtocolId;
    PACKET_CONTROL PacketControl;
    UINT uiRet;
    PTEEFER_RULE pRule;
    
	if (pProtocolInfo->bNeedToRestoreOpenHandles)
	{
		pProtocolInfo->bNeedToRestoreOpenHandles = FALSE;
		RestoreOpenHandles (pProtocolInfo);
		IF_LOUD(DbgPrint("TEEFER: ProtoID=%d NeedToRestoreOpenHandles=%d\n",
			pProtocolInfo->nIndex, pProtocolInfo->bNeedToRestoreOpenHandles);)
	}

    if (g_MyOpen==NULL || !g_MyOpen->bEnableReceive
        || pProtocolInfo->bIsTrustedProtocolDriver
		|| pProtocolInfo->bAllowProtocolTraffic)
    {
        //UpdateReceiveStatPass(pProtocolInfo, nTotalLen);
        return pProtocolInfo->ProtocolCharacteristics.ReceivePacketHandler(
            ProtocolBindingContext,
            pPacket
            );
    }

	if (AllowTokenRingTraffic)
	{
		PNDIS_ADAPTER_INFO pAdapterInfo = GetAdapterInfoFromProtocolBinding(ProtocolBindingContext, pProtocolInfo);
		if (pAdapterInfo &&	pAdapterInfo->NdisMedium == NdisMedium802_5)
		{
#ifdef DEBUG_802_5
			DbgPrint("TEEFER: NdisMedium802_5 receive packet\n");
#endif

			return pProtocolInfo->ProtocolCharacteristics.ReceivePacketHandler(
		        ProtocolBindingContext,
			    pPacket
				);
		}
	}

    if (ConvertPacketToBuffer(szTmp, &nTotalLen, pPacket)==NDIS_STATUS_SUCCESS)
    {
        if (!GetInterfaceIdFromProtocolBinding(
            ProtocolBindingContext,
            pProtocolInfo,
            &dwInterfaceId,
            &dwProtocolId
            ))
        {
            IF_LOUD(DbgPrint(
                "TEEFER: ReceivePacket cannot find interface for Protocol %x\n",
                pProtocolInfo->nIndex);)
            UpdateReceiveStatBlock(pProtocolInfo, nTotalLen);
            return NDIS_STATUS_SUCCESS;
        }
        
        if (nTotalLen>=14)
        {
            nLen = 14;
            nTotalLen -= 14;
        }
        else
        {
            nLen = nTotalLen;
            nTotalLen = 0;
        }
                
        if (IsBlackHole(
            pProtocolInfo, 
            szTmp,
            nLen,
            &szTmp[nLen],
            nTotalLen,
            TRUE))
        {
            UpdateReceiveStatPass(pProtocolInfo, nLen+nTotalLen);
            return pProtocolInfo->ProtocolCharacteristics.ReceivePacketHandler(
                ProtocolBindingContext,
                pPacket
                );
        }
        
        pRule = TeeferMatchRuleByPacket(
            pProtocolInfo,
            dwInterfaceId,
            szTmp,
            nLen,
            &szTmp[nLen],
            nTotalLen,
            TRUE
            );
        if (pRule!=NULL)
        {
            if (pRule->Action==TEEFER_RULE_ACTION_EXAMINE
	           && g_MyOpen->ppfIn!=NULL && !g_MyOpen->bIsClosing)
            {
                // From ReceivePacket
                if (!PktFifoIsNotExpiring(g_MyOpen->ppfIn))
                {
                    PacketControl.NdisDispatchFunctionIndex = 1;
                    PacketControl.ProtocolHandle = ProtocolBindingContext;
                    PacketControl.MacReceiveContext = NULL;
                    PacketControl.TeeferFlags = PACKET_CONTROL_FROM_RECEIVE 
                        | (dwInterfaceId<<16)|(dwProtocolId<<24);
                    if (g_bInterfaceListHasChanged)
                        PacketControl.TeeferFlags |= 0x80000000;
                    PacketControl.pPacketControlList = NULL;
                    PacketControl.dwProcessId = 0;
                
#ifdef WINNT
                    NdisAcquireSpinLock(&g_MyOpen->NdisSpinLockPacket);
                    uiRet = PktFifoPut3 (g_MyOpen->ppfIn, &PacketControl,
                        szTmp, nLen, &szTmp[nLen], nTotalLen);
                    NdisReleaseSpinLock(&g_MyOpen->NdisSpinLockPacket);
#else
                    uiRet = PktFifoPut3 (g_MyOpen->ppfIn, &PacketControl,
                        szTmp, nLen, &szTmp[nLen], nTotalLen);
#endif
                    if (uiRet==0)
                    {
                        UpdateReceiveStatExamine(pProtocolInfo, nLen+nTotalLen);
                        PktFifoSetEventIfNotBusy(g_MyOpen->ppfIn,
                            g_MyOpen->PacketInIsPending);
                    }
                    return 0;
                }
            }   
            else if (pRule->Action==TEEFER_RULE_ACTION_BLOCK)
            {
				IF_LOUD(DbgPrint("TEEFER:L%d *** Drop Packet ***\n", __LINE__);)
                UpdateReceiveStatBlock(pProtocolInfo, nLen+nTotalLen);
                return 0;
            }
        }
    }
    if (pProtocolInfo==NULL)
        return 0;

    return pProtocolInfo->ProtocolCharacteristics.ReceivePacketHandler(
        ProtocolBindingContext,
        pPacket
        );
}

//     Send

NDIS_STATUS NDIS_API
TeeferSendPacketToUser(
    IN PNDIS_PROTOCOL_INFO pProtocolInfo,
    IN NDIS_HANDLE  MacBindingHandle,
    IN UINT         NdisDispatchFunctionIndex,
    IN UINT         TeeferFlags,
    IN PNDIS_PACKET pPacket
    )
{
    PTEEFER_RULE    pRule;
    CHAR            *szTmp; //[MAX_PACKET_SIZE];
#ifdef WINNT
	CHAR			*szHeap;
#else
	CHAR			szStack[MAX_PACKET_SIZE];
#endif

    UINT            nTotalLen;	//sizeof(szTmp);
    UINT            nLen = 0;
    PACKET_CONTROL  PacketControl;
    PPACKET_CONTROL_LIST pPacketControlList;
    UINT            dwProcessId;
    UINT            dwInterfaceId;
    UINT            dwProtocolId;
    UINT            uiRet;
	PNDIS_BUFFER    pBuffer;
	NDIS_STATUS     Status;
	NDIS_PHYSICAL_ADDRESS highestAddress = {-1};

#ifdef WINNT
	szHeap = GetIpBuffer(g_MyOpen);
	if (szHeap == NULL)
		return STATUS_INSUFFICIENT_RESOURCES;
	szTmp = szHeap;
	nTotalLen = 65535;
#else
	szTmp = szStack;
	nTotalLen = sizeof(szStack);
#endif

	do {

		dwProcessId = (UINT)TeeferGetProcessId();

		if (pProtocolInfo->bNeedToRestoreOpenHandles)
		{
			pProtocolInfo->bNeedToRestoreOpenHandles = FALSE;
			RestoreOpenHandles (pProtocolInfo);
			IF_LOUD(DbgPrint("TEEFER: ProtoID=%d NeedToRestoreOpenHandles=%d\n",
				pProtocolInfo->nIndex, pProtocolInfo->bNeedToRestoreOpenHandles);)
		}

		if (g_MyOpen==NULL || pPacket==NULL || !g_MyOpen->bEnableSend
			|| pProtocolInfo->bIsTrustedProtocolDriver
            || pProtocolInfo->bIsWinPoETProtocolDriver
			|| pProtocolInfo->bAllowProtocolTraffic
            )
		{
			// return failure to indicate we don't deal with it (punt to original)
			Status = NDIS_STATUS_FAILURE;
			break;
		}

		if (ConvertPacketToBuffer(szTmp, &nTotalLen, pPacket)==NDIS_STATUS_SUCCESS)
		{
			PNDIS_ADAPTER_INFO pAdapterInfo;

			if (nTotalLen>=14)
			{
				nLen = 14;
                nTotalLen -= 14;
            }
            else
            {
                nLen = nTotalLen;
                nTotalLen = 0;
            }
            
            if (!GetInterfaceIdFromMacBinding(
                MacBindingHandle,
                pProtocolInfo,
                &dwInterfaceId,
                &dwProtocolId,
				&pAdapterInfo
                ))
            {
				IF_LOUD(DbgPrint("TEEFER:L%d *** Drop Packet ***\n", __LINE__);)
				UpdateSendStatBlock(pProtocolInfo, pPacket, nTotalLen+nLen);
				Status = NDIS_STATUS_SUCCESS;
				break;
			}

			PacketControl.NdisDispatchFunctionIndex = NdisDispatchFunctionIndex;
			PacketControl.ProtocolHandle = MacBindingHandle;
			PacketControl.MacReceiveContext = pPacket;
			PacketControl.TeeferFlags
			= TeeferFlags | (dwInterfaceId<<16)|(dwProtocolId<<24);
			if (g_bInterfaceListHasChanged)
				PacketControl.TeeferFlags |= 0x80000000;
			PacketControl.dwProcessId = dwProcessId;

			if (AllowTokenRingTraffic && pAdapterInfo->NdisMedium == NdisMedium802_5)
			{
#ifdef DEBUG_802_5
				DbgPrint("TEEFER: NdisMedium802_5 send\n");
#endif

				Status = NDIS_STATUS_FAILURE;
				break;
			}

			if (IsBlackHole(pProtocolInfo, szTmp, nLen, &szTmp[nLen], nTotalLen, FALSE))
			{
				// return failure to indicate we don't deal with it
				// (punt to original)
				Status = NDIS_STATUS_FAILURE;
				break;
			}
        
			pRule = TeeferMatchRuleByPacket(
						pProtocolInfo,
						dwInterfaceId,
						szTmp,
						nLen,
						&szTmp[nLen],
						nTotalLen,
						FALSE
						);

			if (pRule!=NULL)
			{
				if (pRule->Action==TEEFER_RULE_ACTION_EXAMINE)
				{  
					if (g_MyOpen->ppfIn==NULL
						|| g_MyOpen->bIsClosing
						|| PktFifoIsNotExpiring(g_MyOpen->ppfIn))
					{
						Status = NDIS_STATUS_FAILURE;
						break;
					}
					pPacketControlList=NULL;
	#ifdef WINNT
					NdisQueryPacket(pPacket, NULL, NULL, &pBuffer, &nTotalLen);
					if (pBuffer==NULL)
						return NDIS_STATUS_FAILURE;
					
					// Pin:  We cannot examine the buffer in user space because the packet will later
					// dispatch in teefer kernel thread.  Some drivers (ipsecw2k.sys for example) that
					// teefer calls down may attempt to use the invalid buffer and BSOD
					/* commented by craige for compatible with 802.1x
					if (!IsGoodKPtr(MmGetMdlVirtualAddress((PMDL)pBuffer)))
					{
						IF_LOUD(DbgPrint("TEEFER: <<<<VIRTUALADDRESS %x\n", MmGetMdlVirtualAddress((PMDL)pBuffer));)
						return NDIS_STATUS_FAILURE;
					}
					*/
					NdisAcquireSpinLock(&g_MyOpen->NdisSpinLockSendList);
					if (!IsListEmpty(&g_MyOpen->SendFreeList))
						pPacketControlList=(PPACKET_CONTROL_LIST)RemoveHeadList(
						&g_MyOpen->SendFreeList
						);
					NdisReleaseSpinLock(&g_MyOpen->NdisSpinLockSendList);
	#else
					if (!IsListEmpty(&g_MyOpen->SendFreeList))
						pPacketControlList=(PPACKET_CONTROL_LIST)RemoveHeadList(
						&g_MyOpen->SendFreeList
						);
	#endif
					if (pPacketControlList == NULL)
					{
						Status = NDIS_STATUS_FAILURE;
						break;
					}
                
					pPacketControlList->NdisDispatchFunctionIndex
						= PacketControl.NdisDispatchFunctionIndex;
					pPacketControlList->ProtocolHandle = PacketControl.ProtocolHandle;
					pPacketControlList->MacReceiveContext = PacketControl.MacReceiveContext;
					pPacketControlList->TeeferFlags = PacketControl.TeeferFlags;
					pPacketControlList->dwProcessId = PacketControl.dwProcessId;
                
					PacketControl.pPacketControlList = pPacketControlList;
                
	#ifdef WINNT
					NdisAcquireSpinLock(&g_MyOpen->NdisSpinLockSendList);
					InsertTailList(
						&g_MyOpen->SendPendingList,
						(PLIST_ENTRY)pPacketControlList
						);
					NdisReleaseSpinLock(&g_MyOpen->NdisSpinLockSendList);
					NdisAcquireSpinLock(&g_MyOpen->NdisSpinLockPacket);
					uiRet = PktFifoPut (g_MyOpen->ppfIn, &PacketControl,
						szTmp, nLen+nTotalLen);
					NdisReleaseSpinLock(&g_MyOpen->NdisSpinLockPacket);
					if (uiRet==0)
					{
						UpdateSendStatExamine(pProtocolInfo, pPacket,
							nTotalLen+nLen);
						PktFifoSetEventIfNotBusy(g_MyOpen->ppfIn,
							g_MyOpen->PacketInIsPending);
						Status = NDIS_STATUS_PENDING;
						break;
					}
					else
					{
						// Push fifo fail.  Cleanup.  Note that we must fix up
						// the sendpending list before pushing because the 
						NdisAcquireSpinLock(&g_MyOpen->NdisSpinLockSendList);
						RemoveEntryList((PLIST_ENTRY)pPacketControlList);
						NdisReleaseSpinLock(&g_MyOpen->NdisSpinLockSendList);
					}
	#else
					uiRet = PktFifoPut (g_MyOpen->ppfIn, &PacketControl,
						szTmp, nLen+nTotalLen);
					if (uiRet==0)
					{
						InsertTailList(
							&g_MyOpen->SendPendingList,
							(PLIST_ENTRY)pPacketControlList
							);
						UpdateSendStatExamine(pProtocolInfo, pPacket,
							nTotalLen+nLen);
						PktFifoSetEventIfNotBusy(g_MyOpen->ppfIn,
							g_MyOpen->PacketInIsPending);
						Status = NDIS_STATUS_PENDING;
						break;
					}
	#endif				
				}   
				else if (pRule->Action==TEEFER_RULE_ACTION_BLOCK)
				{
					IF_LOUD(DbgPrint("TEEFER:L%d *** Drop Packet ***\n", __LINE__);)
					UpdateSendStatBlock(pProtocolInfo, pPacket, nTotalLen+nLen);
					Status = NDIS_STATUS_SUCCESS;
					break;
				}
				else
				{
					// return failure to indicate we don't deal with it
					// (punt to original)
					Status = NDIS_STATUS_FAILURE;
					break;
				}
			}
		}
		else
		{
			Status = NDIS_STATUS_FAILURE;
			break;
		}

		IF_LOUD(DbgPrint("TEEFER:L%d *** Drop Packet ***\n", __LINE__);)
		UpdateSendStatBlock(pProtocolInfo, pPacket, nTotalLen+nLen);
		Status = NDIS_STATUS_SUCCESS;
		break;
	} while (0);

#ifdef WINNT
	FreeIpBuffer(g_MyOpen, szHeap);
#endif
	return Status;
}


NDIS_STATUS
SendToOriginalSendHandler(
    IN PNDIS_PROTOCOL_INFO pProtocolInfo,
    IN NDIS_HANDLE         MacBindingHandle,
    IN PNDIS_PACKET        Packet
    )
{
    PNDIS_ADAPTER_INFO pAdapterInfo;

    pAdapterInfo = GetAdapterInfoFromMacBinding(MacBindingHandle,
                       pProtocolInfo);
    if (pAdapterInfo==NULL || pAdapterInfo->pFuncOriginalSendHandler==NULL)
    {
        IF_LOUD(DbgPrint("TEEFER: Cannot dispatch with adapterInfo=%x from MacB %x\n",
            pAdapterInfo, MacBindingHandle);)
        UpdateSendStatBlock(pProtocolInfo, Packet, 0);
        return NDIS_STATUS_SUCCESS;
    }
    UpdateSendStatPass(pProtocolInfo, Packet, 0);
    return pAdapterInfo->pFuncOriginalSendHandler(
               MacBindingHandle,
               Packet
               );
}


NDIS_STATUS
SendToOriginalWanSendHandler(
    IN PNDIS_PROTOCOL_INFO pProtocolInfo,
    IN NDIS_HANDLE         MacBindingHandle,
    IN NDIS_HANDLE         NdisLinkHandle,
    IN PNDIS_WAN_PACKET    pWanPacket
    )
{
    PNDIS_ADAPTER_INFO pAdapterInfo;
    
    pAdapterInfo = GetAdapterInfoFromMacBinding(MacBindingHandle,
        pProtocolInfo);
    if (pAdapterInfo==NULL || pAdapterInfo->pFuncOriginalSendHandler==NULL)
    {
        IF_LOUD(DbgPrint("TEEFER: Cannot dispatch with adapterInfo=%x from MacB %x\n",
            pAdapterInfo, MacBindingHandle);)
        if (pWanPacket!=NULL)
        {
            UpdateSendStatBlock(pProtocolInfo, NULL, pWanPacket->CurrentLength);
        }
        return NDIS_STATUS_SUCCESS;
    }
    if (pWanPacket!=NULL)
    {
        UpdateSendStatPass(pProtocolInfo, NULL, pWanPacket->CurrentLength);
    }
    return (*(WAN_SEND_HANDLER)pAdapterInfo->pFuncOriginalSendHandler)(
        MacBindingHandle,
        NdisLinkHandle,
        pWanPacket
        );
}



VOID
SendToOriginalSendPacketsHandler(
    IN PNDIS_PROTOCOL_INFO  pProtocolInfo,
    IN NDIS_HANDLE  MacBindingHandle,
    IN PPNDIS_PACKET  PacketArray,
    IN UINT  NumberOfPackets
    )
{
    PNDIS_ADAPTER_INFO pAdapterInfo;
    PPNDIS_PACKET PacketArrayTmp = PacketArray;
    UINT uiCount = NumberOfPackets;
    
    pAdapterInfo = GetAdapterInfoFromMacBinding(MacBindingHandle,
        pProtocolInfo);
    if (pAdapterInfo==NULL
        || pAdapterInfo->pFuncOriginalSendPacketsHandler==NULL)
    {
        IF_LOUD(DbgPrint("TEEFER: Can't sendpackets with adapterInfo=%x from MacB %x\n",
            pAdapterInfo, MacBindingHandle);)
        return;
    }
    while (uiCount--)
    {
        UpdateSendStatPass(pProtocolInfo, *PacketArrayTmp, 0);
        PacketArrayTmp++;
    }
    pAdapterInfo->pFuncOriginalSendPacketsHandler(
        MacBindingHandle,
        PacketArray,
        NumberOfPackets
        );
}


__declspec(naked)
NDIS_STATUS
TeeferSendEntry(
    IN PNDIS_PROTOCOL_INFO pProtocolInfo,
    IN NDIS_HANDLE         MacBindingHandle,
    IN PNDIS_PACKET        Packet
    )
{
    DISPATCH_TO_WAN_OR_ETHER_HANDLER(
        [esp+4],
        TeeferWanSend,
        TeeferSend
        );
}
                

NDIS_STATUS NDIS_API
TeeferWanSend(
    IN PNDIS_PROTOCOL_INFO pProtocolInfo,
    IN NDIS_HANDLE         MacBindingHandle,
    IN NDIS_HANDLE         NdisLinkHandle,
    IN PNDIS_WAN_PACKET    Packet
    )
{
    return SendToOriginalWanSendHandler(
        pProtocolInfo,
        MacBindingHandle,
        NdisLinkHandle,
        Packet
        );

}

    
NDIS_STATUS NDIS_API
TeeferSend(
    IN PNDIS_PROTOCOL_INFO pProtocolInfo,
    IN NDIS_HANDLE         MacBindingHandle,
    IN PNDIS_PACKET        Packet
    )
{
    NDIS_STATUS Status;
    if (pProtocolInfo==NULL || MacBindingHandle==NULL || Packet==NULL)
    {
        return NDIS_STATUS_FAILURE;
    }

    Status = TeeferSendPacketToUser(
                 pProtocolInfo,
                 MacBindingHandle,
                 0,
                 PACKET_CONTROL_FROM_SEND,
                 Packet
                 );
    
    if (Status==NDIS_STATUS_FAILURE)
    {
        return SendToOriginalSendHandler(
                   pProtocolInfo,
                   MacBindingHandle,
                   Packet
                   );
    }
    return Status;
}


VOID
TeeferSendPacketsEntry(
    IN PNDIS_PROTOCOL_INFO pProtocolInfo,
    IN NDIS_HANDLE MacBindingHandle,
    IN PPNDIS_PACKET PacketArray,
    IN UINT NumberOfPackets
    )
{
    UINT uiCount = NumberOfPackets;
    PPNDIS_PACKET PacketArrayTmp = PacketArray;
    NDIS_STATUS Status;
    
    if (MacBindingHandle==NULL)
    {
        return;
    }

    while (uiCount)
    {
        Status = TeeferSendPacketToUser(
                    pProtocolInfo,
                    MacBindingHandle,
                    0,
                    PACKET_CONTROL_FROM_NDIS_SEND_PACKETS,
                    *PacketArrayTmp
                    );
        if (Status==NDIS_STATUS_FAILURE)
        {
            break;
        }
        PacketArrayTmp++;
        uiCount--;
    }
    if (uiCount)
    {
        SendToOriginalSendPacketsHandler(
            pProtocolInfo,
            MacBindingHandle,
            PacketArrayTmp,
            uiCount
            );
    }

    return;
}


VOID NDIS_API
TeeferOpenAdapterCompleteEntry(
    IN PNDIS_PROTOCOL_INFO pProtocolInfo,
    IN NDIS_HANDLE  ProtocolBindingContext,
    IN NDIS_STATUS  Status,
    IN NDIS_STATUS  OpenErrorStatus
    )
{
    if (pProtocolInfo==NULL)
        return;
    /*
    DbgPrint("opencomplete prot %d handle=%x binding=%x name=%s\r\n",
        pProtocolInfo->nIndex, pProtocolInfo->pProtocol,
        ProtocolBindingContext,
        pProtocolInfo->nsProtocolName.Buffer);
    */
    pProtocolInfo->ProtocolCharacteristics.OpenAdapterCompleteHandler(
        ProtocolBindingContext,
        Status,
        OpenErrorStatus
        );
    RebuildAdapterList(pProtocolInfo);

	{
		struct LIST_MEDIUM *p = MediumFind(ProtocolBindingContext);
		PNDIS_ADAPTER_INFO pAdapterInfo = GetAdapterInfoFromProtocolBinding(ProtocolBindingContext, pProtocolInfo);
		if (pAdapterInfo && p)
		{
#ifdef DEBUG_802_5
			DbgPrint("TEEFER: NdisMedium = %d\n", p->NdisMedium);
#endif

			pAdapterInfo->NdisMedium = p->NdisMedium;
		}

#ifdef DEBUG_802_5
		DbgPrint("TEEFER: # opencomplete p=%08x, a=%08x\n", p, pAdapterInfo);
#endif
		if (p)
			MediumDelete(p);
	}
}



VOID NDIS_API
TeeferCloseAdapterCompleteEntry(
    IN PNDIS_PROTOCOL_INFO pProtocolInfo,
    IN NDIS_HANDLE  ProtocolBindingContext,
    IN NDIS_STATUS  Status
    )
{
    if (pProtocolInfo==NULL)
        return;
    /*
    DbgPrint("close complete prot %d handle=%x binding=%x name=%s\r\n",
        pProtocolInfo->nIndex, pProtocolInfo->pProtocol,
        ProtocolBindingContext,
        pProtocolInfo->nsProtocolName.Buffer);
    */
    pProtocolInfo->ProtocolCharacteristics.CloseAdapterCompleteHandler(
        ProtocolBindingContext,
        Status
        );
    RebuildAdapterList(pProtocolInfo);
}


VOID TeeferRandomizeSeqAck (char *pBuf, unsigned bufsize, BOOLEAN bIsincoming )
{
    SEtherII_FrameHead *peth = 0;
    SIp4_FrameHead* pip = 0;
    STcpSegment_FrameHead* ptcp = 0;
    SUdp_FrameHead* pudp = 0;
    UINT ipheadlen;
    UINT dwSeqAck;
    
    if (bufsize < (14+16))
        return;
    
    peth = (SEtherII_FrameHead *)pBuf;
    
    if ( peth->Type != TOWORD( ETHENRET_PROTOCOL_IP_TYPE ) ) 
        return;
    
    pip = (SIp4_FrameHead*)( pBuf+sizeof(SEtherII_FrameHead) );
    
    // check for bad packet
    ipheadlen =  (pip->Vers_Hlen & 0xf) * 4;
    if ((ipheadlen+sizeof(STcpSegment_FrameHead)+sizeof(SEtherII_FrameHead))>bufsize)
        return;
    
    if (pip->Protocol != IP_PROTOCOL_TCP_TYPE)
        return;
    
    ptcp = (STcpSegment_FrameHead* ) ( ((char*)pip) + ipheadlen );
    
    if (!bIsincoming)	// outgoing
    {
        dwSeqAck = TODWORD(ptcp->SeqNumber);
        dwSeqAck = dwSeqAck + g_dwMySeed
                 + (pip->DestAddr ^ g_dwMySeed ^ 0x773222d);
        ptcp->SeqNumber = TONDWORD(dwSeqAck);

        if(pip->HeadChecksum != 0)
        {
            CalcTcpipChecksum(pip);
        }
        else
        {
            // why?
            // NIC card not offloading the SYN packet even you enable offloading
            // but it does with following non-SYN packet
            // So, we check to see if the packet is SYN, if it's SYN, refill checksum
            // but set the ip headcheck to 0
            // if not syn, leave it
            
            if (ptcp->Offset_Flags&TCP_FLAGS_SYN)
            {
                CalcTcpipChecksum(pip);
                pip->HeadChecksum = 0;
            }
            
        }
    }
    else	// incoming
    {

        dwSeqAck = TODWORD(ptcp->AckNumber);

        dwSeqAck = dwSeqAck - g_dwMySeed
                 - (pip->SourAddr ^ g_dwMySeed ^ 0x773222d);
        ptcp->AckNumber = TONDWORD(dwSeqAck);
        
        CalcTcpipChecksum(pip);
    }
    
}


RECEIVE_INDICATE_THK(0)
RECEIVE_INDICATE_THK(1)
RECEIVE_INDICATE_THK(2)
RECEIVE_INDICATE_THK(3)
RECEIVE_INDICATE_THK(4)
RECEIVE_INDICATE_THK(5)
RECEIVE_INDICATE_THK(6)
RECEIVE_INDICATE_THK(7)
RECEIVE_INDICATE_THK(8)
RECEIVE_INDICATE_THK(9)
RECEIVE_INDICATE_THK(10)
RECEIVE_INDICATE_THK(11)
RECEIVE_INDICATE_THK(12)
RECEIVE_INDICATE_THK(13)
RECEIVE_INDICATE_THK(14)
RECEIVE_INDICATE_THK(15)
RECEIVE_INDICATE_THK(16)
RECEIVE_INDICATE_THK(17)
RECEIVE_INDICATE_THK(18)
RECEIVE_INDICATE_THK(19)
RECEIVE_INDICATE_THK(20)
RECEIVE_INDICATE_THK(21)
RECEIVE_INDICATE_THK(22)
RECEIVE_INDICATE_THK(23)
RECEIVE_INDICATE_THK(24)
RECEIVE_INDICATE_THK(25)
RECEIVE_INDICATE_THK(26)
RECEIVE_INDICATE_THK(27)
RECEIVE_INDICATE_THK(28)
RECEIVE_INDICATE_THK(29)
RECEIVE_INDICATE_THK(30)
RECEIVE_INDICATE_THK(31)
RECEIVE_INDICATE_THK(32)
RECEIVE_INDICATE_THK(33)
RECEIVE_INDICATE_THK(34)
RECEIVE_INDICATE_THK(35)
RECEIVE_INDICATE_THK(36)
RECEIVE_INDICATE_THK(37)
RECEIVE_INDICATE_THK(38)
RECEIVE_INDICATE_THK(39)
RECEIVE_INDICATE_THK(40)
RECEIVE_INDICATE_THK(41)
RECEIVE_INDICATE_THK(42)
RECEIVE_INDICATE_THK(43)
RECEIVE_INDICATE_THK(44)
RECEIVE_INDICATE_THK(45)
RECEIVE_INDICATE_THK(46)
RECEIVE_INDICATE_THK(47)
RECEIVE_INDICATE_THK(48)
RECEIVE_INDICATE_THK(49)
RECEIVE_INDICATE_THK(50)
RECEIVE_INDICATE_THK(51)
RECEIVE_INDICATE_THK(52)
RECEIVE_INDICATE_THK(53)
RECEIVE_INDICATE_THK(54)
RECEIVE_INDICATE_THK(55)
RECEIVE_INDICATE_THK(56)
RECEIVE_INDICATE_THK(57)
RECEIVE_INDICATE_THK(58)
RECEIVE_INDICATE_THK(59)
RECEIVE_INDICATE_THK(60)
RECEIVE_INDICATE_THK(61)
RECEIVE_INDICATE_THK(62)
RECEIVE_INDICATE_THK(63)

#ifdef WINNT
STATUS_THK(0)
STATUS_THK(1)
STATUS_THK(2)
STATUS_THK(3)
STATUS_THK(4)
STATUS_THK(5)
STATUS_THK(6)
STATUS_THK(7)
STATUS_THK(8)
STATUS_THK(9)
STATUS_THK(10)
STATUS_THK(11)
STATUS_THK(12)
STATUS_THK(13)
STATUS_THK(14)
STATUS_THK(15)
STATUS_THK(16)
STATUS_THK(17)
STATUS_THK(18)
STATUS_THK(19)
STATUS_THK(20)
STATUS_THK(21)
STATUS_THK(22)
STATUS_THK(23)
STATUS_THK(24)
STATUS_THK(25)
STATUS_THK(26)
STATUS_THK(27)
STATUS_THK(28)
STATUS_THK(29)
STATUS_THK(30)
STATUS_THK(31)
STATUS_THK(32)
STATUS_THK(33)
STATUS_THK(34)
STATUS_THK(35)
STATUS_THK(36)
STATUS_THK(37)
STATUS_THK(38)
STATUS_THK(39)
STATUS_THK(40)
STATUS_THK(41)
STATUS_THK(42)
STATUS_THK(43)
STATUS_THK(44)
STATUS_THK(45)
STATUS_THK(46)
STATUS_THK(47)
STATUS_THK(48)
STATUS_THK(49)
STATUS_THK(50)
STATUS_THK(51)
STATUS_THK(52)
STATUS_THK(53)
STATUS_THK(54)
STATUS_THK(55)
STATUS_THK(56)
STATUS_THK(57)
STATUS_THK(58)
STATUS_THK(59)
STATUS_THK(60)
STATUS_THK(61)
STATUS_THK(62)
STATUS_THK(63)

#endif

RECEIVE_PACKET_THK(0)
RECEIVE_PACKET_THK(1)
RECEIVE_PACKET_THK(2)
RECEIVE_PACKET_THK(3)
RECEIVE_PACKET_THK(4)
RECEIVE_PACKET_THK(5)
RECEIVE_PACKET_THK(6)
RECEIVE_PACKET_THK(7)
RECEIVE_PACKET_THK(8)
RECEIVE_PACKET_THK(9)
RECEIVE_PACKET_THK(10)
RECEIVE_PACKET_THK(11)
RECEIVE_PACKET_THK(12)
RECEIVE_PACKET_THK(13)
RECEIVE_PACKET_THK(14)
RECEIVE_PACKET_THK(15)
RECEIVE_PACKET_THK(16)
RECEIVE_PACKET_THK(17)
RECEIVE_PACKET_THK(18)
RECEIVE_PACKET_THK(19)
RECEIVE_PACKET_THK(20)
RECEIVE_PACKET_THK(21)
RECEIVE_PACKET_THK(22)
RECEIVE_PACKET_THK(23)
RECEIVE_PACKET_THK(24)
RECEIVE_PACKET_THK(25)
RECEIVE_PACKET_THK(26)
RECEIVE_PACKET_THK(27)
RECEIVE_PACKET_THK(28)
RECEIVE_PACKET_THK(29)
RECEIVE_PACKET_THK(30)
RECEIVE_PACKET_THK(31)
RECEIVE_PACKET_THK(32)
RECEIVE_PACKET_THK(33)
RECEIVE_PACKET_THK(34)
RECEIVE_PACKET_THK(35)
RECEIVE_PACKET_THK(36)
RECEIVE_PACKET_THK(37)
RECEIVE_PACKET_THK(38)
RECEIVE_PACKET_THK(39)
RECEIVE_PACKET_THK(40)
RECEIVE_PACKET_THK(41)
RECEIVE_PACKET_THK(42)
RECEIVE_PACKET_THK(43)
RECEIVE_PACKET_THK(44)
RECEIVE_PACKET_THK(45)
RECEIVE_PACKET_THK(46)
RECEIVE_PACKET_THK(47)
RECEIVE_PACKET_THK(48)
RECEIVE_PACKET_THK(49)
RECEIVE_PACKET_THK(50)
RECEIVE_PACKET_THK(51)
RECEIVE_PACKET_THK(52)
RECEIVE_PACKET_THK(53)
RECEIVE_PACKET_THK(54)
RECEIVE_PACKET_THK(55)
RECEIVE_PACKET_THK(56)
RECEIVE_PACKET_THK(57)
RECEIVE_PACKET_THK(58)
RECEIVE_PACKET_THK(59)
RECEIVE_PACKET_THK(60)
RECEIVE_PACKET_THK(61)
RECEIVE_PACKET_THK(62)
RECEIVE_PACKET_THK(63)

OPN_ADP_COMPLETE_THK(0)
OPN_ADP_COMPLETE_THK(1)
OPN_ADP_COMPLETE_THK(2)
OPN_ADP_COMPLETE_THK(3)
OPN_ADP_COMPLETE_THK(4)
OPN_ADP_COMPLETE_THK(5)
OPN_ADP_COMPLETE_THK(6)
OPN_ADP_COMPLETE_THK(7)
OPN_ADP_COMPLETE_THK(8)
OPN_ADP_COMPLETE_THK(9)
OPN_ADP_COMPLETE_THK(10)
OPN_ADP_COMPLETE_THK(11)
OPN_ADP_COMPLETE_THK(12)
OPN_ADP_COMPLETE_THK(13)
OPN_ADP_COMPLETE_THK(14)
OPN_ADP_COMPLETE_THK(15)
OPN_ADP_COMPLETE_THK(16)
OPN_ADP_COMPLETE_THK(17)
OPN_ADP_COMPLETE_THK(18)
OPN_ADP_COMPLETE_THK(19)
OPN_ADP_COMPLETE_THK(20)
OPN_ADP_COMPLETE_THK(21)
OPN_ADP_COMPLETE_THK(22)
OPN_ADP_COMPLETE_THK(23)
OPN_ADP_COMPLETE_THK(24)
OPN_ADP_COMPLETE_THK(25)
OPN_ADP_COMPLETE_THK(26)
OPN_ADP_COMPLETE_THK(27)
OPN_ADP_COMPLETE_THK(28)
OPN_ADP_COMPLETE_THK(29)
OPN_ADP_COMPLETE_THK(30)
OPN_ADP_COMPLETE_THK(31)
OPN_ADP_COMPLETE_THK(32)
OPN_ADP_COMPLETE_THK(33)
OPN_ADP_COMPLETE_THK(34)
OPN_ADP_COMPLETE_THK(35)
OPN_ADP_COMPLETE_THK(36)
OPN_ADP_COMPLETE_THK(37)
OPN_ADP_COMPLETE_THK(38)
OPN_ADP_COMPLETE_THK(39)
OPN_ADP_COMPLETE_THK(40)
OPN_ADP_COMPLETE_THK(41)
OPN_ADP_COMPLETE_THK(42)
OPN_ADP_COMPLETE_THK(43)
OPN_ADP_COMPLETE_THK(44)
OPN_ADP_COMPLETE_THK(45)
OPN_ADP_COMPLETE_THK(46)
OPN_ADP_COMPLETE_THK(47)
OPN_ADP_COMPLETE_THK(48)
OPN_ADP_COMPLETE_THK(49)
OPN_ADP_COMPLETE_THK(50)
OPN_ADP_COMPLETE_THK(51)
OPN_ADP_COMPLETE_THK(52)
OPN_ADP_COMPLETE_THK(53)
OPN_ADP_COMPLETE_THK(54)
OPN_ADP_COMPLETE_THK(55)
OPN_ADP_COMPLETE_THK(56)
OPN_ADP_COMPLETE_THK(57)
OPN_ADP_COMPLETE_THK(58)
OPN_ADP_COMPLETE_THK(59)
OPN_ADP_COMPLETE_THK(60)
OPN_ADP_COMPLETE_THK(61)
OPN_ADP_COMPLETE_THK(62)
OPN_ADP_COMPLETE_THK(63)


CLS_ADP_COMPLETE_THK(0)
CLS_ADP_COMPLETE_THK(1)
CLS_ADP_COMPLETE_THK(2)
CLS_ADP_COMPLETE_THK(3)
CLS_ADP_COMPLETE_THK(4)
CLS_ADP_COMPLETE_THK(5)
CLS_ADP_COMPLETE_THK(6)
CLS_ADP_COMPLETE_THK(7)
CLS_ADP_COMPLETE_THK(8)
CLS_ADP_COMPLETE_THK(9)
CLS_ADP_COMPLETE_THK(10)
CLS_ADP_COMPLETE_THK(11)
CLS_ADP_COMPLETE_THK(12)
CLS_ADP_COMPLETE_THK(13)
CLS_ADP_COMPLETE_THK(14)
CLS_ADP_COMPLETE_THK(15)
CLS_ADP_COMPLETE_THK(16)
CLS_ADP_COMPLETE_THK(17)
CLS_ADP_COMPLETE_THK(18)
CLS_ADP_COMPLETE_THK(19)
CLS_ADP_COMPLETE_THK(20)
CLS_ADP_COMPLETE_THK(21)
CLS_ADP_COMPLETE_THK(22)
CLS_ADP_COMPLETE_THK(23)
CLS_ADP_COMPLETE_THK(24)
CLS_ADP_COMPLETE_THK(25)
CLS_ADP_COMPLETE_THK(26)
CLS_ADP_COMPLETE_THK(27)
CLS_ADP_COMPLETE_THK(28)
CLS_ADP_COMPLETE_THK(29)
CLS_ADP_COMPLETE_THK(30)
CLS_ADP_COMPLETE_THK(31)
CLS_ADP_COMPLETE_THK(32)
CLS_ADP_COMPLETE_THK(33)
CLS_ADP_COMPLETE_THK(34)
CLS_ADP_COMPLETE_THK(35)
CLS_ADP_COMPLETE_THK(36)
CLS_ADP_COMPLETE_THK(37)
CLS_ADP_COMPLETE_THK(38)
CLS_ADP_COMPLETE_THK(39)
CLS_ADP_COMPLETE_THK(40)
CLS_ADP_COMPLETE_THK(41)
CLS_ADP_COMPLETE_THK(42)
CLS_ADP_COMPLETE_THK(43)
CLS_ADP_COMPLETE_THK(44)
CLS_ADP_COMPLETE_THK(45)
CLS_ADP_COMPLETE_THK(46)
CLS_ADP_COMPLETE_THK(47)
CLS_ADP_COMPLETE_THK(48)
CLS_ADP_COMPLETE_THK(49)
CLS_ADP_COMPLETE_THK(50)
CLS_ADP_COMPLETE_THK(51)
CLS_ADP_COMPLETE_THK(52)
CLS_ADP_COMPLETE_THK(53)
CLS_ADP_COMPLETE_THK(54)
CLS_ADP_COMPLETE_THK(55)
CLS_ADP_COMPLETE_THK(56)
CLS_ADP_COMPLETE_THK(57)
CLS_ADP_COMPLETE_THK(58)
CLS_ADP_COMPLETE_THK(59)
CLS_ADP_COMPLETE_THK(60)
CLS_ADP_COMPLETE_THK(61)
CLS_ADP_COMPLETE_THK(62)
CLS_ADP_COMPLETE_THK(63)

TRANSFER_DATA_THK(0)
TRANSFER_DATA_THK(1)
TRANSFER_DATA_THK(2)
TRANSFER_DATA_THK(3)
TRANSFER_DATA_THK(4)
TRANSFER_DATA_THK(5)
TRANSFER_DATA_THK(6)
TRANSFER_DATA_THK(7)
TRANSFER_DATA_THK(8)
TRANSFER_DATA_THK(9)
TRANSFER_DATA_THK(10)
TRANSFER_DATA_THK(11)
TRANSFER_DATA_THK(12)
TRANSFER_DATA_THK(13)
TRANSFER_DATA_THK(14)
TRANSFER_DATA_THK(15)
TRANSFER_DATA_THK(16)
TRANSFER_DATA_THK(17)
TRANSFER_DATA_THK(18)
TRANSFER_DATA_THK(19)
TRANSFER_DATA_THK(20)
TRANSFER_DATA_THK(21)
TRANSFER_DATA_THK(22)
TRANSFER_DATA_THK(23)
TRANSFER_DATA_THK(24)
TRANSFER_DATA_THK(25)
TRANSFER_DATA_THK(26)
TRANSFER_DATA_THK(27)
TRANSFER_DATA_THK(28)
TRANSFER_DATA_THK(29)
TRANSFER_DATA_THK(30)
TRANSFER_DATA_THK(31)
TRANSFER_DATA_THK(32)
TRANSFER_DATA_THK(33)
TRANSFER_DATA_THK(34)
TRANSFER_DATA_THK(35)
TRANSFER_DATA_THK(36)
TRANSFER_DATA_THK(37)
TRANSFER_DATA_THK(38)
TRANSFER_DATA_THK(39)
TRANSFER_DATA_THK(40)
TRANSFER_DATA_THK(41)
TRANSFER_DATA_THK(42)
TRANSFER_DATA_THK(43)
TRANSFER_DATA_THK(44)
TRANSFER_DATA_THK(45)
TRANSFER_DATA_THK(46)
TRANSFER_DATA_THK(47)
TRANSFER_DATA_THK(48)
TRANSFER_DATA_THK(49)
TRANSFER_DATA_THK(50)
TRANSFER_DATA_THK(51)
TRANSFER_DATA_THK(52)
TRANSFER_DATA_THK(53)
TRANSFER_DATA_THK(54)
TRANSFER_DATA_THK(55)
TRANSFER_DATA_THK(56)
TRANSFER_DATA_THK(57)
TRANSFER_DATA_THK(58)
TRANSFER_DATA_THK(59)
TRANSFER_DATA_THK(60)
TRANSFER_DATA_THK(61)
TRANSFER_DATA_THK(62)
TRANSFER_DATA_THK(63)

TD_COMPLETE_THK(0)
TD_COMPLETE_THK(1)
TD_COMPLETE_THK(2)
TD_COMPLETE_THK(3)
TD_COMPLETE_THK(4)
TD_COMPLETE_THK(5)
TD_COMPLETE_THK(6)
TD_COMPLETE_THK(7)
TD_COMPLETE_THK(8)
TD_COMPLETE_THK(9)
TD_COMPLETE_THK(10)
TD_COMPLETE_THK(11)
TD_COMPLETE_THK(12)
TD_COMPLETE_THK(13)
TD_COMPLETE_THK(14)
TD_COMPLETE_THK(15)
TD_COMPLETE_THK(16)
TD_COMPLETE_THK(17)
TD_COMPLETE_THK(18)
TD_COMPLETE_THK(19)
TD_COMPLETE_THK(20)
TD_COMPLETE_THK(21)
TD_COMPLETE_THK(22)
TD_COMPLETE_THK(23)
TD_COMPLETE_THK(24)
TD_COMPLETE_THK(25)
TD_COMPLETE_THK(26)
TD_COMPLETE_THK(27)
TD_COMPLETE_THK(28)
TD_COMPLETE_THK(29)
TD_COMPLETE_THK(30)
TD_COMPLETE_THK(31)
TD_COMPLETE_THK(32)
TD_COMPLETE_THK(33)
TD_COMPLETE_THK(34)
TD_COMPLETE_THK(35)
TD_COMPLETE_THK(36)
TD_COMPLETE_THK(37)
TD_COMPLETE_THK(38)
TD_COMPLETE_THK(39)
TD_COMPLETE_THK(40)
TD_COMPLETE_THK(41)
TD_COMPLETE_THK(42)
TD_COMPLETE_THK(43)
TD_COMPLETE_THK(44)
TD_COMPLETE_THK(45)
TD_COMPLETE_THK(46)
TD_COMPLETE_THK(47)
TD_COMPLETE_THK(48)
TD_COMPLETE_THK(49)
TD_COMPLETE_THK(50)
TD_COMPLETE_THK(51)
TD_COMPLETE_THK(52)
TD_COMPLETE_THK(53)
TD_COMPLETE_THK(54)
TD_COMPLETE_THK(55)
TD_COMPLETE_THK(56)
TD_COMPLETE_THK(57)
TD_COMPLETE_THK(58)
TD_COMPLETE_THK(59)
TD_COMPLETE_THK(60)
TD_COMPLETE_THK(61)
TD_COMPLETE_THK(62)
TD_COMPLETE_THK(63)

SEND_THK(0)
SEND_THK(1)
SEND_THK(2)
SEND_THK(3)
SEND_THK(4)
SEND_THK(5)
SEND_THK(6)
SEND_THK(7)
SEND_THK(8)
SEND_THK(9)
SEND_THK(10)
SEND_THK(11)
SEND_THK(12)
SEND_THK(13)
SEND_THK(14)
SEND_THK(15)
SEND_THK(16)
SEND_THK(17)
SEND_THK(18)
SEND_THK(19)
SEND_THK(20)
SEND_THK(21)
SEND_THK(22)
SEND_THK(23)
SEND_THK(24)
SEND_THK(25)
SEND_THK(26)
SEND_THK(27)
SEND_THK(28)
SEND_THK(29)
SEND_THK(30)
SEND_THK(31)
SEND_THK(32)
SEND_THK(33)
SEND_THK(34)
SEND_THK(35)
SEND_THK(36)
SEND_THK(37)
SEND_THK(38)
SEND_THK(39)
SEND_THK(40)
SEND_THK(41)
SEND_THK(42)
SEND_THK(43)
SEND_THK(44)
SEND_THK(45)
SEND_THK(46)
SEND_THK(47)
SEND_THK(48)
SEND_THK(49)
SEND_THK(50)
SEND_THK(51)
SEND_THK(52)
SEND_THK(53)
SEND_THK(54)
SEND_THK(55)
SEND_THK(56)
SEND_THK(57)
SEND_THK(58)
SEND_THK(59)
SEND_THK(60)
SEND_THK(61)
SEND_THK(62)
SEND_THK(63)

SEND_PACKETS_THK(0)
SEND_PACKETS_THK(1)
SEND_PACKETS_THK(2)
SEND_PACKETS_THK(3)
SEND_PACKETS_THK(4)
SEND_PACKETS_THK(5)
SEND_PACKETS_THK(6)
SEND_PACKETS_THK(7)
SEND_PACKETS_THK(8)
SEND_PACKETS_THK(9)
SEND_PACKETS_THK(10)
SEND_PACKETS_THK(11)
SEND_PACKETS_THK(12)
SEND_PACKETS_THK(13)
SEND_PACKETS_THK(14)
SEND_PACKETS_THK(15)
SEND_PACKETS_THK(16)
SEND_PACKETS_THK(17)
SEND_PACKETS_THK(18)
SEND_PACKETS_THK(19)
SEND_PACKETS_THK(20)
SEND_PACKETS_THK(21)
SEND_PACKETS_THK(22)
SEND_PACKETS_THK(23)
SEND_PACKETS_THK(24)
SEND_PACKETS_THK(25)
SEND_PACKETS_THK(26)
SEND_PACKETS_THK(27)
SEND_PACKETS_THK(28)
SEND_PACKETS_THK(29)
SEND_PACKETS_THK(30)
SEND_PACKETS_THK(31)
SEND_PACKETS_THK(32)
SEND_PACKETS_THK(33)
SEND_PACKETS_THK(34)
SEND_PACKETS_THK(35)
SEND_PACKETS_THK(36)
SEND_PACKETS_THK(37)
SEND_PACKETS_THK(38)
SEND_PACKETS_THK(39)
SEND_PACKETS_THK(40)
SEND_PACKETS_THK(41)
SEND_PACKETS_THK(42)
SEND_PACKETS_THK(43)
SEND_PACKETS_THK(44)
SEND_PACKETS_THK(45)
SEND_PACKETS_THK(46)
SEND_PACKETS_THK(47)
SEND_PACKETS_THK(48)
SEND_PACKETS_THK(49)
SEND_PACKETS_THK(50)
SEND_PACKETS_THK(51)
SEND_PACKETS_THK(52)
SEND_PACKETS_THK(53)
SEND_PACKETS_THK(54)
SEND_PACKETS_THK(55)
SEND_PACKETS_THK(56)
SEND_PACKETS_THK(57)
SEND_PACKETS_THK(58)
SEND_PACKETS_THK(59)
SEND_PACKETS_THK(60)
SEND_PACKETS_THK(61)
SEND_PACKETS_THK(62)
SEND_PACKETS_THK(63)


#ifdef WINNT
#define  SET_PROT_HOOK_FUNCTIONS(aInfo, x)                                     \
{                                                                              \
    memset(&##aInfo##x, 0, sizeof(##aInfo##x));                                \
    ##aInfo##x.nIndex = x;                                                     \
    ##aInfo##x.TeeferOpenAdapterCompleteHandler                                \
        =(OPEN_ADAPTER_COMPLETE_HANDLER)TeeferOpenAdapterCompleteThunk##x;     \
    ##aInfo##x.TeeferCloseAdapterCompleteHandler                               \
        =(CLOSE_ADAPTER_COMPLETE_HANDLER)TeeferCloseAdapterCompleteThunk##x;   \
    ##aInfo##x.TeeferTransferDataHandler                                       \
        =(TRANSFER_DATA_HANDLER)TeeferTransferDataThunk##x;                    \
    ##aInfo##x.TeeferTransferDataCompleteHandler                               \
        =(TRANSFER_DATA_COMPLETE_HANDLER)TeeferTDCompleteThunk##x;             \
    ##aInfo##x.TeeferReceiveHandler                                            \
        =(RECEIVE_HANDLER)TeeferReceiveIndicateThunk##x;                       \
    ##aInfo##x.TeeferReceivePacketHandler                                      \
        =(RECEIVE_PACKET_HANDLER)TeeferReceivePacketThunk##x;                  \
    ##aInfo##x.TeeferStatusHandler                                             \
        =(STATUS_HANDLER)TeeferStatusThunk##x;                                 \
    ##aInfo##x.TeeferSendHandler                                               \
        =(SEND_HANDLER)TeeferSendThunk##x;                                     \
    ##aInfo##x.TeeferSendPacketsHandler                                        \
        =(SEND_PACKETS_HANDLER)TeeferSendPacketsThunk##x;                      \
}
#else

#define  SET_PROT_HOOK_FUNCTIONS(aInfo, x)                                     \
{                                                                              \
    memset(&##aInfo##x, 0, sizeof(##aInfo##x));                                \
    ##aInfo##x.nIndex = x;                                                     \
    ##aInfo##x.TeeferOpenAdapterCompleteHandler                                \
        =(OPEN_ADAPTER_COMPLETE_HANDLER)TeeferOpenAdapterCompleteThunk##x;     \
    ##aInfo##x.TeeferCloseAdapterCompleteHandler                               \
        =(CLOSE_ADAPTER_COMPLETE_HANDLER)TeeferCloseAdapterCompleteThunk##x;   \
    ##aInfo##x.TeeferTransferDataHandler                                       \
        =(TRANSFER_DATA_HANDLER)TeeferTransferDataThunk##x;                    \
    ##aInfo##x.TeeferTransferDataCompleteHandler                               \
        =(TRANSFER_DATA_COMPLETE_HANDLER)TeeferTDCompleteThunk##x;             \
    ##aInfo##x.TeeferReceiveHandler                                            \
        =(RECEIVE_HANDLER)TeeferReceiveIndicateThunk##x;                       \
    ##aInfo##x.TeeferReceivePacketHandler                                      \
        =(RECEIVE_PACKET_HANDLER)TeeferReceivePacketThunk##x;                  \
    ##aInfo##x.TeeferSendHandler                                               \
        =(SEND_HANDLER)TeeferSendThunk##x;                                     \
    ##aInfo##x.TeeferSendPacketsHandler                                        \
        =(SEND_PACKETS_HANDLER)TeeferSendPacketsThunk##x;                      \
}

#endif

CHAR  g_szRegistryPath[512];
ULONG AllowTokenRingTraffic = 0;

VOID LoadAllowTokenRingTraffic()
{
	char reg[512];
	strcpy(reg, g_szRegistryPath);
	strcat(reg, "\\InitParameters");

#ifdef WINNT
	{
		OBJECT_ATTRIBUTES attr;
		UNICODE_STRING key, val;
		ANSI_STRING key_a;
		HANDLE hKey;
		PKEY_VALUE_PARTIAL_INFORMATION pData;

		RtlInitUnicodeString(&val, L"AllowTokenRing");
		RtlInitAnsiString(&key_a, reg);
		RtlAnsiStringToUnicodeString(&key, &key_a, TRUE);
		InitializeObjectAttributes(&attr, NULL, OBJ_KERNEL_HANDLE|OBJ_CASE_INSENSITIVE, NULL, NULL);
		
		if (NT_SUCCESS(ZwOpenKey(&hKey, KEY_ALL_ACCESS, &attr)))
		{
			ULONG ResultLength;

			pData = (PKEY_VALUE_PARTIAL_INFORMATION)reg;
			if (NT_SUCCESS(ZwQueryValueKey(hKey, &val, KeyValuePartialInformation, pData, 512, &ResultLength)))
			{
				AllowTokenRingTraffic = *((PULONG)pData->Data);
			}
			ZwClose(hKey);
		}

		RtlFreeUnicodeString(&key);
	}
#else
	{
		HKEY hKey;

		if (ERROR_SUCCESS == RegOpenKey(HKEY_LOCAL_MACHINE, reg, &hKey))
		{
			DWORD cbSize = sizeof(ULONG);
			RegQueryValueEx(hKey, "AllowTokenRing", NULL, NULL, &AllowTokenRingTraffic, &cbSize);
			RegCloseKey(hKey);
		}
	}
#endif
}

void SaveAllowTokenRingTraffic()
{
	char reg[512];
	strcpy(reg, g_szRegistryPath);
	strcat(reg, "\\InitParameters");

#ifdef WINNT
	{
		OBJECT_ATTRIBUTES attr;
		UNICODE_STRING key, val;
		ANSI_STRING key_a;
		HANDLE hKey;

		RtlInitUnicodeString(&val, L"AllowTokenRing");
		RtlInitAnsiString(&key_a, reg);
		RtlAnsiStringToUnicodeString(&key, &key_a, TRUE);
		InitializeObjectAttributes(&attr, NULL, OBJ_KERNEL_HANDLE|OBJ_CASE_INSENSITIVE, NULL, NULL);
		
		if (NT_SUCCESS(ZwOpenKey(&hKey, KEY_ALL_ACCESS, &attr)))
		{
			ZwSetValueKey(hKey, &val, 0, REG_DWORD, &AllowTokenRingTraffic, sizeof(ULONG));
			ZwClose(hKey);
		}

		RtlFreeUnicodeString(&key);
	}
#else
	{
		HKEY hKey;

		if (ERROR_SUCCESS == RegOpenKey(HKEY_LOCAL_MACHINE, reg, &hKey))
		{
			DWORD cbSize = sizeof(ULONG);
			RegSetValueEx(hKey, "AllowTokenRing", NULL, REG_BINARY, &AllowTokenRingTraffic, cbSize);
			RegCloseKey(hKey);
		}
	}
#endif
}

BOOLEAN
InitProtocolTable(
    IN PCHAR szRegistryPath
    )
{
	if (szRegistryPath != g_szRegistryPath)
		strcpy(g_szRegistryPath, szRegistryPath);

    TeeferSetDefaultRuleTable(szRegistryPath);        

    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 0);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 1);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 2);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 3);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 4);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 5);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 6);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 7);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 8);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 9);

    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 10);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 11);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 12);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 13);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 14);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 15);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 16);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 17);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 18);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 19);

    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 20);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 21);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 22);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 23);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 24);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 25);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 26);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 27);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 28);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 29);

    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 30);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 31);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 32);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 33);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 34);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 35);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 36);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 37);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 38);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 39);

    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 40);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 41);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 42);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 43);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 44);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 45);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 46);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 47);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 48);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 49);

    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 50);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 51);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 52);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 53);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 54);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 55);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 56);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 57);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 58);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 59);

    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 60);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 61);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 62);
    SET_PROT_HOOK_FUNCTIONS(g_sProtInfo, 63);

    _asm
    {
        rdtsc
        mov   g_dwMySeed, eax
    }
    return TRUE;
}
