/*++
*************************************************************************
+-----------------------------------------------------------------------+
|  Copyright 1998-2001 by Sygate Technologies, Inc.                     |
|      All Rights Reserved.                                             |
| Reproduction, adaptation, or translation without prior written        |
| permission is prohibited, except as allowed under Copyright laws.     |
|                                                                       |
| N O T I C E                                                           |
|                                                                       |
| THIS MATERIAL IS A TRADE SECRET OF SYGATE Techlogies, INC.            |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED.                             |
+-----------------------------------------------------------------------+
*************************************************************************
--*/

/*++
 *
 * $Author: yyeap $
 * $Date: 2003/01/15 23:16:09 $
 * $Revision: 1.9 $
 * $Workfile:$
 * $Log: Tffun.h,v $
 * Revision 1.9  2003/01/15 23:16:09  yyeap
 * Check in new teefer loader class
 *
 * Revision 1.8  2002/12/03 23:29:42  yyeap
 * Check in allow initial traffic feature
 *
 * Revision 1.7  2002/10/03 02:13:58  yyeap
 * Limit the restore open handle code to after receiving
 * NDIS_STATUS_MEDIA_CONNECT only.
 *
 * Revision 1.6  2002/10/01 21:08:23  yyeap
 * Fix a win2k ndissend not work on a dlink card bug.  This card will get a
 * NdisMFakeSend during boot and later switch to the real NdisMSend
 * after receiving a NDIS_STATUS_LINE_UP.
 *
 * Revision 1.5  2002/03/01 01:33:49  yyeap
 * Check in AllowInitTraffic modification and fixed lots of bugs in the
 * rule engine
 *
 * Revision 1.4  2001/12/19 23:37:57  yyeap
 * Reload default rule on NT if the firewall is not running
 *
 * Revision 1.3  2001/11/29 00:59:02  yyeap
 * Check in support to read default rules from registry
 *
 * Revision 1.2  2001/11/20 03:11:59  yyeap
 * Check in misc bug fixes
 *
 * Revision 1.1  2001/11/02 22:27:12  yyeap
 * no message
 *
 * 
 * $NoKeywords: $
 *
--*/

typedef struct
{
    UINT        Signature;
    PCHAR       SrcBuf;
    UINT        uiSrcBufLen;
} TEEFER_TRANSFER_CONTEXT, *PTEEFER_TRANSFER_CONTEXT;

#define         TEEFER_RECEIVE_CONTEXT_SIGNATURE     'EFET'

//     Utils:  OS dependent

BOOLEAN
TeeferGetRuleTable(
    PTEEFER_RULE pRuleTable,
    UINT uRuleTableSize,
    PUINT puOutRuleCount,
    PUINT puTotalRuleCount
    );

BOOLEAN
TeeferSetRuleTable(
    PTEEFER_RULE pRuleTable,
    UINT uRuleTableSize,
    UINT uRuleCount
    );

BOOLEAN
TeeferSetInitRuleTable(
    PTEEFER_RULE pRuleTable,
    UINT uRuleTableSize,
    UINT uRuleCount
    );

BOOLEAN
TeeferSetRuleTableEx(
    PTEEFER_RULE pSrcRuleTable,
    UINT uSrcRuleTableSize,
    UINT uSrcRuleCount,
    PTEEFER_RULE *ppDstRuleTable,
    PUINT puDstRuleTableSize,
    PUINT puDstRuleCount
    );

BOOLEAN
TeeferSetDefaultRuleTable(
    IN PCHAR szRegistryPath
    );

BOOLEAN
MapAllProtocolNamesInRuleTableToIds(
    VOID
    );

BOOLEAN
IsBlackHole (
    IN PNDIS_PROTOCOL_INFO pProtInfo,
    IN PVOID HeaderBuffer,
    IN UINT HeaderBufferSize,
    IN PVOID LookAheadBuffer,
    IN UINT LookaheadBufferSize,
    IN BOOLEAN IsIncoming
    );

BOOLEAN
RebuildAdapterList(
    PNDIS_PROTOCOL_INFO pProtocolInfo
    );

//     Utils

BOOLEAN
DriverGetFullPathName(
    PCHAR szInName,
    PCHAR szOutName
    );

BOOLEAN
IsTcpIpProtocolInfo(
    IN PNDIS_PROTOCOL_INFO pProtocolInfo
    );

BOOLEAN
IsRasArpProtocolInfo(
    IN PNDIS_PROTOCOL_INFO pProtocolInfo
    );
                      
/*
INT
MatchRuleByPacket(
    IN PRULE_ACTION pRuleAction,
    IN PNDIS_PROTOCOL_INFO pProtInfo,
    IN PVOID HeaderBuffer,
    IN UINT HeaderBufferSize,
    IN PVOID LookAheadBuffer,
    IN UINT LookaheadBufferSize,
    IN UINT IsIncoming
    );
    */


INT
ConvertPacketToBuffer(
    IN PCHAR pTmp,
    IN PUINT pOutTotalLen,
    IN PNDIS_PACKET pPacket
    );


BOOLEAN
GetInterfaceIdFromMacBinding(
    NDIS_HANDLE MacBindingContext,
    PNDIS_PROTOCOL_INFO pProtocolInfo,
    PUINT puiInterfaceId,
    PUINT puiProtocolId,
	PNDIS_ADAPTER_INFO *ppAdapterInfo
    );

                                        
PNDIS_ADAPTER_INFO
GetAdapterInfoFromProtocolBinding(
    NDIS_HANDLE ProtocolBindingContext,
    PNDIS_PROTOCOL_INFO pProtocolInfo
	);

BOOLEAN
GetInterfaceIdFromProtocolBinding(
    NDIS_HANDLE ProtocolBindingContext,
    PNDIS_PROTOCOL_INFO pProtocolInfo,
    PUINT puiInterfaceId,
    PUINT puiProtocolId
    );


PNDIS_PROTOCOL_INFO
GetProtocolInfoFromTeeferFlags(
    unsigned flags
    );


PNDIS_PROTOCOL_INFO
GetProtocolInfoFromProtocolHandle(
    NDIS_HANDLE ProtocolHandle
    );


PNDIS_ADAPTER_INFO
GetAdapterInfoFromMacBinding(
    NDIS_HANDLE MacBindingHandle,
    PNDIS_PROTOCOL_INFO pProtocolInfo
    );

BOOLEAN
InitProtocolTable(
    IN PCHAR szRegistryPath
    );

BOOLEAN
AllocTeeferProtocolInfo(
	PNDIS_PROTOCOL_INFO *pProtInfo
	);


BOOLEAN
FreeTeeferProtocolInfo(
	PNDIS_PROTOCOL_INFO pProtInfo
	);


BOOLEAN
UpdateReceiveStatBlock(
    PNDIS_PROTOCOL_INFO pProtocolInfo,
    ULONG ulLen
    );

BOOLEAN
UpdateReceiveStatPass(
    PNDIS_PROTOCOL_INFO pProtocolInfo,
    UINT ulLen
    );

BOOLEAN
UpdateReceiveStatExamine(
    PNDIS_PROTOCOL_INFO pProtocolInfo,
    UINT ulLen
    );

BOOLEAN
UpdateReceiveStatExamineDispatched(
    PNDIS_PROTOCOL_INFO pProtocolInfo,
    UINT ulLen
    );

BOOLEAN
UpdateSendStatBlock(
    PNDIS_PROTOCOL_INFO pProtocolInfo,
    PNDIS_PACKET Packet,
    UINT ulTotalLen
    );

BOOLEAN
UpdateSendStatPass(
    PNDIS_PROTOCOL_INFO pProtocolInfo,
    PNDIS_PACKET Packet,
    UINT ulTotalLen
    );

BOOLEAN
UpdateSendStatExamine(
    PNDIS_PROTOCOL_INFO pProtocolInfo,
    PNDIS_PACKET Packet,
    UINT ulTotalLen
    );

BOOLEAN
UpdateSendStatExamineDispatched(
    PNDIS_PROTOCOL_INFO pProtocolInfo,
    PNDIS_PACKET Packet,
    UINT ulTotalLen
    );

VOID RestoreOpenHandles (
    IN PNDIS_PROTOCOL_INFO pProtocolInfo
    );

NDIS_STATUS
SendToOriginalSendHandler(
    IN PNDIS_PROTOCOL_INFO pProtocolInfo,
    IN NDIS_HANDLE MacBindingHandle,
    IN PNDIS_PACKET Packet
    );

NDIS_STATUS
SendToOriginalWanSendHandler(
    IN PNDIS_PROTOCOL_INFO pProtocolInfo,
    IN NDIS_HANDLE         MacBindingHandle,
    IN NDIS_HANDLE         NdisLinkHandle,
    IN PNDIS_WAN_PACKET    pWanPacket
    );
                             
VOID
SendToOriginalSendPacketsHandler(
    IN PNDIS_PROTOCOL_INFO pProtocolInfo,
    IN NDIS_HANDLE MacBindingHandle,
    IN PPNDIS_PACKET PacketArray,
    IN UINT NumberOfPackets
    );

VOID NDIS_API
TeeferTDCompleteEntry(
    IN PNDIS_PROTOCOL_INFO  pProtInfo,
    IN NDIS_HANDLE  ProtocolBindingContext,
    IN PNDIS_PACKET  pPacket,
    IN NDIS_STATUS  Status,
    IN UINT  BytesTransfered
    );


NDIS_STATUS
TeeferReceiveIndicateEntry(
    IN PNDIS_PROTOCOL_INFO  pProtInfo,
    IN NDIS_HANDLE  ProtocolBindingContext,
    IN NDIS_HANDLE  MacReceiveContext,
    IN PVOID  HeaderBuffer,
    IN UINT  HeaderBufferSize,
    IN PVOID  LookAheadBuffer,
    IN UINT  LookaheadBufferSize,
    IN UINT  PacketSize
    );


NDIS_STATUS NDIS_API
TeeferReceiveIndicate(
    IN PNDIS_PROTOCOL_INFO  pProtInfo,
    IN NDIS_HANDLE  ProtocolBindingContext,
    IN NDIS_HANDLE  MacReceiveContext,
    IN PVOID  HeaderBuffer,
    IN UINT  HeaderBufferSize,
    IN PVOID  LookAheadBuffer,
    IN UINT  LookaheadBufferSize,
    IN UINT  PacketSize
    );


NDIS_STATUS NDIS_API
TeeferWanReceiveIndicate(
    IN PNDIS_PROTOCOL_INFO  pProtInfo,
    IN NDIS_HANDLE  NdisLinkContext,
    IN PUCHAR  PacketBuffer,
    IN UINT  PacketSize
    );


INT NDIS_API
TeeferReceivePacketEntry(
    IN PNDIS_PROTOCOL_INFO  pProtInfo,
    IN NDIS_HANDLE  ProtocolBindingContext,
    IN PNDIS_PACKET  pPacket
    );


NDIS_STATUS NDIS_API
TeeferSendPacketToUser(
    IN PNDIS_PROTOCOL_INFO  pProtocolInfo,
    IN NDIS_HANDLE  MacBindingHandle,
    IN UINT  NdisDispatchFunctionIndex,
    IN UINT  TeeferFlags,
    IN PNDIS_PACKET  pPacket
    );


NDIS_STATUS
TeeferSendEntry(
    IN PNDIS_PROTOCOL_INFO  pProtocolInfo,
    IN NDIS_HANDLE  MacBindingHandle,
    IN PNDIS_PACKET  Packet
    );


NDIS_STATUS NDIS_API
TeeferSend(
    IN PNDIS_PROTOCOL_INFO  pProtocolInfo,
    IN NDIS_HANDLE  MacBindingHandle,
    IN PNDIS_PACKET  Packet
    );


NDIS_STATUS NDIS_API
TeeferWanSend(
    IN PNDIS_PROTOCOL_INFO  pProtocolInfo,
    IN NDIS_HANDLE  MacBindingHandle,
    IN NDIS_HANDLE  NdisLinkHandle,
    IN PNDIS_WAN_PACKET  Packet
    );


VOID
TeeferSendPacketsEntry(
    IN PNDIS_PROTOCOL_INFO  pProtInfo,
    IN NDIS_HANDLE  MacBindingHandle,
    IN PPNDIS_PACKET  PacketArray,
    IN UINT  NumberOfPackets
    );


VOID NDIS_API
TeeferOpenAdapterCompleteEntry(
    IN PNDIS_PROTOCOL_INFO pProtInfo,
    IN NDIS_HANDLE  ProtocolBindingContext,
    IN NDIS_STATUS  Status,
    IN NDIS_STATUS  OpenErrorStatus
    );


VOID NDIS_API
TeeferCloseAdapterCompleteEntry(
    IN PNDIS_PROTOCOL_INFO pProtInfo,
    IN NDIS_HANDLE  ProtocolBindingContext,
    IN NDIS_STATUS  Status
    );


VOID NDIS_API
TeeferTDCompleteEntry(
    IN PNDIS_PROTOCOL_INFO pProtInfo,
    IN NDIS_HANDLE         ProtocolBindingContext,
    IN PNDIS_PACKET        pPacket,
    IN NDIS_STATUS         Status,
    IN UINT                BytesTransfered
    );

VOID
TeeferRandomizeSeqAck(
    char *pBuf,
    unsigned bufsize,
    BOOLEAN bIsincoming
    );

#define RECEIVE_INDICATE_THK(x) __declspec(naked)                              \
                                void TeeferReceiveIndicateThunk##x()           \
                                {                                              \
                                   _asm pop    eax                             \
                                   _asm push   OFFSET g_sProtInfo##x           \
                                   _asm push   eax                             \
                                   _asm jmp    TeeferReceiveIndicateEntry      \
                                }


#define RECEIVE_PACKET_THK(x)   __declspec(naked)                              \
                                void TeeferReceivePacketThunk##x()             \
                                {                                              \
                                   _asm pop    eax                             \
                                   _asm push   OFFSET g_sProtInfo##x           \
                                   _asm push   eax                             \
                                   _asm jmp    TeeferReceivePacketEntry        \
                                }


#define STATUS_THK(x) __declspec(naked)                                        \
                                void TeeferStatusThunk##x()                    \
                                {                                              \
                                   _asm pop    eax                             \
                                   _asm push   OFFSET g_sProtInfo##x           \
                                   _asm push   eax                             \
                                   _asm jmp    TeeferStatusEntry               \
                                }


#define OPN_ADP_COMPLETE_THK(x) __declspec(naked)                              \
                                void TeeferOpenAdapterCompleteThunk##x()       \
                                {                                              \
                                   _asm pop    eax                             \
                                   _asm push   OFFSET g_sProtInfo##x           \
                                   _asm push   eax                             \
                                   _asm jmp    TeeferOpenAdapterCompleteEntry  \
                                }


#define CLS_ADP_COMPLETE_THK(x) __declspec(naked)                              \
                                void TeeferCloseAdapterCompleteThunk##x()      \
                                {                                              \
                                   _asm pop    eax                             \
                                   _asm push   OFFSET g_sProtInfo##x           \
                                   _asm push   eax                             \
                                   _asm jmp    TeeferCloseAdapterCompleteEntry \
                                }

#define TRANSFER_DATA_THK(x)    __declspec(naked)                              \
                                void TeeferTransferDataThunk##x()              \
                                {                                              \
                                   _asm pop    eax                             \
                                   _asm push   OFFSET g_sProtInfo##x           \
                                   _asm push   eax                             \
                                   _asm jmp    TeeferTransferDataEntry         \
                                }

#define TD_COMPLETE_THK(x)      __declspec(naked)                              \
                                void TeeferTDCompleteThunk##x()                \
                                {                                              \
                                   _asm pop    eax                             \
                                   _asm push   OFFSET g_sProtInfo##x           \
                                   _asm push   eax                             \
                                   _asm jmp    TeeferTDCompleteEntry           \
                                }

#define SEND_THK(x)             __declspec(naked)                              \
                                void TeeferSendThunk##x()                      \
                                {                                              \
                                   _asm pop    eax                             \
                                   _asm push   OFFSET g_sProtInfo##x           \
                                   _asm push   eax                             \
                                   _asm jmp    TeeferSendEntry                 \
                                }

#define SEND_PACKETS_THK(x)     __declspec(naked)                              \
                                void TeeferSendPacketsThunk##x()               \
                                {                                              \
                                   _asm pop    eax                             \
                                   _asm push   OFFSET g_sProtInfo##x           \
                                   _asm push   eax                             \
                                   _asm jmp    TeeferSendPacketsEntry          \
                                }

#define MAX_NUMOFSTRINGPOOL		16

// __RAIN 2003-12-02
struct LIST_MEDIUM
{
	LIST_ENTRY Next;
	PVOID arg;
	NDIS_MEDIUM NdisMedium;
};

void MediumAdd(PVOID arg, NDIS_MEDIUM NdisMedium);
struct LIST_MEDIUM *MediumFind(PVOID arg);
void MediumDelete(struct LIST_MEDIUM *p);

extern CHAR g_szRegistryPath[512];

extern ULONG AllowTokenRingTraffic;

VOID LoadAllowTokenRingTraffic();
VOID SaveAllowTokenRingTraffic();
