// file checksum.h

/*++
*************************************************************************
+-----------------------------------------------------------------------+
|  Copyright (C) SYBERGEN, INC. 1998,1999                               |
|      All Rights Reserved.                                             |
| Reproduction, adaptation, or translation without prior written        |
| permission is prohibited, except as allowed under Copyright laws.     |
|                                                                       |
| N O T I C E                                                           |
|                                                                       |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC.                     |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED.                             |
+-----------------------------------------------------------------------+
*************************************************************************
--*/
/*++
History:

04/01/1999			Created by Yadong Zhang

--*/



#ifndef SND_CHECKSUM_H
#define SND_CHECKSUM_H

#ifndef SND_DEFINED_BASIC_TYPE
#define SND_DEFINED_BASIC_TYPE
        typedef unsigned char           byte;
        typedef unsigned short          word;
        typedef unsigned long           dword;
        typedef unsigned int            uint;
        typedef unsigned __int64        uint64;
        typedef __int64                         int64;
        typedef long                            sbool;
#endif

#define CHK_DEBUG          0

#define sysprintln     DbgPrint

word Checksum(void* pf,unsigned len);

word IpChecksum(void *pIp, unsigned len);
word TcpChecksum(void *pIp, unsigned len);
word UdpChecksum(void *pIp, unsigned len);
word IcmpChecksum(void *pIp, unsigned len);

void CalcUdpChecksum(void *pIp);
void CalcTcpipChecksum(void *pIp);
void CalcIcmpChecksum(void *pIp);

word IncrementChecksum(word old_checksum, word old_word, word new_word);
void RecalcChecksumWithNewDestIp(void *p_old_ip, dword new_dest_ip);
// p_old_ip points to the old ip packet.
void RecalcChecksumWithNewSourIp(void *p_old_ip, dword new_sour_ip);
// p_old_ip points to the old ip packet.

#endif
// end of checksum.h
