// file PROTOCOL.H

/*++
*************************************************************************
+-----------------------------------------------------------------------+
|  Copyright (C) SYBERGEN, INC. 1998                                    |
|      All Rights Reserved.                                             |
| Reproduction, adaptation, or translation without prior written        |
| permission is prohibited, except as allowed under Copyright laws.     |
|                                                                       |
| N O T I C E                                                           |
|                                                                       |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC.                     |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED.                             |
+-----------------------------------------------------------------------+
*************************************************************************
--*/



#ifndef TEEFERPROTOCOL_H
#define TEEFERPROTOCOL_H

#ifndef NDIS_API
#define NDIS_API __stdcall
#endif

#include "packon1.h"

#ifdef  USER_APP
typedef void*                 SEND_PACKETS_HANDLER;
typedef void*                 TRANSFER_DATA_HANDLER;
typedef void*                 NDIS_SEND_HANDLER;
typedef void*                 OPEN_ADAPTER_COMPLETE_HANDLER;
typedef void*                 CLOSE_ADAPTER_COMPLETE_HANDLER;
typedef void*                 SEND_COMPLETE_HANDLER;
typedef void*                 SEND_HANDLER;
typedef void*                 TRANSFER_DATA_COMPLETE_HANDLER;
typedef void*                 RESET_COMPLETE_HANDLER;
typedef void*                 REQUEST_COMPLETE_HANDLER;
typedef void*                 RECEIVE_HANDLER;
typedef void*                 RECEIVE_PACKET_HANDLER;
typedef void*                 RECEIVE_COMPLETE_HANDLER;
typedef void*                 STATUS_HANDLER;
typedef void*                 STATUS_COMPLETE_HANDLER;
typedef void*                 UNLOAD_PROTOCOL_HANDLER;
typedef PVOID                 NDIS_HANDLE, *PNDIS_HANDLE;
typedef VOID                  NDIS_OPEN_BLOCK, *PNDIS_OPEN_BLOCK;
typedef VOID                  NDIS_ADAPTER_BLOCK, *PNDIS_ADAPTER_BLOCK;
typedef VOID                  NDIS_PROTOCOL_BLOCK, *PNDIS_PROTOCOL_BLOCK;
typedef struct  _NDIS_STRING {
    USHORT  S_Length;
    USHORT  S_MaxLength;
    PUCHAR  S_Buffer;
} NDIS_STRING, *PNDIS_STRING;

typedef ULONG NDIS_STATUS;
typedef NDIS_STATUS *PNDIS_STATUS;

#ifndef _NDIS_
//
// Medium the Ndis Driver is running on (OID_GEN_MEDIA_SUPPORTED/ OID_GEN_MEDIA_IN_USE).
//
typedef enum _NDIS_MEDIUM
{
	NdisMedium802_3,
	NdisMedium802_5,
	NdisMediumFddi,
	NdisMediumWan,
	NdisMediumLocalTalk,
	NdisMediumDix,				// defined for convenience, not a real medium
	NdisMediumArcnetRaw,
	NdisMediumArcnet878_2,
	NdisMediumAtm,
	NdisMediumWirelessWan,
	NdisMediumIrda,
	NdisMediumBpc,
	NdisMediumCoWan,
	NdisMedium1394,
	NdisMediumMax				// Not a real medium, defined as an upper-bound
} NDIS_MEDIUM, *PNDIS_MEDIUM;
#endif

#else   USER_APP

typedef
NDIS_STATUS
(NDIS_API *WAN_RECEIVE_HANDLER)(
    IN NDIS_HANDLE NdisLinkHandle,
    IN PUCHAR PacketBuffer,
    IN ULONG PacketSize
    );

typedef
VOID
(NDIS_API *SEND_PACKETS_HANDLER)(
    IN NDIS_HANDLE MiniportAdapterContext,
    IN PNDIS_PACKET *PacketArray,
    IN UINT NumberOfPackets
    );

typedef
NDIS_STATUS
(NDIS_API *WAN_SEND_HANDLER)(
    IN NDIS_HANDLE MacBindingHandle,
    IN NDIS_HANDLE LinkHandle,
    IN PVOID Packet
    );

typedef
VOID
(NDIS_API *NDIS_SEND_HANDLER)(
    OUT PNDIS_STATUS pStatus,
    IN NDIS_HANDLE  OpenBindingHandle,
    IN PNDIS_PACKET Packet
    );
#endif   // USER_APP

typedef
VOID
(NDIS_API *BIND_ADAPTER_HANDLER)(
	OUT	PNDIS_STATUS			Status,
	IN	NDIS_HANDLE				BindContext,
	IN	PNDIS_STRING			DeviceName,
	IN	PVOID					SystemSpecific1,
	IN	PVOID					SystemSpecific2
	);

typedef
VOID
(NDIS_API *UNBIND_ADAPTER_HANDLER)(
	OUT	PNDIS_STATUS			Status,
	IN	NDIS_HANDLE				ProtocolBindingContext,
	IN	NDIS_HANDLE				UnbindContext
	);

#ifndef WINNT

//
// WAN Packet. This is used by WAN miniports only. This is the legacy model.
// Co-Ndis is the preferred model for WAN miniports
//
typedef struct _NDIS_WAN_PACKET
{
        LIST_ENTRY                      WanPacketQueue;
        PUCHAR                          CurrentBuffer;
        ULONG                           CurrentLength;
        PUCHAR                          StartBuffer;
        PUCHAR                          EndBuffer;
        PVOID                           ProtocolReserved1;
        PVOID                           ProtocolReserved2;
        PVOID                           ProtocolReserved3;
        PVOID                           ProtocolReserved4;
        PVOID                           MacReserved1;
        PVOID                           MacReserved2;
        PVOID                           MacReserved3;
        PVOID                           MacReserved4;
} NDIS_WAN_PACKET, *PNDIS_WAN_PACKET;

typedef
NDIS_STATUS
(*PNP_EVENT_HANDLER)(
	IN	NDIS_HANDLE				ProtocolBindingContext,
//	IN	PNET_PNP_EVENT			NetPnPEvent
	IN	PVOID                   NetPnPEvent
);


//
// Protocol characteristics for down-level NDIS 3.0 protocols
//
typedef struct _NDIS30_PROTOCOL_CHARACTERISTICS
{
	UCHAR							MajorNdisVersion;
	UCHAR							MinorNdisVersion;
	USHORT							Filler;
	UINT	    					Flags;
    OPEN_ADAPTER_COMPLETE_HANDLER	OpenAdapterCompleteHandler;
    CLOSE_ADAPTER_COMPLETE_HANDLER	CloseAdapterCompleteHandler;
	SEND_COMPLETE_HANDLER		    SendCompleteHandler;
    TRANSFER_DATA_COMPLETE_HANDLER	TransferDataCompleteHandler;
	RESET_COMPLETE_HANDLER			ResetCompleteHandler;
	REQUEST_COMPLETE_HANDLER		RequestCompleteHandler;
	RECEIVE_HANDLER				    ReceiveHandler;
	RECEIVE_COMPLETE_HANDLER		ReceiveCompleteHandler;
	STATUS_HANDLER					StatusHandler;
	STATUS_COMPLETE_HANDLER			StatusCompleteHandler;
	NDIS_STRING						Name;
} NDIS30_PROTOCOL_CHARACTERISTICS;

//
// Protocol characteristics for NDIS 4.0 protocols
//
typedef struct _NDIS40_PROTOCOL_CHARACTERISTICS
{
#ifdef __cplusplus
	NDIS30_PROTOCOL_CHARACTERISTICS	Ndis30Chars;
#else
	NDIS30_PROTOCOL_CHARACTERISTICS;
#endif

	//
	// Start of NDIS 4.0 extensions.
	//
	RECEIVE_PACKET_HANDLER			ReceivePacketHandler;

	//
	// PnP protocol entry-points
	//
	BIND_ADAPTER_HANDLER            BindAdapterHandler;
	UNBIND_ADAPTER_HANDLER          UnbindAdapterHandler;
	PNP_EVENT_HANDLER               PnPEventHandler;
	UNLOAD_PROTOCOL_HANDLER         UnloadHandler;

} NDIS40_PROTOCOL_CHARACTERISTICS;

#endif // UNDEF_NDIS_DDK_STRUCT

#define  NDIS40                     1

#if NDIS40
typedef NDIS40_PROTOCOL_CHARACTERISTICS  DDK_NDIS_PROTOCOL_CHARACTERISTICS;
#else
typedef NDIS30_PROTOCOL_CHARACTERISTICS  DDK_NDIS_PROTOCOL_CHARACTERISTICS;
#endif  // NDIS40

typedef DDK_NDIS_PROTOCOL_CHARACTERISTICS *PDDK_NDIS_PROTOCOL_CHARACTERISTICS;

#define PI_PROTOCOL_NAME_MAX_LENGTH           64
#define PI_PROTOCOL_DESCRIPTION_MAX_LENGTH    128

#define MAX_TCPIP_ADAPTER                     30
#define AI_ADAPTER_NAME_MAX_LENGTH            132
#define AI_MAC_NAME_MAX_LENGTH                32
#define AI_ADAPTER_DESCRIPTION_MAX_LENGTH     132
#define MAX_PROTOCOL_INFO                     64
#define MAX_PROTOCOL_PATH                     260

#define NAI_ADAPTER_NAME_MAX_LENGTH           64
#define NAI_MAC_NAME_MAX_LENGTH               32
#define NAI_ADAPTER_DESCRIPTION_MAX_LENGTH    132
#define PROTOCOL_MAX_ADAPTER                  16


typedef struct
{
    unsigned                        Index;
    char                            szAdapterName[AI_ADAPTER_NAME_MAX_LENGTH];
    char                            szMacName[AI_MAC_NAME_MAX_LENGTH];
    char                            szDescription[AI_ADAPTER_DESCRIPTION_MAX_LENGTH];
    char                            szMacAddress[6];
    BOOLEAN                         bDHCPEnable;
    BOOLEAN                         bReserved;
    char                            ipAddress[4];
    char                            ipSubmask[4];
    PVOID                           pOpen;
    PVOID                           pAdapter;
    PVOID                           pProtocolBindingContext;
    PVOID                           pMacBindingContext;
    PVOID                           pProtocol;
    PVOID                           pFuncOriginalReceiveHandler;
    PVOID                           pFuncOriginalReceiveCompleteHandler;
    PVOID                           pFuncOriginalReceivePacketHandler;
    PVOID                           pFuncOriginalTransferDataCompleteHandler;
    PVOID                           pFuncOriginalSendCompleteHandler;
    PVOID                           pFuncOriginalSendHandler;
    PVOID                           pFuncOriginalSendPacketsHandler;
} NDIS_ADAPTER_OLD_INFO, *PNDIS_ADAPTER_OLD_INFO;

typedef struct
{
    LIST_ENTRY                      ListEntry;
    unsigned                        nIndex;
    char                            szAdapterName[NAI_ADAPTER_NAME_MAX_LENGTH];
    char                            szAdapterPath[MAX_PROTOCOL_PATH];
    char                            szMacName[NAI_MAC_NAME_MAX_LENGTH];
    char                            szDescription[NAI_ADAPTER_DESCRIPTION_MAX_LENGTH];
    char                            szMacAddress[6];
    BOOLEAN                         bDHCPEnable;
    BOOLEAN                         bNeedToRestoreOpenHandle;
    char                            ipAddress[4];
    char                            ipSubmask[4];
    PNDIS_OPEN_BLOCK                pOpen;
    PNDIS_ADAPTER_BLOCK             pAdapter;
    NDIS_HANDLE                     pProtocolBindingContext;
    NDIS_HANDLE                     pMacBindingContext;
    SEND_HANDLER                    pFuncOriginalSendHandler;
    SEND_PACKETS_HANDLER            pFuncOriginalSendPacketsHandler;
    TRANSFER_DATA_HANDLER           pFuncOriginalTransferDataHandler;
    NDIS_PACKET_STAT                Stat;
	NDIS_MEDIUM						NdisMedium;
    UINT                            uiReserved[15];
} NDIS_ADAPTER_INFO, *PNDIS_ADAPTER_INFO;


typedef struct
{
    unsigned short                  nIndex;
    unsigned short                  nNumberAdapter;
    PNDIS_PROTOCOL_BLOCK            pProtocol;
    NDIS_STRING                     nsProtocolName;
    char                            szProtocolName[PI_PROTOCOL_NAME_MAX_LENGTH];
    char                            szProtocolPath[MAX_PROTOCOL_PATH];
    char                            szProtocolDriverModuleName[12];
    BOOLEAN                         bHookOn;
    BOOLEAN                         bInterfaceListHasChanged;
    BOOLEAN                         bIsTrustedProtocolDriver;
    BOOLEAN                         bNeedToRestoreOpenHandles;

    UINT                            nProtocolType;
    SEND_HANDLER                    pFuncOriginalNdisSendHandler;
    SEND_PACKETS_HANDLER            pFuncOriginalNdisSendPacketsHandler;

    DDK_NDIS_PROTOCOL_CHARACTERISTICS   ProtocolCharacteristics;

    BIND_ADAPTER_HANDLER            TeeferBindAdapterHandler;
    OPEN_ADAPTER_COMPLETE_HANDLER   TeeferOpenAdapterCompleteHandler;
    UNBIND_ADAPTER_HANDLER          TeeferUnbindAdapterHandler;
    CLOSE_ADAPTER_COMPLETE_HANDLER  TeeferCloseAdapterCompleteHandler;
    TRANSFER_DATA_COMPLETE_HANDLER  TeeferTransferDataCompleteHandler;
    TRANSFER_DATA_HANDLER           TeeferTransferDataHandler;
    RECEIVE_HANDLER                 TeeferReceiveHandler;
    RECEIVE_PACKET_HANDLER          TeeferReceivePacketHandler;
    SEND_HANDLER                    TeeferSendHandler;
    SEND_PACKETS_HANDLER            TeeferSendPacketsHandler;
    NDIS_PACKET_STAT                Stat;
    STATUS_HANDLER                  TeeferStatusHandler;
    BOOLEAN                         bIsWinPoETProtocolDriver;
    BOOLEAN	                        bAllowProtocolTraffic;
    UCHAR                           uiReserved[58];
    LIST_ENTRY                      pAdapterInfoList;
} NDIS_PROTOCOL_INFO, *PNDIS_PROTOCOL_INFO;

#define IS_EQUAL_MAC(x, y) ((*(PUINT)x==*(PUINT)y)&&(*((PUSHORT)x+2)==*((PUSHORT)y+2)))
#define IS_MAC_ANY(x) (!(*(PUINT)x) && !(*((PUSHORT)x+2)))

#include "packoff1.h"

#endif

// end of PROTOCOL.H
