// file tfioctl.h
/*++
*************************************************************************
+-----------------------------------------------------------------------+
|  Copyright (C) SYBERGEN, INC. 1998                                    |
|      All Rights Reserved.                                             |
| Reproduction, adaptation, or translation without prior written        |
| permission is prohibited, except as allowed under Copyright laws.     |
|                                                                       |
| N O T I C E                                                           |
|                                                                       |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC.                     |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED.                             |
+-----------------------------------------------------------------------+
*************************************************************************
--*/

/*++
 *
 * $Author: yyeap $
 * $Date: 2003/01/03 01:15:44 $
 * $Revision: 1.3 $
 * $Workfile: tfioctl.h $
 * $Log: tfioctl.h,v $
 * Revision 1.3  2003/01/03 01:15:44  yyeap
 * Check in IP Spoofing in driver
 *
 * Revision 1.2  2001/11/02 22:26:34  yyeap
 * no message
 *
 * 
 * 4     2/02/01 9:38p Yyeap
 * Check in Teefer with interface ID
 * 
 * 3     10/26/00 4:11p Yyeap
 * Added back the full sendpacket blocking support
 * Fix a browse network neighboarhood bug
 * 
 * 1     10/17/00 2:53p Yyeap
 * 
 * 3     10/17/00 11:37a Yyeap
 * Checked in new Teefer with full Send support
 * 
 * 2     9/05/00 6:51p Yyeap
 * 
 * 1     8/11/00 5:53p Yyeap
 * $NoKeywords: $
 *
--*/


#ifndef TF_IOCTL_H
#define TF_IOCTL_H

#define ETHER_ADDR_LENGTH               6
#define MAX_ETHER_SIZE                  1514
#define MIN_ETHER_SIZE                  60

//#define TEEFER_MAGIC                    'AYYP'

#ifndef CTL_CODE
#define CTL_CODE( DeviceType, Function, Method, Access ) (   ((DeviceType) << 16) | ((Access) << 14) | ((Function) << 2) | (Method)  )
#define METHOD_BUFFERED                 0
#define METHOD_IN_DIRECT                1
#define METHOD_OUT_DIRECT               2
#define METHOD_NEITHER                  3

#define FILE_ANY_ACCESS                 0
#define FILE_READ_ACCESS                1    // file & pipe
#define FILE_WRITE_ACCESS               2    // file & pipe
#endif

#define IOCTL_BASE                    0x00000021
#define IOCTL_BIND_UNBIND_ADAPTER\
    CTL_CODE(IOCTL_BASE, 0x0803, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_SEND_PACKET\
    CTL_CODE(IOCTL_BASE, 0x0804, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_PASS_EVENT\
    CTL_CODE(IOCTL_BASE, 0x0806, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_GET_ADDRESS\
    CTL_CODE(IOCTL_BASE, 0x0808, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CLEAR_EVENT\
    CTL_CODE(IOCTL_BASE, 0x0809, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_LOOPBACK_SET\
    CTL_CODE(IOCTL_BASE, 0x080a, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_LOOPBACK_CLEAR\
    CTL_CODE(IOCTL_BASE, 0x080b, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_SET_RECEIVE_MODE \
    CTL_CODE(IOCTL_BASE, 0x081c, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_RESET_RECEIVE_MODE \
    CTL_CODE(IOCTL_BASE, 0x081d, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_READ_REG \
    CTL_CODE(IOCTL_BASE, 0x081e, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_GET_STATUS \
    CTL_CODE(IOCTL_BASE, 0x081f, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_SET_IP_FILTER \
    CTL_CODE(IOCTL_BASE, 0x0820, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_TEEFER_ALLOC_FIFOS \
    CTL_CODE(IOCTL_BASE, 0x0821, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_TEEFER_FREE_FIFOS \
    CTL_CODE(IOCTL_BASE, 0x0822, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_TEEFER_DISPATCH_PACKET \
    CTL_CODE(IOCTL_BASE, 0x0823, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_TEEFER_GET_STATUS \
    CTL_CODE(IOCTL_BASE, 0x0824, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_TEEFER_SET_HOOKING \
    CTL_CODE(IOCTL_BASE, 0x0825, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_TEEFER_GET_INTERFACE_INFO \
    CTL_CODE(IOCTL_BASE, 0x0826, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_TEEFER_GET_PROTOCOL_INFO \
    CTL_CODE(IOCTL_BASE, 0x0827, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_TEEFER_GET_RULE_TABLE \
    CTL_CODE(IOCTL_BASE, 0x0828, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_TEEFER_SET_RULE_TABLE \
    CTL_CODE(IOCTL_BASE, 0x0829, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_TEEFER_SET_IP_SPOOFING \
    CTL_CODE(IOCTL_BASE, 0x082a, METHOD_BUFFERED, FILE_ANY_ACCESS)

// __RAIN 2003-12-03
#define IOCTL_SET_ALLOWTOKENRINGTRAFFIC \
    CTL_CODE(IOCTL_BASE, 0x0830, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_SET_ALLOWPROTOCOLTRAFFIC \
    CTL_CODE(IOCTL_BASE, 0x0831, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_GET_DEBUGINFO \
    CTL_CODE(IOCTL_BASE, 0x083f, METHOD_BUFFERED, FILE_ANY_ACCESS)

#endif
