// file tfman.h
/*++
*************************************************************************
+-----------------------------------------------------------------------+
|  Copyright (C) SYBERGEN, INC. 1998                                    |
|      All Rights Reserved.                                             |
| Reproduction, adaptation, or translation without prior written        |
| permission is prohibited, except as allowed under Copyright laws.     |
|                                                                       |
| N O T I C E                                                           |
|                                                                       |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC.                     |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED.                             |
+-----------------------------------------------------------------------+
*************************************************************************
--*/

/*++
 *
 * $Author: yyeap $
 * $Date: 2003/01/15 23:15:04 $
 * $Revision: 1.6 $
 * $Workfile: tfman.h $
 * $Log: tfman.h,v $
 * Revision 1.6  2003/01/15 23:15:04  yyeap
 * Check in new teefer loader class
 *
 * Revision 1.5  2002/02/26 23:41:08  jianli
 * no message
 *
 * Revision 1.4  2001/11/29 02:37:06  jianli
 * no message
 *
 * Revision 1.3  2001/11/15 23:42:54  ydz
 * * changed parameter rulesize to rulenumber in TeeferGet/SetRuleTable().
 *
 * Revision 1.2  2001/11/02 22:34:47  yyeap
 * no message
 *
 * 
 * 16    5/02/01 5:41p Yyeap
 * Check in more Novell related fixes
 * 
 * 15    4/25/01 11:57a Yyeap
 * 
 * 14    3/29/01 4:20p Jil
 * 
 * 13    3/07/01 6:34p Yyeap
 * Teefer now try to dispatch a packet for up to 5 sec if the outgoing
 * FIFO is full.
 * DispatchPacket will return error code now.
 * Install will request a reboot is NTS PPPoe is running.
 * 
 * 12    3/07/01 3:19p Yyeap
 * Teefer uninstall may request a reboot now (if NTS is found on the
 * system)
 * 
 * 11    2/22/01 3:43p Yyeap
 * Fix a DoS crashes Teefer bug
 * Change hooking sequence for NdisSend in Win95 and Win98
 * 
 * 10    2/02/01 9:38p Yyeap
 * Check in Teefer with interface ID
 * 
 * 9     12/22/00 11:53a Yyeap
 * Check in the Interface Id for Win9x system (VXD support only).
 * 
 * 8     12/18/00 9:13p Ydz
 * support new parameter "is_dontblock" in packet callback func in
 * TFMAN.
 * 
 * 7     11/09/00 4:56p Yyeap
 * Check in Teefer with new Interface.  PacketControl now includes the
 * processid for all outgoing packets.
 * 
 * 6     10/26/00 4:13p Yyeap
 * Added back the full sendpacket blocking support
 * Fix a browse network neighboarhood bug
 * 
 * 2     10/26/00 1:46p Yyeap
 * Added complete send (drop) packet support
 * Fix a Win9x Netbios hang problem
 * 
 * 1     10/17/00 3:13p Yyeap
 * 
 * 6     10/17/00 11:37a Yyeap
 * Checked in new Teefer with full Send support
 * 
 * 5     9/08/00 3:25p Yyeap
 * Renamed the label PKTFIFO_H to TEEFERPKTFIFO_H to resolve the name
 * conflict with other modules.
 * 
 * 4     9/06/00 4:36p Yyeap
 * Update version to 1.01
 * Update Copyright statement in version info to Sygate Technologies
 * Implement robust single instance initializing/exiting routines in Win9x
 * driver
 * Added support to Sniffing/blocking outgoing packets
 * 
 * 
 * 3     9/05/00 6:51p Yyeap
 * 
 * 2     8/14/00 2:37p Yyeap
 * 
 * 1     8/11/00 5:53p Yyeap
 * 
 * 1     8/11/00 5:52p Yyeap
 * $NoKeywords: $
 *
--*/


#ifndef TF_MAN_H
#define TF_MAN_H

#include "..\driver\common\sharedef.h"

/******************************************************************************
 * The following ifdef block is the standard way of creating macros which make*
 * exporting from a DLL simpler. All files within this DLL are compiled with  *
 * the TFMAN_EXPORTS symbol defined on the command line. this symbol should   *
 * not be defined on any project that uses this DLL. This way any other       *
 * project whose source files include this file see TFDRV_API functions as    *
 * being imported from a DLL, wheras this DLL sees symbols defined with this  *
 * macro as being exported.                                                   *
 ******************************************************************************/

#ifdef TFMAN_EXPORTS
#define TFDRV_API __declspec(dllexport)
#else
#define TFDRV_API __declspec(dllimport)
#endif

#define TEEFER_OK                           0
#define TEEFER_INVALID_HANDLE               1
#define TEEFER_FIFO_IS_FULL                 2
#define TEEFER_INVALID_PACKET               -3
#define TEEFER_INTERFACE_UNSUPPORTED        -2
#define TEEFER_ERR                          -1

#define TEEFER_SPECIAL_FAKE_HANDLE	(TEEFER_HANDLE)0xFFFFFF00

typedef struct _TEEFER_STATUS {
    unsigned long      dwReceiveIndicateCount;
    unsigned long      dwReceivePacketCount;
    unsigned long      dwSendPacketCount;
    unsigned long      dwRasReceiveIndicateCount;
    unsigned long      dwRasReceivePacketCount;
    unsigned long      dwTransferDataCount;
    unsigned long      dwDispatchReceiveCount;
    unsigned long      dwDispatchSendCount;
    unsigned long      dwDropReceiveIndicateCount;
    unsigned long      dwDropReceivePacketCount;
    unsigned long      dwDropSendPacketCount;
}   TEEFER_STATUS, *PTEEFER_STATUS;

#define     OLD_AI_ADAPTER_NAME_MAX_LENGTH              132
#define     OLD_AI_MAC_NAME_MAX_LENGTH                  32
#define     OLD_AI_ADAPTER_DESCRIPTION_MAX_LENGTH       132

typedef     unsigned int                            TEEFER_INTERFACE_ID;
typedef struct
{
    TEEFER_INTERFACE_ID             Index;
    char                            AdapterName[OLD_AI_ADAPTER_NAME_MAX_LENGTH];
    char                            MacName[OLD_AI_MAC_NAME_MAX_LENGTH];
    char                            Description[OLD_AI_ADAPTER_DESCRIPTION_MAX_LENGTH];
    char                            MacAddress[6];
    unsigned char                   bReserved[2];
    DWORD                           Reserved[4];
} TEEFER_OLD_INTERFACE_INFO, *PTEEFER_OLD_INTERFACE_INFO;

typedef LARGE_INTEGER    STAT_TYPE;
typedef struct _PACKET_STAT {
    STAT_TYPE                       SendExamineBytesCount;
    STAT_TYPE                       SendExaminePacketCount;
    STAT_TYPE                       ReceiveExamineBytesCount;
    STAT_TYPE                       ReceiveExaminePacketCount;
    STAT_TYPE                       SendExamineDispatchedBytesCount;
    STAT_TYPE                       SendExamineDispatchedPacketCount;
    STAT_TYPE                       ReceiveExamineDispatchedBytesCount;
    STAT_TYPE                       ReceiveExamineDispatchedPacketCount;
    STAT_TYPE                       SendBlockBytesCount;
    STAT_TYPE                       SendBlockPacketCount;
    STAT_TYPE                       ReceiveBlockBytesCount;
    STAT_TYPE                       ReceiveBlockPacketCount;
    STAT_TYPE                       SendPassBytesCount;
    STAT_TYPE                       SendPassPacketCount;
    STAT_TYPE                       ReceivePassBytesCount;
    STAT_TYPE                       ReceivePassPacketCount;
}   PACKET_STAT, *PPACKET_STAT;


#define     TPI_PROTOCOL_NAME_MAX_LENGTH             128
#define     TPI_PROTOCOL_DESCRIPTION_MAX_LENGTH      128
#define     TAI_ADAPTER_NAME_MAX_LENGTH              132
#define     TAI_MAC_NAME_MAX_LENGTH                  32
#define     TAI_ADAPTER_DESCRIPTION_MAX_LENGTH       132

typedef     unsigned int           TEEFER_INTERFACE_ID, *PTEEFER_INTERFACE_ID;
typedef     unsigned int           TEEFER_PROTOCOL_ID, *PTEEFER_PROTOCOL_ID;

#define     TEEFER_PROTOCOL_ID_UNDEFINED             0x7f
#define     TEEFER_INTERFACE_ID_UNDEFINED            0x7f


typedef struct
{
    TEEFER_INTERFACE_ID            Index;
    char                           AdapterName[TAI_ADAPTER_NAME_MAX_LENGTH];
    char                           AdapterPath[MAX_PATH];
    char                           MacName[TAI_MAC_NAME_MAX_LENGTH];
    char                           Description[TAI_ADAPTER_DESCRIPTION_MAX_LENGTH];
    char                           MacAddress[6];
    unsigned char                  bReserved[2];
    PACKET_STAT                    Stat;
    unsigned long                  Reserved[4];
} TEEFER_INTERFACE_INFO, *PTEEFER_INTERFACE_INFO;



typedef struct
{
    TEEFER_PROTOCOL_ID             Index;
    unsigned int                   nNumberAdapter;
    char                           ProtocolName[TPI_PROTOCOL_NAME_MAX_LENGTH];
    char                           ProtocolPath[MAX_PATH];
    char                           ProtocolDriverModuleName[12];
    unsigned int                   nProtocolType;
    PACKET_STAT                    Stat;
    unsigned long                  Reserved[4];
} TEEFER_PROTOCOL_DRIVER_INFO, *PTEEFER_PROTOCOL_DRIVER_INFO;


#ifndef TEEFERPKTFIFO_H

    #define     PACKET_CONTROL_FROM_RECEIVE              0x1
    #define     PACKET_CONTROL_FROM_SEND                 0x2
    #define     PACKET_CONTROL_FROM_SEND_PACKETS         0x4
    #define     PACKET_CONTROL_FROM_NDIS_SEND            0x8
    #define     PACKET_CONTROL_DISCARD_PACKET            0x100
    #define     PACKET_CONTROL_REPLACE_PACKET            0x200

    typedef struct _PACKET_CONTROL {
        unsigned         NdisDispatchFunctionIndex;
        unsigned         TeeferFlags;
        void*            ProtocolHandle;
        void*            MacReceiveContext;
        void*            pPacketControlList;
        unsigned         dwProcessId;
    }  PACKET_CONTROL, *PPACKET_CONTROL;

#endif
    
typedef void* TEEFER_HANDLE;
typedef void (__cdecl *FUNC_TEEFER_Dbg_CallBack)(
                         const char *szOutput);

typedef int (__cdecl *FUNC_TEEFER_PacketCallback)(
                         unsigned nProtocolId,
                         unsigned nInterfaceId,
                         void    *pPacket,
                         unsigned nPacketLen,
                         unsigned dwProcessId,
                         BOOL     bIsSending,
                         BOOL     bDonotBlock,
                         void    *pPacketReferenceBlock,
                         unsigned nPacketReferenceLen,
                         void    *pCallbackReference);


/******************************************************************************
 * Set Teefer DEBUG mode                                                      *
 * under DEBUG mode, more debug information will be printed in DebugOutput    *
 ******************************************************************************/
void TFDRV_API 
TeeferSetDebugMode(
    BOOL bDebugOn
    );


/******************************************************************************
 * Set Teefer debug output call-back function.                                *
 ******************************************************************************/
void TFDRV_API
TeeferSetDebugOutput(
    FUNC_TEEFER_Dbg_CallBack pfnDebugCallBack
    );


/******************************************************************************
 * Open Teefer Driver and bind to the given adapter                           *
 *                                                                            *
 * Return:                                                                    *
 * Handle               If success                                            *
 * NULL                 If fail                                               *
 ******************************************************************************/
TEEFER_HANDLE TFDRV_API
TeeferOpen(
   	BOOL bFakeDriver,
    char *szAdapterName,                          // Name of adapter
    int   nFIFOInSize,                            // Size of input receive FIFO
    int   nFIFOOutSize,                           // Size of output receive FIFO
    FUNC_TEEFER_PacketCallback pfnTeeferCallBack, // Callback for every packet
	void *pContextPtr                             // Context for call back
    );


/******************************************************************************
 * Close the driver                                                           *
 *                                                                            *
 * Return:                                                                    *
 * TEEFER_OK            If success                                            *
 * TEEFER_ERR           If fail                                               *
 ******************************************************************************/
int  TFDRV_API
TeeferClose(
    TEEFER_HANDLE h                              // Returns by TeeferOpen
    );


/******************************************************************************
 * Enable/Disable the hookings of Teefer Driver                               *
 *                                                                            *
 * Return:                                                                    *
 * TEEFER_OK            If success                                            *
 * TEEFER_ERR           If fail                                               *
 ******************************************************************************/
int  TFDRV_API
TeeferSetMode(
    TEEFER_HANDLE   h,                           // Returns by TeeferOpen
    BOOL            bEnableReceive,              // Enable/Disable receive flag
    BOOL            bEnableSend                  // Enable/Disable send flag
    );


/******************************************************************************
 * Dispatch packet to Teefer                                                  *
 *                                                                            *
 * Return:                                                                    *
 * 0 if sucess                                                                *
 * 1 if invalid TEEFER_HANDLE                                                 *
 * 2 if Fifo is full                                                          *
 * TEEFER_ERR if input len is invalid                                         *
 ******************************************************************************/
int TFDRV_API
TeeferDispatchPacket(
    TEEFER_HANDLE   h,                           // Returns by TeeferOpen
    void           *pPacket,                     // Pointer to packet buffer
    unsigned        nLen,                        // Length of packet
    BOOL            bReplacePacket,              // TRUE if we want to replace packet
    BOOL            bDiscardPacket,              // TRUE if we want to discard packet
    BOOL            bDoNotBlock,                 // TRUE if we cannot block packet
    void           *pPacketReference             // Pointer of packet control
    );


/******************************************************************************
 * Fill the packet stats capture by Teefer driver                             *
 *                                                                            *
 * Return:                                                                    *
 * TEEFER_OK            If success                                            *
 * TEEFER_ERR           If fail                                               *
 ******************************************************************************/
int TFDRV_API
TeeferGetInfo(
    TEEFER_HANDLE h,                              // Returns by TeeferOpen
    TEEFER_STATUS *pInfo                          // Structure for info
    );


/******************************************************************************
 * Fill the all protocol id found by Teefer driver                            *
 *                                                                            *
 * Return:                                                                    *
 * TEEFER_OK            If success                                            *
 * TEEFER_ERR           If fail                                               *
 *                                                                            *
 * Parameters:                                                                *
 * h                    Returns by TeeferOpen                                 *
 * pProtocolIDBuffer    Array of protocol id to be filled by driver           *
 * cbBufferSize         Total size of pProtocolIDBuffer in BYTES              *
 * pRetBufferSize       Size of pProtocolIDBuffer filled by driver in BYTES   *
 ******************************************************************************/
int TFDRV_API
TeeferEnumProtocolDriver(
    TEEFER_HANDLE  h,                               // Returns by TeeferOpen
    PTEEFER_PROTOCOL_ID pProtocolIDBuffer,          // array of protocol id
    DWORD  cbBufferSize,                            // size of IDBuffer
    PDWORD  pRetBufferSize                          // size of IDBuffer filled
    );


/******************************************************************************
 * Get detailed info about a protocol driver                                  *
 *                                                                            *
 * Return:                                                                    *
 * TEEFER_OK            If success                                            *
 * TEEFER_ERR           If fail                                               *
 *                                                                            *
 * Parameters:                                                                *
 * h                    Returns by TeeferOpen                                 *
 * Id                   protocol id to be queries                             *
 * pProtocolInfo        TEEFER_PROTOCOL_DRIVER_INFO to receive the info       *
 * pRetBufferSize       Size of pProtocolInfo in BYTES                        *
 ******************************************************************************/
int TFDRV_API
TeeferGetProtocolDriverInfo(
    TEEFER_HANDLE  h,                               // Returns by TeeferOpen
    TEEFER_PROTOCOL_ID  Id,                         // Protocol id to be queried
    PTEEFER_PROTOCOL_DRIVER_INFO  pProtocolInfo,    // Info for protocol
    DWORD  dwProtocolInfoSize                       // size of pProtocolInfo
    );


/******************************************************************************
 * Get a list of all interfaces opened by a protocol driver                   *
 *                                                                            *
 * Return:                                                                    *
 * TEEFER_OK            If success                                            *
 * TEEFER_ERR           If fail                                               *
 *                                                                            *
 * Parameters:                                                                *
 * h                    Returns by TeeferOpen                                 *
 * ProtocolId           Id of the Protocol be to queried                      *
 * pInterfaceIDBuffer   Array of interface id to be filled by driver          *
 * cbBufferSize         Total size of pInterfaceIDBuffer in BYTES             *
 * pRetBufferSize       Size of pInterfaceIDBuffer filled by driver in BYTES  *
 ******************************************************************************/
int TFDRV_API
TeeferEnumProtocolDriverInterface(
    TEEFER_HANDLE  h,                               // Returns by TeeferOpen
    TEEFER_PROTOCOL_ID  ProtocolId,                 // Protocol id
    PTEEFER_INTERFACE_ID  pInterfaceIDBuffer,       // Structure for interface info
    DWORD  cbBufferSize,                            // size of pInterfaceIDBuffer
    PDWORD  pRetBufferSize                          // size of pInterfaceIDBuffer
    );

                                  
/******************************************************************************
 * Get detailed info about an interface                                       *
 *                                                                            *
 * Return:                                                                    *
 * TEEFER_OK            If success                                            *
 * TEEFER_ERR           If fail                                               *
 *                                                                            *
 * Parameters:                                                                *
 * h                    Returns by TeeferOpen                                 *
 * Id                   protocol id to be queries                             *
 * pProtocolInfo        TEEFER_PROTOCOL_DRIVER_INFO to receive the info       *
 * pRetBufferSize       Size of pProtocolInfo in BYTES                        *
 ******************************************************************************/
int TFDRV_API
TeeferGetProtocolDriverInterfaceInfo(
    TEEFER_HANDLE  h,                               // Returns by TeeferOpen
    TEEFER_PROTOCOL_ID  ProtocolId,                 // Protocol id
    TEEFER_INTERFACE_ID  InterfaceId,               // Interface id
    PTEEFER_INTERFACE_INFO  pInterfaceInfo,         // Structure for interface info
    DWORD  dwInterfaceInfoBufferSize                // size of pInterfaceInfo
    );


/******************************************************************************
 * Return the serial number of the Protocol list on the system.  Caller can   *
 * use this function to determine if the protocol list has been changed.      *
 *                                                                            *
 * Return:                                                                    *
 * Serial number                                                              *
 *                                                                            *
 * Input:                                                                     *
 * None                                                                       *
 ******************************************************************************/                                     
DWORD TFDRV_API
TeeferGetProtocolDriverListSerial(
    void
);


// TODO: please move the const to shareddef.xxx
const DWORD TEEFER_MAX_RULE_NUMBER = 0xFFFF;	// 65535 rules, max.

int TFDRV_API
TeeferGetRuleTable(
    TEEFER_HANDLE h,
    PTEEFER_RULE  pRulesBuffer,
    DWORD  dwTeeferRuleBufferSize,		// byte size of rule buffer
    DWORD  dwRuleTableSize,
    PDWORD pdwRetRuleNumber
    );
// *pdwRetRuleNumber: the number of rule returned.

int TFDRV_API
TeeferSetRuleTable(
    TEEFER_HANDLE  h, 
    PTEEFER_RULE  pRules,
    DWORD  dwRuleNumber
    );
// dwRuleNumber: the number of rule that is going to write                   

int TFDRV_API
TeeferApplyRuleTable(
    TEEFER_HANDLE  h, 
    UINT  dwApply
    );

/******************************************************************************
 * Fill the interface info found by Teefer driver                             *
 *                                                                            *
 * Return:                                                                    *
 * TEEFER_OK            If success                                            *
 * TEEFER_ERR           If fail                                               *
 *                                                                            *
 * Input:                                                                     *
 * pNICArrayBuffer      Pointer to INTERFACE_INFO to be filled                *
 * dwId                 Index of the interface                                *
 ******************************************************************************/
int TFDRV_API
TeeferGetNetworkInterfaceInfo(
    TEEFER_HANDLE       h,                            // Returns by TeeferOpen
    TEEFER_INTERFACE_ID dwId,
    PTEEFER_OLD_INTERFACE_INFO  pInterfaceInfo,       // Structure for interface info
    DWORD               dwInterfaceInfoBufferSize     // size of each info
    );

/******************************************************************************
 * Fill the Protocol info found by Teefer driver                              *
 *                                                                            *
 * Return:                                                                    *
 * TEEFER_OK                 If success                                       *
 * TEEFER_ERR                If fail                                          *
 *                                                                            *
 * Input:                                                                     *
 * pNICArrayBuffer           Array of INTERFACE_INFO to be filled             *
 * pdwNumberOfInterfaceReturn Number of INTERFACE_INFO in pNicArray           *
 *                                                                            *
 * Output:                                                                    *
 * pNICArrayBuffer      Info of Protocols found by Teefer                     *
 * pdwNumberOfInterfaceReturn Number of NIC returned                          *
 * pdwTotalNumProtocol       Total Number of NIC found by Teefer              *
 ******************************************************************************/
int TFDRV_API
TeeferGetAllProtocolAndNetworkInterfaceInfo(
    TEEFER_HANDLE       h,                           // Returns by TeeferOpen
    PTEEFER_INTERFACE_INFO     pNICArrayBuffer,      // Structure for protocol info
    DWORD               dwProtocolInfoBufferSize,    // size of each info
    DWORD               *pdwNumberOfProtocolReturn,  // number of info in pProtocolArray
    DWORD               *pdwTotalNumInterface        // Total of Protocol found by Teefer
    );


/******************************************************************************
 * Fill the interface info found by Teefer driver                             *
 *                                                                            *
 * Return:                                                                    *
 * TEEFER_OK            If success                                            *
 * TEEFER_ERR           If fail                                               *
 *                                                                            *
 * Input:                                                                     *
 * pNICArrayBuffer      Pointer to INTERFACE_INFO to be filled                *
 * dwInterfaceId        Index of the interface                                *
 * dwProtocolId         Index of the protocol                                 *
******************************************************************************/
int TFDRV_API
TeeferGetProtocolAndNetworkInterfaceInfo(
    TEEFER_HANDLE       h,                           // Returns by TeeferOpen
    TEEFER_INTERFACE_ID dwInterfaceId,
    PTEEFER_INTERFACE_INFO     pNICArrayBuffer,      // Structure for interface info
    DWORD               dwInterfaceInfoBufferSize    // size of each info
    );


/******************************************************************************
 * Install the Teefer Driver service and optionally copy/upgrade the binary   *
 * file                                                                       *
 *                                                                            *
 * Return:                                                                    *
 * TEEFER_OK            If success                                            *
 * TEEFER_ERR           If fail                                               *
 ******************************************************************************/
int TFDRV_API
TeeferInstall(
    char               *szPath,                       // Path to install from
    BOOL               *pbNeedReboot
    );


/******************************************************************************
 * Uninstall the Teefer Driver service and optionally remove the binary file  *
 *                                                                            *
 * Return:
 * TEEFER_OK            If success                                            *
 * TEEFER_ERR           If fail                                               *
 ******************************************************************************/
int TFDRV_API
TeeferUninstall(
    BOOL *pbNeedReboot
    );


/******************************************************************************
 * Check if the Teefer Driver service exist									  *
 *                                                                            *
 * Return:
 * TRUE					If teefer has been installed                          *
 * FALSE				if teefer has not been installed                      *
 ******************************************************************************/
BOOL TFDRV_API
TeeferIsInstall();




/******************************************************************************
 * Set the TEEFER Default RULE table. Old content in table will be overwriten.*
 * rule_table		the table												  *	
 * rule_num			the number of rule
 * Return :	
 * return TEEFER_OK if successfully											  *				
 * return TEEFER_ERR if operation failed.                                     *
 ******************************************************************************/
int TFDRV_API
TeeferSetDefaultRuleTable(
    PTEEFER_RULE  pRules,
    DWORD  dwRuleNumber
    );

/******************************************************************************
 * Set the TEEFER Init RULE table. Old content in table will be overwriten.   *
 * rule_table		the table												  *	
 * rule_num			the number of rule
 * Return :	
 * return TEEFER_OK if successfully											  *				
 * return TEEFER_ERR if operation failed. 
 * It's different from TeeferSetDefaultRuleTable for it's only effect when    *
 * system boot up
 ******************************************************************************/
int TFDRV_API
TeeferSetInitRuleTable(
    PTEEFER_RULE  pRules,
    DWORD  dwRuleNumber
    );

/******************************************************************************
 * Enable/Disable 802.5 protocol traffic                                      *
 * // __RAIN 2003-12-03                                                       *
 * Return:                                                                    *
 * TEEFER_OK            If success                                            *
 * TEEFER_ERR           If fail                                               *
 ******************************************************************************/
int  TFDRV_API
TeeferAllowTokenRingTraffic(
    TEEFER_HANDLE   h,							// Returns by TeeferOpen
    BOOL            bEnable						// Enable/Disable flag
    );

/******************************************************************************
 * Enable/Disable NDIS protocol traffic                                       *
 * Return:                                                                    *
 * TEEFER_OK            If success                                            *
 * TEEFER_ERR           If fail                                               *
 ******************************************************************************/
int TFDRV_API
TeeferAllowProtocolTraffic(
    TEEFER_HANDLE   h,                           // Returns by TeeferOpen
    ULONG           uEnable,                     // Enable/Disable flag
	PCHAR			szProtocolDriverPath		 // Protocol Driver Path
    );

/******************************************************************************
 * Get Teefer debugging infomation                                            *
 * Return:                                                                    *
 * TEEFER_OK            If success                                            *
 * TEEFER_ERR           If fail                                               *
 ******************************************************************************/
int  TFDRV_API
TeeferGetDebugInfo(
    TEEFER_HANDLE   h,							// Returns by TeeferOpen
    PVOID			pBuffer,
    DWORD			nBufSize,
	PDWORD			nInfoSize
    );

#endif

