// CheckFile.cpp: implementation of the CheckFile class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CheckFile.h"
#include "io.h"
#include "fcntl.h"
#include "stdlib.h"
#include "windows.h"
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CheckFile::CheckFile()
{
	return ;
}

CheckFile::~CheckFile()
{
	return ;
}

int CheckFile::GetFileInfo(const char* lpFileName, SFILE_INFO* lpfi)
{
	return CalcCheckSum(lpFileName,lpfi); 
}

int CheckFile::CalcCheckSum(const char *pFileName, SFILE_INFO* lpfi)
{
	BYTE			*pCheckSum = NULL;
	BYTE			*pStartAddress = NULL;
	dword			dwRet = 0 ;
	dword			dwOut = 0;
	dword			dwFileSizeInByte;
	dword			dwBlockSize = 0;
	dword			dwLen = 0;
	int				iRR = 0;
	int				i = 0;
	int				j = 0;
	int				iRetFlag = 0 ;
	char			*pExecName = NULL;
	char			cCnt = '\0';
	HANDLE			hFile = INVALID_HANDLE_VALUE;
	HANDLE			hMap = INVALID_HANDLE_VALUE;

//Init check
	if(NULL == lpfi||strlen(pFileName)>=MAX_FILE_LENGTH)
	{
		return iRetFlag;
	}
	
	hFile = CreateFile(pFileName,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if(INVALID_HANDLE_VALUE == hFile)	// we get error, can't open the file
	{
		return iRetFlag;// return 0 means error!!!! Be careful 
	}
	
/*------------- Part 1 (Get Short File Name) ----------------*/ 
	//Next, validate and isolate the executable name 
	i = j = 0 ;
	cCnt = *(pFileName+i);
	while(cCnt != '\0')
	{
		if(cCnt=='\\')
			j = i + 1 ;
		i++ ;
		cCnt = *(pFileName+i);
	}
	pExecName = (char *)pFileName + j ;
	strcpy(lpfi->ExecName, pExecName) ;
	iRetFlag|=1 ;
	
/*------------- Part 2 (Get File Size) ----------------*/ 
	//Record the file size
	dwFileSizeInByte = GetFileSize(hFile,NULL);
	if(dwFileSizeInByte != -1)
	{
		//No error
		lpfi->lFileSize = dwFileSizeInByte; 
		iRetFlag|=2 ;
	}
	else
		//On error
		lpfi->lFileSize=0 ;

/*------------- Part 3 (Get File CheckSum) ----------------*/ 
	dwBlockSize = CS_BLOCK*4 ;
	
//	pCheckSum = (BYTE *)malloc(dwBlockSize);
	if(lpfi->lFileSize<3)
	{
		lpfi->ulFileCheckSum=0 ;
		CloseHandle(hFile);
		return iRetFlag ;
	}

	//Calc. the checksum block size and length
	dwLen = lpfi->lFileSize/3 ;
	if((dword)lpfi->lFileSize<(dwBlockSize*3))
	{
		dwBlockSize = dwLen ;
		if(dwBlockSize<4)
		{
			lpfi->ulFileCheckSum=0 ;
			CloseHandle(hFile);
			return iRetFlag;
		}
	}
	pCheckSum = new BYTE[dwBlockSize];

	//creare file mapping
	hMap = CreateFileMapping(hFile,NULL,PAGE_READONLY,0,0,NULL);
	if (hMap != NULL && GetLastError() == ERROR_ALREADY_EXISTS) 
	{ 
		CloseHandle(hMap); 
		hMap = NULL; 
	}
	if(NULL == hMap)
	{
		CloseHandle(hFile);
		if(pCheckSum)
			delete pCheckSum;
		pCheckSum = NULL;
		lpfi->ulFileCheckSum =0;
		return iRetFlag;
	}
	pStartAddress = (BYTE *)MapViewOfFile(hMap,FILE_MAP_READ,0,0,0);
	if(NULL == pStartAddress)
	{
		CloseHandle(hMap);
		CloseHandle(hFile);
		if (pCheckSum)
			delete pCheckSum;
		pCheckSum = NULL;
		lpfi->ulFileCheckSum =0;
		return iRetFlag;
	}

	/* -------------- First Block -----------------	*/
	memset(pCheckSum,0,dwBlockSize);
	memcpy(pCheckSum,pStartAddress,dwBlockSize);
	dwRet=*(dword*)pCheckSum ;
	iRR = dwBlockSize;
	for(i=4; i<(unsigned int)(iRR-4); i+=4)
		dwRet=dwRet^(*(dword*)(pCheckSum+i)) ;

	/*-------------- Second Block ----------------- */
	memset(pCheckSum,0,dwBlockSize);
	memcpy(pCheckSum,pStartAddress+dwLen,dwBlockSize);		
	//Calculate check sum for the second block
	iRR = dwBlockSize;
	for(i=4; i<(unsigned int)(iRR-4); i+=4)
		dwRet=dwRet^(*(dword*)(pCheckSum+i)) ;
	
	/*-------------- Last Block -------------------- */
	memset(pCheckSum,0,dwBlockSize);
	memcpy(pCheckSum,pStartAddress+(lpfi->lFileSize-dwBlockSize),dwBlockSize);
	//Calculate check sum for the last block
	iRR = dwBlockSize;
	for(i=4; i<(unsigned int)(iRR-4); i+=4)
		dwRet=dwRet^(*(dword*)(pCheckSum+i)) ;

	//Success!  Record the checksum into the structure.
	lpfi->ulFileCheckSum = dwRet ;
	delete pCheckSum;
	UnmapViewOfFile(pStartAddress);
	CloseHandle(hMap);
	CloseHandle(hFile);
	iRetFlag|=4;

	return iRetFlag;
}
