/* $Header: /usr2/cvs/master/Develop/Products/Smc/build/sndfc/src/sndfc/snd/CoRTLock.h,v 1.1.1.1 2001/06/29 19:30:08 herbert Exp $ */
/*++
*************************************************************************
+-----------------------------------------------------------------------+
|  Copyright (C) SYBERGEN, INC. 1998,1999                               |
|      All Rights Reserved.                                             |
| Reproduction, adaptation, or translation without prior written        |
| permission is prohibited, except as allowed under Copyright laws.     |
|                                                                       |
| N O T I C E                                                           |
|                                                                       |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC.                     |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED.                             |
+-----------------------------------------------------------------------+
*************************************************************************
--*/

/*++
 * 
 * $Author: herbert $
 * $Date: 2001/06/29 19:30:08 $
 * $Revision: 1.1.1.1 $
 * $Workfile: CoRTLock.h $
 * $Log: CoRTLock.h,v $
 * Revision 1.1.1.1  2001/06/29 19:30:08  herbert
 * Migrate from VSS to CVS.
 *
 * 
 * 1     9/06/00 11:35a Ydz
 * 
 * 5     8/22/99 2:41p Ydz
 * 
 * 4     8/20/99 12:07p Ydz
 * 
 * 3     6/22/99 10:04p Ydz
 * FlatStream thread-safe works.
 * 
 * 2     6/20/99 6:25p Ydz
 * 
 * 1     6/20/99 1:40p Ydz
 * $NoKeywords: $
--*/



#ifndef CORERT_CORTLOCK_H
#define CORERT_CORTLOCK_H


class CCoreRtLock
{
public:
	CCoreRtLock() {}
	virtual ~CCoreRtLock() {}
	virtual void Lock(void) = 0;
	virtual void Unlock(void) = 0;
};


class CCoreRtCriticalSection: public CCoreRtLock
{
private:
	CRITICAL_SECTION	CriticalSection;
public:
	inline CCoreRtCriticalSection()
	{
		InitializeCriticalSection(&CriticalSection); 
		//sysprintln("criticalsection initialized, handle: " + &CriticalSection);
	}

	inline ~CCoreRtCriticalSection()
	{
		DeleteCriticalSection(&CriticalSection);
		//sysprintln("criticalsection deleted, handle: " + &CriticalSection);
	}

	void Lock(void)
	{
		EnterCriticalSection(&CriticalSection);
	}

	void Unlock(void)
	{
		LeaveCriticalSection(&CriticalSection);
	}
};


// CCoreRtLockIt will unlock the lock automatically when it was destoried.
// So you don't have to unlock it 
class CCoreRtLockIt
{
private:
	CCoreRtLock	*pLock;
public:
	inline CCoreRtLockIt(CCoreRtLock* lock)
	{
		lock->Lock();
		pLock = lock;
	}

	inline void Unlock(void)
	{
		CCoreRtLock* p = pLock;
		if (p)
		{
			pLock = 0;
			p->Unlock();
		}

	}

	inline ~CCoreRtLockIt()
	{
		Unlock();
	}

};




#endif
// end of CORTLOCK.H


