/* $Header: /usr2/cvs/master/Develop/Products/Smc/build/sndfc/src/sndfc/snd/Domain.cpp,v 1.1 2002/10/17 23:45:39 ydz Exp $*/
/*++
*************************************************************************
+-----------------------------------------------------------------------+
| Copyright (C) SYBERGEN NETWORKS, INC. 1998,1999 |
| All Rights Reserved. |
| Reproduction, adaptation, or translation without prior written |
| permission is prohibited, except as allowed under Copyright laws. |
| |
| N O T I C E |
| |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC. |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED. |
+-----------------------------------------------------------------------+
*************************************************************************
--*/

/*++
 * 
 * $Author: ydz $
 * $Date: 2002/10/17 23:45:39 $
 * $Revision: 1.1 $
 * $Workfile: osutils.h $
 * $NoKeywords: $
 *
--*/

#include "stdafx.h"
#include <lm.h>
#include "osutils.h"
#include "NetUtils.h"

typedef DWORD (WINAPI *PNETSERVERENUM) (LPTSTR,DWORD,LPBYTE *,DWORD,LPDWORD,LPDWORD,DWORD,LPCWSTR,LPDWORD);
typedef DWORD (WINAPI *PNETBUFFREE)	(LPVOID);

#define	CNETBIOS_DEFAULT_NAMECODE	32
#define SMC_WIN9X_ENABLELOGONDOMAIN_KEY	"Network\\Logon"
#define SMC_WIN9X_DOMAINNAME_KEY		"System\\CurrentControlSet\\Services\\MSNP32\\NetworkProvider"
#define SMC_WIN9X_WORKGROUPNAME_KEY		"System\\CurrentControlSet\\Services\\VxD\\VNETSUP"

static int MakeNetbiosName(char *pDest,char *pSrc)
{
	int cchSrc;
	if(pDest == NULL || pSrc == NULL)
		return ERR;
    cchSrc = lstrlen (pSrc);    

	if (cchSrc > NCBNAMSZ)
        cchSrc = NCBNAMSZ;    
	
	memset (pDest, ' ', NCBNAMSZ);
    memcpy (pDest, pSrc, cchSrc);
	pDest[NCBNAMSZ-1] = 0;
	strupr(pDest);
	pDest[NCBNAMSZ-1] = CNETBIOS_DEFAULT_NAMECODE;
	return OK;
}

static sbool GetDomainName(char	*pname, char	*DomainName, DWORD	dwSize)
{
	static int logprintflag = -1;

	int				cbBuffer;
    int				i;
	ADAPTER_STATUS	*pStatus;    
	sbool			bRet;
   	HANDLE			hHeap;    
   	NCB				ncb;    
	NAME_BUFFER		*pNames; 
	char			Name[NCBNAMSZ];
	LANA_ENUM		le;
	UCHAR			uRetCode;

	if(strlen(pname)>=NCBNAMSZ||dwSize<NCBNAMSZ)
		return false;
	
	if(IsWin9x())
	{
		// If it's Windows 9x, read from registry
		char	buf[64];
		dword	dwtmp;
		sbool	bLogonDomain;

		memset(buf,0,64);
		bLogonDomain = false;

		if( OK == ReadBinaryFromRegistry(	HKEY_LOCAL_MACHINE, 
											SMC_WIN9X_ENABLELOGONDOMAIN_KEY,
											"LMLogon",
											buf,
											63,
											&dwtmp))
		{
			
			if(buf[0])
			{
				bLogonDomain = true;
				if(logprintflag == -1)
				{
					sysprintln("Domain95:	Logon to Domain");
					logprintflag = 0;
				}
			}
		}

		if(bLogonDomain)
		{
			// Logon to Domain

			memset(buf,0,64);
			
			if( OK != ReadStringFromRegistry(	HKEY_LOCAL_MACHINE,
												SMC_WIN9X_DOMAINNAME_KEY,
												"AuthenticatingAgent",
												buf,
												63,
												&dwtmp))
			{
				if(logprintflag !=1 )
				{
					sysprintln("Domain95:	Could not get Domain name");
					logprintflag = 1;
				}
				return false;
			}
			if(logprintflag !=1 )
			{				
				sysprintln("Domain95:	Domain name is "+buf);
				logprintflag = 1;
			}
			memcpy(DomainName,buf,NCBNAMSZ);
			return true;
		}
		else
		{
			// Logon to Workgroup

			memset(buf,0,64);
			
			if( OK != ReadStringFromRegistry(	HKEY_LOCAL_MACHINE,
												SMC_WIN9X_WORKGROUPNAME_KEY,
												"Workgroup",
												buf,
												63,
												&dwtmp))
			{
				if(logprintflag !=2 )
				{
					sysprintln("Domain95:	Could not get Workgroup name");
					logprintflag = 2;
				}
				return false;
			}
			if(logprintflag !=2 )
			{
				sysprintln("Domain95:	Workgroup name is "+buf);
				logprintflag = 2;
			}
			memcpy(DomainName,buf,NCBNAMSZ);
			return true;
		}
		
	}
	else
	{
	
		//Enum LANA
		memset( &ncb, 0, sizeof(ncb) );
		ncb.ncb_command = NCBENUM;
		ncb.ncb_buffer = (PUCHAR)&le;
		ncb.ncb_length = sizeof(le);
		uRetCode = Netbios( &ncb );
		if(uRetCode != NRC_GOODRET) 
			return false;
		if(le.length == 0) 
			return false;
		
		//Allocate memory for pStatus
		hHeap = GetProcessHeap();
		cbBuffer = sizeof (ADAPTER_STATUS) + 255 * sizeof (NAME_BUFFER);
		pStatus = (ADAPTER_STATUS *) HeapAlloc (hHeap, 0, cbBuffer);
		if (NULL == pStatus)        
			return FALSE;

		memset(DomainName,0,dwSize);
		for(i = 0; i < le.length; i++) 
		{
			//Reset NCB
			memset (&ncb, 0, sizeof (ncb));    
			ncb.ncb_command = NCBRESET;
			ncb.ncb_lsn 	= 0;                // Allocate new lana_num resources 
			ncb.ncb_lana_num = le.lana[i];
			ncb.ncb_callname[0] = 20;  // maximum sessions 
			ncb.ncb_callname[2] = 30;   // maximum names     
			Netbios (&ncb);
			
			//Try NCBASTAT
			memset (&ncb, 0, sizeof (ncb));    
			ncb.ncb_command		= NCBASTAT;
			ncb.ncb_lana_num	= le.lana[i];    
			ncb.ncb_buffer		= (PUCHAR) pStatus;
			ncb.ncb_length		= cbBuffer;    
			MakeNetbiosName((char *)ncb.ncb_callname, pname);
			Netbios (&ncb);
			bRet = (NRC_GOODRET == ncb.ncb_retcode);
			if(bRet)
			{
				pNames = (NAME_BUFFER *) (pStatus + 1);
				for (int i = 0; i < pStatus->name_count; i++)
				{
					if(pNames[i].name[15]==0)
					{
						if (pNames[i].name_flags & GROUP_NAME)
						{
							memcpy(Name, pNames[i].name, NCBNAMSZ-1);
							for(int j=0;j<NCBNAMSZ-1;j++)
							{
								if(Name[j]==' ')
								{
									Name[j]=0;
									break;
								}
							}
							memcpy(DomainName,Name,NCBNAMSZ);
							HeapFree (hHeap, 0, pStatus);
							return true;
						}
					}
				}
			}
		}
		if(logprintflag !=5 )
		{
			sysprintln("Fail to get domain name!!!");	
			logprintflag = 5;
		}
			
   		HeapFree (hHeap, 0, pStatus);    
		return false;
	}
}

static int GetPDCName(outputstr *pstr)
{
	LPSERVER_INFO_101	pBuf = NULL;
	LPSERVER_INFO_101	pTmpBuf;
	DWORD				dwLevel = 101;
	DWORD				dwPrefMaxLen = -1;
	DWORD				dwEntriesRead = 0;
	DWORD				dwTotalEntries = 0;
	DWORD				dwTotalCount = 0;
	DWORD				dwServerType = SV_TYPE_DOMAIN_CTRL; // I only want to get PDC
	DWORD				dwResumeHandle = 0;
	NET_API_STATUS		nStatus;
	LPTSTR				pszServerName = NULL;
	HINSTANCE			hNetDLL = NULL;
	PNETSERVERENUM		pfnNetServerEnum;
	PNETBUFFREE			pfnNetBufferFree;
	char				buf[128];

	memset(buf,0,128);

	hNetDLL = GetModuleHandle("NETAPI32.DLL");
	if(NULL == hNetDLL)
	{
		hNetDLL = LoadLibrary("NETAPI32.DLL");
		if(NULL == hNetDLL)
		{
			sysprintln("Can't load netapi32.dll");
			return ERR;
		}
	}

	pfnNetServerEnum = (PNETSERVERENUM) GetProcAddress(hNetDLL,"NetServerEnum");
	if(NULL == pfnNetServerEnum)
	{
		FreeLibrary(hNetDLL);
		hNetDLL = NULL;
		return ERR;
	}
	pfnNetBufferFree = (PNETBUFFREE) GetProcAddress(hNetDLL,"NetApiBufferFree");
	if(NULL == pfnNetBufferFree)
	{
		FreeLibrary(hNetDLL);
		hNetDLL = NULL;
		return ERR;
	}
	nStatus = pfnNetServerEnum(pszServerName,
							   dwLevel,
							   (LPBYTE *) &pBuf,
	                           dwPrefMaxLen,
	                           &dwEntriesRead,
	                           &dwTotalEntries,
	                           dwServerType,
	                           NULL,
	                           &dwResumeHandle);
	//
	// If the call succeeds,
	//
	if ((nStatus == NERR_Success) || (nStatus == ERROR_MORE_DATA))
	{
	  if ((pTmpBuf = pBuf) != NULL)
	  {
			if(dwTotalEntries == 1)
			{
				pstr->Empty();
				wsprintf(buf,"%S",pTmpBuf->sv101_name);
				*pstr = buf;
				pfnNetBufferFree(pBuf);
				FreeLibrary(hNetDLL);
				return OK;
			}
			else
			{
				sysprintln("error!!! This domain have "+ dwTotalEntries +" PDC");
				pfnNetBufferFree(pBuf);
				pstr->Empty();
				FreeLibrary(hNetDLL);
				return ERR;
			}
	  }   
	}
	if (pBuf != NULL)
		pfnNetBufferFree(pBuf);
	FreeLibrary(hNetDLL);
	return ERR;
}


//**********************************************************************
// 
//  FUNCTION:     GetUserAndDomain - This function looks up
//                the user name and domain name for the user account
//                associated with a process.
// 
//  PARAMETERS:   hProcess - handle of the process.
//				  szUser - a buffer that receives the user name
//                pcchUser - the size, in characters, of szUser
//                szDomain - a buffer that receives the domain name
//                pcchDomain - the size, in characters, of szDomain
// 
//  RETURN VALUE: TRUE if the function succeeds. Otherwise, FALSE and
//                GetLastError() will return the failure reason.
// 
//                If either of the supplied buffers are too small, 
//                GetLastError() will return ERROR_INSUFFICIENT_BUFFER
//                and pcchUser and pcchDomain will be adjusted to 
//                reflect the required buffer sizes.
// 
//**********************************************************************
static BOOL GetProcessUserAndDomainNT(HANDLE	hProcess, 
						outputstr* out_username,
						outputstr* out_domainname
					   ) 
{
	char user_name[UNLEN + 2];
	user_name[0] = 0;
	char domain_name[UNLEN + 2];
	domain_name[0] = 0;

	DWORD user_name_size = sizeof(user_name);
	DWORD domain_name_size = sizeof(domain_name);
	
	BOOL         fSuccess = FALSE;
	HANDLE       hToken   = NULL;
	PTOKEN_USER  ptiUser  = NULL;
	DWORD        cbti     = 0;
	SID_NAME_USE snu;
	
	__try
	{
		
		if (!OpenProcessToken(hProcess, TOKEN_QUERY, 
			&hToken))
			__leave;
		
		// Obtain the size of the user information in the token.
		if (GetTokenInformation(hToken, TokenUser, NULL, 0, &cbti)) 
		{
			
			// Call should have failed due to zero-length buffer.
			__leave;
			
		} 
		else 
		{
			
			// Call should have failed due to zero-length buffer.
			if (GetLastError() != ERROR_INSUFFICIENT_BUFFER)
				__leave;
		}
		
		// Allocate buffer for user information in the token.
		ptiUser = (PTOKEN_USER) HeapAlloc(GetProcessHeap(), 0, cbti);
		if (!ptiUser)
			__leave;
		
		// Retrieve the user information from the token.
		if (!GetTokenInformation(hToken, TokenUser, ptiUser, cbti, &cbti))
			__leave;
		
		// Retrieve user name and domain name based on user's SID.
		if (!LookupAccountSid(NULL, ptiUser->User.Sid, user_name, &user_name_size, 
			domain_name, &domain_name_size, &snu))
			__leave;
		

		if ( out_username )
			*out_username = user_name;

		if ( out_domainname )
			*out_domainname = domain_name;

		fSuccess = TRUE;
		
	}
	__finally 
	{
		
		// Free resources.
		if (hToken)
			CloseHandle(hToken);
		
		if (ptiUser)
			HeapFree(GetProcessHeap(), 0, ptiUser);
	}
	
	return fSuccess;
} 


static BOOL GetProcessUserAndDomain9x(HANDLE	hProcess, outputstr *out_username, 
							   outputstr* out_domainname) 
{
	char user_name[UNLEN + 2];
	user_name[0] = 0;
	char domain_name[UNLEN + 2];
	domain_name[0] = 0;

	DWORD user_name_size = sizeof(user_name);
	DWORD domain_name_size = sizeof(domain_name);

	if ( !GetUserName(user_name, &user_name_size) )
		return FALSE;

	ipaddr localip; localip.dwVal = GetLocalIP(NULL, 0);
	outputstr str; str = str + localip;

	if ( ! GetDomainName(str.GetString(), domain_name, domain_name_size) )
		return FALSE;

	if ( out_username )
		*out_username = user_name;

	if ( out_domainname )
		*out_domainname = domain_name;
	
	return TRUE;
}

BOOL GetProcessUserAndDomain(HANDLE	hProcess, outputstr *out_username, 
							   outputstr* out_domainname) 
{
	if ( IsWinNT())
	{
		return GetProcessUserAndDomainNT(hProcess, out_username, out_domainname);
	}

	return GetProcessUserAndDomain9x(hProcess, out_username, out_domainname);
}
