/* $Header: /usr2/cvs/master/Develop/Products/Smc/build/sndfc/src/sndfc/snd/GNDialer.cpp,v 1.1.1.1 2001/06/29 19:30:08 herbert Exp $*/
/*++
*************************************************************************
+-----------------------------------------------------------------------+
| Copyright (C) SYBERGEN NETWORKS, INC. 1998,1999 |
| All Rights Reserved. |
| Reproduction, adaptation, or translation without prior written |
| permission is prohibited, except as allowed under Copyright laws. |
| |
| N O T I C E |
| |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC. |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED. |
+-----------------------------------------------------------------------+
*************************************************************************
--*/

/*++
 * 
 * $Author: herbert $
 * $Date: 2001/06/29 19:30:08 $
 * $Revision: 1.1.1.1 $
 * $Workfile: GNDialer.cpp $
 * $Log: GNDialer.cpp,v $
 * Revision 1.1.1.1  2001/06/29 19:30:08  herbert
 * Migrate from VSS to CVS.
 *
 * 
 * 4     11/01/00 12:14p Herbertw
 * Change hangup command line from "hangupnow" to "exitnow"
 * 
 * 3     9/22/00 10:36a Herbertw
 * Add file check in case the GNDialer is uninstalled.
 * 
 * 2     9/21/00 6:42p Herbertw
 * 
 * 1     9/21/00 5:45p Herbertw
 * 
 * 2     9/01/00 3:25p Herbertw
 * 
 * 1     8/31/00 3:42p Herbertw
 * $NoKeywords: $
 *
--*/
#include "stdafx.h"
#include "GNDialer.h"
#include "RegUtil.h"
#include "osutils.h"
#include "miniras.h"

#define GNDIALER_REGKEY_VALUE	"Software\\AT&T Global Network\\Dialer\\Install"
#define GNDIALER_REG_INSTALLDIR_VALUE	"Directory"
//this registry key is for sygate use to detect if GN dialer is installed
#define GNDIALER_REG_GNINSTDIR_VALUE	"GNInstDir"

#define DEFAULT_IDLETIME		180000

CGNDialer::CGNDialer(dword idletime,  char * cfg_registry_path, bool * urgent_exit_flag_ptr)
{
	if(idletime == 0)
		m_wIdletime = DEFAULT_IDLETIME;
	else
		m_wIdletime = idletime;
	m_pUrgentExitflag = urgent_exit_flag_ptr;
	memset(m_strDialerPath, 0, sizeof(m_strDialerPath));
	m_bIsInstalled = IsDialerInstalled(cfg_registry_path);
}

CGNDialer::~CGNDialer(void)
{
}

sbool CGNDialer::IsDialerInstalled(char * cfg_registry_path)
{
	dword outlen;
	char	strtemp[256];
	outlen = strlen(strtemp);
	int iret  = ERR;
	if(cfg_registry_path != NULL)
	{
		iret = ReadStringFromRegistry(HKEY_LOCAL_MACHINE, cfg_registry_path, GNDIALER_REG_GNINSTDIR_VALUE, strtemp, sizeof(strtemp), &outlen);
	}

	if(iret != OK)
	{
		iret = ReadStringFromRegistry(HKEY_CURRENT_USER, GNDIALER_REGKEY_VALUE, GNDIALER_REG_INSTALLDIR_VALUE, strtemp, sizeof(strtemp), &outlen);
		if(iret == OK)
			WriteStringToRegistry(HKEY_LOCAL_MACHINE, cfg_registry_path, GNDIALER_REG_GNINSTDIR_VALUE, strtemp);
	}
	if(iret == OK)
	{
		if(strlen(strtemp) == 0)//something error.
			return false;
		if(m_strDialerPath[strlen(strtemp)-1] == '\\')
			m_strDialerPath[strlen(strtemp)-1] = 0;
		strcpy(m_strDialerPath, strtemp);
		
		WIN32_FIND_DATA FindFileData;
		HANDLE hFind;

		strcat(strtemp, "\\IDialer.exe");
		hFind = FindFirstFile(strtemp, &FindFileData);
			
		if (hFind == INVALID_HANDLE_VALUE)
		{
			DeleteRegistry(HKEY_LOCAL_MACHINE, cfg_registry_path, GNDIALER_REG_GNINSTDIR_VALUE, false);
			return false;
		}			
		else 
		    FindClose(hFind);
		
		return true;
	}
	else
	{
		if(DEBUG)sysprintln("GNDialer is not installed! ");
		return false;
	}
}
int CGNDialer::GoOnline(bool bAsycDial)
{
	if(!IsInstalled())return ERR;

	char filename[512];
	char command_line[512];

	sprintf(filename, "%s\\IDialer.exe", m_strDialerPath);
//	sprintf(command_line, "IDialer.exe -background -unattended -dial -timeout=%d", m_wIdletime/1000);
	sprintf(command_line, "\"%s\\IDialer.exe\" -background -unattended -dial", m_strDialerPath);
	Exec(filename, command_line, false, true); //We don't wait here.
	if(!bAsycDial)
	{
		SleepEx(5000, TRUE);//Wait 5 second to launch the program.
		CMiniRas	ATTRASEntry(GNRASENTRYNAME, NULL, NULL, 0xffffffff, m_pUrgentExitflag);
		for(int i = 0 ; i <180 * 10; i++)
		{
			if(ATTRASEntry.GetLineStatus() == ELS_OFFLINE)
				return ERR;
			if(ATTRASEntry.GetLineStatus() == ELS_ONLINE)
				return OK;
			if(m_pUrgentExitflag)
			{
				if(*m_pUrgentExitflag)break;
			}
			SleepEx(100, TRUE);
		}
		return ERR;
	}

	return OK;
}

int CGNDialer::GoOffline(bool bAsycHangup)
{
	if(!IsInstalled())return ERR;
	char filename[512];
	char command_line[512];
	
	sprintf(filename, "%s\\IDialer.exe", m_strDialerPath);
	sprintf(command_line, "\"%s\\IDialer.exe\" -exitnow", m_strDialerPath);
	Exec(filename, command_line, false, true);//We don't wait here.
	return OK;
}