#include "stdafx.h"
#include "Integerset.h."


void	CIntegerSet::AppendOneIntegerSet(const char	*str)
{
	SIntegerSetSection	section;

	if (str==NULL)
		return;

	char *pEnd;

	while (*str==' ') str++;
	pEnd = strchr(str, '-');

	if (pEnd==NULL)
	{
		if (!isdigit(*str))
			THROW_SND_EXCEPTION("CIntegerSet: Input is not a valid string");
		section.Begin = strtoul(str, NULL, 0);
		section.End = section.Begin;
		if (0)
		{
			char szTmp[200];
			sprintf(szTmp, "%d - %d", section.Begin, section.End);
			OutputDebugString(szTmp);
		}
		section_array.push_back(section);
	}
	else
	{
		*pEnd = 0;
		pEnd++;
		while (*pEnd==' ') pEnd++;
		if (!isdigit(*pEnd))
			THROW_SND_EXCEPTION("CIntegerSet: Input is not a valid string");
		section.Begin = strtoul(str, NULL, 0);
		section.End = strtoul(pEnd, NULL, 0);
		if (section.Begin>section.End)
		{
			dword tmp = section.Begin;
			section.Begin = section.End;
			section.End = tmp;
		}
		if (0)
		{
			char szTmp[200];
			sprintf(szTmp, "&& %d - %d", section.Begin, section.End);
			OutputDebugString(szTmp);
		}
		section_array.push_back(section);
	}
}


void	CIntegerSet::Append(const char	*str)
{
#if 1
	char *pTok;

	if (str==NULL)
		return;
	
	outputstr strTmp = str;

	pTok = strtok(strTmp.GetString(), ",");
	while( pTok != NULL )
	{
		AppendOneIntegerSet(pTok);
		pTok = strtok( NULL, ",");
	}

	return;
#else
	dword	len = strlen(str);
	int		i,j = 0;
	char	int_str[10];
	char	*pStr;
	SIntegerSetSection	section;
	BOOL	bSetBegin = FALSE;

	if (str == NULL)
		return;

	pStr = new char[len+2];

	if (str[0] == ',')
	{
		memcpy(pStr, str+1, len - 1);
		len--;
	}
	else
		memcpy(pStr, str, len);

	if (pStr[len -1] != ',')
	{
		pStr[len++] = ',';
	}

	pStr[len] = 0;

	for (i = 0;i < len; i++)
	{
		
		if (pStr[i] == ',')
		{
			if(i > 0)
			{
				if(!isdigit(pStr[i-1]))
				{
					THROW_SND_EXCEPTION("Error!!! The input is not a valid string");
				}
			}
			int_str[j] = 0;
			j = 0;
			if(strlen(int_str)==10)
			{
				if(strcmp(int_str,"2415919103")>0)
				{
					int_str[0] = '0';
					int_str[1] = 0;
				}
			}
			section.End = atoi(int_str);
			
			if (!bSetBegin)
				section.Begin = section.End;
			else
			{
				if (section.Begin > section.End)
				{
					dword	temp = section.Begin;
					section.Begin = section.End;
					section.End = temp;
				}
			}
			section_array.push_back(section);
			bSetBegin = FALSE;
			continue;
		}

		if (pStr[i] == '-')
		{
			if(i > 0)
			{
				if(!isdigit(pStr[i-1]))
				{
					THROW_SND_EXCEPTION("Error!!! Input is a invalid string");
				}
			}
			else
			{
				THROW_SND_EXCEPTION("Error!!! Input is a invalid string");
			}
			int_str[j] = 0;
			j = 0;
			if(strlen(int_str)==10)
			{
				if(strcmp(int_str,"2415919103")>0)
				{
					int_str[0] = '0';
					int_str[1] = 0;
				}
			}
			section.Begin = atoi(int_str);
			bSetBegin = TRUE;
			continue;
		}

		if(j < 9)
			int_str[j++] = pStr[i];
	}

	delete	pStr;
#endif
}


void	CIntegerSet::Reset(void)
{
	section_array.clear();
}


CIntegerSet::CIntegerSet(const char	*str)
{
	if (str != NULL)
	{
		Append(str);
	}
}

const char* CIntegerSet::GetString(void)
{
	dword	dwSize = section_array.size();
	set_str.Empty();

	if (dwSize==0)
		return set_str.GetString();
	
	for (int i = 0; i < (dwSize - 1); i ++)
	{
		if (section_array[i].Begin == section_array[i].End)
			set_str = set_str + section_array[i].Begin + ",";
		else
			set_str = set_str + section_array[i].Begin + "-" + section_array[i].End + ",";
	}

	if (section_array[dwSize - 1].Begin == section_array[dwSize - 1].End)
		set_str = set_str + section_array[dwSize - 1].Begin;
	else
		set_str = set_str + section_array[dwSize - 1].Begin + "-" + section_array[dwSize - 1].End;
	
	return set_str.GetString();
	
}

const char* CIntegerSet::GetHexString(void)
{
	dword	dwSize = section_array.size();
	set_str.Empty();
	char szBegin[32];
	char szEnd[32];

	if (dwSize==0)
		return set_str.GetString();
	
	for (int i = 0; i < (dwSize - 1); i ++)
	{
		sprintf(szBegin, "0x%x", section_array[i].Begin);
		sprintf(szEnd, "0x%x", section_array[i].End);
		if (section_array[i].Begin == section_array[i].End)
			set_str = set_str + szBegin + ",";
		else
			set_str = set_str + szBegin + "-" + szEnd + ",";
	}

	sprintf(szBegin, "0x%x", section_array[dwSize-1].Begin);
	sprintf(szEnd, "0x%x", section_array[dwSize-1].End);

	if (section_array[dwSize - 1].Begin == section_array[dwSize - 1].End)
		set_str = set_str + szBegin;
	else
		set_str = set_str + szBegin + "-" + szEnd;
	
	return set_str.GetString();
}

dword	CIntegerSet::GetSectionCount()
{
	return section_array.size();
}

int	CIntegerSet::GetSection(dword id, SIntegerSetSection	*pSection)
{
	if (id >= section_array.size())
	{
		return	ERR_INVALID_INDEX;
	}

	pSection->Begin = section_array[id].Begin;
	pSection->End = section_array[id].End;

	return OK;
}

sbool	CIntegerSet::IsInIntegerset(dword a)
{
	for (int i = 0; i < section_array.size(); i ++)
	{
		if ((a >= section_array[i].Begin) && (a <= section_array[i].End))
			return	TRUE;
	}

	return	FALSE;
}
	
CIntegerSet& CIntegerSet::operator=(const CIntegerSet&	int_set)
{
	section_array.clear();
	Append(((CIntegerSet)int_set).GetString());

	return *this;
}

CIntegerSet& CIntegerSet::operator=(const char *str)
{
	section_array.clear();
	Append(str);

	return *this;
}

outputstr operator+(outputstr &str, const CIntegerSet&	int_set)
{
	return str + ((CIntegerSet)int_set).GetString();
}


