/* file LICENSE.C */

/*++
*************************************************************************
+-----------------------------------------------------------------------+
|  Copyright (C) SYBERGEN, INC. 1998                                    |
|      All Rights Reserved.                                             |
| Reproduction, adaptation, or translation without prior written        |
| permission is prohibited, except as allowed under Copyright laws.     |
|                                                                       |
| N O T I C E                                                           |
|                                                                       |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC.                     |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED.                             |
+-----------------------------------------------------------------------+
*************************************************************************
--*/

#include "stdafx.h"
#include "licenseBase.h"


LicenseNewProduct::LicenseNewProduct()
{
}

char LicenseNewProduct::AdjustedChar(char ch)
{
	// Adjust character to guarantee that it is in following range
	// '0'-'9' or 'A'-'Z'

	ch &= 0x7F;

	if (ch<'0')
	{
		if (ch & 0x10)
			return (ch%26+'A');
		else
			return (ch%10+'0');
	}

	if (ch>'9' && ch<'A')
	{
		return ch-10;
	}

	if (ch>'Z')
	{
		return (ch%26+'A');
	}

	return ch;
}

void LicenseNewProduct::SnCsByClient(char *sn, char *sn3)
{
	// Generate client Checksum from Serial number(SN)
	// Input:  sn
	// Output: sn3

	(*(sn3)) = AdjustedChar( (*sn)*4 + (*(sn+1))*3 + (*(sn+2))*7 + (*(sn+3))*5 + (*(sn+4))*13 + (*(sn+5))*17 + (*(sn+6))*23 + (*(sn+8))*53 + (*(sn+9))*9 + (*(sn+10))*3 + (*(sn+11))*31 );
	(*(sn3+1)) = AdjustedChar( (*(sn+1))*13 + (*(sn+2))*12 + (*(sn+3))*9 + (*(sn+4))*8 + (*(sn+5))*2 + (*(sn+6))*4 + (*(sn+7))*3 + (*(sn+8))*5 + (*(sn+9))*8 + (*(sn+10))*7 + (*(sn+11))*3 );
	(*(sn3+2))='\0';
}

void LicenseNewProduct::SnRc(char *sn, char *rc)
{
	// Generate registration code from Serial number(SN)
	// Input:  sn
	// Output: rc

	(*(rc)) = AdjustedChar( (*(sn+1)) + (*(sn+2)) + (*(sn+3)) + (*(sn+4)) + (*(sn+5))*9 + (*(sn+6))*2 + (*(sn+7))*3 + (*(sn+8)) + (*(sn+9)) + (*(sn+10)) + (*(sn+11))*33 );
	(*(rc+1)) = AdjustedChar( (*(sn+1))*3 + (*(sn+2))*6 + (*(sn+3))*11 + (*(sn+4))*3 + (*(sn+5))*9 + (*(sn+6))*25 + (*(sn+7))*2 + (*(sn+8))*53 + (*(sn+9))*9 + (*(sn+10))*3 + (*(sn+11))*31 + 11 );
	(*(rc+2)) = AdjustedChar( (*(sn+1))*5 + (*(sn+2))*4 + (*(sn+3))*3 + (*(sn+4))*11 + (*(sn+5))*11 + (*(sn+6))*2 + (*(sn+7))*23 + (*(sn+8))*3 + (*(sn+9))*7 + (*(sn+10))*5 + (*(sn+11))*11 + 12 );
	(*(rc+3)) = AdjustedChar( (*(sn+1))*7 + (*(sn+2))*8 + (*(sn+3))*5 + (*(sn+4))*12 + (*(sn+5))*13 + (*(sn+6))*3 + (*(sn+7))*33 + (*(sn+8))*8 + (*(sn+9))*5 + (*(sn+10))*11 + (*(sn+11))*8 + 13 );
	(*(rc+4)) = AdjustedChar( (*(sn+1))*8 + (*(sn+2))*3 + (*(sn+3))*6 + (*(sn+4))*8 + (*(sn+5))*19 + (*(sn+6))*7 + (*(sn+7))*31 + (*(sn+8))*5 + (*(sn+9))*3 + (*(sn+10))*81 + (*(sn+11))*5 + 14 );
	(*(rc+5)) = AdjustedChar( (*(sn+1))*12 + (*(sn+2))*11 + (*(sn+3))*7 + (*(sn+4))*9 + (*(sn+5))*23 + (*(sn+6))*9 + (*(sn+7))*11 + (*(sn+8))*7 + (*(sn+9))*2 + (*(sn+10))*22 + (*(sn+11))*3 + 15 );
	(*(rc+6)) = AdjustedChar( (*(sn+1))*11 + (*(sn+2))*13 + (*(sn+3))*9 + (*(sn+4))*2 + (*(sn+5))*27 + (*(sn+6))*4 + (*(sn+7))*41 + (*(sn+8))*4 + (*(sn+9))*4 + (*(sn+10))*32 + (*(sn+11))*2 + 16 );
	(*(rc+7)) = AdjustedChar( (*(sn+1))*13 + (*(sn+2))*11 + (*(sn+3))*7 + (*(sn+4))*3 + (*(sn+5))*7 + (*(sn+6))*7 + (*(sn+7))*4 + (*(sn+8))*7 + (*(sn+9))*5 + (*(sn+10))*31 + (*(sn+11))*3 + 163 );
	(*(rc+8)) ='\0';
}
	
int LicenseNewProduct::VerifyByClient(char *strSN, unsigned slen, char *strRegCode, unsigned rlen)
/* return LICENSE_OK if passed */
/* return LICENSE_ERR_SERIALNUM_INVALID if sn doesn't passed. */
/* return LICENSE_ERR_REGCODE_INVALID if sn passed, but rc doesn't pass. */
{
	// Verify client checksum and registration code

	char sn3[3];
	char rc[9];
	int i;

	if (slen!=16)
		return LICENSE_ERR_SERIALNUM_INVALID;

	if (rlen!=8)
		return LICENSE_ERR_REGCODE_INVALID;

	// recalculate sn3
	SnCsByClient(strSN, sn3);

	if ( (*(strSN+14))!=sn3[0] || (*(strSN+15))!=sn3[1] ) 
		return LICENSE_ERR_SERIALNUM_INVALID;

	// recalculate rc
	SnRc(strSN, rc);
	
	for (i=0; i<8; i++)
	{
		if ( (*(strRegCode+i))!=rc[i] )
			return LICENSE_ERR_REGCODE_INVALID;
	}

	return LICENSE_OK;
}

int LicenseNewProduct::GetLicenseType(char *strSN, unsigned slen, char *strRegCode, unsigned rlen)
/* return LICENSE_TYPE_XXXX */
/* return LICENSE_TYPE_FREE if s/n or regcode 's verification failed. */
{
	if (VerifyByClient(strSN, slen, strRegCode, rlen) != LICENSE_OK) 
		return LICENSE_TYPE_FREE;
	
	return LICENSE_TYPE_UNLIMITED;
}

