// MiniInet.cpp: implementation of the CMiniInet class.
//
//////////////////////////////////////////////////////////////////////
/*++
*************************************************************************
+-----------------------------------------------------------------------+
|  Copyright (C) SYBERGEN, INC. 1998,1999                               |
|      All Rights Reserved.                                             |
| Reproduction, adaptation, or translation without prior written        |
| permission is prohibited, except as allowed under Copyright laws.     |
|                                                                       |
| N O T I C E                                                           |
|                                                                       |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC.                     |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED.                             |
+-----------------------------------------------------------------------+
*************************************************************************
--*/
/*++
History:

04/15/1999			merged into SNDFC by Yadong Zhang
xx/xx/xxxx			Created by Yadong Zhang

--*/

#include "stdafx.h"
#include "MiniInet.h"

typedef HINTERNET WINAPI DEF_InternetOpen(
	IN LPCSTR lpszAgent,
    IN DWORD dwAccessType,
    IN LPCSTR lpszProxy OPTIONAL,
    IN LPCSTR lpszProxyBypass OPTIONAL,
    IN DWORD dwFlags
    );

typedef HINTERNET WINAPI DEF_InternetOpenUrl(
    IN HINTERNET hInternet,
    IN LPCSTR lpszUrl,
    IN LPCSTR lpszHeaders OPTIONAL,
    IN DWORD dwHeadersLength,
    IN DWORD dwFlags,
    IN DWORD dwContext
    );

typedef BOOL WINAPI DEF_InternetReadFile(
    IN HINTERNET hFile,
    IN LPVOID lpBuffer,
    IN DWORD dwNumberOfBytesToRead,
    OUT LPDWORD lpdwNumberOfBytesRead
    );

typedef BOOL WINAPI DEF_InternetCloseHandle(IN HINTERNET hInternet);

typedef INTERNET_STATUS_CALLBACK WINAPI DEF_InternetSetStatusCallback(
    IN HINTERNET hInternet,
    IN INTERNET_STATUS_CALLBACK lpfnInternetCallback
    );

// for WININET.DLL
static HINSTANCE		hWinInetDll = 0;
static unsigned			WinInetDllUsageCount = 0;

static DEF_InternetOpen			*ptr_InternetOpen = 0;
static DEF_InternetOpenUrl		*ptr_InternetOpenUrl = 0;
static DEF_InternetReadFile		*ptr_InternetReadFile = 0;
static DEF_InternetCloseHandle	*ptr_InternetCloseHandle = 0;
static DEF_InternetSetStatusCallback	*ptr_InternetSetStatusCallback = 0;

//**************** NOTICE !!!!!!! ********************
// These WinINET APIs are only for ***ANSI*** code 


int LoadWinInet(void)
// return OK if successful.
{
	WinInetDllUsageCount++;
	if (hWinInetDll == 0)
	{
		sysprintln("Loading wininet...");
		hWinInetDll = LoadLibrary("wininet.dll");
		sysprintln("wininet loaded.");
		if (hWinInetDll == 0) return ERR;
		bool b;
		b = (  (ptr_InternetOpen = (DEF_InternetOpen*) GetProcAddress(hWinInetDll, "InternetOpenA"))
			&& (ptr_InternetOpenUrl = (DEF_InternetOpenUrl*) GetProcAddress(hWinInetDll, "InternetOpenUrlA"))
			&& (ptr_InternetReadFile = (DEF_InternetReadFile*) GetProcAddress(hWinInetDll, "InternetReadFile"))
			&& (ptr_InternetCloseHandle = (DEF_InternetCloseHandle*) GetProcAddress(hWinInetDll, "InternetCloseHandle"))
			&& (ptr_InternetSetStatusCallback = (DEF_InternetSetStatusCallback*) GetProcAddress(hWinInetDll, "InternetSetStatusCallback"))
			);
		if (b == false) 
		{
			// some functions required cannot be located.
			return ERR;
		}

	}
	return OK;
}


int UnloadWinInet(void)
// return OK if successful.
{
	if (WinInetDllUsageCount == 0) goto unloaddll;
	
	WinInetDllUsageCount--;
	if (WinInetDllUsageCount) return OK;

unloaddll:
	if (hWinInetDll)
	{
		sysprintln("Unloading wininet...");
		//SleepEx(1000, TRUE);
		//==============================================
		//We can't free library when we use this at sygate manager. that will cause a crash! :o(
		FreeLibrary(hWinInetDll); hWinInetDll = 0;
		//==============================================
		//SleepEx(1000, TRUE);
		sysprintln("wininet unloaded.");
	//	if (DEBUG) sdbg<<"MiniINet: wininet.dll unloaded."<<endl;
	}

	return OK;
}

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CMiniInet::CMiniInet()
{
	bItWorks = false;
	
	if (LoadWinInet() != OK) return;
	
	bItWorks = true;

}

CMiniInet::~CMiniInet()
{
	UnloadWinInet();
	bItWorks = false;
}


HINTERNET CMiniInet::InternetOpen(
		IN LPCSTR lpszAgent,
		IN DWORD dwAccessType,
		IN LPCSTR lpszProxy OPTIONAL,
		IN LPCSTR lpszProxyBypass OPTIONAL,
		IN DWORD dwFlags
		)
{
	return (*ptr_InternetOpen)(lpszAgent,dwAccessType,
		lpszProxy, lpszProxyBypass,
		dwFlags);
}


HINTERNET CMiniInet::InternetOpenUrl(
		IN HINTERNET hInternet,
		IN LPCSTR lpszUrl,
		IN LPCSTR lpszHeaders OPTIONAL,
		IN DWORD dwHeadersLength,
		IN DWORD dwFlags,
		IN DWORD dwContext
		)
{
	return (*ptr_InternetOpenUrl)(hInternet,
		lpszUrl, lpszHeaders, dwHeadersLength,
		dwFlags, dwContext);

}


BOOL CMiniInet::InternetReadFile(
		IN HINTERNET hFile,
		IN LPVOID lpBuffer,
		IN DWORD dwNumberOfBytesToRead,
		OUT LPDWORD lpdwNumberOfBytesRead
		)
{
	return (*ptr_InternetReadFile)(hFile, lpBuffer,
		dwNumberOfBytesToRead,
		lpdwNumberOfBytesRead);

}


BOOL CMiniInet::InternetCloseHandle(
		IN HINTERNET hInternet
		)
{
	return (*ptr_InternetCloseHandle)(hInternet);
}

INTERNET_STATUS_CALLBACK CMiniInet::InternetSetStatusCallback(
    IN HINTERNET hInternet,
    IN INTERNET_STATUS_CALLBACK lpfnInternetCallback
    )
{
    return (*ptr_InternetSetStatusCallback)(hInternet, lpfnInternetCallback);
}
