// MiniInet.h: interface for the CMiniInet class.
//
//////////////////////////////////////////////////////////////////////
/*++
*************************************************************************
+-----------------------------------------------------------------------+
|  Copyright (C) SYBERGEN, INC. 1998,1999                               |
|      All Rights Reserved.                                             |
| Reproduction, adaptation, or translation without prior written        |
| permission is prohibited, except as allowed under Copyright laws.     |
|                                                                       |
| N O T I C E                                                           |
|                                                                       |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC.                     |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED.                             |
+-----------------------------------------------------------------------+
*************************************************************************
--*/
/*++
History:

04/15/1999			merged into SNDFC by Yadong Zhang
xx/xx/xxxx			Created by Yadong Zhang

--*/

#if !defined(AFX_MINIINET_H__EA6C3B00_FC00_11D1_9855_00C026807807__INCLUDED_)
#define AFX_MINIINET_H__EA6C3B00_FC00_11D1_9855_00C026807807__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "sndbasex.h"

/*++
CMiniInet provides a WinInet API function set with DLL loaded
 dynamatically. When you don't like static link with WinInet.DLL,
 MiniInet will be helpful.
--*/


class CMiniInet  
{
private:
	bool				bItWorks;
public:
	CMiniInet();
	~CMiniInet();

	inline bool ItWorks(void) { return bItWorks; }
	// return true if MiniInet is fine, you can use it.

	HINTERNET InternetOpen(
		IN LPCSTR lpszAgent,
		IN DWORD dwAccessType,
		IN LPCSTR lpszProxy OPTIONAL,
		IN LPCSTR lpszProxyBypass OPTIONAL,
		IN DWORD dwFlags
		);
	// see help on WinInet API from M$, they are same one.

	HINTERNET InternetOpenUrl(
		IN HINTERNET hInternet,
		IN LPCSTR lpszUrl,
		IN LPCSTR lpszHeaders OPTIONAL,
		IN DWORD dwHeadersLength,
		IN DWORD dwFlags,
		IN DWORD dwContext
		);
	// see help on WinInet API from M$, they are same one.

	BOOL InternetReadFile(
		IN HINTERNET hFile,
		IN LPVOID lpBuffer,
		IN DWORD dwNumberOfBytesToRead,
		OUT LPDWORD lpdwNumberOfBytesRead
		);
	// see help on WinInet API from M$, they are same one.

	BOOL InternetCloseHandle(
		IN HINTERNET hInternet
		);
	// see help on WinInet API from M$, they are same one.

	INTERNET_STATUS_CALLBACK InternetSetStatusCallback(
	    IN HINTERNET hInternet,
	    IN INTERNET_STATUS_CALLBACK lpfnInternetCallback
	    );
	// see help on WinInet API from M$, they are same one.


};

#endif // !defined(AFX_MINIINET_H__EA6C3B00_FC00_11D1_9855_00C026807807__INCLUDED_)
