// file MINIWS.CPP
/*++
*************************************************************************
+-----------------------------------------------------------------------+
|  Copyright (C) SYBERGEN, INC. 1998                                    |
|      All Rights Reserved.                                             |
| Reproduction, adaptation, or translation without prior written        |
| permission is prohibited, except as allowed under Copyright laws.     |
|                                                                       |
| N O T I C E                                                           |
|                                                                       |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC.                     |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED.                             |
+-----------------------------------------------------------------------+
*************************************************************************
--*/

/*++
History:

01/05/1999			Created by Yadong Zhang

--*/


#include "stdafx.h"
#include "MiniWS.h"


typedef
int
(WSAAPI DEF_WSAStartup)(
    WORD wVersionRequested,
    LPWSADATA lpWSAData
    );

typedef
int
(WSAAPI DEF_WSACleanup)(
    void
    );

typedef
int
(WSAAPI DEF_gethostname)(
    char FAR * name,
    int namelen
    );

typedef
struct hostent FAR *
(WSAAPI DEF_gethostbyname)(
    const char FAR * name
    );


typedef 
HANDLE 
(WSAAPI DEF_WSAAsyncGetHostByName)(
    HWND hWnd,
    u_int wMsg,
    const char FAR * name,
    char FAR * buf,
    int buflen
    );


// for WINSOCK.DLL
static HINSTANCE		hWinsockDll = 0;
static unsigned			WinsockDllUsageCount = 0;

static DEF_WSAStartup			*ptr_WSAStartup = 0;
static DEF_WSACleanup			*ptr_WSACleanup = 0;
static DEF_gethostname			*ptr_gethostname = 0;
static DEF_gethostbyname		*ptr_gethostbyname = 0;
static DEF_WSAAsyncGetHostByName	*ptr_WSAAsyncGetHostByName = 0;
//**************** NOTICE !!!!!!! ********************


int LoadWinsock(void)
// return OK if successful.
{
	WinsockDllUsageCount++;
	if (hWinsockDll == 0)
	{
		hWinsockDll = LoadLibrary("WSOCK32.dll");
		if (hWinsockDll == 0) return ERR;
		bool b;
		b = (  (ptr_WSAStartup = (DEF_WSAStartup*) GetProcAddress(hWinsockDll, "WSAStartup"))
			&& (ptr_WSACleanup = (DEF_WSACleanup*) GetProcAddress(hWinsockDll, "WSACleanup"))
			&& (ptr_gethostname = (DEF_gethostname*) GetProcAddress(hWinsockDll, "gethostname"))
			&& (ptr_gethostbyname = (DEF_gethostbyname*) GetProcAddress(hWinsockDll, "gethostbyname"))
			&& (ptr_WSAAsyncGetHostByName = (DEF_WSAAsyncGetHostByName*) GetProcAddress(hWinsockDll, "WSAAsyncGetHostByName"))
			);
		if (b == false) 
		{
			// some functions required cannot be located.
			return ERR;
		}

	}
	return OK;
}


int UnloadWinsock(void)
// return OK if successful.
{
	if (WinsockDllUsageCount == 0) goto unloaddll;
	
	WinsockDllUsageCount--;
	if (WinsockDllUsageCount) return OK;

unloaddll:
	if (hWinsockDll)
	{
		FreeLibrary(hWinsockDll); hWinsockDll = 0;
	//	if (DEBUG) sdbg<<"MiniINet: Winsock.dll unloaded."<<endl;
	}

	return OK;
}

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CMiniWinsock::CMiniWinsock()
{
	bItWorks = false;
	
	if (LoadWinsock() != OK) return;
	
	bItWorks = true;

}

CMiniWinsock::~CMiniWinsock()
{
	UnloadWinsock();
	bItWorks = false;
}


int
CMiniWinsock::WSAStartup(
    WORD wVersionRequested,
    LPWSADATA lpWSAData
    )
{
	return (*ptr_WSAStartup)(wVersionRequested, lpWSAData);
}


int
CMiniWinsock::WSACleanup(
    void
    )
{
	return (*ptr_WSACleanup)();
}


int
CMiniWinsock::gethostname(
    char FAR * name,
    int namelen
    )
{
	return (*ptr_gethostname)(name, namelen);

}


struct hostent FAR *
CMiniWinsock::gethostbyname(
    const char FAR * name
    )
{
	return (*ptr_gethostbyname)(name);
}


HANDLE CMiniWinsock::WSAAsyncGetHostByName(
		HWND hWnd,
		u_int wMsg,
		const char FAR * name,
		char FAR * buf,
		int buflen
		)
{
	return (*ptr_WSAAsyncGetHostByName)(hWnd, wMsg, name, buf, buflen);
}

