#ifndef __NETAID_H__
#define __NETAID_H__
#include <windows.h>

//#include <crtdbg.h>



//#include <winioctl.h> 
#include "tdiinfo.h" // from recent NT4DDK "\ddk\src\network\inc\tdiinfo.h"
#include "smpletcp.h" // from recent NT4DDK "\ddk\src\network\wshsmple\smpletcp.h"
#include "TDIQHelp.h"

#define NO_ERR           0
#define ERR_BASE         10000
#define ERR_NOT_INSTALL_IP  (ERR_BASE+1)
#define ERR_NOT_INIT        (ERR_BASE+2)
#define ERR_GETIPSNMPINFO	(ERR_BASE+3)
#define ERR_GETIPADDRTABLE  (ERR_BASE+4)
#define ERR_GETIPROUTETABLE (ERR_BASE+5)
#define ERR_REFRESHNETAIDINFO  (ERR_BASE+6)


#define MIN_REFRESH_TIME     2000   //5 second

enum NicCableStatus
{
	NICCABLESTATUS_CABLE_UNKNOWN=0,
	NICCABLESTATUS_CABLE_CONNECTED,
	NICCABLESTATUS_CABLE_DISCONNECTED
};
class CNetAid
{

private:
	DWORD dwLastRefreshTime;
	CRITICAL_SECTION NetAid_CriticalSection;
	BOOL bInit;

	DWORD dwErrCode;
	IPSNMPInfo  ipSnmpInfo;
	IPAddrEntry *pIPAddrTable;
	PUCHAR      pIPRouteTableBuffer ;
public:
	CNetAid();
	~CNetAid();
//	DWORD Init();
	void Init();
	// throw sndexception();

	//DWORD RefreshNetAidInfo();
	int RefreshNetAidInfo();
	// throw exception if failed.

	int QueryNicCableConnectionStatusByMacAddress(
		const byte* pMacAddr,
		NicCableStatus * out_eNicCableStatus);   //this function only support win2000 and winXP
	// return OK if successfully
	// return ERR_NOT_FOUND if the mac is not found or it is not supported.
	
	int QueryGatewayIpAddress(
			DWORD* gateway_list_buf,	// support NULL.
			DWORD buf_size,			// size in byte
			DWORD* out_gw_Num,		// number of gateway returned
			DWORD* out_total_gw_num	// total number of gateway detected
			);
	// return OK if successfully
	// return ERR if failed.


};

#endif