//  file NicIp.h
/*++
*************************************************************************
+-----------------------------------------------------------------------+
|  Copyright (C) SYBERGEN, INC. 1998,1999                               |
|      All Rights Reserved.                                             |
| Reproduction, adaptation, or translation without prior written        |
| permission is prohibited, except as allowed under Copyright laws.     |
|                                                                       |
| N O T I C E                                                           |
|                                                                       |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC.                     |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED.                             |
+-----------------------------------------------------------------------+
*************************************************************************
--*/
/*++
History:

04/01/1999			Created by Yadong Zhang

--*/


#ifndef SND_NICIP_H
#define SND_NICIP_H

#include "sndbase.h"

#define	DOMAIN_LEN			128
#define NICNAME_LEN			128
#define	DOMAINSUFFIX_LEN	64
#define	HOSTNAME_LEN		64
#define	MAX_DNS				3
#define MAX_DOMAINSUFFIX	6

#define	MAX_DHCPINFO		100
#define MAX_IP_ADDR_LIST     8
#include "packon1.h"

struct Ip_Address
{
	long IpAddress;
	long SubnetMask;
};
struct Ip_address_List
{
	DWORD dwIpAddressEntry;
	Ip_Address IpAddr[MAX_IP_ADDR_LIST]; 
};
struct SNicNetParam
{
	bool	DhcpEnabled;
	long	IpAddress;		// to convert "long" to class ipaddr, you can use toipaddr(long)
	long	SubnetMask;
	long	DefaultGateway;

	//add IP address List support
	Ip_address_List IpAddrList;
};

struct	SDNSData
{
	char	strDomain[DOMAIN_LEN];
	char	strHostName[HOSTNAME_LEN];
	bool	bDNSEnabled;
	long	DNSServer[MAX_DNS];
	char	strNicName[NICNAME_LEN]; //this varient only used at Win2K. otherwise it will be ignored.
	char	strSearchList[MAX_DOMAINSUFFIX][DOMAINSUFFIX_LEN];
};
#include "packoff1.h"

int GetNicNetParam(char *nicname, SNicNetParam* nnp,etheraddr *mac);
// return OK if successful, otherwise return ERR
// WinNT and Win95/98 : need MACaddress if Dhcp is enabled.
// Win2K : return the MACaddress via parameter mac


int SetNicNetParam(char *nicname, SNicNetParam* nnp);
// return OK if successful, otherwise return ERR


int GetDHCPNicNetParam(char*, SNicNetParam*, etheraddr*);
// Get current DHCP settings
// return 0 if successful
// return -1 if failed

bool VerifyNicDev(char *nicname);
// Win95/98: sometimes, some NicName under Net\XXXX have NOT really Device.
// the function return true if here is a really device for this nicname
// return false if no device
// WinNT: return true always
// Win2K: always return true

int IsNetDevUnderDyn(char *reg_path);
// NOTICE: reg_path Does NOT end with '\';
// return 0 if succeeded
// return -1 if failed.
//this function get the dynamic info to reflect the existence of one network card
//WinNT and Win2K : always return true.

bool GetNicDevPath(char *nicname, char * path); //Enhance VerifyNicDev function.
//Win95/98: sometimes, some NicName under Net\XXXX have not really Device.
// the function return true if here is a really device for this nicname
// return false if no device
// WinNT: return true always
// Win2K: always return true

int SetDnsServer(ipaddr ip, char * nicname = NULL);
// Set the DNS Server setting
// At Win2K, nicname must have a value. To other platform, it will be ignored.
// return 0 if successful
// return 1 if successful and it will take effect after reboot.
// return -1 if failed.

ipaddr GetDnsServer(char * nicname = NULL);
// Get the DNS server setting.
// return DNS server ip address
// At Win2K, if nicname has a value, it will return first DNS setting bind to that nic.
//    otherwise, return the first DNS setting.
// return 0 if it was not defined or failure occured.

int GetAllDnsServer(ipaddr * piplist, dword * plistnum);
//[in] plistnum : Specifies the number of the list pointed to by the piplist parameter. 
//	If the buffer is not large enough to hold the returned DNS server list, the function sets this parameter 
//	equal to the required number. 
//	else return the number of ip fill in the list
// return 0 if successful.
// return -1 if need more space to hold the DNS server list.


int SetDnsData(SDNSData*);
// Set the DNS Server setting, use SDNSData structure to send DNS information
// At Win2K, this function can only return DNS and Hostname setting.
// SDNSData.strNicName must has a value at Win2K.
// return 0 if successful
// return -1 if failed.

int GetDnsData(SDNSData*);
// Get the DNS server setting, save these information in a SDNSData structure
// At Win2K, this function only support DNS setting change.
// At Win2K, if SDNSData.strNicName has a value, then only return the DNS bind to that adapter.
// Otherwise it will return All adapter's DNS setting.
// return 0 if successful
// return -1 if failed.

bool IsFixedIp(char *nicname);

DWORD GetNicMTU(char * nicname);
// return MTU value of relative adapter
// return 0 if failure occured.
// Win2K : doesn't support.

DWORD GetNicRecieveWindow(char *nicname);
// return maximum recieve window value of relative adapter
// only Win2K support nicname parameter.
// return 0 if failure occured or using default value.

// =====================================================
// The function is FOR COMPATIABLILITY WITH SYGATE
// Normally, user should use GetNicNetParm
DWORD GetNicIpAddr(char *nicname,etheraddr *mac);
// it support 95 and NT, return 0 if fail
// ======================================================

#endif
