/* $Header: /usr2/cvs/master/Develop/Products/Smc/build/sndfc/src/sndfc/snd/NicIphlp.cpp,v 1.1.1.1 2001/06/29 19:30:08 herbert Exp $*/
/*++
*************************************************************************
+-----------------------------------------------------------------------+
| Copyright (C) SYBERGEN NETWORKS, INC. 1998,1999 |
| All Rights Reserved. |
| Reproduction, adaptation, or translation without prior written |
| permission is prohibited, except as allowed under Copyright laws. |
| |
| N O T I C E |
| |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC. |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED. |
+-----------------------------------------------------------------------+
*************************************************************************
--*/

/*++
 * 
 * $Author: herbert $
 * $Date: 2001/06/29 19:30:08 $
 * $Revision: 1.1.1.1 $
 * $Workfile: NicIphlp.cpp $
 * $Log: NicIphlp.cpp,v $
 * Revision 1.1.1.1  2001/06/29 19:30:08  herbert
 * Migrate from VSS to CVS.
 *
 * 
 * 3     5/24/01 6:47p Jianli
 * 
 * 2     5/16/00 5:46p Herbertw
 * Merge SNDFC from  NatSrv and Netport
 * 
 * 1     1/28/00 10:58a Ydz
 * 
 * 5     12/10/99 4:21p Herbertw
 * Fix bug about multi-creat iphlp class failed at same time.
 * 
 * 4     12/05/99 7:57p Herbertw
 * 
 * 3     12/02/99 12:21p Herbertw
 * 
 * 2     11/29/99 6:41p Herbertw
 * 
 * 1     11/29/99 6:09p Herbertw
 * 
 * 3     8/26/99 3:33p Herbertw
 * Add new function IphlpGetNetworkParams() .
 * $NoKeywords: $
 *
--*/
#include "stdafx.h"
#include "NicIpHlp.h"
#include "AppFileInfo.h"

unsigned	CNicIpHlpApi::IphlpApiDllUsageCount = 0;
HINSTANCE	CNicIpHlpApi::hIphlpApiDll = NULL;

typedef DWORD WINAPI DEF_GetAdaptersInfo(PIP_ADAPTER_INFO pAdapterInfo, PULONG pOutBufLen);
typedef DWORD WINAPI DEF_GetNetworkParams(PFIXED_INFO pFixedInfo, PULONG pOutBufLen);
typedef DWORD WINAPI DEF_GetNumberOfInterfaces(PDWORD pdwNumIf);
typedef DWORD WINAPI DEF_GetIfTable(PMIB_IFTABLE pIfTable, PULONG pdwSize, BOOL bOrder);
typedef DWORD WINAPI DEF_GetIfEntry(PMIB_IFROW pIfRow);
typedef	DWORD WINAPI DEF_GetIpForwardTable(PMIB_IPFORWARDTABLE pIpForwardTable, PULONG pdwSize, BOOL bOrder);
typedef DWORD WINAPI DEF_GetIpAddrTable(PMIB_IPADDRTABLE pIpAddrTable, PULONG pdwSize, BOOL bOrder);
typedef DWORD WINAPI DEF_GetIpNetTable(PMIB_IPNETTABLE pIpNetTable,PULONG pdwSize,BOOL bOrder);

static DEF_GetAdaptersInfo	*ptr_IphlpGetAdaptersInfo = NULL;
static DEF_GetNetworkParams	*ptr_IphlpGetNetworkParams = NULL;
static DEF_GetNumberOfInterfaces *ptr_IphlpGetNumberOfInterfaces = NULL;
static DEF_GetIfTable		*ptr_IphlpGetIfTable = NULL;
static DEF_GetIfEntry		*ptr_IphlpGetIfEntry = NULL;
static DEF_GetIpForwardTable	*ptr_IphlpGetIpForwardTable = NULL;
static DEF_GetIpAddrTable	*ptr_IphlpGetIpAddrTable = NULL;
static DEF_GetIpNetTable   *ptr_IphlpGetIpNetTable=NULL;

int CNicIpHlpApi::GetValidIphlpApiPath(LPSTR dllPath)
{
	char szTmpFile[MAX_PATH];
	char szWinSysPath[MAX_PATH];

	sprintf(szTmpFile, "%s", "iphlpapi.dll");
	if(CheckIphlpApiVer(szTmpFile) == ERR)
	{
		// Get the system directory
		GetSystemDirectory(szWinSysPath,sizeof(szWinSysPath));
		sprintf(szTmpFile,"%s\\%s",szWinSysPath,"iphlpapi.dll");
		
		if(CheckIphlpApiVer(szTmpFile) == ERR)
		{				
			return ERR;
		}
		
	}
	
	strcpy(dllPath, szTmpFile);
	return OK;
}

int CNicIpHlpApi::CheckIphlpApiVer(LPSTR dllPath)
{
	char szTmpFile[MAX_PATH];
	SAppFileInfo AppInfo;
	HINSTANCE hDll = 0;
	int retVal = ERR;

	hDll = LoadLibrary(dllPath);
	if (hDll == 0) 
	{
		return ERR;			
	}

	if(GetModuleFileName(hDll, szTmpFile, MAX_PATH) > 0)
	{
		if(GetAppFileInfo(szTmpFile, &AppInfo) == OK)
		{
			// File found, check version
			if (strcmp(AppInfo.FileVersion.GetString(),"5.0.1952.1")==0 || strcmp(AppInfo.FileVersion.GetString(),"5.00.1952.1")==0)
				retVal = ERR;
			else
				retVal = OK;
		}
	}

	FreeLibrary(hDll);
	return retVal;
}

int CNicIpHlpApi::LoadIphlpApi(void)
// return OK if successful.
{
	char szDllFile[MAX_PATH];

	if (hIphlpApiDll == 0)
	{
		
		if(GetValidIphlpApiPath(szDllFile) == OK)
		{
			hIphlpApiDll = LoadLibrary(szDllFile);
		}
		else		
		{
			sysprintln("Can't load Iphlpapi.dll");
			return ERR;			
		}

		ptr_IphlpGetAdaptersInfo = (DEF_GetAdaptersInfo *)GetProcAddress(hIphlpApiDll,"GetAdaptersInfo");
		ptr_IphlpGetNetworkParams = (DEF_GetNetworkParams *)GetProcAddress(hIphlpApiDll, "GetNetworkParams");
		ptr_IphlpGetNumberOfInterfaces = (DEF_GetNumberOfInterfaces *)GetProcAddress(hIphlpApiDll, "GetNumberOfInterfaces");
		ptr_IphlpGetIfTable = (DEF_GetIfTable *)GetProcAddress(hIphlpApiDll, "GetIfTable");
		ptr_IphlpGetIfEntry = (DEF_GetIfEntry *)GetProcAddress(hIphlpApiDll, "GetIfEntry");
		ptr_IphlpGetIpForwardTable = (DEF_GetIpForwardTable *)GetProcAddress(hIphlpApiDll, "GetIpForwardTable");
		ptr_IphlpGetIpAddrTable = (DEF_GetIpAddrTable *)GetProcAddress(hIphlpApiDll, "GetIpAddrTable");
		ptr_IphlpGetIpNetTable=(DEF_GetIpNetTable   *)GetProcAddress(hIphlpApiDll, "GetIpNetTable");

		if(ptr_IphlpGetAdaptersInfo == NULL || ptr_IphlpGetNetworkParams == NULL || ptr_IphlpGetNumberOfInterfaces == NULL 
			|| ptr_IphlpGetIfTable == NULL || ptr_IphlpGetIfEntry == NULL || ptr_IphlpGetIpForwardTable == NULL
			|| ptr_IphlpGetIpAddrTable == NULL || ptr_IphlpGetIpNetTable==NULL)
			sysprintln("some function can't be loaded!");

		if(DEBUG)sysprintln("Iphlpapi.dll loaded.");
	}
	return OK;
}

int CNicIpHlpApi::UnloadIphlpApi(void)
// return OK if successful.
{
	if (IphlpApiDllUsageCount != 0)
	{
		IphlpApiDllUsageCount--;
		if (IphlpApiDllUsageCount) return OK;
	}
	if (hIphlpApiDll)
	{
		FreeLibrary(hIphlpApiDll);
		hIphlpApiDll = 0;
	}
	return OK;
}

CNicIpHlpApi::CNicIpHlpApi(void)
{
	bItExist = false;
	if(IphlpApiDllUsageCount == 0)
	{
		if(LoadIphlpApi()==OK)
			bItExist = true;
	}
	else
		bItExist = true;
	if(bItExist)
		IphlpApiDllUsageCount ++;
}
CNicIpHlpApi::~CNicIpHlpApi(void)
{
	if(bItExist)
	{
		UnloadIphlpApi();
		bItExist = false;
	}
}

DWORD CNicIpHlpApi::IphlpGetAdaptersInfo(PIP_ADAPTER_INFO pAdapterInfo,PULONG pOutBufLen)
{
	if(bItExist && ptr_IphlpGetAdaptersInfo != NULL)
	{
		return (*ptr_IphlpGetAdaptersInfo)(pAdapterInfo, pOutBufLen);
	}
	return ERROR_NOT_SUPPORTED;
}

DWORD CNicIpHlpApi::IphlpGetNetworkParams(PFIXED_INFO pFixedInfo, PULONG pOutBufLen)
{
	if(bItExist && ptr_IphlpGetNetworkParams != NULL)
	{
		return (*ptr_IphlpGetNetworkParams)(pFixedInfo, pOutBufLen);
	}
	return ERROR_NOT_SUPPORTED;
}

DWORD CNicIpHlpApi::IphlpGetNumberOfInterfaces(PDWORD pdwNumIf)
{
	if(bItExist && ptr_IphlpGetNumberOfInterfaces != NULL)
	{
		return (*ptr_IphlpGetNumberOfInterfaces)(pdwNumIf);
	}
	return ERROR_NOT_SUPPORTED;
}

DWORD CNicIpHlpApi::IphlpGetIfTable(PMIB_IFTABLE pIfTable, PULONG pdwSize, BOOL bOrder)
{
	if(bItExist && ptr_IphlpGetIfTable != NULL)
	{
		return (*ptr_IphlpGetIfTable)(pIfTable, pdwSize, bOrder);
	}
	return ERROR_NOT_SUPPORTED;
}

DWORD CNicIpHlpApi::IphlpGetIfEntry(PMIB_IFROW pIfRow)
{
	if(bItExist && ptr_IphlpGetIfEntry != NULL)
	{
		return (*ptr_IphlpGetIfEntry)(pIfRow);
	}
	return ERROR_NOT_SUPPORTED;
}

DWORD CNicIpHlpApi::IphlpGetIpForwardTable(PMIB_IPFORWARDTABLE pIpForwardTable, PULONG pdwSize, BOOL bOrder)
{
	if(bItExist && ptr_IphlpGetIpForwardTable != NULL)
	{
		return (*ptr_IphlpGetIpForwardTable)(pIpForwardTable, pdwSize, bOrder);
	}
	return ERROR_NOT_SUPPORTED;
}

DWORD CNicIpHlpApi::IphlpGetIpAddrTable(PMIB_IPADDRTABLE pIpAddrTable, PULONG pdwSize, BOOL bOrder)
{
	if(bItExist && ptr_IphlpGetIpAddrTable != NULL)
	{
		return (*ptr_IphlpGetIpAddrTable)(pIpAddrTable, pdwSize, bOrder);
	}
	return ERROR_NOT_SUPPORTED;
}

DWORD CNicIpHlpApi::IphlpGetIpNetTable(PMIB_IPNETTABLE pIpNetTable,PULONG pdwSize,BOOL bOrder)
{
	if(bItExist && ptr_IphlpGetIpNetTable!=NULL)
	{
		return (*ptr_IphlpGetIpNetTable)(pIpNetTable,pdwSize,bOrder);
	}
	return ERROR_NOT_SUPPORTED;
}  	