// file NicUtils.cpp
#include "stdafx.h"
#include "osutils.h"
#include "NicUtils.h"
#include "NicIpHlp.h"

#include "nicip.h"


typedef struct
{
	char ServiceName[64];
	char Description[256];
} STdi_NT;


#define MaxNumberNic	16
typedef struct _NIC_ID {
	DWORD	dwNumberOfNic;
	BOOL	bIsPPP[MaxNumberNic];
	BYTE*	pNicId[MaxNumberNic];
} NIC_ID, *PNIC_ID;

static DWORD GetNICID(BYTE* NicId)
// List all Nics within Windows 95.
// it is a old function from SyGate 1.1 for Win95.
{
    HKEY		SystemKey, Subkey;
    DWORD       Status;
	FILETIME	dwDummy;
	DWORD		dwNameLength;
	DWORD		i=0;
	DWORD		j=0;
	PNIC_ID		pNic = (PNIC_ID) NicId;
	BYTE	*   pNicIdBuf = NicId + sizeof(NIC_ID);

	Status = RegOpenKeyEx(
           HKEY_LOCAL_MACHINE,
           "SYSTEM\\CurrentControlSet\\Services\\Class\\Net",
           0,
           KEY_READ,
           &SystemKey
           );

	if (Status == ERROR_SUCCESS) {
		do {
			dwNameLength = 5;
			Status = RegEnumKeyEx(SystemKey, j, (LPSTR) pNicIdBuf, &dwNameLength, 
						NULL, NULL, NULL, &dwDummy);
			if (Status != ERROR_SUCCESS)
			{
				if(Status == ERROR_MORE_DATA)//We meet an error when we read current value, skip it.
				{
					j++;
					continue;
				}
				else
					break;
			}
			//  Now we find a NIC, 000?. Is its lower binding to Ethernet?
			// The "SYSTEM\\CurrentControlSet\\Services\\Class\\Net\\000?\\Ndi\\Interfaces" 
			// DefLower should be "ethernet".
			{
				BYTE tempbuf[400];
				BYTE szLowerBind[20];

				DWORD BufferSize, RegType;

				wsprintf((char*) tempbuf, "%s%s%s", "SYSTEM\\CurrentControlSet\\Services\\Class\\Net\\",
						      pNicIdBuf, "\\Ndi\\Interfaces");
				Status = RegOpenKeyEx(
						   HKEY_LOCAL_MACHINE,
							(char*) tempbuf, 0, KEY_READ, &Subkey );
				if (Status == ERROR_SUCCESS)
				{
					BufferSize = 20;
					Status=RegQueryValueEx(Subkey, "DefLower", 
                               NULL, &RegType,
                               szLowerBind,  &BufferSize);
					if (Status != ERROR_SUCCESS)
					{
						// No "DefLower", tring "LowerRange" .
						Status = RegQueryValueEx(Subkey,"LowerRange",NULL, &RegType,szLowerBind,&BufferSize);
					}
					RegCloseKey(Subkey);
					if(Status != ERROR_SUCCESS)
					{
						//Neither "DefLower" nor "LowerRange" exist. Skip this nic.
						Status = ERROR_SUCCESS;
						j++;
						continue;
					}
					// Status = ERROR_SUCCESS, We got a Nic.
					if (( !strcmp((char*) szLowerBind, "ethernet")) 
						||(!strcmp((char*)szLowerBind, "intelonet"))// intelonet is PassPort Nic.
						|| (!strcmp((char *)szLowerBind,"usb")))// support usb networkcard
					{
						pNic->pNicId[i] = pNicIdBuf;
						pNic->bIsPPP[i] = FALSE;
						pNicIdBuf += dwNameLength + 1;
						i++;
						j++;
					}
					else if ( !strcmp((char*) szLowerBind, "vcomm"))
					{
						pNic->pNicId[i] = pNicIdBuf;
						pNic->bIsPPP[i] = TRUE;
						pNicIdBuf += dwNameLength + 1;
						i++;
						j++;
					}
					else 
					{
						j++;
						continue;
					}
				}
				else
				{
					Status = ERROR_SUCCESS;
					j++;
					// No such subkey, then skip this NIC.
					continue;
				}
			}
		} while (Status == ERROR_SUCCESS || Status == ERROR_MORE_DATA);

		pNic->dwNumberOfNic = i;

        RegCloseKey(SystemKey);

		if (Status != ERROR_NO_MORE_ITEMS) {
			return 1;
		}
	}
	else {
		return 1;
	}

	return 0;
}


static DWORD NicDescription(BYTE * pNic, BYTE*pDescription)
// get a nic's description
// it is a old function from SyGate 1.1 for Win95.
{
    HKEY		hKey;
    DWORD       dwStatus;
	BYTE		buf[200];
	DWORD		dwBufSize, RegType;

	wsprintf((char*) buf, "%s%s", 
			"SYSTEM\\CurrentControlSet\\Services\\Class\\Net\\", pNic);
	dwStatus = RegOpenKeyEx(
           HKEY_LOCAL_MACHINE,
           (char*)buf,
           0,
           KEY_READ,
           &hKey
           );
	if (dwStatus != ERROR_SUCCESS) 
		return 1;
	dwBufSize=100;
	dwStatus=RegQueryValueEx(hKey, "DriverDesc", 
                               NULL, &RegType,
                               buf,  &dwBufSize);
	RegCloseKey(hKey);
	if (dwStatus)
		return 1;
	if (dwBufSize ) {
		strcpy((char*) pDescription , (char*)buf);
		return ERROR_SUCCESS;
	}
	else {
		pDescription[0] = '\0';
		return ERROR_SUCCESS;
	}
}

//#include "wgman.h"

int GetAllNicList_95(SNic niclist[], unsigned bytesize)
// return the nic's number(>0) if successful.
// return a number less than zero if fail
// return ERR if failure
{
	BYTE		szNICID[1024], *pNicFound;
	PNIC_ID		pNic = (PNIC_ID) szNICID;
	BYTE		szDesc[100];
	DWORD		dwStatus;
	DWORD		i;
	DWORD		j;

	dwStatus = GetNICID(szNICID);
	if (dwStatus) 
		return ERR;

	memset(niclist, 0, bytesize);

	j = 0;
	for (i=0; i < pNic->dwNumberOfNic; i++) 
	{
		pNicFound = pNic->pNicId[i];

		// sprintf(tempstr, "%s, bIsPPP=%d, ", szDesc, (int)pNic->bIsPPP[i]);*/
		memset(szDesc, 0, sizeof(szDesc));
		NicDescription(pNicFound, szDesc);
		szDesc[sizeof(szDesc) - 1] = 0;

		// we have got NicName, in pNicFound
		// we have got Description, in szDesc
		// if (!pNic->bIsPPP[i])
		{
			if (j >= bytesize / sizeof(SNic)) break;
			strncpy(niclist[j].NicName, (char*)pNicFound, sizeof(niclist[j].NicName) - 1);
			strncpy(niclist[j].NicDescription, (char*)szDesc, sizeof(niclist[j].NicDescription) - 1);
			niclist[j].NicName[sizeof(niclist[j].NicName) - 1] = 0;
			niclist[j].NicDescription[sizeof(niclist[j].NicDescription) - 1] = 0;

			j++;
		}
	}
	return j;
}

int SetEtherNicList_95(SNic * pppnic,BOOL bAvailable)
//return OK if successful
//return ERR if pppnic is unavaiable or Set fail
{
	HKEY		SubKey;
	BYTE		szNICID[1024], *pNicFound;
	PNIC_ID		pNic = (PNIC_ID) szNICID;
	BYTE		sztemp[400];
	DWORD		dwStatus;
	int			iret;

	dwStatus = GetNICID(szNICID);
	if (dwStatus) 
		return ERR;
	
	iret = ERR;
	for (DWORD i=0; i < pNic->dwNumberOfNic; i++) 
	{
		pNicFound = pNic->pNicId[i];

		// we have got NicName, in pNicFound
		wsprintf((char *)sztemp,"%s%s%s","SYSTEM\\CurrentControlSet\\Services\\Class\\Net\\",
			(char *)pNicFound,"\\Ndi");
		dwStatus = RegOpenKeyEx(HKEY_LOCAL_MACHINE,(char *)sztemp,0,KEY_ALL_ACCESS,&SubKey);
		if (dwStatus != ERROR_SUCCESS)
			continue;
		if(!pNic->bIsPPP[i])
		{
			if (strcmp(pppnic->NicName,(char*)pNicFound)==0) 
			{
				if(bAvailable)
					RegDeleteValue(SubKey,"Available");
				else
				{
					DWORD	dwtemp;
					dwtemp = 0;
					dwStatus = RegSetValueEx(SubKey,"Available",0,REG_DWORD,(BYTE *)&dwtemp,sizeof(DWORD));
					if(dwStatus == ERROR_SUCCESS)
						iret = OK;
				}
			}
		}
		RegCloseKey(SubKey);
	}
	return iret;
}

int GetEtherNicList_95(SNic niclist[], unsigned bytesize)
// return the nic's number(>0) if successful.
// return a number less than zero if fail
// return ERR if failure
{
	BYTE		szNICID[1024], *pNicFound;
	PNIC_ID		pNic = (PNIC_ID) szNICID;
	BYTE		szDesc[100];
	DWORD		dwStatus;
	DWORD		i;
	DWORD		j;

	dwStatus = GetNICID(szNICID);
	if (dwStatus) 
		return ERR;

	memset(niclist, 0, bytesize);

	j = 0;
	for (i=0; i < pNic->dwNumberOfNic; i++) 
	{
		pNicFound = pNic->pNicId[i];

		// sprintf(tempstr, "%s, bIsPPP=%d, ", szDesc, (int)pNic->bIsPPP[i]);*/
		memset(szDesc, 0, sizeof(szDesc));
		NicDescription(pNicFound, szDesc);
		
		// we have got NicName, in pNicFound
		// we have got Description, in szDesc
		if (!pNic->bIsPPP[i]) 
			if (strnicmp((char*)szDesc, "AOL Adapter", strlen("AOL Adapter")) != 0 &&
				strnicmp((char*)szDesc, "AOL Dial-Up Adapter", strlen("AOL Dial-Up Adapter")) != 0)	// it is NOT AOL
			{
				if (j >= bytesize / sizeof(SNic)) break;
				strncpy(niclist[j].NicName, (char*)pNicFound, sizeof(niclist[j].NicName) - 1);
				strncpy(niclist[j].NicDescription, (char*)szDesc, sizeof(niclist[j].NicDescription) - 1);
				niclist[j].NicName[sizeof(niclist[j].NicName) - 1] = 0;
				niclist[j].NicDescription[sizeof(niclist[j].NicDescription) - 1] = 0;
				j++;
			}
	}
	return j;
}


int GetAvailEtherNicList_95(SNic niclist[],unsigned bytesize)
//return the nic's number (>0)if successful.
//reutrn a number less than zero if fail
//return ERR if failure
{
	BYTE		szNICID[1024], *pNicFound;
	PNIC_ID		pNic = (PNIC_ID) szNICID;
	BYTE		szDesc[100];
	DWORD		dwStatus;
	DWORD		i;
	DWORD		j;

	dwStatus = GetNICID(szNICID);
	if (dwStatus) 
		return ERR;

	memset(niclist, 0, bytesize);

	j = 0;
	for (i=0; i < pNic->dwNumberOfNic; i++) 
	{
		pNicFound = pNic->pNicId[i];

		// sprintf(tempstr, "%s, bIsPPP=%d, ", szDesc, (int)pNic->bIsPPP[i]);*/
		memset(szDesc, 0, sizeof(szDesc));
		NicDescription(pNicFound, szDesc);
		
		// we have got NicName, in pNicFound
		// we have got Description, in szDesc
		if (!pNic->bIsPPP[i]) 
			if (strnicmp((char*)szDesc, "AOL Adapter", strlen("AOL Adapter")) != 0 && 
				strnicmp((char*)szDesc, "AOL Dial-Up Adapter", strlen("AOL Dial-Up Adapter")) != 0)	// it is NOT AOL
			{
				char		szTemp[400];


				if(GetNicDevPath((char*)pNicFound, szTemp))
				{
					if(IsNetDevUnderDyn(szTemp) == 0)
					{
						if (j >= bytesize / sizeof(SNic)) break;
						strncpy(niclist[j].NicName, (char*)pNicFound, sizeof(niclist[j].NicName) - 1);
						strncpy(niclist[j].NicDescription, (char*)szDesc, sizeof(niclist[j].NicDescription) - 1);
						niclist[j].NicName[sizeof(niclist[j].NicName) - 1] = 0;
						niclist[j].NicDescription[sizeof(niclist[j].NicDescription) - 1] = 0;
						j++;
					}
				}
			}
	}
	return j;
}

int GetAllNicList_2000FromRegistry(SNic niclist[], unsigned bytesize)
// return value is same as win95.
{
    HKEY		SystemKey;
	HKEY		hk=NULL;
    DWORD       Status;
	FILETIME	dwDummy;
	DWORD		dwNameLength;
	DWORD		RegType;
	DWORD		j=0, k;
	char	    pBuf[256];
	char		buf2[256];
	char        buf3[256];
	HKEY		subkey=NULL;
	DWORD		outlen;
	int			err;

	char *NicRegPath="SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\NetworkCards";
	// First get the iIndex
	err = 0;

	memset(niclist, 0, bytesize);
	
	Status = RegOpenKeyEx(
           HKEY_LOCAL_MACHINE,
           NicRegPath,
           0,
           KEY_READ,
           &SystemKey
           );

	if (Status != ERROR_SUCCESS) 
		return ERR;

	k = 0; 

	do {
		dwNameLength = sizeof(pBuf);
		Status = RegEnumKeyEx(SystemKey, j, (LPSTR) pBuf, &dwNameLength, 
					NULL, NULL, NULL, &dwDummy);
		if (Status == ERROR_SUCCESS)
		{
			if (k >= bytesize/sizeof(SNic)) 
			{
				err = OK;
				break;
			}
			sprintf(buf2, "%s\\%s", NicRegPath, pBuf);
			Status = RegOpenKeyEx(
	           HKEY_LOCAL_MACHINE,
		       buf2,
			   0, KEY_READ,
	           &subkey
		       );
			if (Status == ERROR_SUCCESS)
			{
				// ok, we have got a nic
				DWORD status;
				char prodname[128];
				outlen = sizeof(prodname);
				status = RegQueryValueEx(subkey, "ServiceName", 0, &RegType,
							  (BYTE*)prodname,  &outlen);
				if (status == ERROR_SUCCESS)
				{
					// following are some nic known as non-ethernet nic.
					{
						outlen = sizeof(niclist[k].NicName);
						Status = RegQueryValueEx(subkey, "ServiceName", 0, &RegType,
								   (BYTE*)niclist[k].NicName,  &outlen);

						outlen = sizeof(niclist[k].NicDescription);
						Status = RegQueryValueEx(subkey, "Description", 0, &RegType,
								   (BYTE*)niclist[k].NicDescription,  &outlen);

						niclist[k].NicName[sizeof(niclist[k].NicName) - 1] = 0;
						niclist[k].NicDescription[sizeof(niclist[k].NicDescription) - 1] = 0;

						k++;
					}
				}

				RegCloseKey(subkey);
			}
		}
		j ++;
	} while (Status == ERROR_SUCCESS);

	RegCloseKey(SystemKey);

	if (err) return err;
	
	//the follow try to find VPN adapter
	char *VpnRegPath="SYSTEM\\CurrentControlSet\\Enum\\Root\\NET";
	char *VpnAdapPath="SYSTEM\\CurrentControlSet\\Control\\Class";
	Status = RegOpenKeyEx(
           HKEY_LOCAL_MACHINE,
           VpnRegPath,
           0,
           KEY_READ,
           &SystemKey
           );

	if (Status != ERROR_SUCCESS) 
		return k;
	j=0;
	do {
		dwNameLength = sizeof(pBuf);
		Status = RegEnumKeyEx(SystemKey, j, (LPSTR) pBuf, &dwNameLength, 
					NULL, NULL, NULL, &dwDummy);
		if (Status == ERROR_SUCCESS)
		{
			if (k >= bytesize/sizeof(SNic)) 
			{
				err = OK;
				break;
			}
			sprintf(buf2, "%s\\%s", VpnRegPath, pBuf);
			Status = RegOpenKeyEx(
	           HKEY_LOCAL_MACHINE,
		       buf2,
			   0, KEY_READ,
	           &subkey
		       );
			if (Status == ERROR_SUCCESS)
			{
				// ok, we have got a nic
				DWORD status;
				char drivername[128];
				outlen = sizeof(drivername);
				status = RegQueryValueEx(subkey, "Driver", 0, &RegType,
							  (BYTE*)drivername,  &outlen);
				if (status == ERROR_SUCCESS)
				{
					

					
					sprintf(buf3, "%s\\%s", VpnAdapPath, drivername);
					Status = RegOpenKeyEx(
						   HKEY_LOCAL_MACHINE,
						   buf3,
						   0,
						   KEY_READ,
						   &hk
						   );
					if (Status!=ERROR_SUCCESS) goto __cleanup;
					
					{
						outlen = sizeof(niclist[k].NicName);
						Status = RegQueryValueEx(hk, "NetCfgInstanceId", 0, &RegType,
								   (BYTE*)niclist[k].NicName,  &outlen);

						outlen = sizeof(niclist[k].NicDescription);
						Status = RegQueryValueEx(subkey, "FriendlyName", 0, &RegType,
								   (BYTE*)niclist[k].NicDescription,  &outlen);
						if (Status!=ERROR_SUCCESS)
						{
							Status = RegQueryValueEx(subkey, "DeviceDesc", 0, &RegType,
								   (BYTE*)niclist[k].NicDescription,  &outlen);
						}

						niclist[k].NicName[sizeof(niclist[k].NicName) - 1] = 0;
						niclist[k].NicDescription[sizeof(niclist[k].NicDescription) - 1] = 0;

						k++;
					}
					RegCloseKey(hk);
					hk=NULL;
				}

				RegCloseKey(subkey);
				subkey=NULL;
			}
		}
		j ++;
	} while (Status == ERROR_SUCCESS);

__cleanup:
	if (hk) RegCloseKey(hk);
	if (subkey) RegCloseKey(subkey);
	RegCloseKey(SystemKey);


	return k;
}

sbool GetAdapterDescByName_2000(char * nicname, char * desc)
//change adapter description with registry.
{
	if(nicname == NULL || desc == NULL)
		return false;

	SNic niclist[16];
	DWORD nicnum;
	nicnum = GetAllNicList_2000FromRegistry(niclist, sizeof(niclist));
	if (nicnum!=ERR) 
	{
		for(dword i = 0; i< nicnum; i++)
		{
			if(strcmp(nicname, niclist[i].NicName) == 0)
			{
				strcpy(desc, niclist[i].NicDescription);
				return true;
			}
		}	
	}
	sysprintln("Can't map nic description by Name " + nicname);
	return false;
}

int GetAllNicList_2000(SNic niclist[],unsigned bytesize)
// return value is same as win95.
{
	CNicIpHlpApi	iphlp;

	if(iphlp.ItExist() == false)
		return ERR;

	unsigned long	buflen;
	PIP_ADAPTER_INFO pAdapterInfo;
	DWORD	dwret;
	int		iret=0;

    buflen = 0;
	dwret = iphlp.IphlpGetAdaptersInfo(NULL, &buflen);
	if(dwret != ERROR_BUFFER_OVERFLOW)
	
		return ERR;
	pAdapterInfo = 	(PIP_ADAPTER_INFO) new char[buflen];

	if(pAdapterInfo == NULL) return ERR; 

	dwret = iphlp.IphlpGetAdaptersInfo(pAdapterInfo,&buflen);
	if(dwret == ERROR_SUCCESS)
	{
		iret = 0;
		PIP_ADAPTER_INFO	pNext;
		pNext = pAdapterInfo;
		while(pNext != NULL)
		{
			if( iret > (int)(bytesize/ sizeof(SNic)))
			{
				iret--;
				break;
			}
				

			strcpy(niclist[iret].NicName, pNext->AdapterName);
			strcpy(niclist[iret].NicDescription, pNext->Description);
			GetAdapterDescByName_2000(niclist[iret].NicName, niclist[iret].NicDescription);
			iret ++;
			pNext = pNext->Next;
		}
	}
	
	delete pAdapterInfo;

	return iret;
}

int GetAllNicList_NT(SNic niclist[], unsigned bytesize)
// return value is same as win95.
{
    HKEY		SystemKey;
    DWORD       Status;
	FILETIME	dwDummy;
	DWORD		dwNameLength;
	DWORD		RegType;
	DWORD		j=0, k;
	char	    pBuf[256];
	char		buf2[256];
	HKEY		subkey;
	DWORD		outlen;
	int			err;

	char *NicRegPath="SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\NetworkCards";
	// First get the iIndex
	err = 0;

	memset(niclist, 0, bytesize);
	
	Status = RegOpenKeyEx(
           HKEY_LOCAL_MACHINE,
           NicRegPath,
           0,
           KEY_READ,
           &SystemKey
           );

	if (Status != ERROR_SUCCESS) 
		return ERR;

	k = 0; 
	do {
		dwNameLength = sizeof(pBuf);
		Status = RegEnumKeyEx(SystemKey, j, (LPSTR) pBuf, &dwNameLength, 
					NULL, NULL, NULL, &dwDummy);
		if (Status == ERROR_SUCCESS)
		{
			if (k >= bytesize/sizeof(SNic)) 
			{
				err = OK;
				break;
			}
			sprintf(buf2, "%s\\%s", NicRegPath, pBuf);
			Status = RegOpenKeyEx(
	           HKEY_LOCAL_MACHINE,
		       buf2,
			   0, KEY_READ,
	           &subkey
		       );
			if (Status == ERROR_SUCCESS)
			{
				// ok, we have got a nic
				DWORD status;
				char prodname[128];
				outlen = sizeof(prodname);
				status = RegQueryValueEx(subkey, "ProductName", 0, &RegType,
							  (BYTE*)prodname,  &outlen);
				if (status == ERROR_SUCCESS)
				{
					// following are some nic known as non-ethernet nic.
					{
						outlen = sizeof(niclist[k].NicName);
						Status = RegQueryValueEx(subkey, "ServiceName", 0, &RegType,
								   (BYTE*)niclist[k].NicName,  &outlen);

						outlen = sizeof(niclist[k].NicDescription);
						Status = RegQueryValueEx(subkey, "Description", 0, &RegType,
								   (BYTE*)niclist[k].NicDescription,  &outlen);

						niclist[k].NicName[sizeof(niclist[k].NicName) - 1] = 0;
						niclist[k].NicDescription[sizeof(niclist[k].NicDescription) - 1] = 0;

						k++;
					}
				}

				RegCloseKey(subkey);
			}
		}
		j ++;
	} while (Status == ERROR_SUCCESS);

	RegCloseKey(SystemKey);

	if (err) return err;
	return k;
}
	
int GetEtherNicList_2000(SNic niclist[], unsigned bytesize)
// return value is same as win95
{
	CNicIpHlpApi	iphlp;

	if(iphlp.ItExist() == false)
		return ERR;

	unsigned long	buflen;
	PIP_ADAPTER_INFO pAdapterInfo;
	DWORD	dwret;
	int		iret;

    buflen = 0;
	dwret = iphlp.IphlpGetAdaptersInfo(NULL, &buflen);
	if(dwret != ERROR_BUFFER_OVERFLOW)
	
		return ERR;
	pAdapterInfo = 	(PIP_ADAPTER_INFO) new char[buflen];

	if(pAdapterInfo == NULL) return ERR; 

	dwret = iphlp.IphlpGetAdaptersInfo(pAdapterInfo,&buflen);
	if(dwret == ERROR_SUCCESS)
	{
		iret = 0;
		PIP_ADAPTER_INFO	pNext;
		pNext = pAdapterInfo;
		while(pNext != NULL && pNext->Type)
		{
			if( iret > (int)(bytesize/ sizeof(SNic)))
				break;
			if(pNext->Type == MIB_IF_TYPE_ETHERNET)
			{
				strcpy(niclist[iret].NicName, pNext->AdapterName);
				strcpy(niclist[iret].NicDescription, pNext->Description);
				GetAdapterDescByName_2000(niclist[iret].NicName, niclist[iret].NicDescription);
				iret ++;
			}
			pNext = pNext->Next;
		}
	}
	
	delete pAdapterInfo;

	return iret;
}

int GetEtherNicList_NT(SNic niclist[], unsigned bytesize)
// return value is same as win95.
{
    HKEY		SystemKey;
    DWORD       Status;
	FILETIME	dwDummy;
	DWORD		dwNameLength;
	DWORD		RegType;
	DWORD		j=0, k;
	char	    pBuf[256];
	char		buf2[256];
	HKEY		subkey;
	DWORD		outlen;
	int			err;

	char *NicRegPath="SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\NetworkCards";
	// First get the iIndex
	err = 0;

	memset(niclist, 0, bytesize);
	
	Status = RegOpenKeyEx(
           HKEY_LOCAL_MACHINE,
           NicRegPath,
           0,
           KEY_READ,
           &SystemKey
           );

	if (Status != ERROR_SUCCESS) 
		return ERR;

	k = 0; 
	do {
		dwNameLength = sizeof(pBuf);
		Status = RegEnumKeyEx(SystemKey, j, (LPSTR) pBuf, &dwNameLength, 
					NULL, NULL, NULL, &dwDummy);
		if (Status == ERROR_SUCCESS)
		{
			if (k >= bytesize/sizeof(SNic)) 
			{
				err = OK;
				break;
			}
			sprintf(buf2, "%s\\%s", NicRegPath, pBuf);
			Status = RegOpenKeyEx(
	           HKEY_LOCAL_MACHINE,
		       buf2,
			   0, KEY_READ,
	           &subkey
		       );
			if (Status == ERROR_SUCCESS)
			{
				// ok, we have got a nic
				DWORD status;
				char prodname[128];
				outlen = sizeof(prodname);
				status = RegQueryValueEx(subkey, "ProductName", 0, &RegType,
							  (BYTE*)prodname,  &outlen);
				if (status == ERROR_SUCCESS)
				{
					// following are some nic known as non-ethernet nic.
					char a[]="NdisWan";		// block NdisWanxxx
					char b[]="AsyncMac";	// block AsyncMacxx
					char c[]="RASPPTP";		// block RASPPTPxxx
					if (strnicmp(prodname, a, strlen(a)) !=0 &&
						strnicmp(prodname, b, strlen(b)) !=0 &&
						strnicmp(prodname, c, strlen(c)) !=0 )
					{
						outlen = sizeof(niclist[k].NicName);
						Status = RegQueryValueEx(subkey, "ServiceName", 0, &RegType,
								   (BYTE*)niclist[k].NicName,  &outlen);

						outlen = sizeof(niclist[k].NicDescription);
						Status = RegQueryValueEx(subkey, "Description", 0, &RegType,
								   (BYTE*)niclist[k].NicDescription,  &outlen);
						k++;
					}
				}

				RegCloseKey(subkey);
			}
		}
		j ++;
	} while (Status == ERROR_SUCCESS);

	RegCloseKey(SystemKey);

	if (err) return err;
	return k;
}

int GetAvailEtherNicList_NT(SNic niclist[],unsigned bytesize)
//return the nic's number (>0)if successful.
//reutrn a number less than zero if fail
//return ERR if failure
{
	int iret;
	iret = GetEtherNicList_NT(niclist,bytesize);
	if(iret > 0)
	{
		//Below is based on NetBios over TCP/IP perperty.
		//It should be improved in future.
		int index = 0;
		for (int i = 0; i< iret ; i++)
		{
			char	subkey[256];
			sprintf(subkey, "SYSTEM\\CurrentControlSet\\Services\\NetBT\\Adapters\\%s", niclist[index].NicName);
			if(IsSubKeyExist(HKEY_LOCAL_MACHINE,subkey) != OK)
			{
				for(int j = index; j< iret-(i-index)-1; j++)
				{
					strcpy(niclist[j].NicDescription, niclist[j+1].NicDescription);
					strcpy(niclist[j].NicName, niclist[j+1].NicName);
				}
			}
			else
			{
				//For NetBios over TCP/IP, even it was disabled, It still can be a vailable NIC.
				//Comment below codes, wait for future improvement.
//				char	disablebind[512];
//				DWORD	outlen;
//				if(ReadBinaryFromRegistry(HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\Services\\NetBT\\Linkage\\Disabled", "Bind", disablebind, sizeof(disablebind), &outlen) == OK)
//				{
//					char * pstr;
//					pstr = disablebind;
//					while(strlen(pstr)!= 0)
//					{
//						if(strstr(pstr, niclist[index].NicName))
//						{
//							for(int j = index; j< iret-(i-index)-1; j++)
//							{
//								strcpy(niclist[j].NicDescription, niclist[j+1].NicDescription);
//								strcpy(niclist[j].NicName, niclist[j+1].NicName);
//							}
//							break;
//						}
//						pstr += strlen(pstr) + 1;
//					}
//					if(strlen(pstr) == 0)
//						index ++;
//				}
//				else
				index++;
			}
		}

		iret = index;
	}

	return iret;
}

int GetAllNicList(SNic niclist[], unsigned bytesize)
// return the nic's number(>0) if successful.
// return a number less than zero if fail
// return ERR if failure
{
	if (IsWinNT2000())
		return GetAllNicList_2000(niclist,bytesize);
	else if (IsWinNT())
		return GetAllNicList_NT(niclist, bytesize);
	else
		return GetAllNicList_95(niclist, bytesize);
}

int ChangeNicFriendlyDesc(SNic* nic)
//Only for PCI device at win2000
{
    HKEY		SystemKey;
    DWORD       Status;
	FILETIME	dwDummy1;
	FILETIME	dwDummy2;
	DWORD		dwNameLength;
	DWORD		RegType;
	DWORD		j=0, k;
	char	    pBuf[256];
	char		buf2[256];
	char		buf3[256];
	HKEY		subkey1;
	HKEY		subkey2;
	DWORD		outlen;
	int			found;
	char		strtemp[256];

	char *NicRegPath="System\\CurrentControlSet\\Enum\\PCI";
	// First get the iIndex

	found = 0;
	Status = RegOpenKeyEx(HKEY_LOCAL_MACHINE, NicRegPath, 0, KEY_READ, &SystemKey);

	if (Status != ERROR_SUCCESS) 
		return ERR;

	do {
		dwNameLength = sizeof(pBuf);
		Status = RegEnumKeyEx(SystemKey, j, (LPSTR) pBuf, &dwNameLength, 
					NULL, NULL, NULL, &dwDummy1);
		if (Status == ERROR_SUCCESS)
		{
			sprintf(buf2, "%s\\%s", NicRegPath, pBuf);
			Status = RegOpenKeyEx(HKEY_LOCAL_MACHINE, buf2,0, KEY_READ,&subkey1);
			k = 0;
			if(Status == ERROR_SUCCESS)
			{
				while (Status == ERROR_SUCCESS)
				{
					dwNameLength = sizeof(pBuf);
					Status = RegEnumKeyEx(subkey1, k, (LPSTR)pBuf, &dwNameLength, NULL, NULL, NULL, &dwDummy2);
					if(Status == ERROR_SUCCESS)
					{
						sprintf(buf3, "%s\\%s", buf2, pBuf);
						Status = RegOpenKeyEx(HKEY_LOCAL_MACHINE, buf3, 0, KEY_READ, &subkey2);
						if(Status == ERROR_SUCCESS)
						{
							outlen = sizeof(strtemp);
							Status = RegQueryValueEx(subkey2, "Class", 0, &RegType,
									   (BYTE*)strtemp,  &outlen);
							if(Status == ERROR_SUCCESS && strcmp(strtemp, "Net") == 0)
							{
								dwNameLength = sizeof(strtemp);
								if(ReadStringFromRegistry(HKEY_LOCAL_MACHINE, buf3, "Driver", strtemp, dwNameLength, &outlen) == OK)
								{
									sprintf(buf3, "%s\\%s", "SYSTEM\\CurrentControlSet\\Control\\Class", strtemp);
									if(ReadStringFromRegistry(HKEY_LOCAL_MACHINE, buf3, "NetCfgInstanceId", strtemp, dwNameLength, &outlen) == OK)
									{
										if(strcmp(strtemp, nic->NicName) == 0)
										{
											found = 1;
											outlen = sizeof(strtemp);
											Status = RegQueryValueEx(subkey2, "FriendlyName", 0, &RegType,
													   (BYTE*)strtemp,  &outlen);
											if(Status == ERROR_SUCCESS)
											{
												strcpy(nic->NicDescription, strtemp);
											}
										}
									}
								}
							}
							RegCloseKey(subkey2);
						}
						Status = ERROR_SUCCESS;//keep loop;
					}
					if(found)
						break;
					k++;
				}
				RegCloseKey(subkey1);
			}
			if(found)
				break;
			Status = ERROR_SUCCESS;//keep loop 
		}
		j++;
	}while(Status == ERROR_SUCCESS);
	RegCloseKey(SystemKey);

	if(found)
		return OK;
	else
		return ERR;
}


int GetEtherNicListWithFriendlyDesc(SNic niclist[], unsigned bytesize)
{
	if(IsWinNT2000())
	{
		int nicnum;
		nicnum = GetEtherNicList_2000(niclist, bytesize);
		if (nicnum==ERR) return nicnum;
		for(int i = 0 ; i< nicnum; i++)
		{
			ChangeNicFriendlyDesc(&(niclist[i]));
		}
		return nicnum;
	}
	else if(IsWinNT())
		return GetEtherNicList_NT(niclist, bytesize);
	else
		return GetEtherNicList_95(niclist, bytesize);
}

int GetEtherNicList(SNic niclist[], unsigned bytesize)
// return the nic's number(>0) if successful.
// return a number less than zero if fail
// return ERR if failure
{
	if (IsWinNT2000())
		return GetEtherNicList_2000(niclist, bytesize);
	else if (IsWinNT()) 
		return GetEtherNicList_NT(niclist, bytesize);
	else
		return GetEtherNicList_95(niclist, bytesize);
}

int SetEtherNicList(SNic *pppnic,BOOL bAvailable)
//return OK if successful
//return ERR if pppnic is unavaiable or Set fail
{
	if(IsWinNT2000())//Don't support this function at Win2K.
		return ERR;
	else if(IsWinNT())// Don't support Window NT now
		return ERR;
	else
		return SetEtherNicList_95(pppnic,bAvailable);
}

int GetAvailEtherNicList(SNic niclist[],unsigned bytesize)
//return the nic's number (>0)if successful.
//reutrn a number less than zero if fail
//return ERR if failure
{
	if(IsWinNT2000())
		return GetEtherNicList_2000(niclist,bytesize);
	else if(IsWinNT())
		return GetAvailEtherNicList_NT(niclist,bytesize);
	else
		return GetAvailEtherNicList_95(niclist,bytesize);
}

int GetCurrentDialupAdapter_95(SNic *pppnic)
// return OK if successful
// return ERR if dialup networking doesn't be installed.
{
	HKEY		SubKey;
	BYTE		szNICID[1024], *pNicFound;
	PNIC_ID		pNic = (PNIC_ID) szNICID;
	BYTE		szDesc[100];
	BYTE		szTemp[400];
	DWORD		dwStatus;
	DWORD		i;

	dwStatus = GetNICID(szNICID);
	if (dwStatus) 
		return ERR;

	memset(pppnic, 0, sizeof(*pppnic));

	int pos = -1;
//	long nicn = 0x7FFFFFFFL;

	for (i = 0; i < pNic->dwNumberOfNic; i++) 
	{
		pNicFound = pNic->pNicId[i];

		// sprintf(tempstr, "%s, bIsPPP=%d, ", szDesc, (int)pNic->bIsPPP[i]);*/
		memset(szDesc, 0, sizeof(szDesc));
		NicDescription(pNicFound, szDesc);
		
		// we have got NicName, in pNicFound
		// we have got Description, in szDesc
		wsprintf((char *)szTemp,"%s%s%s","SYSTEM\\CurrentControlSet\\Services\\Class\\Net\\",
			(char *)pNicFound,"\\Ndi");
		dwStatus = RegOpenKeyEx(HKEY_LOCAL_MACHINE,(char *)szTemp,0,KEY_ALL_ACCESS,&SubKey);
		if (dwStatus != ERROR_SUCCESS)
			continue;
		if(pNic->bIsPPP[i])
		{
			DWORD dwtemp,dwoutlen;
			DWORD dwtype;
			dwtype = REG_DWORD;
			dwoutlen = sizeof(DWORD);
			dwStatus = RegQueryValueEx(SubKey,"DefPPP",0,&dwtype,(BYTE *)&dwtemp,&dwoutlen);
			if(dwStatus == ERROR_SUCCESS && dwtemp == 1)
			{
				pos = i;
			}
//			else
//				sdbg<<"FailRead:"<<dwStatus<<","<<dwtemp<<","<<szTemp<<endl;
		}
		RegCloseKey(SubKey);
		if(pos >= 0)
			break;
	}
    if (pos == -1)//Patch for build 516
    {
		for (i = 0; i < pNic->dwNumberOfNic; i++) 
		{
			pNicFound = pNic->pNicId[i];

			// sprintf(tempstr, "%s, bIsPPP=%d, ", szDesc, (int)pNic->bIsPPP[i]);*/
			memset(szDesc, 0, sizeof(szDesc));
			NicDescription(pNicFound, szDesc);
			
			// we have got NicName, in pNicFound
			// we have got Description, in szDesc
			wsprintf((char *)szTemp,"%s%s%s","SYSTEM\\CurrentControlSet\\Services\\Class\\Net\\",
				(char *)pNicFound,"\\Ndi\\Params");
			dwStatus = RegOpenKeyEx(HKEY_LOCAL_MACHINE,(char *)szTemp,0,KEY_ALL_ACCESS,&SubKey);
			if (dwStatus != ERROR_SUCCESS)
				continue;
			if(pNic->bIsPPP[i])
			{
				DWORD dwtemp,dwoutlen;
				DWORD dwtype;
				dwtype = REG_DWORD;
				dwoutlen = sizeof(DWORD);
				dwStatus = RegQueryValueEx(SubKey,"DefPPP",0,&dwtype,(BYTE *)&dwtemp,&dwoutlen);
				if(dwStatus == ERROR_SUCCESS && dwtemp == 1)
				{
					pos = i;
					RegDeleteKey(SubKey,"DefPPP");
				}
	//			else
	//				sdbg<<"FailRead:"<<dwStatus<<","<<dwtemp<<","<<szTemp<<endl;
			}
			RegCloseKey(SubKey);
			if(pos >= 0)
			{
				wsprintf((char *)szTemp,"%s%s%s","SYSTEM\\CurrentControlSet\\Services\\Class\\Net\\",
					(char *)pNicFound,"\\Ndi");
				RegOpenKeyEx(HKEY_LOCAL_MACHINE,(char *)szTemp,0,KEY_ALL_ACCESS,&SubKey);
				DWORD	dwtemp;
				dwtemp = 1;
				RegSetValueEx(SubKey,"DefPPP",0,REG_DWORD,(BYTE *)&dwtemp,sizeof(DWORD));
				RegCloseKey(SubKey);
				break;
			}
		}
    }

	if(pos == -1)//Patch for build before 516 which hasn't used SyDiag.
	{
		for (i = 0; i < pNic->dwNumberOfNic; i++) 
		{
			pNicFound = pNic->pNicId[i];

			// sprintf(tempstr, "%s, bIsPPP=%d, ", szDesc, (int)pNic->bIsPPP[i]);*/
			memset(szDesc, 0, sizeof(szDesc));
			NicDescription(pNicFound, szDesc);
			
			// we have got NicName, in pNicFound
			// we have got Description, in szDesc
			wsprintf((char *)szTemp,"%s%s%s","SYSTEM\\CurrentControlSet\\Services\\Class\\Net\\",
				(char *)pNicFound,"\\Ndi\\Params");
			dwStatus = RegOpenKeyEx(HKEY_LOCAL_MACHINE,(char *)szTemp,0,KEY_ALL_ACCESS,&SubKey);
			if (dwStatus != ERROR_SUCCESS)
				continue;
			if(pNic->bIsPPP[i])
			{
				pos = i; // Use first PPP as default Dialup network
			}
			RegCloseKey(SubKey);
			if(pos >= 0)
				break;
		}
	}
    
	if (pos >= 0)
	{
		pNicFound = pNic->pNicId[pos];
		strncpy(pppnic->NicName, (char*)pNicFound, sizeof(pppnic->NicName) - 1);
		strncpy(pppnic->NicDescription, (char*)szDesc, sizeof(pppnic->NicDescription) - 1);
		return OK;
	}

	return ERR;
}

int GetAllDialupList_2000(SNic niclist[], unsigned bytesize)
// return value is same as win95
// only return the online dialup adapter
{
	CNicIpHlpApi	iphlp;

	if(iphlp.ItExist() == false)
		return ERR;

	//Check wheather there are Dialup network
    HKEY		SystemKey;
    DWORD       Status;
	char	    NicRegPath[256];

	strcpy(NicRegPath,"SYSTEM\\CurrentControlSet\\Services\\Tcpip\\Parameters\\Adapters\\NdisWanIp");
	// First get the iIndex
	memset(niclist, 0, bytesize);
	
	Status = RegOpenKeyEx(
           HKEY_LOCAL_MACHINE,
           NicRegPath,
           0,
           KEY_READ,
           &SystemKey
           );

	if (Status != ERROR_SUCCESS) 
		return 0;
	RegCloseKey(SystemKey);
	
	unsigned long	buflen;
	PIP_ADAPTER_INFO pAdapterInfo;
	DWORD	dwret;
	int		iret;

    buflen = 0;
	dwret = iphlp.IphlpGetAdaptersInfo(NULL, &buflen);
	if(dwret != ERROR_BUFFER_OVERFLOW)
	
		return ERR;
	pAdapterInfo = 	(PIP_ADAPTER_INFO) new char[buflen];

	if(pAdapterInfo == NULL) return ERR; 

	dwret = iphlp.IphlpGetAdaptersInfo(pAdapterInfo,&buflen);
	if(dwret == ERROR_SUCCESS)
	{
		iret = 0;
		PIP_ADAPTER_INFO	pNext;
		pNext = pAdapterInfo;
		while(pNext != NULL && pNext->Type)
		{
			if( iret >= (int)(bytesize/ sizeof(SNic)))
				break;
			if(pNext->Type == MIB_IF_TYPE_PPP)
			{
				strcpy(niclist[iret].NicName, pNext->AdapterName);
				strcpy(niclist[iret].NicDescription, pNext->Description);
				iret ++;
			}
			pNext = pNext->Next;
		}
	}
	
	delete pAdapterInfo;
	///////Temporary
	if(iret == 0)
	{
		strcpy(niclist[iret].NicName,"NdisWanIp");
		strcpy(niclist[iret].NicDescription,"WAN (PPP/SLIP) Interface");
		iret = 1;
	}

	return iret;
}

int GetCurrentDialupAdapter_2000(SNic *pppnic)
// return OK if there is a dialup network online.
// return ERR if no dialup network online.
{
	int iret;
	iret = GetAllDialupList_2000(pppnic,sizeof(SNic));
	if(iret == 0)
		return ERR;
	else
		return OK;
}

int GetCurrentDialupAdapter_NT(SNic *pppnic)
// return OK if successful
// return ERR if dialup networking doesn't be installed.
{
    HKEY		SystemKey;
    DWORD       Status;
	FILETIME	dwDummy;
	DWORD		dwNameLength;
	DWORD		RegType;
	DWORD		j=0xFFFFFFFFL;
	char	    pBuf[256];
	char		buf2[256];
	HKEY		subkey;
	DWORD		outlen;
	bool		igotit;

	char *NicRegPath="SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\NetworkCards";
	// First get the iIndex

	memset(pppnic, 0, sizeof(*pppnic));
	
	Status = RegOpenKeyEx(
           HKEY_LOCAL_MACHINE,
           NicRegPath,
           0,
           KEY_READ,
           &SystemKey
           );

	if (Status != ERROR_SUCCESS) 
		return ERR;

	igotit = false;
	do {
		dwNameLength = sizeof(pBuf);
		Status = RegEnumKeyEx(SystemKey, ++j, (LPSTR) pBuf, &dwNameLength, 
					NULL, NULL, NULL, &dwDummy);
		if (Status != ERROR_SUCCESS) break;

		sprintf(buf2, "%s\\%s", NicRegPath, pBuf);
		Status = RegOpenKeyEx(
           HKEY_LOCAL_MACHINE,
	       buf2,
		   0, KEY_READ,
           &subkey
	       );
		if (Status == ERROR_SUCCESS)
		{
			// ok, we have got a nic
			DWORD status;
			char prodname[128];
			outlen = sizeof(prodname);
			status = RegQueryValueEx(subkey, "ProductName", 0, &RegType,
                          (BYTE*)prodname,  &outlen);
			if (status == ERROR_SUCCESS)
			{
				char a[]="NdisWanDialoutIp";
				if (strnicmp(prodname, a, strlen(a)) == 0)
				{
					// we got it.
					outlen = sizeof(pppnic->NicName);
					Status = RegQueryValueEx(subkey, "ServiceName", 0, &RegType,
                          (BYTE*)pppnic->NicName,  &outlen);
						outlen = sizeof(pppnic->NicDescription);
					Status = RegQueryValueEx(subkey, "Description", 0, &RegType,
							   (BYTE*)pppnic->NicDescription,  &outlen);

					igotit = true;
				}
			}

			RegCloseKey(subkey);
		}

	} while (!igotit);

	RegCloseKey(SystemKey);
	
	if (igotit) return OK;
	return ERR;
}

int GetAllDialupList_NT(SNic niclist[],unsigned bytesize)
{
	//return current dial up adapter.
    HKEY		SystemKey;
    DWORD       Status;
	FILETIME	dwDummy;
	DWORD		dwNameLength;
	DWORD		RegType;
	DWORD		j=0xFFFFFFFFL;
	char	    pBuf[256];
	char		buf2[256];
	HKEY		subkey;
	DWORD		outlen;
	int			NicNum;

	char *NicRegPath="SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\NetworkCards";
	// First get the iIndex

	memset(niclist, 0, bytesize);
	
	Status = RegOpenKeyEx(
           HKEY_LOCAL_MACHINE,
           NicRegPath,
           0,
           KEY_READ,
           &SystemKey
           );

	if (Status != ERROR_SUCCESS) 
		return ERR;

	NicNum = 0;
	do {
		dwNameLength = sizeof(pBuf);
		Status = RegEnumKeyEx(SystemKey, ++j, (LPSTR) pBuf, &dwNameLength, 
					NULL, NULL, NULL, &dwDummy);
		if (Status != ERROR_SUCCESS) break;

		sprintf(buf2, "%s\\%s", NicRegPath, pBuf);
		Status = RegOpenKeyEx(
           HKEY_LOCAL_MACHINE,
	       buf2,
		   0, KEY_READ,
           &subkey
	       );
		if (Status == ERROR_SUCCESS)
		{
			// ok, we have got a nic
			DWORD status;
			char prodname[128];
			outlen = sizeof(prodname);
			status = RegQueryValueEx(subkey, "ProductName", 0, &RegType,
                          (BYTE*)prodname,  &outlen);
			if (status == ERROR_SUCCESS)
			{
				char a[]="NdisWanDialoutIp";
				if (strnicmp(prodname, a, strlen(a)) == 0)
				{
					// we got it.
					outlen = sizeof(niclist[NicNum].NicName);
					Status = RegQueryValueEx(subkey, "ServiceName", 0, &RegType,
                          (BYTE*)niclist[NicNum].NicName,  &outlen);
						outlen = sizeof(niclist[NicNum].NicDescription);
					Status = RegQueryValueEx(subkey, "Description", 0, &RegType,
							   (BYTE*)niclist[NicNum].NicDescription,  &outlen);
					NicNum ++;

				}
			}

			RegCloseKey(subkey);
		}

	} while (NicNum < int(bytesize/sizeof(SNic)));

	RegCloseKey(SystemKey);
	
	return NicNum;
}


int GetAllDialupList_95(SNic niclist[],unsigned bytesize)
{
	BYTE		szNICID[1024], *pNicFound;
	PNIC_ID		pNic = (PNIC_ID) szNICID;
	BYTE		szDesc[100];
	DWORD		dwStatus;
	DWORD		i;
	DWORD		j;

	dwStatus = GetNICID(szNICID);
	if (dwStatus) 
		return ERR;

	memset(niclist, 0, bytesize);

	j = 0;
	for (i=0; i < pNic->dwNumberOfNic; i++) 
	{
		pNicFound = pNic->pNicId[i];

		// sprintf(tempstr, "%s, bIsPPP=%d, ", szDesc, (int)pNic->bIsPPP[i]);*/
		memset(szDesc, 0, sizeof(szDesc));
		NicDescription(pNicFound, szDesc);
		
		// we have got NicName, in pNicFound
		// we have got Description, in szDesc
		if (pNic->bIsPPP[i]) 
		{
			if (j >= bytesize / sizeof(SNic)) break;
			strncpy(niclist[j].NicName, (char*)pNicFound, sizeof(niclist[j].NicName) - 1);
			strncpy(niclist[j].NicDescription, (char*)szDesc, sizeof(niclist[j].NicDescription) - 1);
			niclist[j].NicName[sizeof(niclist[j].NicName)] = 0;
			niclist[j].NicDescription[sizeof(niclist[j].NicDescription)] = 0;
			j++;
		}
	}
	return j;
}

int GetAllDialupAdapter(SNic niclist[],unsigned bytesize)
// return the nic's number(>0) if successful.
// return a number less than zero if fail
// return ERR if failure
{
	if (IsWinNT2000())
		return GetAllDialupList_2000(niclist,bytesize);
	if (IsWinNT())
		return GetAllDialupList_NT(niclist, bytesize); 
	else
		return GetAllDialupList_95(niclist, bytesize);
}

int SetCurrentDialupAdapter_95(SNic *pppnic)
{
	HKEY		SubKey;
	BYTE		szNICID[1024], *pNicFound;
	PNIC_ID		pNic = (PNIC_ID) szNICID;
	BYTE		sztemp[400];
	DWORD		dwStatus;
	int			iret;

	dwStatus = GetNICID(szNICID);
	if (dwStatus) 
		return ERR;
	
	iret = ERR;
	for (DWORD i=0; i < pNic->dwNumberOfNic; i++) 
	{
		pNicFound = pNic->pNicId[i];

		// we have got NicName, in pNicFound
		wsprintf((char *)sztemp,"%s%s%s","SYSTEM\\CurrentControlSet\\Services\\Class\\Net\\",
			(char *)pNicFound,"\\Ndi");
		dwStatus = RegOpenKeyEx(HKEY_LOCAL_MACHINE,(char *)sztemp,0,KEY_ALL_ACCESS,&SubKey);
		if (dwStatus != ERROR_SUCCESS)
			continue;
		if(pNic->bIsPPP[i])
		{
			if (strcmp(pppnic->NicName,(char*)pNicFound)==0) 
			{
				DWORD	dwtemp;
				dwtemp = 1;
				dwStatus = RegSetValueEx(SubKey,"DefPPP",0,REG_DWORD,(BYTE *)&dwtemp,sizeof(DWORD));
				if(dwStatus == ERROR_SUCCESS)
					iret = OK;
			}
			else
				RegDeleteValue(SubKey,"DefPPP");
		}
		RegCloseKey(SubKey);
	}
	return iret;
}

int SetCurrentDialupAdapter(SNic *pppnic)
//return OK if successful
// return ERR if pppnic is not available.
{
	if(IsWinNT2000())//doesn't support Win2K
		return ERR;
	if(IsWinNT()) // doesn't support WindowsNT
		return ERR;
	else
		return SetCurrentDialupAdapter_95(pppnic);
}

int GetCurrentDialupAdapter(SNic *pppnic)
// return OK if successful
// return ERR if dialup networking doesn't be installed.
{
	if (IsWinNT2000())
		return GetCurrentDialupAdapter_2000(pppnic);
	if (IsWinNT()) 
		return GetCurrentDialupAdapter_NT(pppnic);
	else
		return GetCurrentDialupAdapter_95(pppnic);
}


int GetCurrentAolAdapter_95(SNic *pppnic)
// get Amercia On-Line (AOL) adapter.
// return OK if successful
// return ERR if AOL doesn't be installed.
{
	BYTE		szNICID[1024], *pNicFound;
	PNIC_ID		pNic = (PNIC_ID) szNICID;
	BYTE		szDesc[100];
	DWORD		dwStatus;
	DWORD		i;

	dwStatus = GetNICID(szNICID);
	if (dwStatus) 
		return ERR;

	memset(pppnic, 0, sizeof(*pppnic));

	for (i=0; i < pNic->dwNumberOfNic; i++) 
	{
		pNicFound = pNic->pNicId[i];

		// sprintf(tempstr, "%s, bIsPPP=%d, ", szDesc, (int)pNic->bIsPPP[i]);
		memset(szDesc, 0, sizeof(szDesc));
		NicDescription(pNicFound, szDesc);
		
		// we have got NicName, in pNicFound
		// we have got Description, in szDesc
		if (!pNic->bIsPPP[i])
		{
			if (strnicmp((char*)szDesc, "AOL Adapter", strlen("AOL Adapter")) == 0)
			{
				strncpy(pppnic->NicName, (char*)pNicFound, sizeof(pppnic->NicName) - 1);
				strncpy(pppnic->NicDescription, (char*)szDesc, sizeof(pppnic->NicDescription) - 1);
				return OK;
			}
		}
	}
	return ERR;
}

int GetCurrentAolAdapter(SNic *pppnic)
// return OK if successful
// return ERR if AOL doesn't be installed.
{
	if (IsWinNT2000())// doesn't support Win2K
		return ERR;
	if (IsWinNT()) // doesn't support Windows NT.
		return ERR;
	else
		return GetCurrentAolAdapter_95(pppnic);
}

int ChangeNicNametoAdapterName(char * NicName, char * AdapterName, unsigned bytesize)
// This function only used for Win2K
// return OK if successful
// return ERR if fail.
{
	if(!IsWinNT2000())
	{
		if(strlen(NicName)+1 > bytesize)
			return ERR;
		strcpy(AdapterName,NicName);
		return OK;
	}
	

    HKEY		SystemKey, Subkey;
    DWORD       Status;
	FILETIME	dwDummy;
	DWORD		RegType;
	DWORD		dwNameLength;
	DWORD		outlen;
	DWORD		j=0;
	char		pBuf[256];
	char		pBuf2[512];
	char		NicRegPath[512];

	strcpy(NicRegPath, "SYSTEM\\CurrentControlSet\\Control\\Network");
	Status = RegOpenKeyEx(
           HKEY_LOCAL_MACHINE,
           NicRegPath,
           0,
           KEY_READ,
           &SystemKey
           );
	strcpy(pBuf2,NicRegPath);
	do{
		dwNameLength = sizeof(pBuf);
		Status = RegEnumKeyEx(SystemKey, j++, (LPSTR) pBuf, &dwNameLength, 
					NULL, NULL, NULL, &dwDummy);
		if (Status == ERROR_SUCCESS)
		{
			sprintf(pBuf2, "%s\\%s", NicRegPath, pBuf);
			Status = RegOpenKeyEx(
			   HKEY_LOCAL_MACHINE,
			   pBuf2,
			   0, KEY_READ,
			   &Subkey
		       );
			if (Status == ERROR_SUCCESS)
			{
				// ok, we have got a class
				char Classname[128];

				outlen = sizeof(Classname);
				RegType = REG_SZ;
				Status = RegQueryValueEx(Subkey, "Class", 0, &RegType,
							  (BYTE*)Classname,  &outlen);
				RegCloseKey(Subkey);
				if (Status == ERROR_SUCCESS)
				{
					if(strcmp(Classname,"Net")== 0)
						break;
				}
			}
			Status = ERROR_SUCCESS;// Search next key
		}
	}while(Status == ERROR_SUCCESS);

	RegCloseKey(SystemKey);

	if(Status == ERROR_SUCCESS)
	{
		sprintf(NicRegPath,"%s\\%s\\%s",pBuf2,NicName,"Connection");
		Status = RegOpenKeyEx(
			   HKEY_LOCAL_MACHINE,
			   NicRegPath,
			   0,
			   KEY_READ,
			   &SystemKey
			   );
		if(Status == ERROR_SUCCESS)
		{
			outlen = bytesize;
			RegType = REG_SZ;
			Status = RegQueryValueEx(SystemKey, "Name", 0, &RegType,
						  (BYTE*)AdapterName,  &outlen);

		}
		RegCloseKey(SystemKey);
	}

	if(Status == ERROR_SUCCESS)
		return OK;
	else
		return ERR;
}

int ChangeAdapterNametoNicName(char * AdapterName, char * NicName, unsigned bytesize)
{

	if(!IsWinNT2000())
	{
		if(strlen(AdapterName)+1 > bytesize)
			return ERR;
		strcpy(NicName,AdapterName);
		return OK;
	}

	

    HKEY		SystemKey, Subkey;
    DWORD       Status;
	FILETIME	dwDummy;
	DWORD		RegType;
	DWORD		dwNameLength;
	DWORD		outlen;
	DWORD		j=0;
	char		pBuf[256];
	char		pBuf2[512];
	char		NicRegPath[512];
	strcpy(NicRegPath, "SYSTEM\\CurrentControlSet\\Control\\Network");
	Status = RegOpenKeyEx(
           HKEY_LOCAL_MACHINE,
           NicRegPath,
           0,
           KEY_READ,
           &SystemKey
           );
	do{
		dwNameLength = sizeof(pBuf);
		Status = RegEnumKeyEx(SystemKey, j++, (LPSTR) pBuf, &dwNameLength, 
					NULL, NULL, NULL, &dwDummy);
		if (Status == ERROR_SUCCESS)
		{
			sprintf(pBuf2, "%s\\%s", NicRegPath, pBuf);
			Status = RegOpenKeyEx(
			   HKEY_LOCAL_MACHINE,
			   pBuf2,
			   0, KEY_READ,
			   &Subkey
		       );
			if (Status == ERROR_SUCCESS)
			{
				// ok, we have got a class
				char Classname[128];

				outlen = sizeof(Classname);
				RegType = REG_SZ;
				Status = RegQueryValueEx(Subkey, "Class", 0, &RegType,
							  (BYTE*)Classname,  &outlen);
				if (Status == ERROR_SUCCESS)
				{
					if(strcmp(Classname,"Net")== 0)
					{
						strcpy(NicRegPath, pBuf2);
						RegCloseKey(Subkey);
						break;			
					}
				}
				RegCloseKey(Subkey);
			}
			Status = ERROR_SUCCESS;// Search next key
		}
	}while(Status == ERROR_SUCCESS);

	RegCloseKey(SystemKey);
	Status = RegOpenKeyEx(HKEY_LOCAL_MACHINE, NicRegPath, 0, KEY_READ, &SystemKey);
	j = 0;
	do{
		dwNameLength = sizeof(pBuf);
		Status = RegEnumKeyEx(SystemKey, j++, (LPSTR)pBuf, & dwNameLength, NULL, NULL,NULL, &dwDummy);
		if(Status == ERROR_SUCCESS)
		{
			sprintf(pBuf2, "%s\\%s\\%s", NicRegPath, pBuf, "Connection");
			Status = RegOpenKeyEx(HKEY_LOCAL_MACHINE, pBuf2,0, KEY_READ, &Subkey);
			if(Status == ERROR_SUCCESS)
			{
				outlen = bytesize;
				char name[512];
				RegType = REG_SZ;
				Status = RegQueryValueEx(Subkey, "Name", 0, &RegType, (BYTE*)name, &outlen);
				if(Status == ERROR_SUCCESS)
				{
					if(strcmp(name, AdapterName) == 0)
					{
						if(strlen(pBuf) + 1 > bytesize)
							return ERR;
						strcpy(NicName, pBuf);
						RegCloseKey(Subkey);
						break;
					}
				}
				RegCloseKey(Subkey);
			}
			Status = ERROR_SUCCESS;//continue search
		}
	}while (Status  == ERROR_SUCCESS);

	if(Status == ERROR_SUCCESS)
		return OK;
	else
		return ERR;	
}
// end of NicUtils.cpp