// file NICUTILS.H

#ifndef NICUTILS_H
#define NICUTILS_H


#include "packon1.h"
typedef struct
{
	char NicName[64];		// the name can be used by WgdrvOpen, such as "RTL80291"
	char NicDescription[256];
} SNic;
#include "packoff1.h"

int GetEtherNicListWithFriendlyDesc(SNic niclist[], unsigned bytesize);
//return the nic's number (>0) if successful
//ruturn a number less than zero if fail
//return ERR if failure
//This function will return friendly Description at win2000. at other 
// platform, it will return the same value as function GetEtherNicList.

int GetAllNicList(SNic niclist[], unsigned bytesize);
// return the nic's number(>0) if successful.
// return a number less than zero if fail
// return ERR if failure


int GetEtherNicList(SNic niclist[], unsigned bytesize);
// return the nic's number(>0) if successful.
// return a number less than zero if fail
// return ERR if failure


int GetAvailEtherNicList(SNic niclist[],unsigned bytesize);
//return the nic's number (>0)if successful.
//reutrn a number less than zero if fail
//return ERR if failure

int GetCurrentAolAdapter(SNic *pppnic);
// return OK if successful
// return ERR if AOL doesn't be installed.


//For Win2K, NicName looks like {122315-1...238}
//Adapter name is the name user named at network and dialup connection.
//We must use NicName at low level, like change ip or others. adaptername is only use for display.
int ChangeNicNametoAdapterName(char * NicName, char * AdapterName, unsigned bytesize);
// This function only used for Win2K
// return OK if successful
// return ERR if fail.

int ChangeAdapterNametoNicName(char * AdapterName, char * NicName, unsigned bytesize);
//This function is only for Win2K
//return OK if successful
//return ERR if fail


// ==========================================================
// The following functions is for compatibility with SyGate.
// 
// DON'T USE IT.
// ==========================================================
int GetCurrentDialupAdapter(SNic *pppnic);
// return OK if successful
// return ERR if dialup networking doesn't be installed.
// ATTENTION: For Win2K, this function return the first online dialup adapter

int GetAllDialupAdapter(SNic niclist[],unsigned bytesize);
// return the nic's number(>0) if successful.
// return a number less than zero if fail
// return ERR if failure
// ATTENTION: For Win2K, this function only return the online dialup adapter 

int SetEtherNicList(SNic *pppnic,BOOL bAvailable);
//return OK if successful
//return ERR if pppnic is unavaiable or Set fail

int SetCurrentDialupAdapter(SNic *pppnic);
// return OK if successful
// return ERR if pppnic is unavailable or set fail.

#endif
