// file PktFIFO.H

/*++
*************************************************************************
+-----------------------------------------------------------------------+
|  Copyright (C) SYBERGEN, INC. 1998,1999                               |
|      All Rights Reserved.                                             |
| Reproduction, adaptation, or translation without prior written        |
| permission is prohibited, except as allowed under Copyright laws.     |
|                                                                       |
| N O T I C E                                                           |
|                                                                       |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC.                     |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED.                             |
+-----------------------------------------------------------------------+
*************************************************************************
--*/
/*++
History:

04/01/1999			Created by Yadong Zhang

--*/



#ifndef PKTFIFO_H
#define PKTFIFO_H

#include "sndbasex.h"

typedef struct
{
	dword	PktSign;
	dword		PktId;
	dword		PktLen;
	dword		unused;
} SFifoPacketHead;

typedef struct
{
	dword	FifoSign;
	char*			pBuf;
	dword		BufLen;
	dword		Head;
	dword		Tail;
	dword		Bottom;
	dword		PktId;

	dword	PutBytes;		// the bytes put into FIFO, including failure
	dword	GetBytes;		// the bytes get from FIFO.
	dword		FreeBytes;
	dword		MinFreeBytes;
	dword	PutCount;
	dword	PutSuccessCount;
	dword	GetCount;
	dword	GetSuccessCount;
	dword	GetNoPktCount;		// the count of get a empty fifo.
	dword	FifoResetCount;

//	friend ostream& operator<<(ostream& os, CPktFifo &pf);

//	void Dump(ostream &os);

} SPacketFifo;

int PktFifoOpen(SPacketFifo *pPktFifo, dword BufferSize);
// return 0 if sucess
int PktFifoClose(SPacketFifo *ppf);
// return 0 if sucess
// return 1 if invalid SPacketFifo
int PktFifoPut(SPacketFifo *ppf, void *pPktData, dword PktLen);
// return 0 if sucess
// return 1 if invalid SPacketFifo
// return 2 if no enough memory
int PktFifoGet(SPacketFifo *ppf, void *pBuf, dword bufsize, dword *RetLen);
// the bytes copied is placed in *RetLen.
// return 0 if sucess
// return 1 if invalid SPacketFifo
// return 2 if no packet
// return 3 if the Fifo is damaged
// return 4 if buf is too small
void PrintPktFifo(SPacketFifo *ppf);

void PktFifoTest(void);

void PktFifoDump(ostream &os, SPacketFifo *ppf);

void PktFifoReset(SPacketFifo *ppf);



#endif

// end of PKTFIFO.H
