// RegistryUtil.cpp

/*++
*************************************************************************
+-----------------------------------------------------------------------+
|  Copyright (C) SYBERGEN, INC. 1998                                    |
|      All Rights Reserved.                                             |
| Reproduction, adaptation, or translation without prior written        |
| permission is prohibited, except as allowed under Copyright laws.     |
|                                                                       |
| N O T I C E                                                           |
|                                                                       |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC.                     |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED.                             |
+-----------------------------------------------------------------------+
*************************************************************************
--*/

#include "stdafx.h"
#include "RegUtil.h"
//#include "..\..\..\..\sndrc\src\inc\SyDataTypes.h"

#define	REGKEY_VALUE_ERROR	"SOFTWARE\\SyberGen"
#define SYGATE_REGVALUE_ERROROUT	"Error"
int	InitErrorOut(void)
//Initial the Error Value In the registry
// return OK if successful
// return ERR if fail 
{
	return WriteDwordToRegistry(HKEY_LOCAL_MACHINE,	
		REGKEY_VALUE_ERROR,SYGATE_REGVALUE_ERROROUT,0);
}

int WriteError(DWORD OrValue)
//Or Error Value in the registry and  OrValue then Write it to registry
// return OK if successful
// return ERR if fail 
{
	DWORD	dwtemp;
	if(ReadDwordFromRegistry(HKEY_LOCAL_MACHINE,
			REGKEY_VALUE_ERROR,SYGATE_REGVALUE_ERROROUT,&dwtemp)!=OK)
		return ERR;
	dwtemp = dwtemp | OrValue;
	
	return WriteDwordToRegistry(HKEY_LOCAL_MACHINE,
				REGKEY_VALUE_ERROR,SYGATE_REGVALUE_ERROROUT,dwtemp);
}

int ReadErrorValue(DWORD * dwValue)
//return OK if successful
//return ERR if fail
{
	return ReadDwordFromRegistry(HKEY_LOCAL_MACHINE,
				REGKEY_VALUE_ERROR,SYGATE_REGVALUE_ERROROUT,dwValue);
}



int DeleteRegistry(HKEY hRootKey, const char *szKey, const char *szValueName, sbool bFlag)
// return OK if successful
// return ERR if fail 
{
	char	tempBuf[256];

	if(bFlag && szValueName == NULL)
	{
		DWORD	index ;
		char	subkey[256];
		if(QuerySubKeyNum(hRootKey, szKey) > 0)
		{
			index = 0;
			while(EnumSubKeyString(hRootKey, szKey, &index, subkey, sizeof(subkey)) == OK)
			{
				sprintf(tempBuf, "%s\\%s", szKey, subkey);
				if(DeleteRegistry(hRootKey, tempBuf, NULL,  bFlag) != OK)
					return ERR;
				index = 0;
			}
		}
		if(QuerySubValueNum(hRootKey, szKey) > 0)
		{
			DWORD	bufsize;
			bufsize = sizeof(subkey);
			index  = 0;
			while(EnumSubValueString(hRootKey, szKey, &index, subkey, &bufsize) == OK)
			{
				if(DeleteRegistry(hRootKey, szKey, subkey) != OK)
					return ERR;
				bufsize = sizeof(subkey);
				index = 0;
			}
		}
	}


	HKEY	hKey;
	DWORD	dwStatus;

	if(szValueName == NULL)
	{
		if(QuerySubKeyNum(hRootKey, szKey) > 0 || QuerySubValueNum(hRootKey, szKey) > 0)
			return ERR;
		dwStatus = RegDeleteKey(hRootKey,
						szKey);
		if(dwStatus != ERROR_SUCCESS)
			return ERR;
	}
	else	
	{
		dwStatus = RegOpenKeyEx(
					hRootKey,		// handle of open key
					szKey,		// address of name of subkey to open
					0,				// reserved  
					KEY_ALL_ACCESS,		// security access mask
					&hKey	// address of handle of open key
					);
		if (dwStatus != ERROR_SUCCESS)
			return ERR;

		//dwStatus = RegDeleteKey(hKey, szValueName);
		dwStatus = RegDeleteValue(hKey, szValueName);

		RegCloseKey(hKey);

		if ( dwStatus != ERROR_SUCCESS)
			return ERR;
	}

	return OK;
}

int QuerySubKeyNum(HKEY hRootKey, const char *szKey)
//return -1 if fail
//otherwise return the number of subkey under szKey
{
	HKEY	hKey;
	DWORD	dwStatus;
	DWORD	dwIndex;
	char	strTemp[256];

	dwIndex = ERR;
	dwStatus = RegOpenKeyEx(hRootKey,
				szKey,
				0,
				KEY_READ,		//KEY_ALL_ACCESS,
				&hKey);
	if(dwStatus == ERROR_SUCCESS)
	{
		dwIndex = 0;
		while(RegEnumKey(hKey,dwIndex,strTemp,sizeof(strTemp)) == ERROR_SUCCESS)
			dwIndex ++;

		RegCloseKey(hKey);
	}

	return dwIndex;
}
int QuerySubValueNum(HKEY hRootKey, const char * szKey)
{
	HKEY	hKey;
	DWORD	dwStatus;
	DWORD	dwIndex;
	char	strTemp[256];

	dwIndex = ERR;
	dwStatus = RegOpenKeyEx(hRootKey,
				szKey,
				0,
				KEY_READ,		//KEY_ALL_ACCESS,
				&hKey);
	if(dwStatus == ERROR_SUCCESS)
	{
		DWORD bufsize;
		dwIndex = 0;
		bufsize = sizeof(strTemp);
		while(RegEnumValue(hKey, dwIndex, strTemp, &bufsize, NULL, NULL, NULL, NULL)== ERROR_SUCCESS)
		{
			dwIndex ++;
			bufsize = sizeof(strTemp);
		}
		RegCloseKey(hKey);
	}

	return dwIndex;
}

int EnumSubKeyString(HKEY hRootKey, const char * szKey, DWORD *dwindex, char * subkey, DWORD buffersize)
//return OK if success
//return ERR if no more subkey or failed.
{
	HKEY  hKey;
	DWORD dwStatus;
	int	  iret = ERR;
	dwStatus = RegOpenKeyEx(hRootKey,
					szKey,
					0,
					KEY_READ,		//KEY_ALL_ACCESS,
					&hKey);
	if(dwStatus == ERROR_SUCCESS)
	{
		if(RegEnumKey(hKey, *dwindex, subkey, buffersize) == ERROR_SUCCESS)
		{
			(*dwindex)++;
			iret = OK;
		}
		RegCloseKey(hKey);
	}

	return iret;
}

int EnumSubValueString(HKEY hRootKey, const char * szKey, DWORD *dwindex, char * subvalue, DWORD *buffersize)
{
	HKEY	hKey;
	DWORD	dwStatus;
	int	iret = ERR;
	dwStatus = RegOpenKeyEx(hRootKey,
				szKey,
				0,
				KEY_READ,
				&hKey);
	if(dwStatus == ERROR_SUCCESS)
	{
		if(RegEnumValue(hKey, *dwindex, subvalue, buffersize, NULL, NULL, NULL, NULL)== ERROR_SUCCESS)
		{
			(*dwindex) ++;
			iret = OK;
		}
		RegCloseKey(hKey);
	}

	return iret;
}

int IsSubKeyExist(HKEY hRootKey, const char *szKey)
// return OK if success
// return ERR if fail 
{
	HKEY	hKey;
	DWORD	dwStatus;
	int		iret = OK;

	dwStatus = RegOpenKeyEx(hRootKey,
				szKey,
				0,
				KEY_ALL_ACCESS,
				&hKey);
	if(dwStatus != ERROR_SUCCESS)
		iret = ERR;
	else
		RegCloseKey(hKey);
	
	return iret;
}

int IsSubKeyExist(HKEY hRootKey, const char * szKey, REGSAM dwRegsam)
// return OK if success
// return ERR if fail 
{
	HKEY	hKey;
	DWORD	dwStatus;
	int		iret = OK;

	dwStatus = RegOpenKeyEx(hRootKey,
				szKey,
				0,
				dwRegsam,
				&hKey);
	if(dwStatus != ERROR_SUCCESS)
		iret = ERR;
	else
		RegCloseKey(hKey);
	
	return iret;
}

int WriteBinaryToRegistry(HKEY hRootKey, const char *szKey, const char *szValueName,
						  const void *p, const unsigned len)
// return OK if success
// return ERR if fail 
{
	HKEY	hNetKey;
	DWORD	dwStatus;
	DWORD	dwKeyType;

	dwStatus = RegCreateKeyEx (	hRootKey,
								(char*)szKey,
								0, 
								(char*)szValueName,
								REG_OPTION_NON_VOLATILE, 
								KEY_ALL_ACCESS,
								NULL, 
								&hNetKey,
								&dwKeyType);
	if (dwStatus != ERROR_SUCCESS) 
	{
		return ERR;
	}

	dwStatus = RegSetValueEx(
				hNetKey,	// handle of key to set value for  
				szValueName,	// address of value to set 
				0,				// reserved 
				REG_BINARY,		// flag for value type 
				(BYTE*)p,		// address of value data 
				len				// size of value data 
				);

	RegCloseKey(hNetKey);

	if (dwStatus != ERROR_SUCCESS) {
		return ERR;
	}

	return OK;
}


int ReadBinaryFromRegistry(HKEY hRootKey, const  char *szSubKey, const char* szValueName,
						   void *p, const unsigned buflen, DWORD* outlen)
// return OK if success
// return ERR if fail
{
	HKEY	hKey;
	DWORD	dwStatus, RegType;

	dwStatus = RegOpenKeyEx(
				hRootKey,		// handle of open key
				szSubKey,		// address of name of subkey to open
				0,				// reserved  
				KEY_READ,		// security access mask
				&hKey	// address of handle of open key
				);
	if (dwStatus != ERROR_SUCCESS)
		return ERR;

	*outlen = buflen;
	memset((char*) p, 0, buflen );
	
	dwStatus = RegQueryValueEx(
					hKey, 
					szValueName,
                    NULL,
					&RegType,
                    (BYTE*) p,
					outlen);

	RegCloseKey(hKey);

	if ( dwStatus != ERROR_SUCCESS)
		return ERR;

	return OK;
}

int ReadStringFromRegistry(HKEY hRootKey,const char *szKey,const char *szValueName,
					char *pstr,unsigned ubufferlen,DWORD *outlen)
//return OK if success
//return ERR if fail
{
	HKEY	hKey;
	DWORD	dwStatus, RegType;

	dwStatus = RegOpenKeyEx(
				hRootKey,		// handle of open key
				szKey,		// address of name of subkey to open
				0,				// reserved  
				KEY_READ,		// security access mask
				&hKey	// address of handle of open key
				);
	if (dwStatus != ERROR_SUCCESS) 
	{
		return ERR;
	}
	
	*outlen = ubufferlen;
	memset((char*) pstr, 0, ubufferlen );
	
	RegType = REG_SZ;
	dwStatus = RegQueryValueEx(
					hKey, 
					szValueName,
                    NULL,
					&RegType,
                    (BYTE*) pstr,
					outlen);

	RegCloseKey(hKey);

	if ( dwStatus != ERROR_SUCCESS)
		return ERR;

	return OK;
}
					
int WriteStringToRegistry(HKEY hRootKey, const char *szKey, const char *szValueName,
						  const char *pstr)
// return OK if success
// return ERR if fail 
{
	HKEY	hNetKey;
	DWORD	dwStatus;
	DWORD	dwKeyType;

	dwStatus = RegCreateKeyEx (
			   hRootKey,
			   szKey,
			   0, 
			   (char*)szValueName,
			   REG_OPTION_NON_VOLATILE, 
			   KEY_ALL_ACCESS,
			   NULL, 
			   &hNetKey,
			   &dwKeyType
			   );
	if (dwStatus != ERROR_SUCCESS) 
	{
		return ERR;
	}

	dwStatus = RegSetValueEx(
				hNetKey,	// handle of key to set value for  
				szValueName,	// address of value to set 
				0,				// reserved 
				REG_SZ,			// flag for value type 
				(BYTE*)pstr,	// address of value data 
				strlen(pstr)+1	// size of value data 
				);

	RegCloseKey(hNetKey);

	if (dwStatus != ERROR_SUCCESS) {
		return ERR;
	}

	return OK;
}

int ReadDwordFromRegistry(HKEY hRootKey,const char *szKey,const char * szValueName,
					DWORD * pdwValue)
//return OK if success
//return ERR if fail
{
	HKEY	hKey;
	DWORD	dwStatus, RegType,dwoutlen;

	dwStatus = RegOpenKeyEx(
				hRootKey,		// handle of open key
				szKey,		// address of name of subkey to open
				0,				// reserved  
				KEY_READ,		// security access mask
				&hKey	// address of handle of open key
				);
	if (dwStatus != ERROR_SUCCESS) 
	{
		return ERR;
	}
	
	dwoutlen = sizeof(DWORD);
	RegType = REG_DWORD;
	dwStatus = RegQueryValueEx(
					hKey, 
					szValueName,
                    NULL,
					&RegType,
                    (BYTE*)pdwValue,
					&dwoutlen);

	RegCloseKey(hKey);

	if ( dwStatus != ERROR_SUCCESS)
		return ERR;

	return OK;
}
					
int WriteDwordToRegistry(HKEY hRootKey, const char *szKey, const char *szValueName,
						  DWORD dwValue)
// return OK if success
// return ERR if fail 
{
	HKEY	hNetKey;
	DWORD	dwStatus;
	DWORD	dwKeyType;

	dwStatus = RegCreateKeyEx (
			   hRootKey,
			   szKey,
			   0, 
			   (char*)szValueName,
			   REG_OPTION_NON_VOLATILE, 
			   KEY_ALL_ACCESS,
			   NULL, 
			   &hNetKey,
			   &dwKeyType
			   ); //Create this key if it is inexsitant. Otherwise Open it.
	if (dwStatus != ERROR_SUCCESS) 
	{
		return ERR;
	}

	dwStatus = RegSetValueEx(
				hNetKey,	// handle of key to set value for  
				szValueName,	// address of value to set 
				0,				// reserved 
				REG_DWORD,			// flag for value type 
				(BYTE*)&dwValue,	// address of value data 
				sizeof(dwValue)	// size of value data 
				);

	RegCloseKey(hNetKey);

	if (dwStatus != ERROR_SUCCESS) {
		return ERR;
	}

	return OK;
}

// The function gets the Installation folder of various Sygate Products
//  Returns ERR if it could not find the path else OK
//  product (IN) : sygate product type
//  pbuf    (OUT):  it holds the path name
//  len     (IN) : length of the pbuf
/*int GetAppPathFromRegistry(int product, char *pbuf, unsigned len)
{
	int r;
	dword outlen;
	pbuf[0] = 0;
	if (product == ENUM_PRODUCT_SYGATE)
		r = ReadBinaryFromRegistry(HKEY_LOCAL_MACHINE,
			SYGATE_REGKEY, SYGATE_REGVALUE_DIRECTORY,
			pbuf, len, &outlen);
	else if (product == ENUM_PRODUCT_SYACCESS)
		r = ReadBinaryFromRegistry(HKEY_LOCAL_MACHINE,
			SYGATE_REGKEY, SYGATE_REGVALUE_DIRECTORY,
			pbuf, len, &outlen);
	else // if (product == CSyDetect::SYSHIELD)
		r = ReadBinaryFromRegistry(HKEY_LOCAL_MACHINE,
			"SOFTWARE\\SyberGen\\SyShieldClass","SyShieldDirectory",
			pbuf, len, &outlen);
	if (r != OK)
	{
		pbuf[0] = 0;
		return ERR;
	}
	return OK;
}*/

