// ============ RegUtil.H ================

/*++
*************************************************************************
+-----------------------------------------------------------------------+
|  Copyright (C) SYBERGEN, INC. 1998                                    |
|      All Rights Reserved.                                             |
| Reproduction, adaptation, or translation without prior written        |
| permission is prohibited, except as allowed under Copyright laws.     |
|                                                                       |
| N O T I C E                                                           |
|                                                                       |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC.                     |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED.                             |
+-----------------------------------------------------------------------+
*************************************************************************
--*/
#ifndef __REGISTRYUTIL__H__
#define __REGISTRYUTIL__H__

#include "snderror.h"

// Common equates
#define REG_RECURSIVE			1
#define REG_IS_A_KEY			2


int ReadBinaryFromRegistry(HKEY hRootKey, const char *szSubKey, const char* szValueName, 
						   void *p, const unsigned buflen, DWORD* outlen);
// return OK if success
// return ERR if fail

int WriteBinaryToRegistry(HKEY hRootKey, const char *szSubKey, 
			  const char *szValueName, const void *p, const unsigned len);
// return OK if success
// return ERR if fail 

int ReadStringFromRegistry(HKEY hRootKey,const char *szKey,const char *szValueName,
					char *pstr,unsigned ubufferlen,DWORD *outlen);
//return OK if success
//return ERR if fail

int WriteStringToRegistry(HKEY hRootKey, const char *szKey, 
				  const char *szValueName, const char *pstr);
// return OK if success
// return ERR if fail 

int ReadDwordFromRegistry(HKEY hRootKey,const char *szKey,const char * szValueName,
					DWORD * dwValue);
//return OK if success
//return ERR if fail
					
int WriteDwordToRegistry(HKEY hRootKey, const char *szKey, 
						 const char *szValueName, DWORD dwValue);
// return OK if success
// return ERR if fail 

int DeleteRegistry(HKEY hRootKey, const char *szKey,
				   const char *szValueName, sbool bRecursive = false);
// if szValueName = NULL , delete this registry key
// return OK if successful
// return ERR if fail 

int QuerySubKeyNum(HKEY hRootKey, const char *szKey);
//return -1 if fail 
//otherwise return the number of subkey under szKey
int QuerySubValueNum(HKEY hRootKey, const char * szKey);
//return -1 if fail
//otherwise return the numer of sub value under szKey

int EnumSubKeyString(HKEY hRootKey, const char * szKey, DWORD* dwindex, char * subkey, DWORD buffersize);
//return OK if success
//return ERR if no more subkey or failed.
//To get first key dwindex should be equal 0. this function will return the next index by dwindex.

int EnumSubValueString(HKEY hRootKey, const char * szKey, DWORD *dwindex, char * subvalue, DWORD * buffersize);
//return OK if success
//return ERR if no more subkey or failed.
//To get first key dwindex should be equal 0. this function will return the next index bye dwindex.

int IsSubKeyExist(HKEY hRootKey, const char *szKey);
int IsSubKeyExist(HKEY hRootKey, const char *szKey, REGSAM dwRegsam);
//return OK if success
//return ERR if fail

//int GetAppPathFromRegistry(int product, char *pbuf, unsigned len);
// return OK if successful
// get sygate directory from registry for different Sygate Products


//===============================================
//Below functions was for compatible with sygate
//Please don't use it
//===============================================

int	InitErrorOut(void);
//Initial the Error Value In the registry
// return OK if successful
// return ERR if fail 
				   
int WriteError(DWORD OrValue);
//Or Error Value in the registry and  OrValue then Write it to registry
// return OK if successful
// return ERR if fail 

int ReadErrorValue(DWORD * dwValue);
//return OK if successful
//return ERR if fail



#endif

//end of RegUtil.h