// md5checksum.h: interface for the md5checksum class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(CRC_CHECKSUM_H)
#define CRC_CHECKSUM_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CSndCrc32Table
{
private:
    unsigned long crc_table[256];

public:

    CSndCrc32Table()
    {
        unsigned long crc, poly;
        int i, j;
        
        poly = 0xEDB88320L;
        for (i = 0; i < 256; i++)
        {
            crc = i;
            for (j = 8; j > 0; j--)
            {
                if (crc & 1)
                    crc = (crc >> 1) ^ poly;
                else
                    crc >>= 1;
            }
            crc_table[i] = crc;
        }
    };
    inline unsigned long& operator [] (int i) { return crc_table[i]; };
};


class CSndCrc32
{
public:
    CSndCrc32() {}
    
    dword Calc(void* data, dword data_len, dword init_crc = 0xFFFFFFFF);
    // return the CRC32 value
};

#endif // !defined(CRC_CHECKSUM_H)
