/* $Header: /usr2/cvs/master/Develop/Products/Smc/build/sndfc/src/sndfc/snd/dnspkt.cpp,v 1.4 2002/01/22 22:34:11 ytian Exp $*/
/*++
*************************************************************************
+-----------------------------------------------------------------------+
| Copyright (C) SYBERGEN NETWORKS, INC. 1998,1999 |
| All Rights Reserved. |
| Reproduction, adaptation, or translation without prior written |
| permission is prohibited, except as allowed under Copyright laws. |
| |
| N O T I C E |
| |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC. |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED. |
+-----------------------------------------------------------------------+
*************************************************************************
--*/

/*++
 * 
 * $Author: ytian $
 * $Date: 2002/01/22 22:34:11 $
 * $Revision: 1.4 $
 * $Workfile: dnspkt.cpp $
 * $Log: dnspkt.cpp,v $
 * Revision 1.4  2002/01/22 22:34:11  ytian
 * add checking
 *
 * Revision 1.3  2001/07/26 01:53:14  ytian
 * fixed bug 3887
 *
 * Revision 1.2  2001/07/20 22:16:21  mgopal
 * Removed the error for invalid packet size. because it causes error.
 *
 * Revision 1.1.1.1  2001/06/29 19:30:08  herbert
 * Migrate from VSS to CVS.
 *
 * 
 * 11    2/13/01 2:49p Vhsieh
 * Add no_error varible .
 * 
 * 10    2/13/01 2:19p Philipq
 * 
 * 9     2/13/01 2:18p Philipq
 * Test, add some debug info
 * 
 * 8     1/07/01 4:43p Philipq
 * Add Some check, udp length<=512 and flags
 * 
 * 7     1/07/01 10:13a Ydz
 * * fixed bug DNS packet may crash on DoS attack.
 * 
 * 6     8/15/00 3:39p Herbertw
 * 
 * 5     8/07/00 2:56p Herbertw
 * Change GetAnswerIP to old procedure. (See bug #1032 for detail)
 * 
 * 4     8/02/00 5:50p Herbertw
 * Merge with SSD sndfc
 * 
 * 3     5/16/00 5:46p Herbertw
 * Merge SNDFC from  NatSrv and Netport
 * 
 * 1     1/28/00 10:58a Ydz
 * 
 * 1     1/26/00 2:07p Herbertw
 * 
 * 12    10/14/99 11:23a Jchuang
 * 
 * 11    10/13/99 1:49p Jchuang
 * better dns logging handling
 * 
 * 10    10/12/99 4:36p Jchuang
 * move log handling from coreproc to protocol handlers
 * 
 * 9     9/30/99 5:25p Jchuang
 * Fix problem on AOL 4.0 and 5.0
 * 
 * 8     9/16/99 6:04p Jchuang
 * 
 * 7     8/12/99 6:15p Jchuang
 * fix crash on query DNS
 * 
 * 6     8/12/99 10:37a Herbertw
 * Add debug code for DNS answer packet.
 * 
 * 5     8/11/99 3:56p Jchuang
 * fix crash when DNS request fails when black list is activated.
 * 
 * 4     8/06/99 12:22p Herbertw
 * Add DNS solution to Logfile
 * $NoKeywords: $
 *
--*/

 

/*++
History:

08/14/1998			Created by Yadong Zhang

--*/

#include "stdafx.h"
#include "dnspkt.h"

ostream& operator<<(ostream& os, CDnsPacket &ep)
{
	char iqname[256];
	iqname[0] = 0;
	ep.GetQName(iqname, sizeof(iqname));
		
	os	<<"===== DNS Packet==== len:"<<dec<<ep.GetPacketBinary().GetLen()<<"====\n"
		<< ep.GetUdpPkt().GetIpPkt().GetSourIp()<<":"<<ep.GetUdpPkt().GetSourPort()<< " -> "
		<< ep.GetUdpPkt().GetIpPkt().GetDestIp()<<":"<<ep.GetUdpPkt().GetDestPort()
		<<",  Type: "<<hex<<ep.GetMsgType()
		<<"\nQName: "<<iqname
		<<endl;

	return os;
}

outputstr operator +(const outputstr ops, CDnsPacket &dp)
{
	ostrstream outbuf;
	outbuf<<dp<<(char)0;
	outputstr out = ops + outbuf.str();

	// unfreeze it, otherwise strstream won't release the memory 
	// and memory leak will occur.
	outbuf.freeze(false);
	return out;
}

////////////////////////////////////////////////////
//  The functions don't support Name compressed.


void CDnsPacket::Initial(void)
{
	memset(AnswerIP,0,sizeof(AnswerIP));
	ANCount = 0;
	QDCount = 0;
	ResourceType = 0;
}

CDnsPacket::CDnsPacket(void)
{
	Initial();
}

CDnsPacket::CDnsPacket(CUdpPacket &upp)
{
	Initial();
	Set(upp);
}

int CDnsPacket::Set(CUdpPacket& upp)
// return OK if it is our packet
// return UDP_ERR_ISNT_MINE if not.
{
	m_iNoError = OK;
 	if (upp.GetDestPort() != tonword(PROTO_UDP_PORT_DNS)
 		&& upp.GetSourPort() != tonword(PROTO_UDP_PORT_DNS)
 		) 
	{
		m_iNoError = DNS_ERR_ISNT_MINE;
		return m_iNoError;
	}

	memptr p_Dns = upp.GetDataSection();
	if (p_Dns.GetLen() < sizeof (SDns_FrameHead))
		return DNS_ERR_ISNT_MINE;

	if(upp.GetDataLen() > 512)	//See RFC 1035 2.3.4
	{
		if(DEBUG)sysprintln("The data length is "+upp.GetDataLen());
		//m_iNoError = DNS_ERR_ISNT_MINE; // THis cause crash in SPNetand bug 3887
		//return m_iNoError;
	}
	
	CPacket::Set(upp, p_Dns);
	
//Check some flag in head section to make sure it's a dns packee. See RFC 1035 section 4.1.1
	word	wflag = GetFlags();
	word	opcode	= (wflag&0x0078)>>3;
	if(opcode>2)
	{
		if(DEBUG)sysprintln("The opcode is "+opcode);
		m_iNoError = DNS_ERR_ISNT_MINE;
		return m_iNoError;
	}
	word	z = (wflag&0x7000);
	if(0 != z)
	{
		if(DEBUG)sysprintln("The dword is "+z);
		m_iNoError = DNS_ERR_ISNT_MINE;
		return m_iNoError;
	}
	word	rcode  =(wflag&0x0f00)>>8;
	if(rcode >5)
	{
		if(DEBUG) sysprintln("The rcode is "+rcode);
		m_iNoError = DNS_ERR_ISNT_MINE;
		return m_iNoError;
	}
//End of check head
	
	byte * tail = (byte *)GetFramePtr() + upp.GetDataLen();	
	byte * p = (byte *)GetFramePtr() + sizeof(SDns_FrameHead);

	unsigned utemp = (unsigned) toword(GetQDCount());

	QDCount = utemp;
	if (QDCount != 1)
	{
		m_iNoError = DNS_ERR_ISNT_MINE;
		return m_iNoError;
	}
	for (unsigned i = 0; i<utemp ; i++) //Skip Question Session
	{
		// BUGG!! don't do like this: while( *p != 0 && p <= tail)
		while( p <= tail )
		{
			if ( *p == 0 ) break;
			p += (*p);
			p ++;
		}
		p++;
		ResourceType = *(unsigned short*)p;
		
		//
		// Modified by Philip Qi to fix bug#7089
		//
		// AD send SRV request to DNS server which smartDNS can't handle
		// So a DNS_RREC_TYPE_SRV added to fix this bug
		// The fix won't affect "Reverse DNS" feature in Security Engine
		//
		if (!(ResourceType == DNS_RREC_TYPE_PTR_NET || ResourceType == DNS_RREC_TYPE_ADDR_NET || ResourceType == DNS_RREC_TYPE_SRV))
		{
			m_iNoError = DNS_ERR_ISNT_MINE;
			return m_iNoError;
		}
		p += 4;
		if(p>tail) return DNS_ERR_ISNT_MINE;
	}

	
	utemp = (unsigned) toword(GetANCount());

	for(i = 0; i<utemp; i++)
	{
		if (*p == 0xc0)
		{
			p += 2;
		}
		else
		{
			while (*p != 0 && p<=tail)
			{
				p += (*p);
				p ++;
				if(p>tail) return DNS_ERR_ISNT_MINE;
			}
			p++;
		}

		SDns_ResourceRecord * SRec = (SDns_ResourceRecord *) p;
		p += sizeof(SDns_ResourceRecord);
		p += toword(SRec->RDLength);
		if(p>tail) return DNS_ERR_ISNT_MINE;
	}

	m_lenOfQuestionSections = 0;

	UdpPacket = upp;
	return OK;
}

unsigned int CDnsPacket::GetAnswerIP (ipaddr *ip, unsigned ipBufCount)
{
	//We should call GetAnswerAddresses() to get AnswerIPs.
	//But there is bug at GetAnswerAddresses(), see Bug #1032 for detial
	unsigned ANCount = 0;
	if(IsAnswer())
	{
		unsigned QDCount;
		unsigned uTemp;
		byte * p = (byte *)GetFramePtr() + sizeof(SDns_FrameHead);

		QDCount = (unsigned) toword(GetQDCount());
		for (unsigned i = 0; i<QDCount ; i++) //Skip Question Session
		{
			while( *p != 0)
			{
				p += (*p);
				p ++;
			}
			p += 5;
		}

		uTemp = (unsigned) toword(GetANCount());
		if(toword(GetANCount()) > ipBufCount)
			uTemp = ipBufCount;

		ANCount = 0;
		for(i = 0; i<uTemp; i++)
		{
			if (*p == 0xc0)
			{
				p += 2;
			}
			else
			{
				while (*p != 0)
				{
					p += (*p);
					p ++;
				}
				p++;
			}

			SDns_ResourceRecord * SRec = (SDns_ResourceRecord *) p;
			p += sizeof(SDns_ResourceRecord);
			if( SRec->Type == tonword(DNS_RREC_TYPE_ADDR))
			{
				*(ip+ANCount) = *((ipaddr *)p);
				ANCount++;
			}
			p += toword(SRec->RDLength);
		}
	}
	return ANCount;
}

unsigned int CDnsPacket::GetAnswerTTL(unsigned int *ttl)
{
	unsigned int retVal = OK;
	*ttl = 0;

	if(IsAnswer())
	{
		unsigned QDCount;
		unsigned uTemp;
		byte * p = (byte *)GetFramePtr() + sizeof(SDns_FrameHead);

		QDCount = (unsigned) toword(GetQDCount());
		for (unsigned i = 0; i<QDCount ; i++) //Skip Question Session
		{
			while( *p != 0)
			{
				p += (*p);
				p ++;
			}
			p += 5;
		}

		uTemp = (unsigned) toword(GetANCount());

		if (uTemp == 0)
		{
			*ttl = 0;
			return OK;
		}

		if (*p == 0xc0)
		{
			p += 2;
		}
		else
		{
			while (*p != 0)
			{
				p += (*p);
				p ++;
			}
			p++;
		}

		SDns_ResourceRecord * SRec = (SDns_ResourceRecord *) p;
		p += sizeof(SDns_ResourceRecord);
		if( SRec->Type == tonword(DNS_RREC_TYPE_PTR))	// double check
		{
			unsigned int *pUtemp;
			pUtemp = (unsigned int*)SRec->TTL;
			*ttl = ntohl(*pUtemp);

		}
	}

	return retVal;
}

unsigned int CDnsPacket::GetAnswerName(char *outbf, unsigned buflen)
{
	unsigned int retVal = ERR;
	dword		 dwlen;
	memptr		 packetbin;
	byte		 *ptail;

	packetbin  = GetPacketBinary();

	dwlen = packetbin.GetLen();

	ptail = (byte *)packetbin.GetAddr() + dwlen;

	if(IsAnswer())
	{
		unsigned QDCount;
		unsigned uTemp;
		byte * p = (byte *)GetFramePtr() + sizeof(SDns_FrameHead);

		QDCount = (unsigned) toword(GetQDCount());
		for (unsigned i = 0; i<QDCount ; i++) //Skip Question Session
		{
			while( *p != 0)
			{
				p += (*p);
				p ++;
			}
			p += 5;
		}

		uTemp = (unsigned) toword(GetANCount());

		if (uTemp == 0)
		{
			outbf[0] = 0;
			return OK;
		}

		if (*p == 0xc0)
		{
			p += 2;
		}
		else
		{
			while (*p != 0)
			{
				p += (*p);
				p ++;
			}
			p++;
		}
		
		// check p before access SRec->Type.
		// see comments before the while loop for detail
		// about why need to check p

		if(p >= ptail)
		{
			return ERR;
		}

		SDns_ResourceRecord * SRec = (SDns_ResourceRecord *) p;

		p += sizeof(SDns_ResourceRecord);

		// access SRec->Type should be OK becasue the p should always < ptail
		// so the access the first 2 bytes of the p which is the SRec->Type should be OK

		//while(p < ptail && SRec->Type != tonword(DNS_RREC_TYPE_PTR))
		while(p < ptail)
		{
			if(SRec->Type == tonword(DNS_RREC_TYPE_PTR))
				break;
			do
			{
				if(*p == 0xc0)
				{
					p += 2;
					break;
				}
				else
					p++;
			}while(p < ptail);
			
			SRec = (SDns_ResourceRecord *) p;
			p += sizeof(SDns_ResourceRecord);
		}
		
		if( SRec->Type == tonword(DNS_RREC_TYPE_PTR))
		{
			// p is not pointing to the start of domain name.

			if (toword(SRec->RDLength) > buflen)
				return ERR;

			int alen = 1;
			int tlen = toword(SRec->RDLength);;
			char *pSrc = (char*)p;
			char *pDest = outbf;
			
			do
			{
				int len;

				len = *pSrc;
				if ( len > buflen || len > tlen) 
					break;
				
				// copy current label
				memcpy(pDest, pSrc + 1, len);

				alen += len + 1;
				// move to next label
				pDest += len; 
				pSrc = pSrc + len + 1; 
				m_lenOfQuestionSections += len+1;
			
				// if it is end flag
				if (alen >= tlen) 
				{	
					// count on NULL, QType(2 octets) and QClass(2 octets)
					m_lenOfQuestionSections += 5; 
					*pDest = 0;
					retVal = OK;
					break;
				}
			
				*pDest = '.'; 
				pDest++;

			} while (1);

		}

	}

	return retVal;
}


////////////////////////////////////////////////////
//  The function don't support Name compressed.
int CDnsPacket::GetQName(char *outbuf, unsigned buflen)
// get the name queried. 
// The function supports ONLY Multi-QName. seprate the name with common
// return OK if successful.
{
	if (toword(GetFramePtr()->QDCount) < 1 ) return ERR;
	
	char *pDest = outbuf;
	char *pSrc;
	pSrc = (char*) (GetPacketBinary().GetAddr() + sizeof(SDns_FrameHead));
	unsigned len = 0;
	
	for (int i = 0; i<toword(GetFramePtr()->QDCount); i++)
	{
		if (i)
		{
			*pDest = ',';
			pDest++;
			pSrc += 5;
		}

		do
		{
			len = *pSrc;
			if ( len > buflen) 
				break;
			
			// copy current label
			memcpy(pDest, pSrc + 1, len);
		
			// move to next label
			pDest += len; 
			pSrc = pSrc + len + 1; 
			m_lenOfQuestionSections += len+1;
		
			// if it is end flag
			if (*pSrc == 0) 
			{	
				// count on NULL, QType(2 octets) and QClass(2 octets)
				m_lenOfQuestionSections += 5; 
				break;
			}
		
			*pDest = '.'; 
			pDest++;

		} while (1);
	}
	
	*pDest = 0;
	outbuf[buflen - 1] = 0;
	
	return OK;
}

unsigned int CDnsPacket::GetQIP(unsigned long *ip)
{
	if (toword(GetFramePtr()->QDCount) != 1) return ERR;

	char ip_buffer[32];
	char *pDest = ip_buffer;
	char *pSrc;
	pSrc = (char*) (GetPacketBinary().GetAddr() + sizeof(SDns_FrameHead));
	unsigned len = 0;

	do
	{
		len = *pSrc;

		if (len > 3) return ERR;
		
		// copy current label
		memcpy(pDest, pSrc + 1, len);
	
		// move to next label
		pDest += len; 
		pSrc = pSrc + len + 1; 
		m_lenOfQuestionSections += len+1;
	
		// if it is end flag
		if (*pSrc == 7) 
		{	
			// count on NULL, QType(2 octets) and QClass(2 octets) and inaddr.arpa
			m_lenOfQuestionSections += 13 + 5; 
			break;
		}
	
		*pDest = '.'; 
		pDest++;

	} while (1);
	
	*pDest = 0;
	
	*ip = ntohl(inet_addr(ip_buffer));

	return OK;
}


////////////////////////////////////////////////////
//  The function supports Name compressed.
int CDnsPacket::GetAnswerAddresses(dword *outbuf, unsigned buflen)
{
	if (toword(GetFramePtr()->ANCount) < 1 ) return ERR;
	
	dword *pDest = outbuf;
	char *pAnswer;
	pAnswer = (char*) (GetPacketBinary().GetAddr() + sizeof(SDns_FrameHead)) + 
		m_lenOfQuestionSections;
	unsigned len = 0;
	unsigned retcount = 0;

	for (int i=0; i<toword(GetFramePtr()->ANCount); i++)
	{
		if( retcount * sizeof(dword) >= buflen)
			break;
		len = *pAnswer;
		if ( len >= 0xC0) 
		{
			// Compressed domain name. It always takes 2 octets
			pAnswer += 2;
		}
		else
		{
			// Non-compressed domain name. Go through the name.
			for (int j=0; j<256; j++)
			{
				if (*(pAnswer+j)=='\0')
					break;
			}

			if (j > 256)
			{
				// Failed to find valid format
				return ERR;
			}

			// Move to Type field
			pAnswer += j+1;
		}

		nword type = (*(nword*)pAnswer);
			
		// Skip Class and TTL. Jump to RDLength
		pAnswer += 8;
		nword rdLength = (*(nword*)pAnswer);

		if (toword(type)!=RESOURCE_TYPE_A || toword(rdLength)!=4)
		{
			// we don't care it if the type is not A(host address) or
			// RDLength is not 4(32 bits)
			pAnswer += sizeof(rdLength);
			pAnswer += toword(rdLength);
			continue;
		}

		// Goes to RData for reading 32 bits IP
		pAnswer += 2;
		ipaddr ip;
		ip.byVal[0] = *pAnswer++;
		ip.byVal[1] = *pAnswer++;
		ip.byVal[2] = *pAnswer++;
		ip.byVal[3] = *pAnswer++;
		(*pDest) = ip.dwVal;
		pDest ++;
		retcount ++;
	}

	(*pDest) = 0;

	return OK;
}
// End of DNSPKT.CPP
