// IcmpPkt.cpp: implementation of the CIcmpPkt class.
//
//////////////////////////////////////////////////////////////////////

/*++
*************************************************************************
+-----------------------------------------------------------------------+
|  Copyright (C) SYBERGEN, INC. 1998,1999                               |
|      All Rights Reserved.                                             |
| Reproduction, adaptation, or translation without prior written        |
| permission is prohibited, except as allowed under Copyright laws.     |
|                                                                       |
| N O T I C E                                                           |
|                                                                       |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC.                     |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED.                             |
+-----------------------------------------------------------------------+
*************************************************************************
--*/
/*++
History:

04/02/1999			Merged into SNDFC by Yadong Zhang
05/10/1998			Created by Yadong Zhang

--*/



#include "stdafx.h"
#include "IcmpPkt.h"
#include "checksum.h"

odstream& operator<<(odstream& os, CIcmpPacket &ep)
{
	os	<<"===== ICMP Packet==== len:"<<dec<<ep.GetPacketBinary().GetLen()<<"====\n"
		<<", type: 0x"<<hex<<(unsigned)ep.GetType()
		<<", Code: "<<dec<<(unsigned)ep.GetCode()
		<<", Checksum: 0x"<<hex<<ep.GetFramePtr()->Checksum
		<<dec;
	return os;
}

outputstr operator +(const outputstr& ops,CIcmpPacket& ip)
{
	ostrstream outbuf;
	outbuf<<ip<<(char)0;
	outputstr out = ops + outbuf.str();

	// unfreeze it, otherwise strstream won't release the memory 
	// and memory leak will occur.
	outbuf.freeze(false);
	return out;
}

bool CIcmpPacket::IsValidIcmpChecksum(void)
{
	return( IcmpChecksum(GetIpPkt().GetPacketBinary().GetAddr(), 
			GetIpPkt().GetPacketBinary().GetLen()) == 0);
}


int CIcmpPacket::RefillIcmpChecksum(void)
// re-calculate the ipheader's checksum and write to ipheader.
// return OK if successful,,, I think it should succeed always..  :-)
{
	CalcIcmpChecksum(GetIpPkt().GetPacketBinary().GetAddr());
	return OK;
}
