// IPPKT: implementation of the CIpPacket class.
//
//////////////////////////////////////////////////////////////////////

/*++
*************************************************************************
+-----------------------------------------------------------------------+
|  Copyright (C) SYBERGEN, INC. 1998                                    |
|      All Rights Reserved.                                             |
| Reproduction, adaptation, or translation without prior written        |
| permission is prohibited, except as allowed under Copyright laws.     |
|                                                                       |
| N O T I C E                                                           |
|                                                                       |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC.                     |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED.                             |
+-----------------------------------------------------------------------+
*************************************************************************
--*/

/*++
History:

04/01/1999			Merged into SNDFC by Yadong Zhang
03/29/1998			Created by Yadong Zhang

--*/


#include "stdafx.h"
#include "IpPkt.h"

#include "checksum.h"

odstream& operator<<(odstream& os, CIpPacket &ep)
{
	os	<<"===== IP Packet==== len:"<<dec<<ep.GetPacketBinary().GetLen()<<"====\n"
		<<ep.GetSourIp()<<" --> "<<ep.GetDestIp()
		<<", type: 0x"<<hex<<(unsigned)ep.GetProtocol()
		<<", Id: "<<dec<<ep.GetFramePtr()->Identification
		<<", Frg: 0x"<<dec<<ep.GetFramePtr()->Flags_FragmentOffset;
	return os;
}

outputstr operator +(const outputstr &ops, CIpPacket &ep)
{
	ostrstream outbuf;
	outbuf<<ep<<(char)0;
	outputstr out = ops + outbuf.str();

	// unfreeze it, otherwise strstream won't release the memory 
	// and memory leak will occur.
	outbuf.freeze(false);
	return out;
}

bool CIpPacket::IsValidIpChecksum(void)
{
	return( IpChecksum(GetPacketBinary().GetAddr(), GetPacketBinary().GetLen()) == 0);
}


word CIpPacket::CalculatedChecksum(void)
{
    word oldchksum, newchksum;
    oldchksum = GetFramePtr()->HeadChecksum;
    GetFramePtr()->HeadChecksum = 0;
    newchksum = IpChecksum(GetPacketBinary().GetAddr(), GetPacketBinary().GetLen());
    GetFramePtr()->HeadChecksum = oldchksum;
    return newchksum;
}

int CIpPacket::RefillIpChecksum(void)
// re-calculate the ipheader's checksum and write to ipheader.
// return OK if success,,, I think it should success always..  :-)
{
	GetFramePtr()->HeadChecksum = 0;
	GetFramePtr()->HeadChecksum = IpChecksum(GetPacketBinary().GetAddr(), GetPacketBinary().GetLen());
	return OK;
}

