/* =================================================================================================
 * 
 *  md5.h
 *  ???
 * Copyright (C) 1991-2, RSA Data Security, Inc. Created 1991. All
 * rights reserved.
 * 
 * License to copy and use this software is granted provided that it
 * is identified as the "RSA Data Security, Inc. MD5 Message-Digest
 * Algorithm" in all material mentioning or referencing this software
 * or this function.
 * 
 * License is also granted to make and use derivative works provided
 * that such works are identified as "derived from the RSA Data
 * Security, Inc. MD5 Message-Digest Algorithm" in all material
 * mentioning or referencing the derived work.
 * 
 * RSA Data Security, Inc. makes no representations concerning either
 * the merchantability of this software or the suitability of this
 * software for any particular purpose. It is provided "as is"
 * without express or implied warranty of any kind.
 * 
 * These notices must be retained in any copies of any part of this
 * documentation and/or software.
 *
 * Modified by E. Thioux to fit C++ style
 * 
 * -------------------------------------------------------------------------------------------------
 * 
 */
#ifndef __MD5_H__
#define __MD5_H__


/* PROTOTYPES should be set to one if and only if the compiler supports
  function argument prototyping.
  The following makes PROTOTYPES default to 0 if it has not already
  been defined with C compiler flags.
 */

#define PROTOTYPES 1

/* POINTER defines a generic pointer type */
typedef unsigned char *POINTER;

/* UINT2 defines a two byte word */
typedef unsigned short int UINT2;

/* UINT4 defines a four byte word */
typedef unsigned long int UINT4;

/* PROTO_LIST is defined depending on how PROTOTYPES is defined above.
   If using PROTOTYPES, then PROTO_LIST returns the list, otherwise it
   returns an empty list.
 */

#if PROTOTYPES
#define PROTO_LIST(list) list
#else
#define PROTO_LIST(list) ()
#endif

/* MD5 context. */
typedef struct {
  UINT4 state[4];             /* state (ABCD) */
  UINT4 count[2];             /* number of bits, modulo 2^64 (lsb first) */
  unsigned char buffer[64];   /* input buffer */
} MD5_CTX;


class CMD5 {
  public:
	CMD5();
    CMD5(char* szIn, char* pMD5);
    CMD5(char* pbBuffer, int cbBuffer, char* pbKey);
    ~CMD5();

    int Calc();

    void MD5Init ();
    void MD5Update PROTO_LIST ((unsigned char *, unsigned int));
    void MD5Final PROTO_LIST ((unsigned char [16]));
    void MD5Transform (UINT4 state[4], unsigned char block[64]);
    void Encode (unsigned char *output, UINT4 *input, unsigned int len);
    void Decode (UINT4 *output, unsigned char *input, unsigned int len);

  private:
    char*   m_InBuffer;
    char*   m_OutBuffer;
    char*   m_pbKey;
    MD5_CTX m_mdctx;
};


#endif //__MD5_H__

