// md5checksum.cpp: implementation of the md5checksum class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "md5checksum.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


static outputstr Md5ToString(const byte checksum[MD5_CHECKSUM_LENGTH]
							 )
{
	char buf[128];
	sprintf(buf,	"%02X%02X%02X%02X%02X%02X%02X%02X"
		"%02X%02X%02X%02X%02X%02X%02X%02X",
		(unsigned char)checksum[0],
		(unsigned char)checksum[1],
		(unsigned char)checksum[2],
		(unsigned char)checksum[3],
		(unsigned char)checksum[4],
		(unsigned char)checksum[5],
		(unsigned char)checksum[6],
		(unsigned char)checksum[7],
		(unsigned char)checksum[8],
		(unsigned char)checksum[9],
		(unsigned char)checksum[10],
		(unsigned char)checksum[11],
		(unsigned char)checksum[12],
		(unsigned char)checksum[13],
		(unsigned char)checksum[14],					
		(unsigned char)checksum[15]
		);
	
	return (outputstr) buf;
}

outputstr md5checksum::Dump(void) const
{
	return Md5ToString(uaChecksumBinary);
}

outputstr operator+(const outputstr& ops, const md5checksum& a)
{
	return ops + a.Dump();
}

/*++
md5checksum StringToMd5Checksum(outputstr& str)
{
	if ( str.GetLength() != MD5_CHECKSUM_LENGTH*2 )
		THROW_SND_EXCEPTION
		dword len = str.GetLength();
	char buf[MD5_CHECKSUM_LENGTH*2 + 2];
	memset(buf, '0', sizeof(buf));
	memcpy(buf, str, str.GetLength());
		

}

outputstr Md5ChecksumToString(md5checksum& cs)
{
	return Md5ToString(cs.uaChecksumBinary);
}

--*/