// md5checksum.h: interface for the md5checksum class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MD5CHECKSUM_H__12497A38_2850_481E_886A_56805F8CFE0B__INCLUDED_)
#define AFX_MD5CHECKSUM_H__12497A38_2850_481E_886A_56805F8CFE0B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#define MD5_CHECKSUM_LENGTH		16


#include "packon1.h"
struct md5checksum
{
	byte   uaChecksumBinary[MD5_CHECKSUM_LENGTH];
	
	inline void Empty(void);
	// set md5 checksum to 0

	inline sbool operator==(const md5checksum& cs);
	// check if two checksum is equal
	inline sbool operator!=(const md5checksum& cs);
	// check if two checksum is equal
	
	outputstr Dump(void) const;
	// dump MD5 checksum in HEX
	
	inline memptr GetRaw(void);
	// return the checksum internal buffer, array: byte[MD5_CHECKSUM_LENGTH]

	void Calc(void* data, dword data_len);
	// The function wasn't implemented yet

};
#include "packoff1.h"

//md5checksum StringToMd5Checksum(outputstr& str);
//outputstr Md5ChecksumToString(md5checksum& cs);

outputstr operator+(const outputstr& ops, const md5checksum& a);

inline void md5checksum::Empty(void)
{
	memset(uaChecksumBinary, 0, sizeof(uaChecksumBinary));
}

inline sbool md5checksum::operator==(const md5checksum& cs)
{
	return memcmp(uaChecksumBinary, cs.uaChecksumBinary, sizeof(uaChecksumBinary)) == 0;
}

inline sbool md5checksum::operator!=(const md5checksum& cs)
{
	return memcmp(uaChecksumBinary, cs.uaChecksumBinary, sizeof(uaChecksumBinary)) != 0;
}

inline memptr md5checksum::GetRaw(void)
{
	memptr a(uaChecksumBinary, MD5_CHECKSUM_LENGTH);
	return a;
}

#endif // !defined(AFX_MD5CHECKSUM_H__12497A38_2850_481E_886A_56805F8CFE0B__INCLUDED_)
