// file miniGNet.h

#ifndef MINIGATEWAYNET_H
#define MINIGATEWAYNET_H

#include "dunline.h"

int GWNetInit(int autohangup_max_idletime, bool *urgent_exit_flag_ptr);
// return OK if successfully

int GWNetProcMaintain(void);

void GWNetReportActivity(void);

DWORD GWNetGetIdleTime(void);

int GWNetShut(void);

bool GWNetIsOnline(void);

bool GWNetIsOnlineByGui(void);

bool GWNetIsRunning(void);

EDialingDevLineStatus GWNetGetLineStatus(void);
// return ELS_XXXXXXX

int GWNetDial(bool bAsyncDail = false);
// return OK if successfully

int GWNetStopProgram(bool wait_for_end = true);
//return OK if successfully;

int GWNetHangup(bool always_close_gwnet = false, bool wait_for_end = true);
// return OK if successfully
// always_close_gwnet = true:  always close Gateway.net even if Gateway.net was not opened 
//           by MiniGWNet.

DWORD GWNetGetDialingFailedCount(void);
/* return the failure count since the lastest success. */


bool GWNetIsInstalled(void);
/* the function can be called without GWNetInit() */


#endif

// end of MINIGATEWAYNET_H
