// file miniaol.h

#ifndef MINIAOL_H
#define MINIAOL_H

#include "dunline.h"

int AolInit(int autohangup_max_idletime, bool *urgent_exit_flag_ptr);
// return OK if successfully

int AolProcMaintain(void);

void AolReportActivity(void);

DWORD AolGetIdleTime(void);

int AolShut(void);

bool AolIsOnline(void);

bool AolIsOnlineByGui(void);

bool AolIsRunning(void);

EDialingDevLineStatus AolGetLineStatus(void);
// return ELS_XXXXXXX

int AolDial(bool bAsyncDail = false);
// return OK if successfully

int AolStopProgram(bool wait_for_end = true);
//return OK if successfully;
// always_close_aol = true:  always close aol even if aol was not opened 
//           by MiniAol.

int AolHangup(bool always_close_aol = false, bool wait_for_end = true);
// return OK if successfully
// always_close_aol = true:  always close aol even if aol was not opened 
//           by MiniAol.

DWORD AolGetDialingFailedCount(void);
/* return the failure count since the lastest success. */


bool AolIsInstalled(void);
/* the function can be called without AolInit() */


#endif

// end of MINIAOL_H
