// netutils.h

/*++
*************************************************************************
+-----------------------------------------------------------------------+
|  Copyright (C) SYBERGEN, INC. 1998,1999                               |
|      All Rights Reserved.                                             |
| Reproduction, adaptation, or translation without prior written        |
| permission is prohibited, except as allowed under Copyright laws.     |
|                                                                       |
| N O T I C E                                                           |
|                                                                       |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC.                     |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED.                             |
+-----------------------------------------------------------------------+
*************************************************************************
--*/
/*++
History:

04/01/1999			Created by Yadong Zhang

--*/


#ifndef SND_NETUTILS_H
#define SND_NETUTILS_H

#include "sndbasex.h"
#include "ipaddr.h"

ipaddr GetLocalIPList(ipaddr *pIpList, unsigned IpListSizeByByte);
// Try to get a IP list on this computer.
//
// No ip list returned if pIpList == NULL.
// IpListSizeByByte will be ignore if pIpList == NULL.
// GetLocalIP will copy 16 IP address at most.


int SendAUdp(DWORD sourip, DWORD destip, WORD destport, char * Message = NULL, int MessLen = 0);
// Send a udp packet for probe
// myiptoa: source IP, if you want to use local IP which is assigned by TCP/IP stack, 
// set sourip to ADDR_ANY.
// return 0 if success

// !!!!!!!!! DON'T USE IT !!!!!!!!!!
// The function will do nothing and return OK 
// Keeping the declaration is for compatibility with SyGate code.
int RunNcpa(bool wait_for_end);
// if wait_for_end is true, the function won't return until the program executed finished
// return OK if success


int OpenNetworkAppletOnControlPanel(void);
// return OK if success

int SetAutoDial(bool enable);
// enable/disable Auto-Dial. The setting is same as 
// control panel -> Internet -> Connection -> Connect to Internet using XXXX
// NOTICE: It is supported only by Internet Explorer 3.0 or above.
// return OK if successful
// return ERR if failed.

// ==========================================
// FOR COMPATIBILITY WITH SYGATE
// DON'T USE IT
// ===========================================
DWORD GetLocalIP(DWORD *pIpList, unsigned IpListSizeByByte);
// No ip list returned if pIpList == NULL.
// IpListSizeByByte will be ignore if pIpList == NULL.
// GetLocalIP will copy 16 IP address at most.
// NOTICE: for history reason, the return value of 
// GetLocalIP() is Net-Ordered.
// the pIpList is Local-machine-Ordered.


// !---- Helen
int SetProxySetting(bool enable);
// enable/disable the proxy setting. The setting is same as 
// control panel -> Internet -> Connection -> LAN Settings -> check "Proxy Server"
// return OK if successful
// return ERR if failed.


#endif
