/* $Header: /usr2/cvs/master/Develop/Products/Smc/build/sndfc/src/sndfc/snd/osutils.cpp,v 1.10 2003/01/27 19:49:20 bzhao Exp $*/
/*++
*************************************************************************
+-----------------------------------------------------------------------+
| Copyright (C) SYBERGEN NETWORKS, INC. 1998,1999 |
| All Rights Reserved. |
| Reproduction, adaptation, or translation without prior written |
| permission is prohibited, except as allowed under Copyright laws. |
| |
| N O T I C E |
| |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC. |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED. |
+-----------------------------------------------------------------------+
*************************************************************************
--*/

/*++
 * 
 * $Author: bzhao $
 * $Date: 2003/01/27 19:49:20 $
 * $Revision: 1.10 $
 * $Workfile: osutils.cpp $
 * $NoKeywords: $
 *
--*/

  
#include "stdafx.h"
#include <shellapi.h>
#include "osutils.h"

static HANDLE GetCurUserToken(void);
static int GetDefaultBrowserFullPath(const char *p, outputstr *pfullpath);
static int GetDefaulHtmlHelperFullPath(const char *p, outputstr *pfullpath);


int Exec(char *executable_filename, char *command_line, bool wait_for_end, bool visiable,char * output_filename)
// if wait_for_end is true, the function won't return until the program executed finished
// return OK if successfully
{
	BOOL br;
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	HANDLE hfile;
	
	GetStartupInfo(&si);
	hfile = NULL;
	if (!visiable)
	{
		si.dwFlags = STARTF_USESHOWWINDOW;
		si.wShowWindow = SW_HIDE;
	}
	else
	{
		si.dwFlags = STARTF_USESHOWWINDOW;
		si.wShowWindow = SW_SHOWNORMAL;
	}
	
	if(output_filename != NULL)
	{
		hfile = CreateFile(output_filename,GENERIC_WRITE,0,0,CREATE_NEW,FILE_ATTRIBUTE_ARCHIVE,0);
		if(hfile ==INVALID_HANDLE_VALUE) // try another way;
			hfile = CreateFile(output_filename,GENERIC_WRITE,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,0);
		if(hfile != INVALID_HANDLE_VALUE)
		{
			si.dwFlags = si.dwFlags | STARTF_USESTDHANDLES;
			si.hStdError = hfile;
			si.hStdOutput = hfile;
		}
	}

	br = CreateProcess( 
		executable_filename,// pointer to name of executable module
		command_line,		// pointer to command line string
		NULL,				// pointer to process security attributes
		NULL,				// pointer to thread security attributes
		FALSE,				// handle inheritance flag
		CREATE_DEFAULT_ERROR_MODE,	// creation flags
		NULL,				// pointer to new environment block
		NULL,				// pointer to current directory name
		&si,				// pointer to STARTUPINFO
		&pi					// pointer to PROCESS_INFORMATION
		);
	if (br == 0)
	{
		
/*		serr<<"Exec: cannot execute a process. Error Code:"<<GetLastError()<<endl;
		serr<<"file: ";
		if (executable_filename) serr<<executable_filename<<endl;
			else serr<<"<none>"<<endl;

		serr<<"cmdline: ";
		if (command_line) serr<<command_line<<endl;
			else serr<<"<none>"<<endl;*/
		sysprintln("Exec: cannot execute a process. Error Code:" + GetLastError());
		sysprint("file: ");
		if(executable_filename)
			sysprintln(executable_filename);
		else
			sysprintln("<none>");
		sysprint("cmdline: ");
		if(command_line)
			sysprintln(command_line);
		else
			sysprintln("<none>");

		return ERR;
	}

	//sout<<"the process is running. waiting."<<endl;

	DWORD n;
	if (wait_for_end)
	{
		while (GetExitCodeProcess(pi.hProcess, &n) != 0)
		{
			if (n != STILL_ACTIVE) break;
			SleepEx(50, TRUE);
		}
	}

	CloseHandle(pi.hThread);
	CloseHandle(pi.hProcess);
	memset(&pi, 0, sizeof(pi));
	if(hfile != NULL)
		CloseHandle(hfile);

	return OK;
}

char *GetOSString(DWORD *os)
//return the string of MS OS
{
	static char strVersion[128];
	char temp[32];
	OSVERSIONINFO ov; 
	DWORD dwVer;

	ov.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&ov);
	dwVer = ov.dwMajorVersion << 8 | ov.dwMinorVersion;

	// xx.xx.xxxx
	WORD wBuild, wMajor, wMinor;

	wBuild = ov.dwBuildNumber;	// low word
	wMajor = ov.dwMajorVersion;
	wMinor = ov.dwMinorVersion;

	switch (ov.dwPlatformId)
	{
	case VER_PLATFORM_WIN32_NT:
		if (dwVer >= 0x502)
		{
			*os = SY_WIN_XP;
			strcpy(temp, "Windows Server 2003 family");
		}
		else if (dwVer >= 0x501)
		{
			*os = SY_WIN_XP;
			strcpy(temp, "Windows XP");
		}
		else if (dwVer >= 0x500)
		{
			*os = SY_WIN_2000;
			strcpy(temp, "Windows 2000");
		}
		else
			{
				*os = SY_WIN_NT4;
				strcpy(temp, "Windows NT");
			}
		//sprintf(strVersion,"Operating System: %s %s ",temp, ov.szCSDVersion);
		break;

	case VER_PLATFORM_WIN32_WINDOWS:
		if (dwVer >= 0x45A)
			{
				*os = SY_WIN_ME;
				strcpy(temp, "Windows Millennium");
			}
		else
		if (dwVer > 0x400) // ov.dwMinorVersion > 0
			{
				// Further differentiate 98 and 98se
				//if (ov.dwBuildNumber >= 2222)
				if (ov.dwBuildNumber >= 67766446L)
				{
					*os = SY_WIN_98_SE;
					strcpy(temp, "Windows 98 SE");
				}
				else
				{
					// 1998 : 67766222 (build number)
					*os = SY_WIN_98;
					strcpy(temp, "Windows 98");
				}
			}
		else // ov.dwMinorVersion == 0
			{
				*os = SY_WIN_95;
				strcpy(temp, "Windows 95");
			}
		//sprintf(strVersion,"Operating System: %s",temp);
		break;
	}
	sprintf(strVersion,"Operating System: %s (%d.%d.%d %s)",
			temp, wMajor, wMinor, wBuild, ov.szCSDVersion);

	return strVersion;
}

bool IsWin95(void)
// return true if os is win95.
{
	DWORD dwOS;

	GetOSString(&dwOS);

	if (dwOS == SY_WIN_95)
	{
		return true;
	}
	return false;
}

bool IsWin98(void)
{
	return (IsWin98Org() || IsWin98SE());
}

bool IsWin98Org(void)
{
	DWORD dwOS;

	GetOSString(&dwOS);

	if (dwOS == SY_WIN_98)
	{
		return true;
	}
	return false;
}
bool IsWin98SE(void)
{
	DWORD dwOS;

	GetOSString(&dwOS);

	if (dwOS == SY_WIN_98_SE)
	{
		return true;
	}
	return false;
}

bool IsWin9x(void)
{
	return (IsWin95() || IsWin98() || IsWinME());
}

bool IsWinME(void)
{
	DWORD dwOS;

	GetOSString(&dwOS);

	if (dwOS == SY_WIN_ME)
	{
		return true;
	}
	return false;	
}

bool IsWinNT(void)
// return true if os is winNT.
{
	return (IsWinNT4() || IsWinNT2000() || IsWinXP() );
}

bool IsWinNT4(void)
{
	DWORD dwOS;

	GetOSString(&dwOS);

	if (dwOS == SY_WIN_NT4)
	{
		return true;
	}
	return false;
}
bool IsWinNT2000(void)
// return true if os is Win2K or WinXp
{
	DWORD dwOS;

	GetOSString(&dwOS);

	if ((dwOS == SY_WIN_2000) || IsWinXP())
	{
		return true;
	}
	return false;
}
bool IsWin2000(void) //win2k only
{
	DWORD dwOS;

	GetOSString(&dwOS);

	return  (dwOS == SY_WIN_2000) ;
	
}

bool IsWinXP(void)
// return true if os is WinXP.
{
	DWORD dwOS;
	
	GetOSString(&dwOS);
	
	if (dwOS == SY_WIN_XP)
	{
		return true;
	}
	return false;
}


bool IsServer(void)
// return true if os is server (nt server or win2k server)
{
	OSVERSIONINFOEX ove;
	ove.dwOSVersionInfoSize = sizeof(ove);

	GetVersionEx((OSVERSIONINFO*)&ove);

	if (VER_NT_DOMAIN_CONTROLLER == ove.wProductType ||
		VER_NT_SERVER == ove.wProductType)
		return true;
	return false;
}

bool IsNT4Server(void)
{
	return (IsServer() && IsWinNT4());
}
// return true if os is NT4 server
bool IsWin2000Server(void)
{
	return (IsServer() && IsWin2000());
}
// return true if os is Win2k server



bool IsNtSp3(void)
// return true if there is a service pack 3 installed.
{
	OSVERSIONINFO ov;
	ov.dwOSVersionInfoSize = sizeof(ov);

	GetVersionEx(&ov);
	if (stricmp(ov.szCSDVersion, "Service Pack 3") == 0 )
	{
		return true;
	}
	return false;
}

bool IsNtSp4(void)
// return true if there is a service pack 4 installed.
{
	OSVERSIONINFO ov;
	ov.dwOSVersionInfoSize = sizeof(ov);

	const char sp4[] = "Service Pack 4";
	GetVersionEx(&ov);
	if (strnicmp(ov.szCSDVersion, sp4, strlen(sp4)) == 0 )
	{
		return true;
	}
	return false;
}

bool IsNtSp5(void)
//return true if there is a service pack5 installed
{
	OSVERSIONINFO ov;
	ov.dwOSVersionInfoSize = sizeof(ov);

	const char sp5[] = "Service Pack 5";
	GetVersionEx(&ov);
	if(strnicmp(ov.szCSDVersion, sp5, strlen(sp5)) == 0)
	{
		return true;
	}
	return false;
}

bool IsNtSp6(void)
//return true if there is a service pack5 installed
{
	OSVERSIONINFO ov;
	ov.dwOSVersionInfoSize = sizeof(ov);

	const char sp6[] = "Service Pack 6";
	GetVersionEx(&ov);
	if(strnicmp(ov.szCSDVersion, sp6, strlen(sp6)) == 0)
	{
		return true;
	}
	return false;
}

int GetNtSpVersion(void)
{
	int nVersion = 0;
	OSVERSIONINFO ov;
	char *p;

	ov.dwOSVersionInfoSize = sizeof(ov);
	GetVersionEx(&ov);
	p = strpbrk(ov.szCSDVersion, "0123456789");
	if(p != NULL)
		nVersion = atoi(p);
	
	return nVersion;	
}

int RebootSystem_95(void)
{
	if (ExitWindowsEx(
		EWX_REBOOT, // shutdown operation 
		0			// reserved 
		))
		return OK; 
	return ERR;
}


int RebootSystem_NT(void)
{
	HANDLE hToken; 
	TOKEN_PRIVILEGES tkp;  
	
	// Get a token for this process.  
	if (!OpenProcessToken(GetCurrentProcess(), 
        TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken)) 
			return ERR;
	
	// Get the LUID for the shutdown privilege.  
	LookupPrivilegeValue(NULL, SE_SHUTDOWN_NAME,&tkp.Privileges[0].Luid);  
	tkp.PrivilegeCount = 1;				// one privilege to set    
	tkp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;  

	// Get the shutdown privilege for this process.  
	AdjustTokenPrivileges(hToken, FALSE, &tkp, 0, 
        (PTOKEN_PRIVILEGES)NULL, 0);  
	
	// Cannot test the return value of AdjustTokenPrivileges.  
	if (GetLastError() != ERROR_SUCCESS) return ERR;
	
	// Shut down the system and force all applications to close.  
	if (!ExitWindowsEx(EWX_REBOOT , 0))   
		return ERR;
	
	return OK;
}


int RebootSystem(void)
{
	if (IsWinNT()) return RebootSystem_NT();
	return RebootSystem_95();
}


int OpenBrowser(HWND handle, char *url)
{
/*	this version has a problem under win2000 professional ,so I change it as follow: after command
    
    HINSTANCE hi;
 	char sysdir[MAX_PATH];
 
 	// if Internet Explorer 3.0+ installed, it should work.
 	sysdir[0] = 0;
	GetSystemDirectory(sysdir, sizeof(sysdir));
 	hi = ShellExecute(handle, "open", url, NULL, sysdir, SW_SHOWNORMAL);
 	if ((DWORD)hi > 32) return OK;

 	// The win95/NT seems too old and IE wasn't installed, 
 	// we cannot "run" a URL directly.
 	// Ok, try to call netscape.
 	hi = ShellExecute(handle, "open", "netscape.exe", url, sysdir, SW_SHOWNORMAL);
 	if ((DWORD)hi > 32) return OK;
*/

	HINSTANCE hi;
 	char sysdir[MAX_PATH];
	
 	// if Internet Explorer 3.0+ installed, it should work.
 	sysdir[0] = 0;
	GetSystemDirectory(sysdir, sizeof(sysdir));
   SNDFC_OSVERSIONINFOEX osvi;
   BOOL bOsVersionInfoEx;

   // Try calling GetVersionEx using the OSVERSIONINFOEX structure,
   // which is supported on Windows 2000.
   //
   // If that fails, try using the OSVERSIONINFO structure.

   ZeroMemory(&osvi, sizeof(OSVERSIONINFOEX));
   osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);

   if( !(bOsVersionInfoEx = GetVersionEx ((OSVERSIONINFO *) &osvi)) )
   {
      // If OSVERSIONINFOEX doesn't work, try OSVERSIONINFO.

      osvi.dwOSVersionInfoSize = sizeof (OSVERSIONINFO);
      if (! GetVersionEx ( (OSVERSIONINFO *) &osvi) ) 
         return ERR;
   }

   if (osvi.dwPlatformId==VER_PLATFORM_WIN32_NT && osvi.dwMajorVersion == 5 && osvi.wProductType == VER_NT_WORKSTATION )
   {
	   HKEY  hk;
	   char caBuf[400];
	   DWORD dwSize=400;
	   if (RegOpenKeyEx(
			HKEY_CLASSES_ROOT,         // handle to open key
			"http\\shell\\open\\command",  // subkey name
			0,   // reserved
			KEY_READ, // security access mask
			&hk    // handle to open key
		)!=ERROR_SUCCESS) return FALSE;
	    if (ERROR_SUCCESS != RegQueryValueEx(hk, NULL,
				0, NULL, (LPBYTE)caBuf, &dwSize)) 
		{
			RegCloseKey(hk);
			return ERR;
		}
		RegCloseKey(hk);
  
		if (strstr(caBuf,"iexplore.exe"))
		{
			hi = ShellExecute(handle, "open","iexplore.exe" , url, sysdir, SW_SHOWNORMAL);
			if ((DWORD)hi > 32) return OK;
		}
		else if (strstr(caBuf,"NETSCP6.EXE"))
		{
			hi=ShellExecute(handle, "open",url,NULL, sysdir, SW_SHOWNORMAL);
			if ((DWORD)hi > 32) return OK;
			return ERR;
		}
		else
		{
			hi = ShellExecute(handle, "open", "netscape.exe", url, sysdir, SW_SHOWNORMAL);
 			if ((DWORD)hi > 32) return OK;
		}
   }
   if (osvi.dwPlatformId==VER_PLATFORM_WIN32_WINDOWS)
   {
		HKEY  hk;
	   char caBuf[400];
	   DWORD dwSize=400;
	   if (RegOpenKeyEx(
			HKEY_CLASSES_ROOT,         // handle to open key
			"http\\shell\\open\\command",  // subkey name
			0,   // reserved
			KEY_READ, // security access mask
			&hk    // handle to open key
		)!=ERROR_SUCCESS) return ERR;
	    if (ERROR_SUCCESS != RegQueryValueEx(hk, NULL,
				0, NULL, (LPBYTE)caBuf, &dwSize))
		{
			RegCloseKey(hk);
			return ERR;
		}
		RegCloseKey(hk);
  
		if (strstr(caBuf,"iexplore.exe"))
		{
			if (FindWindow("IEFrame",NULL)) 
		    {
		        hi = ShellExecute(handle, "open",url,NULL, sysdir, SW_SHOWNORMAL);
		        if ((DWORD)hi > 32) return OK;
			}
		    else
		    {
		       	hi = ShellExecute(handle, "open","iexplore.exe", url, sysdir, SW_SHOWNORMAL);
		        if ((DWORD)hi > 32) return OK;
			}
		}
		/*else if (strstr(caBuf,"NETSCP6.exe"))
		{
			hi = ShellExecute(handle, "open", url, NULL,sysdir, SW_SHOWNORMAL);
			if ((DWORD)hi > 32) return TRUE;
					
		}*/
		else 
		{
			hi = ShellExecute(handle, "open", url, NULL, sysdir, SW_SHOWNORMAL);
 			if ((DWORD)hi > 32) return OK;
			return ERR;
		}
		
		
   }
 	// if Internet Explorer 3.0+ installed, it should work.

 	hi = ShellExecute(handle, "open", url, NULL, sysdir, SW_SHOWNORMAL);
 	if ((DWORD)hi > 32) return OK;

 
 	return ERR;
}

typedef BOOL	WINAPI	SNDFC_DUPLICATETOKENEX(HANDLE, DWORD, LPSECURITY_ATTRIBUTES, SECURITY_IMPERSONATION_LEVEL, TOKEN_TYPE, PHANDLE);

int OpenBrowserEx(HWND handle, char *url)
{
	HINSTANCE hi;
 	char sysdir[MAX_PATH];

	GetSystemDirectory(sysdir, sizeof(sysdir));

	if(IsWinNT())
	{
		HKEY  hk;
		char caBuf[400];
		DWORD dwSize=400;
		if (RegOpenKeyEx(HKEY_CLASSES_ROOT,
						 "http\\shell\\open\\command",
						 0,
						 KEY_READ,
						 &hk)!=ERROR_SUCCESS)	return FALSE;
	    if (ERROR_SUCCESS != RegQueryValueEx(hk, NULL, 0, NULL, (LPBYTE)caBuf, &dwSize)) 
		{
			RegCloseKey(hk);
			return ERR;
		}

		RegCloseKey(hk);
  
		HANDLE				hToken;
		HANDLE				hNewToken;
		STARTUPINFO			si;
		PROCESS_INFORMATION pi;
		outputstr			cmdline;

		HMODULE hDll = LoadLibrary("Advapi32.dll");
		if (NULL == hDll)
		{
			return ERR;
		}

		SNDFC_DUPLICATETOKENEX			*pDuplicateTokenEx = NULL;
			
		pDuplicateTokenEx			= (SNDFC_DUPLICATETOKENEX*)GetProcAddress(hDll, "DuplicateTokenEx");
		
		if((NULL == pDuplicateTokenEx))
		{
			FreeLibrary(hDll);
			return ERR;
		}

		hToken = GetCurUserToken();
		if(hToken != INVALID_HANDLE_VALUE)
		{
			//
			// duplicate the impersonation token to primary
			// since we are impersonating the client, the token will get the
			// default Dacl of the client
			//
			if(!(*pDuplicateTokenEx)(hToken,
								 TOKEN_IMPERSONATE | TOKEN_READ |
								 TOKEN_ASSIGN_PRIMARY | TOKEN_DUPLICATE,
								 NULL,
								 SecurityImpersonation,
								 TokenPrimary,
								 &hNewToken)) 
			{
				CloseHandle(hToken);
				sysprintln("Fail to use new method to open d4 browser at A!! use old one to open the d4 browser.");
				
				hi = ShellExecute(handle, "open", url, NULL, sysdir, SW_SHOWNORMAL);
 				if ((DWORD)hi > 32) 
					return OK;
				else
					return ERR;

			}

			CloseHandle(hToken);
			hToken = INVALID_HANDLE_VALUE;

			memset(&si,0,sizeof(STARTUPINFO));

			//
			// setup STARTUPINFO structure
			//
			si.cb			= sizeof(STARTUPINFO);
			si.lpReserved	= NULL;
			si.lpDesktop	= NULL;
			si.lpTitle		= NULL;
			si.cbReserved2	= 0;
			si.lpReserved2	= NULL;
			si.dwFlags		= STARTF_RUNFULLSCREEN;
			
			//
			// create a process running as the user
			//

			if(OK != GetDefaultBrowserFullPath((const char*)caBuf, &cmdline))
			{
				CloseHandle(hToken);
				sysprintln("Fail to use new method to open d4 browser at B!! use old one to open the d4 browser.");
				
				hi = ShellExecute(handle, "open", url, NULL, sysdir, SW_SHOWNORMAL);
 				if ((DWORD)hi > 32) 
					return OK;
				else
					return ERR;

			}
			
			cmdline = cmdline + " ";
			cmdline = cmdline + url;

			if(!CreateProcessAsUser(hNewToken,
									NULL,		// commandline to execute
									cmdline.GetString(),
									NULL,   // process sa
									NULL,   // thread sa
									FALSE,   // inherit handles?
									0,      // process creation flags (inherit existing console)
									NULL,   // environment
									NULL,   // current directory
									&si,    // startupinfo
									&pi     // processinfo
									)) 
			{
				CloseHandle(hNewToken);
				sysprintln("Fail to use new method to open d4 browser at C!! use old one to open the d4 browser.");
				
				hi = ShellExecute(handle, "open", url, NULL, sysdir, SW_SHOWNORMAL);
 				if ((DWORD)hi > 32) 
					return OK;
				else
					return ERR;

			}
			else if (pi.hProcess)
				CloseHandle(pi.hProcess); // not used anywhere

			CloseHandle(hNewToken);
						
			return OK;
		}
		else
		{
			sysprintln("Fail to use new method to open d4 browser at D!! use old one to open the d4 browser.");

		 	hi = ShellExecute(handle, "open", url, NULL, sysdir, SW_SHOWNORMAL);
			if ((DWORD)hi > 32) 
				return OK;
			else
				return ERR;
		}
   }
   if (IsWin9x())
   {
	   HKEY  hk;
	   char caBuf[400];
	   DWORD dwSize=400;
	   if (RegOpenKeyEx(
			HKEY_CLASSES_ROOT,         // handle to open key
			"http\\shell\\open\\command",  // subkey name
			0,   // reserved
			KEY_READ, // security access mask
			&hk    // handle to open key
		)!=ERROR_SUCCESS) return ERR;
	    if (ERROR_SUCCESS != RegQueryValueEx(hk, NULL,
				0, NULL, (LPBYTE)caBuf, &dwSize))
		{
			RegCloseKey(hk);
			return ERR;
		}
		RegCloseKey(hk);
  
		if (strstr(caBuf,"iexplore.exe"))
		{
			if (FindWindow("IEFrame",NULL)) 
		    {
		        hi = ShellExecute(handle, "open",url,NULL, sysdir, SW_SHOWNORMAL);
		        if ((DWORD)hi > 32) return OK;
			}
		    else
		    {
		       	hi = ShellExecute(handle, "open","iexplore.exe", url, sysdir, SW_SHOWNORMAL);
		        if ((DWORD)hi > 32) return OK;
			}
		}
		/*else if (strstr(caBuf,"NETSCP6.exe"))
		{
			hi = ShellExecute(handle, "open", url, NULL,sysdir, SW_SHOWNORMAL);
			if ((DWORD)hi > 32) return TRUE;
					
		}*/
		else 
		{
			hi = ShellExecute(handle, "open", url, NULL, sysdir, SW_SHOWNORMAL);
 			if ((DWORD)hi > 32) return OK;
			return ERR;
		}
		
		
   }
 	// if Internet Explorer 3.0+ installed, it should work.
	
   hi = ShellExecute(handle, "open", url, NULL, sysdir, SW_SHOWNORMAL);
   if ((DWORD)hi > 32) return OK;
	
   return ERR;
}


HANDLE OpenHtmlHelper(HWND handle, char *pchmpath)
{	
	// init process structure, which used in 90% cases in the following code
	SHELLEXECUTEINFO execInfo;
	ZeroMemory(&execInfo, sizeof(execInfo));
	execInfo.cbSize = sizeof(execInfo);
	execInfo.hwnd = NULL;
	// execInfo.lpFile = pchmpath;
	execInfo.lpParameters = NULL;
	execInfo.nShow = SW_SHOWNORMAL	; 
	execInfo.fMask = SEE_MASK_NOCLOSEPROCESS;
	execInfo.lpVerb = NULL;
	
	if (IsWinNT())
	{
		HKEY  hk;
		char caBuf[400];
		DWORD dwSize=400;
		if (RegOpenKeyEx(HKEY_CLASSES_ROOT,
						 "chm.file\\shell\\open\\command",
						 0,
						 KEY_READ,
						 &hk)!=ERROR_SUCCESS)	return FALSE;
	    if (ERROR_SUCCESS != RegQueryValueEx(hk, NULL, 0, NULL, (LPBYTE)caBuf, &dwSize)) 
		{
			RegCloseKey(hk);
			sysprintln("osutils::OpenHtmlHelper() failed to read help shell command from registry");
			return NULL;
		}

		RegCloseKey(hk);
  
		HANDLE				hToken;
		HANDLE				hNewToken;
		STARTUPINFO			si;
		PROCESS_INFORMATION pi;
		outputstr			cmdline;

		HMODULE hDll = LoadLibrary("Advapi32.dll");
		if (NULL == hDll)
		{
			sysprintln("osutils::OpenHtmlHelper() failed to load Advapi32.dll");
			return NULL;
		}

		SNDFC_DUPLICATETOKENEX			*pDuplicateTokenEx = NULL;
			
		pDuplicateTokenEx			= (SNDFC_DUPLICATETOKENEX*)GetProcAddress(hDll, "DuplicateTokenEx");
		
		if((NULL == pDuplicateTokenEx))
		{
			FreeLibrary(hDll);
			sysprintln("osutils::OpenHtmlHelper() failed find DuplicateTokenEx function");
			return NULL;
		}
		hToken = GetCurUserToken();
		if(hToken != INVALID_HANDLE_VALUE)
		{
			//
			// duplicate the impersonation token to primary
			// since we are impersonating the client, the token will get the
			// default Dacl of the client
			//
			if(!(*pDuplicateTokenEx)(hToken,
								 TOKEN_IMPERSONATE | TOKEN_READ |
								 TOKEN_ASSIGN_PRIMARY | TOKEN_DUPLICATE,
								 NULL,
								 SecurityImpersonation,
								 TokenPrimary,
								 &hNewToken)) 
			{
				CloseHandle(hToken);
				sysprintln("Fail to use new method to open d4 htmlhelp at A!! use old one to open the d4 htmlhelp.");
				
				execInfo.lpFile = pchmpath;
				if (ShellExecuteEx(&execInfo))
				{
					return execInfo.hProcess;
				}
				
				return NULL; // failed
			}

			CloseHandle(hToken);
			hToken = INVALID_HANDLE_VALUE;

			memset(&si,0,sizeof(STARTUPINFO));

			//
			// setup STARTUPINFO structure
			//
			si.cb			= sizeof(STARTUPINFO);
			si.lpReserved	= NULL;
			si.lpDesktop	= NULL;
			si.lpTitle		= NULL;
			si.cbReserved2	= 0;
			si.lpReserved2	= NULL;
			si.dwFlags		= STARTF_RUNFULLSCREEN;
			
			//
			// create a process running as the user
			//

			if (OK != GetDefaulHtmlHelperFullPath((const char*)caBuf, &cmdline))
			{
				CloseHandle(hToken);
				sysprintln("Fail to use new method to open d4 htmlhelp at B!! use old one to open the d4 htmlhelp.");
				
				execInfo.lpFile = pchmpath;

				if (ShellExecuteEx(&execInfo))
				{
					return execInfo.hProcess;
				}
				
				return NULL; // failed
			}
			
			cmdline = cmdline + " ";
			cmdline = cmdline + pchmpath;

			if(!CreateProcessAsUser(hNewToken,
									NULL,		// commandline to execute
									cmdline.GetString(),
									NULL,   // process sa
									NULL,   // thread sa
									FALSE,   // inherit handles?
									0,      // process creation flags (inherit existing console)
									NULL,   // environment
									NULL,   // current directory
									&si,    // startupinfo
									&pi     // processinfo
									)) 
			{
				CloseHandle(hNewToken);
				sysprintln("Fail to use new method to open d4 htmlhelp at C!! use old one to open the d4 htmlhelp.");
				
				execInfo.lpFile = pchmpath;

				if (ShellExecuteEx(&execInfo))
				{
					return execInfo.hProcess;
				}
				
				return NULL; // failed
			}

			CloseHandle(hNewToken);
			return pi.hProcess;
		}
		else
		{
			sysprintln("Fail to use new method to open d4 htmlhelp at D!! use old one to open the d4 htmlhelp.");

			execInfo.lpFile = pchmpath;

			if (ShellExecuteEx(&execInfo))
			{
				return execInfo.hProcess;
			}
				
			return NULL; // failed
		}
	}
    if (IsWin9x())
	{
		execInfo.lpFile = pchmpath;

		if (ShellExecuteEx(&execInfo))
		{
			return execInfo.hProcess;
		}
				
		return NULL; // failed
	}

	// if Internet Explorer 3.0+ installed, it should work
	execInfo.lpFile = pchmpath;

    if (ShellExecuteEx(&execInfo))
	{
		return execInfo.hProcess;
	}
			
	return NULL; // failed	
}


bool IsNtAdministrators(void)
// check if the app has administrators rights.
// NOTICE: it works "as is".

// return true if yes
// return false if no or os isn't WinNT
{
	HKEY	hKey;
	DWORD	dwStatus;

	if (!IsWinNT()) return false;

	dwStatus = RegOpenKeyEx(
				HKEY_LOCAL_MACHINE,				// handle of open key
				"SYSTEM\\CurrentControlSet",	// address of name of subkey to open
				0,				// reserved  
				KEY_ALL_ACCESS,		// security access mask
				&hKey	// address of handle of open key
				);

	if (dwStatus != ERROR_SUCCESS)
		return false;
	
	RegCloseKey(hKey);

	return true;
}


int DestroyDirectory(char * srcdir, bool bRecursive)
{
	char filename[256];

	char searchfile[256];
	sysprintln("Remove files from " + srcdir);
	sprintf(searchfile, "%s\\*.*", srcdir);


	WIN32_FIND_DATA	finddata;
	HANDLE hFind;
	BOOL	bfindfile = FALSE;

	hFind = FindFirstFile(searchfile, &finddata);
	if(hFind != INVALID_HANDLE_VALUE)
		bfindfile = TRUE;

	while(bfindfile)
	{
		if((finddata.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == 0)
		{
			sprintf(filename, "%s\\%s", srcdir, finddata.cFileName);
			SetFileAttributes(filename, FILE_ATTRIBUTE_ARCHIVE);
			DeleteFile(filename);
		}
		else if(bRecursive)
		{
			if(finddata.cFileName[0] != '.')//Not that two default directory . and ..
			{
				sprintf(filename, "%s\\%s", srcdir, finddata.cFileName);
				DestroyDirectory(filename, bRecursive);
			}
		}
		bfindfile = FindNextFile(hFind, &finddata);
	}

	FindClose(hFind);

	if(RemoveDirectory(srcdir))
		return OK;
	else
		return GetLastError();
}

BOOL CALLBACK EnumWindowsProc(HWND hwnd, LPARAM lParam)
{
	char temp[MAX_SEARCHSTRING];
	SSearchWnd	* srcwnd;
	srcwnd = (SSearchWnd *) lParam;
	srcwnd->hWnd = NULL;
	if(strlen(srcwnd->szTitle) != 0)
	{
		GetWindowText(hwnd, temp, sizeof(temp));
		if(strcmp(temp, srcwnd->szTitle) == 0)
		{
			srcwnd->hWnd = hwnd;
			return FALSE;
		}
	}
	if(strlen(srcwnd->szWindowClass) != 0)
	{
		GetClassName(hwnd, temp, sizeof(temp));
		if(strcmp(temp, srcwnd->szWindowClass) == 0)
		{
			srcwnd->hWnd = hwnd;
			return FALSE;
		}
	}
	return TRUE;
}

bool SearchWindow(SSearchWnd &srcParam)
{
	srcParam.hWnd = NULL;
	EnumWindows(EnumWindowsProc, (LONG)&srcParam);
	if(srcParam.hWnd == NULL)
		return FALSE;
	else
		return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
//Below struct is copy from Tlhelp32.h
//Function GWNetProcessRunning is copy from Microsoft simple code TList
typedef struct tagPROCESSENTRY32
{
    DWORD   dwSize;
    DWORD   cntUsage;
    DWORD   th32ProcessID;          // this process
    DWORD   th32DefaultHeapID;
    DWORD   th32ModuleID;           // associated exe
    DWORD   cntThreads;
    DWORD   th32ParentProcessID;    // this process's parent process
    LONG    pcPriClassBase;         // Base priority of process's threads
    DWORD   dwFlags;
    CHAR    szExeFile[MAX_PATH];    // Path
} PROCESSENTRY32;
typedef PROCESSENTRY32 *  PPROCESSENTRY32;
typedef PROCESSENTRY32 *  LPPROCESSENTRY32;
typedef BOOL (WINAPI *PROCESSWALK)(HANDLE hSnapshot, LPPROCESSENTRY32 lppe);
typedef HANDLE (WINAPI *CREATESNAPSHOT)(DWORD dwFlags, DWORD th32ProcessID);
#define TH32CS_SNAPPROCESS  0x00000002

bool IsProcessRunning(char * ExeFileName, DWORD &processid)
{
	if(ExeFileName == NULL) return false;
	if(IsWinNT() && !IsWinNT2000())
		return false;
	bool bret = false;

	CREATESNAPSHOT pCreateToolhelp32Snapshot = NULL;
	PROCESSWALK    pProcess32First           = NULL;
	PROCESSWALK    pProcess32Next            = NULL;

	HANDLE         hKernel        = NULL;
	HANDLE         hProcessSnap   = NULL;
	PROCESSENTRY32 pe32           = {0};


	// Obtain a module handle to KERNEL so that we can get the addresses of
	// the 32-bit Toolhelp functions we need.
	hKernel = GetModuleHandle("KERNEL32.DLL");

	if (hKernel)
	{
	    pCreateToolhelp32Snapshot =
	      (CREATESNAPSHOT)GetProcAddress((HMODULE) hKernel, "CreateToolhelp32Snapshot");

	    pProcess32First = (PROCESSWALK)GetProcAddress((HMODULE)hKernel,
	                                                  "Process32First");
	    pProcess32Next  = (PROCESSWALK)GetProcAddress((HMODULE)hKernel,
	                                                  "Process32Next");
	}

	// make sure we got addresses of all needed Toolhelp functions.
	if (!(pProcess32First && pProcess32Next && pCreateToolhelp32Snapshot))
	{
		sysprintln("Fail to Get Function from kernel32.dll");
		return bret;
	}
	   

	// Take a snapshot of all processes currently in the system.
	hProcessSnap = pCreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
	if (hProcessSnap == (HANDLE)-1)
	{
		sysprintln("Fail to create Snapshot!");
	    return bret;
	}

	// Walk the snapshot of processes and for each process, get information
	// to display.
	pe32.dwSize = sizeof(PROCESSENTRY32);   // must be filled out before use
	if (pProcess32First(hProcessSnap, &pe32))
	{
	    do
	    {
	        LPSTR pCurChar;

	        // strip path and leave executabe filename splitpath
	        for (pCurChar = (pe32.szExeFile + lstrlen (pe32.szExeFile));
	             *pCurChar != '\\' && pCurChar != pe32.szExeFile; 
	             --pCurChar);

			if(*pCurChar == '\\') pCurChar ++;
	        if(_stricmp(pCurChar, ExeFileName) ==0) // Changed to case insensitive comparison - Mohandas
			{
				bret = true;
				processid = pe32.th32ProcessID;
				break;
			}
		}
	    while (pProcess32Next(hProcessSnap, &pe32));
	}
	else
		sysprintln("Error : No Process!");
	// Don't forget to clean up the snapshot object...
	CloseHandle (hProcessSnap);

	return bret;
}


//DWORD ShowWindowsErrMsg(DWORD dwErrCode,  DWORD dwFlag)
//{
//	LPVOID pMsgBuf = NULL;
//	FormatMessage(dwFlag,
//		NULL,
//		dwErrCode,
//		0,
//		(LPTSTR)&pMsgBuf,
//		0,
//		NULL);
//	MessageBox(NULL,  (LPCTSTR)pMsgBuf,  "Windows Error Message",  MB_OK);
//	LocalFree(pMsgBuf);
//
//	return dwErrCode;
//}

//////////////////////////////////////////////////////////////////


typedef	BOOL	WINAPI	SNDFC_ENUMPROCESSMODULES_PROC(HANDLE, HMODULE*, DWORD, LPDWORD);
typedef	DWORD	WINAPI	SNDFC_GETMODULEFILENAMEEX_PROC(HANDLE, HMODULE, LPTSTR, DWORD);
typedef	BOOL	WINAPI	SNDFC_ENUMPROCESS_PROC(DWORD*, DWORD, DWORD*);


#define SNDFC_USER_SHELL_REF_PROCESS_FILENAME "EXPLORER.EXE"
#define SNDFC_USER_SHELL_REF_PROCESS_FILENAME2 "CMD.EXE"

static HANDLE GetCurUserToken(void)
{
	if (!IsWinNT())
	{
		return INVALID_HANDLE_VALUE;
	}
	
	HMODULE hDll = LoadLibrary("PsApi.dll");
	if (NULL == hDll)
	{
		return INVALID_HANDLE_VALUE;
	}

	SNDFC_ENUMPROCESS_PROC			*pEnumProcesses = NULL;
	SNDFC_ENUMPROCESSMODULES_PROC	*pEnumProcessModules = NULL;
	SNDFC_GETMODULEFILENAMEEX_PROC	*pGetModuleFileNameEx = NULL;
	DWORD							processid_list[256];
	DWORD							size_need;
	DWORD							x = 0;
	
	pEnumProcesses			= (SNDFC_ENUMPROCESS_PROC*)GetProcAddress(hDll, "EnumProcesses");
	pEnumProcessModules		= (SNDFC_ENUMPROCESSMODULES_PROC*)GetProcAddress(hDll, "EnumProcessModules");
	pGetModuleFileNameEx	= (SNDFC_GETMODULEFILENAMEEX_PROC*)GetProcAddress(hDll, "GetModuleFileNameExA");
	
	if((NULL == pEnumProcesses) || (NULL == pEnumProcessModules) || (NULL == pGetModuleFileNameEx))
	{
		FreeLibrary(hDll);
		return INVALID_HANDLE_VALUE;
	}

	BOOL res = (*pEnumProcesses)(processid_list, 256, &size_need);
	if (!res)
	{
		FreeLibrary(hDll);
		return INVALID_HANDLE_VALUE;
	}

	HANDLE		hToken   = NULL;
	HANDLE		hProcess = NULL;
	BOOL		found = false;
	char		dir[MAX_PATH];
	
	outputstr	RefProcessName;
	outputstr	RefProcessName2;

	DWORD r = GetWindowsDirectory(dir, sizeof(dir));
	
	if ( r > 0 && r <= sizeof(dir) )
	{			
		RefProcessName = dir;
		RefProcessName = RefProcessName + '\\' + SNDFC_USER_SHELL_REF_PROCESS_FILENAME;
	}
	
	memset(dir, 0, sizeof(dir));
	r = GetSystemDirectory(dir, sizeof(dir));

	if ( r > 0 && r <= sizeof(dir) )
	{			
		RefProcessName2 = dir;
		RefProcessName2 = RefProcessName2 +	'\\' + SNDFC_USER_SHELL_REF_PROCESS_FILENAME2;
	}

	for(x = 0; x < (size_need>>2); x++)
	{
		hProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, processid_list[x]);
		if (NULL == hProcess)
			continue;
		else
		{
			HMODULE hMod;
			DWORD	dwSize2 = 0;
			char	szFileName[MAX_PATH];
			
			memset(szFileName, 0, MAX_PATH);

			if( (*pEnumProcessModules)(hProcess, &hMod, sizeof(hMod), &dwSize2))
			{
				// Get Full pathname:
				if( !(*pGetModuleFileNameEx)( hProcess, hMod, szFileName, sizeof(szFileName)))
				{
					CloseHandle(hProcess);
					continue;
				}
				if (0 == stricmp(szFileName, RefProcessName.GetString()))
				{
					found = true;
					break;
				}
				else
					if (0 == stricmp(szFileName, RefProcessName2.GetString()))
					{
						found = true;
						break;
					}
			}
			CloseHandle(hProcess);
		}	// else
		
	}	// for
	if (found)
	{
		
		if (OpenProcessToken(hProcess, TOKEN_QUERY|TOKEN_DUPLICATE|TOKEN_IMPERSONATE, &hToken))
		{
				CloseHandle(hProcess);
				FreeLibrary(hDll);
				return hToken;
 		}
		else
		{
			CloseHandle(hProcess);
			FreeLibrary(hDll);
			return INVALID_HANDLE_VALUE;
		}
	} // if (found)
	
	FreeLibrary(hDll);
	return INVALID_HANDLE_VALUE;
}

static int GetDefaultBrowserFullPath(const char *p, outputstr *pfullpath)
{
	// I can make sure the *pfullpath is a valid pointer 
	// because this is my private function. So,
	// I bypass the error checking in this function
	// I mean, some of the error checking not all
	// of them

	char	*pbuff;
	int		nlength;
	int		i=0;
	int		j=0;
	

	// Search from the tail for ".exe"
	// Why?
	// Because the full path could be
	// someting like "C:\\a.exe\\a.exe"

	nlength = strlen(p);
	
	// The p at least have 4 chars
	// So the i should > 4
	for(i=nlength;i>4;i--)
	{
		if((*(p+i) == 'E'	|| *(p+i) == 'e')&&
		   (*(p+i-1) == 'X'	|| *(p+i-1) == 'x')&&
		   (*(p+i-2) == 'E'	|| *(p+i-2) == 'e')&&
		   (*(p+i-3) == '.'))
		{
			break;
		}
	}
	
	if(i <= 4)
	{
		// Could not find the ".exe"
		// return ERR

		return ERR;
	}

	// Get the length of full path(include some '"')
	nlength = i + 1;

	// Following code will delete '"' from the string
	// The new string w/o the '"' should not longer than
	// the p. So I allocate a buffer that as long as the p
	// and copy all the char not '"' to the new buffer.

	pbuff = new char[nlength+1];

	memset(pbuff,0, nlength+1);
		
	for(i=0,j=0; i<nlength;i++)
	{
		if(*(p+i) =='"')
		{
			continue;
		}
		else
		{
			pbuff[j] = *(p+i);
			j++;
		}

	}
	
	// We should have a string for full path

	*pfullpath = pbuff;

	delete pbuff;

	return OK;
}

static int GetDefaulHtmlHelperFullPath(const char *p, outputstr *pfullpath)
{
	// I can make sure the *pfullpath is a valid pointer 
	// because this is my private function. So,
	// I bypass the error checking in this function
	// I mean, some of the error checking not all
	// of them

	char	*pbuff;
	int		nlength;
	int		i=0;
	int		j=0;
	

	// Search from the tail for ".exe"
	// Why?
	// Because the full path could be
	// someting like "C:\\a.exe\\a.exe"

	nlength = strlen(p);
	
	// The p at least have 4 chars
	// So the i should > 4
	for(i=nlength;i>4;i--)
	{
		if((*(p+i) == 'E'	|| *(p+i) == 'e')&&
		   (*(p+i-1) == 'X'	|| *(p+i-1) == 'x')&&
		   (*(p+i-2) == 'E'	|| *(p+i-2) == 'e')&&
		   (*(p+i-3) == '.'))
		{
			break;
		}
	}
	
	if(i <= 4)
	{
		// Could not find the ".exe"
		// return ERR

		return ERR;
	}

	// Get the length of full path(include some '"')
	nlength = i + 1;

	// Following code will delete '"' from the string
	// The new string w/o the '"' should not longer than
	// the p. So I allocate a buffer that as long as the p
	// and copy all the char not '"' to the new buffer.

	pbuff = new char[nlength+1];

	memset(pbuff,0, nlength+1);
		
	for(i=0,j=0; i<nlength;i++)
	{
		if(*(p+i) =='"')
		{
			continue;
		}
		else
		{
			pbuff[j] = *(p+i);
			j++;
		}

	}
	
	// We should have a string for full path

	*pfullpath = pbuff;

	delete pbuff;

	return OK;
}