/* $Header: /usr2/cvs/master/Develop/Products/Smc/build/sndfc/src/sndfc/snd/osutils.h,v 1.5 2003/01/27 19:49:20 bzhao Exp $*/
/*++
*************************************************************************
+-----------------------------------------------------------------------+
| Copyright (C) SYBERGEN NETWORKS, INC. 1998,1999 |
| All Rights Reserved. |
| Reproduction, adaptation, or translation without prior written |
| permission is prohibited, except as allowed under Copyright laws. |
| |
| N O T I C E |
| |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC. |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED. |
+-----------------------------------------------------------------------+
*************************************************************************
--*/

/*++
 * 
 * $Author: bzhao $
 * $Date: 2003/01/27 19:49:20 $
 * $Revision: 1.5 $
 * $Workfile: osutils.h $
 * $NoKeywords: $
 *
--*/

 

#ifndef _SND_OSUTILS_H_
#define _SND_OSUTILS_H_

#include "RegUtil.h"

// MS OS type for Sybergen product
//
#define SY_WIN_95				1
#define SY_WIN_98				2
#define SY_WIN_98_SE			3
#define SY_WIN_ME				4
#define SY_WIN_NT4				5
#define SY_WIN_2000				6
#define SY_WIN_XP				7
#define SY_WIN_2003				8

bool IsWin95(void);
// return true if os is win95.

bool IsWin98(void);
// return true if os is win98.
// include win98 original and SE.

bool IsWin98Org(void);
//return true if os is Win98 Original.

bool IsWin98SE(void);
//return true if os is win98 SE.
//Attiontion: win98SE belongs to win98.

bool IsWinME(void);
// return true if os is WinME.

bool IsWin9x(void);//include all windows except WinNT.
// return true if os is win95 ,win98 or winME.

bool IsWinNT(void);//include all windows except win9x.
// return true if os is winNT.
//include WinNT4.0 and Win2K

bool IsWinNT4(void);
//return true if os is winNT4.0
bool IsWinNT2000(void);
// return true if os is Win2K.or WinXp
bool IsWin2000(void); //win2k only
bool IsWinXP(void);
// return true if os is WinXP.

bool IsServer(void);
// return true if os is server (nt server or win2k server)
bool IsNT4Server(void);
// return true if os is NT4 server
bool IsWin2000Server(void);
// return true if os is Win2k server

bool IsNtSp3(void);
// return true if there is a service pack 3 installed.
bool IsNtSp4(void);
// return true if there is a service pack 4 installed.
bool IsNtSp5(void);
// return true if there is a service pack 5 installed.
bool IsNtSp6(void);
// return true if there is a service pack 6 installed.
int GetNtSpVersion(void);
//return NT service pack version
bool IsNtAdministrators(void);
// check if the app has administrators rights.
// NOTICE: it works "as is".
// return true if yes
// return false if no or os isn't WinNT


int Exec(char *executable_filename, char *command_line, bool wait_for_end, bool visiable,char *output_filename = NULL);
//Warning, just use this funciton according to example
// Example: Exec("D:\Windows\ipconfig.exe","D:\Windows\ipconfig.exe /Batch",true,false);
// if wait_for_end is true, the function won't return until the program executed finished
// return OK if successfully

char *GetOSString(DWORD *os);
// Return OS type string

int RebootSystem(void);
// return OK if succeed

int OpenBrowser(HWND handle, char *url);

int OpenBrowserEx(HWND handle, char *url);

HANDLE OpenHtmlHelper(HWND handle, char *pchmpath);

int DestroyDirectory(char * Directory, bool bRecursive = false);
//return OK if succeed

bool IsProcessRunning(char * ExeFileName, DWORD &processid);
//return TRUE if find executive file is runing and return processid.
//Can't use this function under winnt4.0

#define MAX_SEARCHSTRING 128
typedef struct 
{
	HWND	hWnd;
	char	szTitle[MAX_SEARCHSTRING];
	char	szWindowClass[MAX_SEARCHSTRING];
}SSearchWnd;


typedef struct _OSVERSIONINFOEX {
  DWORD dwOSVersionInfoSize;
  DWORD dwMajorVersion;
  DWORD dwMinorVersion;
  DWORD dwBuildNumber;
  DWORD dwPlatformId;
  TCHAR szCSDVersion[ 128 ];
  WORD wServicePackMajor;
  WORD wServicePackMinor;
  WORD wSuiteMask;
  BYTE wProductType;
  BYTE wReserved;
} SNDFC_OSVERSIONINFOEX;
bool SearchWindow(SSearchWnd &srcParam);
//This function can only find top-level windows.
//Pass window's title or class to find the handle for that window
//return TRUE, if success. hWnd stores the window handle.
//return FALSE. if failed.
//Sometime SearchWindow freezes,call this function as less as you can.


//DWORD ShowWindowsErrMsg(DWORD dwErrCode,  DWORD dwFlag = FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_IGNORE_INSERTS|FORMAT_MESSAGE_FROM_SYSTEM);
////.. dwErrCode: Windows system error code value, can use GetLastError() to get it.
////.. return dwErrCode


#endif
// ============= end of OSUTILS.H ===========
