// Packet.h: interface for the CPacket class.
//
//////////////////////////////////////////////////////////////////////

/*++
*************************************************************************
+-----------------------------------------------------------------------+
|  Copyright (C) SYBERGEN, INC. 1998,1999                               |
|      All Rights Reserved.                                             |
| Reproduction, adaptation, or translation without prior written        |
| permission is prohibited, except as allowed under Copyright laws.     |
|                                                                       |
| N O T I C E                                                           |
|                                                                       |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC.                     |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED.                             |
+-----------------------------------------------------------------------+
*************************************************************************
--*/

/*++
History:

04/02/1999			Merged into SNDFC by Yadong Zhang
04/21/1998			Created by Yadong Zhang

--*/


#ifndef SND_PACKET_H
#define SND_PACKET_H

#include "sndbasex.h"
#include "memptr.h"
#include "pktdebug.h"

////////////////////////////////////////////////////
// CPacket is the base class for all packet classes.
// DO NOT use it directly


class CPacket
{
private:
//	CPacket*	pPacketBased;	// the packet based on
	memptr		PacketBinary;	// the  Packet's binary which I know.

public:
	CPacket() {};

	inline int Set(memptr p);
	inline int Set(CPacket &pkt, memptr new_packetbinary);
	inline CPacket& CopyFrom(CPacket& a);
	inline memptr GetPacketBinary(void);
	inline void SetPacketBinary(memptr p);

	/*++ the deliving class DON'T delive the function
		They should define their function 
	
	inline CPacket& operator= (CPacket& a)
	{ 	RawData = a.RawData; PacketBinary = a.PacketBinary; 
		return *this;	}
	--*/

//	virtual inline memptr GetDataSection(void) = 0;

//	int Set(CPacket &pkt);
	// convert a packet to myself
	// return OK if success

};

int CPacket::Set(memptr p)
{
//		pPacketBased = 0;
	PacketBinary = p;
	return OK;
}

int CPacket::Set(CPacket &pkt, memptr new_packetbinary)
{
//		pPacketBased = &pkt;
	PacketBinary = new_packetbinary;
	return OK;
}

CPacket& CPacket::CopyFrom(CPacket& a)
{ 
	PacketBinary = a.PacketBinary;
	return *this;
}


//	inline CPacket* GetPacketBased(void) { return pPacketBased; }
memptr CPacket::GetPacketBinary(void)
{
	return PacketBinary; 
}

void CPacket::SetPacketBinary(memptr p)
{
	PacketBinary = p; 
}


#endif
// end of packet.h

