// PingPkt.cpp: implementation of the CPingPacket class.
//
//////////////////////////////////////////////////////////////////////

/*++
*************************************************************************
+-----------------------------------------------------------------------+
|  Copyright (C) SYBERGEN, INC. 1998                                    |
|      All Rights Reserved.                                             |
| Reproduction, adaptation, or translation without prior written        |
| permission is prohibited, except as allowed under Copyright laws.     |
|                                                                       |
| N O T I C E                                                           |
|                                                                       |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC.                     |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED.                             |
+-----------------------------------------------------------------------+
*************************************************************************
--*/



#include "stdafx.h"
#include "Pingpkt.h"

ostream& operator<<(ostream& os, CPingPacket &ep)
{
	if (ep.IsRequest())
		os<<"Ping, REQUEST";
	else
		os<<"Ping, REPLY  ";
	os	<<", id: "<<ep.GetIdentifier()
		<<", seq: "<<ep.GetSeqNumber();
	return os;
}

outputstr operator+(const outputstr& ops, CPingPacket &pp)
{
	ostrstream outbuf;
	outbuf<<pp<<(char)0;
	outputstr out = ops + outbuf.str();

	// unfreeze it, otherwise strstream won't release the memory 
	// and memory leak will occur.
	outbuf.freeze(false);
	return out;
}


int MakePingReply(CPingPacket* ping)
{
	ipaddr src_ip;
	ipaddr dst_ip;
	etheraddr src_mac;
	etheraddr dst_mac;

	if ( ! ping->IsRequest() )
	{
		// it is not ping request (ECHO request)
		return ERR;
	}

	src_ip = ping->GetIcmpPkt().GetIpPkt().GetSourIp();
	dst_ip = ping->GetIcmpPkt().GetIpPkt().GetDestIp();
	src_mac = ping->GetIcmpPkt().GetIpPkt().GetEthiiPkt().GetSourAddr();
	dst_mac = ping->GetIcmpPkt().GetIpPkt().GetEthiiPkt().GetDestAddr();

	// fill up the fields
	ping->GetIcmpPkt().GetFramePtr()->Type = PROTO_ICMP_TYPE_PING_REPLY;
	ping->GetIpPkt().GetFramePtr()->SourAddr = dst_ip;
	ping->GetIpPkt().GetFramePtr()->DestAddr = src_ip;

	ping->GetIcmpPkt().RefillIcmpChecksum();
	ping->GetIpPkt().RefillIpChecksum();

	ping->GetIcmpPkt().GetIpPkt().GetEthiiPkt().GetFramePtr()->SourAddr = dst_mac;
	ping->GetIcmpPkt().GetIpPkt().GetEthiiPkt().GetFramePtr()->DestAddr = src_mac;

	return OK;
}