// pktutils.cpp

/*++
*************************************************************************
+-----------------------------------------------------------------------+
|  Copyright (C) SYBERGEN, INC. 1998                                    |
|      All Rights Reserved.                                             |
| Reproduction, adaptation, or translation without prior written        |
| permission is prohibited, except as allowed under Copyright laws.     |
|                                                                       |
| N O T I C E                                                           |
|                                                                       |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC.                     |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED.                             |
+-----------------------------------------------------------------------+
*************************************************************************
--*/

/*++
History:

04/01/1998			Created by Yadong Zhang

--*/



#include "stdafx.h"
#include "sndtime.h"
#include "osutils.h"
#include "ethpkt.h"
#include "arppkt.h"
#include "tcppkt.h"
#include "udppkt.h"
#include "icmppkt.h"
#include "pingpkt.h"
#include "grepkt.h"
#include "ttlexpkt.h"
#include "dnspkt.h"
#include "dhcppkt.h"
#include "pktutils.h"

void RawPacketDump(void *raw_pkt, unsigned len, unsigned nicid)
{
	memptr mp; 
	CEtheriiPacket eiip;
	
	mp.Set(raw_pkt, len);
	eiip.Set(mp, nicid);

	PacketDump(eiip);
}



void PacketDump(CEtheriiPacket &eiip)
{
	CArpPacket arpp;
	CIpPacket ipp;
	CTcpPacket tpp;
	CUdpPacket upp;
	CIcmpPacket icpp;
	CPingPacket pingpp;
	CGrePacket	grep;
	CTtlExceededPacket ttlex;
	CDnsPacket	dnsp;
	CDhcpPacket dhcp;
	
	sysprintln("===== Time:" + GetTimeCount());

	if (ETHER_FRAMEHEAD_DEBUG) sysprintln(eiip);

	if (ipp.Set(eiip) == OK)
	{
		if (IP_FRAMEHEAD_DEBUG) sysprintln(ipp);
		if (ipp.IsValidIpChecksum())
		{
			// TCP
			if (tpp.Set(ipp) == OK)
			{
				sysprintln(tpp);
				if (tpp.IsValidTcpChecksum())
				{
					
				}
				else
				{
					sysprint("TCP Checksum error, "+ipp.GetSourIp());
					sysprintln("-->" + ipp.GetDestIp());
				}
			}
			// UDP
			else if (upp.Set(ipp) == OK)
			{
				sysprint(upp);
				if (upp.IsValidUdpChecksum())
				{
					//os<<"u.";
				}
				else
				{
					sysprintln("UDP Checksum error.");
				}
				
				if (dnsp.Set(upp) == OK)
				{
					sysprint(dnsp);
				}
				
				if (dhcp.Set(upp) == OK)
				{
					sysprint(dhcp);
				}
				
				sysprintln("");
			}
			// ICMP
			else if (icpp.Set(ipp) == OK)
			{
				sysprintln(icpp);
				if (icpp.IsValidIcmpChecksum())
				{
					//os<<"u.";
				}
				else
				{
					sysprintln("ICMP Checksum error.");
				}
				if (pingpp.Set(icpp) == OK)
				{
					sysprintln(pingpp);
				}
				else if (ttlex.Set(icpp) == OK)
				{
					sysprintln(ttlex);
				}

			} // end of ICMP
			else if (grep.Set(ipp) == OK)
			{
				sysprintln(grep);
			} // end of GRE

			
			// TODO: add other protocols.
			//
			//
		}
		else
		{
			sysprintln("IP checksum error.." + ipp);
		}
	}
	else if (arpp.Set(eiip) == OK)
	{
		sysprintln(arpp);
	}
	else
	{
		// it is not IP
		sysprint("Data: (len=" + eiip.GetDataLen());
		sysprintln(")");
		sysprintln(eiip.GetDataSection());
	}
	sysprintln("");
}
