/*++
*************************************************************************
+-----------------------------------------------------------------------+
|  Copyright (C) SYBERGEN, INC. 1999                                    |
|      All Rights Reserved.                                             |
| Reproduction, adaptation, or translation without prior written        |
| permission is prohibited, except as allowed under Copyright laws.     |
|                                                                       |
| N O T I C E                                                           |
|                                                                       |
| THIS MATERIAL IS A TRADE SECRET OF SYBERGEN, INC.                     |
| UNAUTHORIZED ACCESS OR USE IS PROHIBITED.                             |
+-----------------------------------------------------------------------+
*************************************************************************
--*/

#ifndef _SERVICE_H
#define _SERVICE_H

//************************************************************************
//
// Turn a Win32 console application to a service is as easy as:
//
// 1. Link to sndfc.lib
// 2. Write your own main() function. (see SyShieldSvc project for sample code) 
// 3. Implement following 2 C functions.
//
//      ServiceStart();
//      ServiceStop();
//
// ServiceStart() and ServiceStop should use ReportStatusToSCMgr 
// to indicate progress.  ServiceStart routine will be used by StartService()
// to report to the SCM when the service is running.
// If a ServiceStop procedure is going to take longer than
// 3 seconds to execute, it should spawn a thread to
// execute the stop code, and return.  Otherwise, the
// ServiceControlManager will believe that the service has
// stopped responding
//
//************************************************************************

class CService
{
public:
	CService(CString strServiceName, CString strServiceDisplayName);
	~CService();

	void CmdInstallService();						// Install service
	void CmdRemoveService();						// uninstall service
	void CmdDebugService(int argc, char ** argv);	// debug service as an application
	void CmdStartService(void);						// start service
	void CmdStopService(void);						// stop service
	

	void DoService(int argc, char **argv);
	// enter service, 
	// the function should be call by main()

	static CString m_strServiceName;
	static CString m_strServiceDisplayName;
	static BOOL bDebug;
	static SERVICE_STATUS ssStatus;       // current status of the service
	static SERVICE_STATUS_HANDLE sshStatusHandle;
	TCHAR szErr[256];

};

// Following two functions will be used when you write ServiceStart()
// and ServiceStop().

	//  FUNCTION: ReportStatusToSCMgr()
	//
	//  PURPOSE: Sets the current status of the service and
	//           reports it to the Service Control Manager
	//
	//  PARAMETERS:
	//    dwCurrentState - the state of the service
	//    dwWin32ExitCode - error code to report
	//    dwWaitHint - worst case estimate to next checkpoint
	//
	//  RETURN VALUE:
	//    TRUE  - success 
	//    FALSE - failure
	//
	BOOL ReportStatusToSCMgr(DWORD dwCurrentState, DWORD dwWin32ExitCode, DWORD dwWaitHint);

	LPTSTR GetLastErrorText( LPTSTR lpszBuf, DWORD dwSize );

#endif
